$if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
    Output TFT_CS : Output TFT_RESET : Output TFT_DC
    Output TFT_MOSI : Output TFT_SCLK : Input TFT_MISO
    PinSet TFT_CS
$endif

$if TFT_COM = PAR_2x8b 
    Output TftDataLowByte : Output TftDataHighByte
    Output TFT_CS : Output TFT_WR : Output TFT_DC        
    Output TFT_RESET : Output TFT_RD   
    PinSet TFT_CS
$endif

$if TFT_COM = PAR_16b 
    Output TftDataWord
    Symbol TftDataLowByte = TftDataWord
    Output TFT_CS : Output TFT_WR : Output TFT_DC        
    Output TFT_RESET : Output TFT_RD  
    PinSet TFT_CS 
$endif

$if TFT_IC = ST7789V
    Include "TftLib\Drivers\ST7789V.inc"
$elseif TFT_IC = ST7789
    Include "TftLib\Drivers\ST7789.inc"    
$elseif TFT_IC = ILI9341
    Include "TftLib\Drivers\ILI9341.inc"
$elseif TFT_IC = ST7796S
    Include "TftLib\Drivers\ST7796S.inc"  
$elseif TFT_IC = ILI9486
    Include "TftLib\Drivers\ILI9486.inc"
$elseif TFT_IC = ILI9488
    Include "TftLib\Drivers\ILI9488.inc"   
$elseif TFT_IC = ST7735S
    Include "TftLib\Drivers\ST7735S.inc"   
$elseif TFT_IC = ST7735
    Include "TftLib\Drivers\ST7735.inc"     
$elseif TFT_IC = GC9A01
    Include "TftLib\Drivers\GC9A01.inc"         
$endif

$if TFT_IC = ST7789V Or TFT_IC = ILI9341 Or TFT_IC = ST7796S Or TFT_IC = ILI9486
    $define TftDisplayOn()        Tft1bWriteCommand(0x29)
    $define TftDisplayOff()       Tft1bWriteCommand(0x28)
    $define TftPartialAreaOn()    Tft1bWriteCommand(0x12)
    $define TftPartialAreaOff()   Tft1bWriteCommand(0x13)  
$endif

$if TFT_IC = ILI9488 Or TFT_IC = ST7735S 
    $define TftDisplayOn()        Tft1bWriteCommand(0x29)
    $define TftDisplayOff()       Tft1bWriteCommand(0x28)
    $define TftPartialAreaOn()    Tft1bWriteCommand(0x12)
    $define TftPartialAreaOff()   Tft1bWriteCommand(0x13)  
$endif
