'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Proc TftSetUp(bOrientation As Byte) 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif      
            PinSet TFT_CS : PinSet T_CS : PinClear TFT_RESET     
            DelayMS 100 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 100 : PinSet TFT_RESET : DelayMS 100
        $endif
        
        'Sleep Out
        Tft1bWriteCommand(0x11)
        DelayMS 120
        
        Tft1bWriteCommand(0xef)
        Tft2bWriteCommand(0xeb, 0x14)
        Tft1bWriteCommand(0xfe)
        Tft1bWriteCommand(0xef)
        Tft2bWriteCommand(0xeb, 0x14)
        Tft2bWriteCommand(0x84, 0x40)
        Tft2bWriteCommand(0x85, 0xff)
        Tft2bWriteCommand(0x86, 0xff)
        Tft2bWriteCommand(0x87, 0xff)
        Tft2bWriteCommand(0x88, 0x0a)
        Tft2bWriteCommand(0x89, 0x21)
        Tft2bWriteCommand(0x8a, 0x00)
        Tft2bWriteCommand(0x8b, 0x80)
        Tft2bWriteCommand(0x8c, 0x01)
        Tft2bWriteCommand(0x8d, 0x01)
        Tft2bWriteCommand(0x8e, 0xff)
        Tft2bWriteCommand(0x8f, 0xff)
        Tft3bWriteCommand(0xb6, 0x00, 0x00)
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x90)
            PinSet TFT_DC
                TftSend(0x08)
                TftSend(0x08)
                TftSend(0x08)
                TftSend(0x08)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x60 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
               
        Tft2bWriteCommand(0xbd, 0x06)  
        Tft2bWriteCommand(0xbc, 0x00) 
        Tft4bWriteCommand(0xff, 0x60, 0x01, 0x04) 
        Tft4bWriteCommand(0xc3, 0x13, 0xc4, 0x13)
        Tft2bWriteCommand(0xc9, 0x22) 
        Tft2bWriteCommand(0xbe, 0x11)  
        Tft3bWriteCommand(0xe1, 0x10, 0x0e)
        Tft4bWriteCommand(0xdf, 0x21, 0x0c, 0x02)
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xf0)
            PinSet TFT_DC
                TftSend(0x45)
                TftSend(0x09)
                TftSend(0x08)
                TftSend(0x08)
                TftSend(0x26)
                TftSend(0x2a)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xf0 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x45  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x26  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2a  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xf1)
            PinSet TFT_DC
                TftSend(0x43)
                TftSend(0x70)
                TftSend(0x72)
                TftSend(0x36)
                TftSend(0x37)
                TftSend(0x6f)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xf1 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x43  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x72  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x36 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x6f  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xf2)
            PinSet TFT_DC
                TftSend(0x45)
                TftSend(0x09)
                TftSend(0x08)
                TftSend(0x08)
                TftSend(0x26)
                TftSend(0x2a)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xf2 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x45  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x26  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2a  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xf3)
            PinSet TFT_DC
                TftSend(0x43)
                TftSend(0x70)
                TftSend(0x72)
                TftSend(0x36)
                TftSend(0x37)
                TftSend(0x6f)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xf3 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x43  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x72  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x36  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x6f  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
               
        Tft3bWriteCommand(0xed, 0x1b, 0x0b) 
        Tft2bWriteCommand(0xae, 0x77)  
        Tft2bWriteCommand(0xcd, 0x63) 
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x70)
            PinSet TFT_DC
                TftSend(0x07)
                TftSend(0x07)
                TftSend(0x04)
                TftSend(0x0e)
                TftSend(0x0f)
                TftSend(0x09)
                TftSend(0x07)
                TftSend(0x08)
                TftSend(0x03)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x70
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0f 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x03  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
             
                   
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x62)
            PinSet TFT_DC
                TftSend(0x18)
                TftSend(0x0d)
                TftSend(0x71)
                TftSend(0xed)
                TftSend(0x70)
                TftSend(0x70)
                TftSend(0x18)
                TftSend(0x0f)
                TftSend(0x71)
                TftSend(0xef)
                TftSend(0x70)
                TftSend(0x70)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x62 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0d  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x71  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xed  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x71  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xef  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x63)
            PinSet TFT_DC
                TftSend(0x18)
                TftSend(0x11)
                TftSend(0x71)
                TftSend(0xf1)
                TftSend(0x70)
                TftSend(0x70)
                TftSend(0x18)
                TftSend(0x13)
                TftSend(0x71)
                TftSend(0xf3)
                TftSend(0x70)
                TftSend(0x70)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x63 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x11  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x71  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xf1  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x13  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x71  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xf3 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x70  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif    
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x64)
            PinSet TFT_DC
                TftSend(0x28)
                TftSend(0x29)
                TftSend(0xf1)
                TftSend(0x01)
                TftSend(0xf1)
                TftSend(0x00)
                TftSend(0x07)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x64 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x28  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x29  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xf1  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x01  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xf1 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif 
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x66)
            PinSet TFT_DC
                TftSend(0x3c)
                TftSend(0x00)
                TftSend(0xcd)
                TftSend(0x67)
                TftSend(0x45)
                TftSend(0x45)
                TftSend(0x10)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x66 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xcd  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x67  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x45 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x45  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x10  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif 
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x67)
            PinSet TFT_DC
                TftSend(0x00)
                TftSend(0x3c)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x01)
                TftSend(0x54)
                TftSend(0x10)
                TftSend(0x32)
                TftSend(0x98)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x67 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x01  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x54  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x10  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x98  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0x74)
            PinSet TFT_DC
                TftSend(0x10)
                TftSend(0x85)
                TftSend(0x80)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x4e)
                TftSend(0x00)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0x74 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x10  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x85  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x80 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x4e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
         Tft3bWriteCommand(0x98, 0x3e, 0x07)  
         Tft1bWriteCommand(0x35)
         Tft1bWriteCommand(0x21)    
                   
               
        'Screen orientation 
        TftSetOrientation(bOrientation) 
        'Interface Pixel Format
        Tft2bWriteCommand(0x3A, 0x55)
            
        Tft1bWriteCommand(0x11)                   
        'Normal Display Mode On
        Tft1bWriteCommand(0x13)
        'Display ON
        Tft1bWriteCommand(0x29)
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %00111000)    
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset
            Tft2bWriteCommand(0x36, %10011000)  
        Case 2
            Tft2bWriteCommand(0x36, %11111000)
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight
            Swap wTftWidthOffset, wTftHeightOffset  
            Tft2bWriteCommand(0x36, %01011000) 
    EndSelect
EndProc
