'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Proc TftSetUp(bOrientation As Byte) 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinClear TFT_RESET     
            DelayMS 100 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 100 : PinSet TFT_RESET : DelayMS 100
        $endif
        
        'Power control settings
        Tft3bWriteCommand(0xC0, 0x19, 0x1a)
        Tft3bWriteCommand(0xC1, 0x45, 0x00)
        'Power/Reset on default             
        Tft2bWriteCommand(0xC2, 0x33)
        'VCOM control
        Tft3bWriteCommand(0xC5, 0x00, 0x28)
        'Frame rate control
        Tft3bWriteCommand(0xB1, 0xA0, 0x11)
        'Display Z Inversion
        Tft2bWriteCommand(0xB4, 0x02)
        'Display Control Function
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xB6)
            PinSet TFT_DC
                TftSend(0x00)
                TftSend(0x42)
                TftSend(0x3B)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xB6
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x42  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3B  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        'Positive Gamma control
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE0)
            PinSet TFT_DC
                TftSend(0x1F)
                TftSend(0x25)
                TftSend(0x22)
                TftSend(0x0B)
                TftSend(0x06)
                TftSend(0x0A)
                TftSend(0x4E)
                TftSend(0xC6)
                TftSend(0x39)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x00)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xE0
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x1F  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x25  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x22 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0B 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x06  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0A 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x4E 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xC6  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x39 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00   
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        'Negative Gamma control
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0XE1)
            PinSet TFT_DC
                TftSend(0x1F)
                TftSend(0x3F)
                TftSend(0x3F)
                TftSend(0x0F)
                TftSend(0x1F)
                TftSend(0x0F)
                TftSend(0x46)
                TftSend(0x49)
                TftSend(0x31)
                TftSend(0x05)
                TftSend(0x09)
                TftSend(0x03)
                TftSend(0x1C)
                TftSend(0x1A)
                TftSend(0x00)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0XE1
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x1F 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3F  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3F 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0F 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1F  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0F 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x46 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x49  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x31 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x05 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x03 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1C 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1A  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        'Misc
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0XF1)
            PinSet TFT_DC
                TftSend(0x36)
                TftSend(0x04)
                TftSend(0x00)
                TftSend(0x3C)
                TftSend(0x0F)
                TftSend(0x0F)
                TftSend(0xA4)
                TftSend(0x02)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0XF1
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x36 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3C  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0F  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0F  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xA4  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0XF2)
            PinSet TFT_DC
                TftSend(0x18)
                TftSend(0xA3)
                TftSend(0x12)
                TftSend(0x02)
                TftSend(0x32)
                TftSend(0x12)
                TftSend(0xFF)
                TftSend(0x32)
                TftSend(0x00)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0XF2
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xA3  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x12  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x02   
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x12  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0xFF  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0XF4)
            PinSet TFT_DC
                TftSend(0x40)
                TftSend(0x00)
                TftSend(0x08)
                TftSend(0x91)
                TftSend(0x04)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0XF4 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x40  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x91  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        Tft3bWriteCommand(0XF8, 0x21, 0x04)
        Tft2bWriteCommand(0x3A, 0x55)
        Tft3bWriteCommand(0xB6, 0x00, 0x22)
        TftSetOrientation(bOrientation)
        
        'Sleep Out
        Tft1bWriteCommand(0x11)
        'Turn on display
        Tft1bWriteCommand(0x29)
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %11111000) 'ok         
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset 
            Tft2bWriteCommand(0x36, %01011000)  'ok
        Case 2
            Tft2bWriteCommand(0x36, %00111000) 'ok
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset 
            Tft2bWriteCommand(0x36, %10011000) 'ok
    EndSelect
EndProc
