'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Dim dColor As Dword

Proc TftSetUp(bOrientation As Byte) 
        'HW TFT Reset
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinClear TFT_RESET     
            DelayMS 120 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 100 : PinSet TFT_RESET : DelayMS 100
        $endif
        
        'Display OFF
        Tft1bWriteCommand(0x28) 
        'Interface Pixel Format
        Tft2bWriteCommand(0x3A, 0x66)
        'Interface Mode Control
        Tft2bWriteCommand(0xB0, 0x00)
        'Frame Rate 
        Tft2bWriteCommand(0xB1, 0xA0)
        'Display Inversion Control
        Tft2bWriteCommand(0xB4, 0x02)
        'RGB/MCU Interface Control
        Tft3bWriteCommand(0xb6, 0x02, 0x02)
        'EntryMode
        Tft2bWriteCommand(0xB7, 0x06)
        'Power Control 1
        Tft3bWriteCommand(0xC0, 0x17, 0x15)
        'Power Control 2
        Tft2bWriteCommand(0xC1, 0x41)
        'VCOM Control
        Tft4bWriteCommand(0xC5, 0x00, 0x12, 0x80)
        'Set Image Func
        Tft2bWriteCommand(0xE9, 0x00)
        'Set Brightness to Max
        Tft2bWriteCommand(0x51, 0xFF)
        'Write CTRL Display Value
        Tft2bWriteCommand(0x53, 0x28)
            
        'Adjust Control
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xf7)
            PinSet TFT_DC
                TftSend(0xa9)
                TftSend(0x51)
                TftSend(0x2c)
                TftSend(0x82)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xf7
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0xa9  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x51  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x82  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS   
        $endif
        
        'N-Gamma
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE1)
            PinSet TFT_DC
                TftSend(0x00)
                TftSend(0x16)
                TftSend(0x19)
                TftSend(0x03)
                TftSend(0x0f)
                TftSend(0x05)
                TftSend(0x32)
                TftSend(0x45)
                TftSend(0x46)
                TftSend(0x04)
                TftSend(0x0e)
                TftSend(0x0d)
                TftSend(0x35)
                TftSend(0x37)
                TftSend(0x0f)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xE0
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x16  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x19  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x03  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x05  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x45  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x46  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0d  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x35  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0f  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS   
        $endif

        'P-Gamma
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE0)
            PinSet TFT_DC
                TftSend(0x00)
                TftSend(0x03)
                TftSend(0x09)
                TftSend(0x08)
                TftSend(0x16)
                TftSend(0x0a)
                TftSend(0x3f)
                TftSend(0x78)
                TftSend(0x4c)
                TftSend(0x09)
                TftSend(0x0a)
                TftSend(0x08)
                TftSend(0x16)
                TftSend(0x1a)
                TftSend(0x0f)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xE0
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x03  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x16  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0a  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x78  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x4c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0a  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x08  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x16  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1a  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0f  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS   
        $endif 
        
        'Screen orientation 
        TftSetOrientation(bOrientation) 
        
        'Sleep Out
        Tft1bWriteCommand(0x11)
        'Idle Mode Off
        Tft1bWriteCommand(0x38)
        'Normal Display Mode On
        Tft1bWriteCommand(0x13)
        'Display ON
        Tft1bWriteCommand(0x29)   
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %10101000)     
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset 
            Tft2bWriteCommand(0x36, %00011000) 
        Case 2
            Tft2bWriteCommand(0x36, %01111000)
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight 
            Swap wTftWidthOffset, wTftHeightOffset 
            Tft2bWriteCommand(0x36, %11011000) 
    EndSelect
EndProc

'Convert 16b RGB565 to 18b RGB888 format
Proc Rgb16ToRgb18(wColor As Word)
    'Blue
    dColor.Byte0 = wColor.Byte0 & %00011111 
    dColor.Byte0 = dColor.Byte0 << 3
    
    'Red
     dColor.Byte2 = wColor.Byte1 & %11111000
     
     'Green
     wColor = wColor >> 3 
     dColor.Byte1 = wColor.Byte0 & %11111100
EndProc







