'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Proc TftSetUp(bOrientation As Byte) 
    'HW TFT Reset
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinClear TFT_RESET     
            DelayMS 100 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS 
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 120 : PinSet TFT_RESET : DelayMS 120
        $endif
        
       'Frame Rate Control in normal mode, full colors
        Tft4bWriteCommand(0xb1, 0x00, 0x01, 0x01)
        'Frame Rate Control in partial mode, full colors
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xB3)
            PinSet TFT_DC
                TftSend(0x05)
                TftSend(0x3c)
                TftSend(0x3c)
                TftSend(0x05)
                TftSend(0x3c)
                TftSend(0x3c)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xB3 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x05 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x05  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3c  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        'Display Inversion Contro
        Tft2bWriteCommand(0xB4, 0x00)
        'power control
        Tft4bWriteCommand(0xc0, %11111100, 0x08, %00000010)
        Tft2bWriteCommand(0xc1, 0xc0)
        Tft3bWriteCommand(0xc2, 0x0d, 0x00)
        Tft3bWriteCommand(0xc3, 0x8d, 0x2a)
        Tft3bWriteCommand(0xc4, 0x8d, 0xee)
        'Gate Pump Clock Frequency
        Tft2bWriteCommand(0xfc, %11011000)
        'VCOM Control 1
        Tft2bWriteCommand(0xc5, %00001111)
        'VCOM Offset Control
        Tft2bWriteCommand(0xc7, %00010000)
        'Gamma Set
        Tft2bWriteCommand(0x26, 0x08)
        'pixel mode
        Tft2bWriteCommand(0x3a, 0x05)
       
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            'Positive Voltage Gamma Control
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE0)
            PinSet TFT_DC
                TftSend(0x02)
                TftSend(0x1c)
                TftSend(0x07)
                TftSend(0x12)
                TftSend(0x37)
                TftSend(0x32)
                TftSend(0x29)
                TftSend(0x2c)
                TftSend(0x29)
                TftSend(0x25)
                TftSend(0x2b)
                TftSend(0x39)
                TftSend(0x00)
                TftSend(0x01)
                TftSend(0x03)
                TftSend(0x10)
            PinSet TFT_CS
            
            'Negative Voltage Gamma Control
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE1)
            PinSet TFT_DC
                TftSend(0x03)
                TftSend(0x1d)
                TftSend(0x07)
                TftSend(0x06)
                TftSend(0x2e)
                TftSend(0x2c)
                TftSend(0x29)
                TftSend(0x2c)
                TftSend(0x2e)
                TftSend(0x2e)
                TftSend(0x37)
                TftSend(0x3f)
                TftSend(0x00)
                TftSend(0x00)
                TftSend(0x02)
                TftSend(0x10)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xE0 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1c 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x12  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x29  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x29  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x25  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2b  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x39  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x01  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x03 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x10  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
            
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xe1
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x03  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1d  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x07  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x06  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x29  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2e  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x10  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS     
        $endif
        
        'Screen orientation 
        TftSetOrientation(bOrientation) 

        'Sleep Out
        Tft1bWriteCommand(0x11)
        DelayMS 120
        ' Display Inversion On
        Tft1bWriteCommand(0x21)
        'Normal Display Mode On
        Tft1bWriteCommand(0x13)
        'Idle Mode Off
        Tft1bWriteCommand(0x38)
        'Display ON
        Tft1bWriteCommand(0x29)
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %00111100)     
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset
            Tft2bWriteCommand(0x36, %10001000) 
        Case 2
            Tft2bWriteCommand(0x36, %11111000)
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight
            Swap wTftWidthOffset, wTftHeightOffset 
            Tft2bWriteCommand(0x36, %01011000) 
    EndSelect
EndProc
