'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Proc TftSetUp(bOrientation As Byte) 
    'HW TFT Reset
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinClear TFT_RESET     
            DelayMS 100 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS 
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 100 : PinSet TFT_RESET : DelayMS 100
        $endif
        
        'Screen orientation 
        TftSetOrientation(bOrientation) 
                            
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            'Porch Setting: Disable separate porch control, 0xC in normal mode, 0x3 in idle and partial modes
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xB2)
            PinSet TFT_DC
                TftSend(0x0C)
                TftSend(0x0C)
                TftSend(0x00)
                TftSend(0x33)
                TftSend(0x33)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xB2 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x0c 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x33  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x33  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        'Gate Control: VGH = 13.26V, VGL = -10.43V
        Tft2bWriteCommand(0xB7, 0x35)
        'VCOM Setting: 0.725V
        Tft2bWriteCommand(0xBB, 0x19)
        'LCM Control: XBGR, XMX, XMH
        Tft2bWriteCommand(0xC0, 0x2C)
        'VDV and VRH Command Enable: VDV and VRH register value comes from command write
        Tft2bWriteCommand(0xC2, 0x01)
        'VRH Set: 4.45V + (vcom + vcom offset + vdv)
        Tft2bWriteCommand(0xC3, 0x12)
        'VDV Set: 0V
        Tft2bWriteCommand(0xC4, 0x20)
        'Frame Rate Control in Normal Mode: 60Hz
        Tft2bWriteCommand(0xC6, 0x0F)
        'Power Control 1: AVDD = 6.8V, AVCL = -4.8V, VDDS = 2.3V
        Tft3bWriteCommand(0xD0, 0xA4, 0xA1)
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            'Positive Voltage Gamma Control
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE0)
            PinSet TFT_DC
                TftSend(0xD0)
                TftSend(0x04)
                TftSend(0x0D)
                TftSend(0x11)
                TftSend(0x13)
                TftSend(0x2B)
                TftSend(0x3F)
                TftSend(0x54)
                TftSend(0x4C)
                TftSend(0x18)
                TftSend(0x0D)
                TftSend(0x0B)
                TftSend(0x1F)
                TftSend(0x23)
            PinSet TFT_CS
            
            'Negative Voltage Gamma Control
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE1)
            PinSet TFT_DC
                TftSend(0xD0)
                TftSend(0x04)
                TftSend(0x0C)
                TftSend(0x11)
                TftSend(0x13)
                TftSend(0x2C)
                TftSend(0x3F)
                TftSend(0x44)
                TftSend(0x51)
                TftSend(0x2F)
                TftSend(0x1F)
                TftSend(0x1F)
                TftSend(0x20)
                TftSend(0x23)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xE0 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0xd0  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04 
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0d  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x11  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x13  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2b  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x54  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x4c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x18  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0d  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0b  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x23  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
            
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xe1
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0xd0  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x04  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x11  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x13  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2c  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x44  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x51  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x1f  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x20  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x23  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS     
        $endif
        
        'Pixel Format Set - RGB 565 Interface Format 65K /16 bits / pixel
        Tft2bWriteCommand(0x3A, %01010101) '%01010101=0x55 
        'CTRL Display
        Tft2bWriteCommand(0x53, %00001100)
        'Display Brightness
        Tft2bWriteCommand(0x51, 255)
        'Adaptive Brightness Control
        Tft2bWriteCommand(0x55, %10010011)
        'Interface Control - EPF = 01 / RM = 1 / RIM = 0
        Tft4bWriteCommand(0xF6, %00000001, %00010000, %00000000) 
        'Sleep Out
        Tft1bWriteCommand(0x11)
        DelayMS 120
        'Normal Display Mode On
        Tft1bWriteCommand(0x13)
        'Display ON
        Tft1bWriteCommand(0x29)
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %11110100)     
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset
            Tft2bWriteCommand(0x36, %01000000) 
        Case 2
            Tft2bWriteCommand(0x36, %00110000)
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset
            Tft2bWriteCommand(0x36, %10010000) 
    EndSelect
EndProc
