'Set up the screen
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  
'Origin is always bottom left corner and direction is left to right, bottom - up

Proc TftSetUp(bOrientation As Byte) 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinClear TFT_RESET     
            DelayMS 100 : PinSet TFT_RESET : DelayMS 100 
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_COM = PAR_2x8b
                Output TftDataLowByte
                Output TftDataHighByte
            $else
                Output TftDataWord                    
            $endif
            $ifdef T_CS
                PinSet T_CS
            $endif
            PinSet TFT_CS : PinSet TFT_WR : PinSet TFT_RD
            PinClear TFT_RESET : DelayMS 100 : PinSet TFT_RESET : DelayMS 100
        $endif
        
        'Sleep Out
        Tft1bWriteCommand(0x11)
        DelayMS 120
        'Command Set Control
        Tft2bWriteCommand(0xF0, 0xC3)
        Tft2bWriteCommand(0xF0, 0x96)
        'Interface Pixel Format
        Tft2bWriteCommand(0x3A, %01010101)
        'Display Inversion Control
        Tft2bWriteCommand(0xB4, 0x01)
        'Frame Rate Control 
        Tft3bWriteCommand(0xB1, 0xC0, 0x10)
        'Adaptive Brightness Contro
        Tft2bWriteCommand(0x55, %10000011)
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xB5)
            PinSet TFT_DC
                TftSend(0x02)
                TftSend(0x02)
                TftSend(0x00)
                TftSend(0x02)
            PinSet TFT_CS
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Blanking Porch Control
            PinClear TFT_CS 
            PinClear TFT_DC 
                TftDataLowByte = 0xB5 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x00  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x02  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
        $endif
        
        'Screen orientation 
        TftSetOrientation(bOrientation) 
        'Power Control 1
        Tft3bWriteCommand(0xC0, 0xf0, 0x17)
        'Power Control 2
        Tft2bWriteCommand(0xC1,0x14)
        'Power Control 3
        Tft2bWriteCommand(0xC2,0xA7)
        'VCOM Control
        Tft2bWriteCommand(0xC5,0x2E)
        
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE0)
            PinSet TFT_DC
                TftSend(0xf0)
                TftSend(0x0b)
                TftSend(0x11)
                TftSend(0x0b)
                TftSend(0x0a)
                TftSend(0x27)
                TftSend(0x3c)
                TftSend(0x55)
                TftSend(0x51)
                TftSend(0x37)
                TftSend(0x15)
                TftSend(0x17)
                TftSend(0x31)
                TftSend(0x35)
            PinSet TFT_CS 
            
            PinClear TFT_SCLK : PinClear TFT_DC
            PinClear TFT_CS
                TftSend(0xE1)
            PinSet TFT_DC
                TftSend(0x4e)
                TftSend(0x15)
                TftSend(0x19)
                TftSend(0x0b)
                TftSend(0x09)
                TftSend(0x27)
                TftSend(0x34)
                TftSend(0x32)
                TftSend(0x46)
                TftSend(0x38)
                TftSend(0x14)
                TftSend(0x16)
                TftSend(0x26)
                TftSend(0x2a)
            PinSet TFT_CS      
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            'Positive Gamma Contro
            PinClear TFT_CS
            PinClear TFT_DC 
                TftDataLowByte = 0xE0 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0xF0  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0B  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x11  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0B  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0A  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x27  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x3C  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x55  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x51  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x37  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x15  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x17  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x31  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x35  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS 
            
            'Negative Gamma Control
            PinClear TFT_CS
            PinClear TFT_DC 
                TftDataLowByte = 0xE1 
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_DC 
                TftDataLowByte = 0x4E  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x15  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x19  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x0B  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x09  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x27  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x34  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x32  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x46  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x38  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x14  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x16  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x26  
                PinClear TFT_WR : PinSet TFT_WR
                TftDataLowByte = 0x2A  
                PinClear TFT_WR : PinSet TFT_WR
            PinSet TFT_CS   
        $endif
                   
        'Command Set Control
        Tft2bWriteCommand(0xF0, 0x3C)
        Tft2bWriteCommand(0xF0, 0x69)
        'Normal Display Mode On
        Tft1bWriteCommand(0x13)
        'Display ON
        Tft1bWriteCommand(0x29)
EndProc

'Changes the screen point of origin
'bOrientation = Origin And Direction: Width x Height
'                                     0 = 320 x 240  
'                                     1 = 240 x 320 
'                                     2 = 320 x 240 inverse 
'                                     3 = 240 x 320 inverse  

Proc TftSetOrientation(bOrientation As Byte)
    Select bOrientation
        Case 0
            Tft2bWriteCommand(0x36, %10111000)    
        Case 1
            Swap wTftScreenWidth, wTftScreenHeight  
            Swap wTftWidthOffset, wTftHeightOffset
            Tft2bWriteCommand(0x36, %00011000)  
        Case 2
            Tft2bWriteCommand(0x36, %01111000)
        Case 3
            Swap wTftScreenWidth, wTftScreenHeight
            Swap wTftWidthOffset, wTftHeightOffset  
            Tft2bWriteCommand(0x36, %11011000) 
    EndSelect
EndProc
