Proc ______TFT_PRINT_BDF_____()
EndProc

'Print character from bdf font with parameters:
'bChar = character to print
'swX_Pos = x position for the lower left corner of this character
'swY_Pos = y position for the lower left corner of this character   
'wForeColor = character color (pixels, forming the character use this color)
'wBackColor = background color (pixels from the glyph box forming each character space will use this color)
'pTransparent = transparent font. Background color (wBackColor) will be ignored and only the pixels will be printed, this however is slower than using background color
'Example: TftPrintBdfChar("G", 1, 1, WHITE, BLACK, 0) --> 
'Print character "G" ; at coordinates x=1 ; y=1 ; font color White ; Background color Black ; not transparent font

Proc TftPrintBdfChar(bChar As Byte, swX_Pos As SWord, swY_Pos As SWord, wForeColor As Word, wBackColor As Word, pTransparent As Bit)
    Global Dim swCurrent_X_Position As SWord Shared
    Global Dim swCurrent_Y_Position As SWord Shared
    Global Dim BitmapOffsetStart As Word Shared
    Global Dim BitmapOffsetEnd As Word Shared
    Global Dim NextGlyphOffsetX As Byte Shared
    Global Dim NextGlyphOffsetY As Byte Shared
    Global Dim GlyphBbX As Byte Shared
    Global Dim GlyphBbY As Byte Shared
    Global Dim GlyphOffsetX As SByte Shared
    Global Dim GlyphOffsetY As SByte Shared
    
    Dim bTemp As Byte          
    Dim bCounter0 As Byte
    Dim bReadByte As Byte
    Dim bBitCounter As Byte
    Dim bRowBitCounter As Byte
    Dim dwCounter0 As Dword         At dwDummy2
    Dim dwCounter1 As Dword         At dwDummy3
    Dim bChHByteCount As Byte
    Dim pPrintBit As Bit
    Dim pLineStartSet As Byte  
    Dim pLineEndSet As Byte    
    Dim wLineStart As Word
    Dim wLineEnd As Word
    Dim swCurChPosiX As SWord       At dwDummy1.Word0
    Dim swCurChPosiY As SWord       At dwDummy1.Word1
    Dim swTmpChPosY As SWord
    
    If bChar < AsciiStartOffset Then
        bChar = 0
    Else
        bChar = bChar - AsciiStartOffset
    EndIf    
         
    TftGlyphProp(bChar)

    If pTransparent = 1 Then 
        swCurChPosiX = swX_Pos + GlyphOffsetX
        swCurChPosiY = swY_Pos + GlyphOffsetY
        
        If GlyphBbX // 8 = 0 Then
            bChHByteCount = GlyphBbX / 8
        Else
            bChHByteCount = 1 + GlyphBbX / 8
        EndIf
        
        swTmpChPosY = 0 : pLineStartSet = 0 : pLineEndSet = 0
        For dwCounter0 = BitmapOffsetEnd - bChHByteCount DownTo BitmapOffsetStart Step bChHByteCount      
            bRowBitCounter = GlyphBbX
            For dwCounter1 = dwCounter0 To dwCounter0 + bChHByteCount - 1
                bReadByte = TftBitmapRead(dwCounter1)
                bBitCounter = 8
                Do
                    If pLineStartSet = 0 Then
                        Do
                            Dec bBitCounter
                            pPrintBit = GetBit bReadByte, bBitCounter
                            If pPrintBit = 1 Then
                                wLineStart = swCurChPosiX + GlyphBbX - bRowBitCounter
                                pLineStartSet = 1
                            EndIf
                            Dec bRowBitCounter
                        Loop Until pLineStartSet = 1 Or bBitCounter = 0 Or bRowBitCounter = 0
                    EndIf
                
                    If pLineStartSet = 1 Then
                        While bBitCounter > 0 And bRowBitCounter > 0
                            Dec bBitCounter
                            pPrintBit = GetBit bReadByte, bBitCounter
                            Dec bRowBitCounter
                            If pPrintBit = 0 Then
                                wLineEnd = swCurChPosiX + GlyphBbX - bRowBitCounter - 2
                                pLineEndSet = 1
                                Break
                            EndIf
                        Wend
                        If pLineStartSet = 1 And pLineEndSet = 1 Then
                            pLineEndSet = 0
                            pLineStartSet = 0
                            $if TftPixelCheck = 1
                                wTempHorizontal = wLineStart : wTempVertical = swCurChPosiY + swTmpChPosY : pOutOfScreen = 1 
                                If wTempHorizontal < TftScreenWidth And wTempVertical < TftScreenHeight Then
                                    pOutOfScreen = 0
                                    If wLineEnd >= TftScreenWidth Then   
                                        wLineEnd = TftScreenWidth - 1
                                        pOutOfScreen = 1
                                    EndIf  
                                    TftLineHN(wLineStart, wLineEnd, swCurChPosiY + swTmpChPosY, wForeColor)
                                EndIf
                            $else
                                TftLineHN(wLineStart, wLineEnd, swCurChPosiY + swTmpChPosY, wForeColor)
                            $endif
                        EndIf
                        If bRowBitCounter = 0 And pLineStartSet = 1 Then
                            pLineEndSet = 0
                            pLineStartSet = 0
                            $if TftPixelCheck = 1
                                wTempHorizontal = wLineStart : wTempVertical = swCurChPosiY + swTmpChPosY : pOutOfScreen = 1
                                If wTempHorizontal < TftScreenWidth And wTempVertical < TftScreenHeight Then
                                    wTempHorizontal = swCurChPosiX + GlyphBbX - 1
                                    If wTempHorizontal >= TftScreenWidth Then   
                                        TftLineHN(wLineStart, TftScreenWidth - 1, swCurChPosiY + swTmpChPosY, wForeColor)
                                    Else
                                        pOutOfScreen = 0
                                        TftLineHN(wLineStart, swCurChPosiX + GlyphBbX - 1, swCurChPosiY + swTmpChPosY, wForeColor)
                                    EndIf  
                                EndIf
                            $else
                                TftLineHN(wLineStart, swCurChPosiX + GlyphBbX - 1, swCurChPosiY + swTmpChPosY, wForeColor)
                            $endif
                        EndIf
                    EndIf
                    
                Loop Until bBitCounter = 0 Or bRowBitCounter = 0
                If bRowBitCounter = 0 Then Break
            Next
            Inc swTmpChPosY
        Next
    EndIf

    If pTransparent = 0 Then
        $if TftPixelCheck = 1
            wTempHorizontal = swX_Pos + GlyphOffsetX : wTempVertical = swY_Pos + GlyphOffsetY : pOutOfScreen = 1
            If wTempHorizontal < TftScreenWidth And wTempVertical < TftScreenHeight Then 
                pOutOfScreen = 0
                wTempHorizontal = swX_Pos + GlyphOffsetX + GlyphBbX - 1 : wTempVertical = swY_Pos + GlyphOffsetY + GlyphBbY - 1
                If wTempHorizontal >= TftScreenWidth Then 
                    wTempHorizontal = TftScreenWidth - 1
                    pOutOfScreen = 1
                EndIf
                If wTempVertical >= TftScreenHeight Then 
                    wTempVertical = TftScreenHeight - 1
                    pOutOfScreen = 1
                EndIf
                TftSetWindow(swX_Pos + GlyphOffsetX, wTempHorizontal, swY_Pos + GlyphOffsetY, wTempVertical)
            Else
                ExitProc
            EndIf
        $else
            TftSetWindow(swX_Pos + GlyphOffsetX, swX_Pos + GlyphOffsetX + GlyphBbX - 1, swY_Pos + GlyphOffsetY, swY_Pos + GlyphOffsetY + GlyphBbY - 1)
        $endif
     
        If GlyphBbX // 8 = 0 Then
            bChHByteCount = GlyphBbX / 8
        Else
            bChHByteCount = 1 + GlyphBbX / 8
        EndIf
    
        TftInitiateDataRam()

        For dwCounter0 = BitmapOffsetEnd - bChHByteCount DownTo BitmapOffsetStart Step bChHByteCount
            bRowBitCounter = GlyphBbX
            For dwCounter1 = dwCounter0 To dwCounter0 + bChHByteCount - 1
                bReadByte  = TftBitmapRead(dwCounter1)
                For bBitCounter = 7 DownTo 0
                    pPrintBit = GetBit bReadByte, bBitCounter 
                    If pPrintBit = 0 Then
                        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
                            $if TFT_IC = ILI9488 
                                Rgb16ToRgb18(wBackColor) 
                                TftSend(dColor.Byte2)
                                TftSend(dColor.Byte1)
                                TftSend(dColor.Byte0)  
                            $else
                                TftSend(wBackColor.Byte1)
                                TftSend(wBackColor.Byte0)  
                            $endif  
                        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
                            TftSend(wBackColor)
                        $endif
                    Else
                        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
                            $if TFT_IC = ILI9488 
                                Rgb16ToRgb18(wForeColor) 
                                TftSend(dColor.Byte2)
                                TftSend(dColor.Byte1)
                                TftSend(dColor.Byte0)  
                            $else
                                TftSend(wForeColor.Byte1)
                                TftSend(wForeColor.Byte0)  
                            $endif  
                        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
                            TftSend(wForeColor)
                        $endif
                    EndIf   
                    Dec bRowBitCounter
                    If bRowBitCounter = 0 Then Break
                Next
                If bRowBitCounter = 0 Then Break
            Next
        Next
        TftStopDataRam()
    EndIf 
     
    swCurrent_X_Position = swCurrent_X_Position + NextGlyphOffsetX
    swCurrent_Y_Position = swCurrent_Y_Position + NextGlyphOffsetY 
EndProc


'Print a signed integer with parameters:
'sdInteger = signed integer to print
'bDigits = number of digits to print, if bDigits is larger than the number of significant digits, leading zeroes will be printed
'                                     if bDigits is smaller than the number of significant digits, only bDigits digits will be printed
'                                     if bDigits is 0 then the significant digits will be automatically printed 
'wX_Pos = x position for the lower left corner of this character
'wY_Pos = y position for the lower left corner of this character   
'wForeColor = character color (pixels, forming the character use this color)
'wBackColor = background color (pixels from the 10x10 box forming each character space will use this color)
'pTransparent = transparent font. Background color (wBackColor) will be ignored and only the pixels will be printed, this however is slower than using background color
'Example: TftPrintBdfInteger(-12345, 7, 1, 1, WHITE, BLACK, 0) --> 
'Print integer -12345 ; 7 significant digits ; font size 2x ; at coordinates x=1 ; y=1 ; coordinates are absolute ; font color White ; Background color Black ; not transparent font

Proc TftPrintBdfInteger(sdInteger As SDword, bDigits As Byte, wX_Pos As Word, wY_Pos As Word, wForeColor As Word, wBackColor As Word, pTransparent As Bit)
    Select bDigits
        Case 1
            sTftString = Str$(SDec1 sdInteger)
        Case 2
            sTftString = Str$(SDec2 sdInteger)
        Case 3
            sTftString = Str$(SDec3 sdInteger)
        Case 4
            sTftString = Str$(SDec4 sdInteger)
        Case 5
            sTftString = Str$(SDec5 sdInteger)
        Case 6
            sTftString = Str$(SDec6 sdInteger)
        Case 7
            sTftString = Str$(SDec7 sdInteger)
        Case 8
            sTftString = Str$(SDec8 sdInteger)
        Case 9
            sTftString = Str$(SDec9 sdInteger)
        Case 10
            sTftString = Str$(SDec10 sdInteger)
        Case Else
            sTftString = Str$(SDec sdInteger)
    EndSelect

    TftPrintBdfString(sTftString, wX_Pos, wY_Pos, 0, 0, wForeColor, wBackColor, pTransparent)
EndProc

'Print a signed decimal with parameters:
'fDec = signed decimal to print
'bSigDigits = number of significant digits to print, if bSigDigits is larger than the number of significant digits, leading zeroes will be printed
'                                                    if bSigDigits is smaller than the number of significant digits, only bSigDigits digits will be printed
'                                                    if bSigDigits = 0 then the number of significant digits will be automatically printed 
'bDecDigits = number of decimal digits to print, if bDecDigits is larger than the number of decimal digits, trailing zeroes will be printed
'                                                if bDecDigits is smaller than the number of decimal digits, only bDecDigits digits will be printed
'                                                if bDecDigits is 0 then a signed integer will be printed 
'wX_Pos = x position for the lower left corner of this character
'wY_Pos = y position for the lower left corner of this character   
'wForeColor = character color (pixels, forming the character use this color)
'wBackColor = background color (pixels from the 10x10 box forming each character space will use this color)
'pTransparent = transparent font. Background color (wBackColor) will be ignored and only the pixels will be printed, this however is slower than using background color
'Example: TftPrintBdfDecimal(-12345.678, 7, 4, 0, 0, WHITE, BLACK, 0) --> 
'Print decimal -12345.678 ; 7 significant digits ; 4 decimal digits ; font size 2x ; at coordinates x=1 ; y=1 ; coordinates are absolute ; font color White ; Background color Black ; not transparent font

Proc TftPrintBdfDecimal(fDec As Float, bSigDigits As Byte, bDecDigits As Byte, wX_Pos As Word, wY_Pos As Word, wForeColor As Word, wBackColor As Word, pTransparent As Bit)
    Dim sdwTemp As SDword
    
    sdwTemp = fDec
    
    If bDecDigits = 0 Then
        TftPrintBdfInteger(fDec, bSigDigits, wX_Pos, wY_Pos, wForeColor, wBackColor, pTransparent)
        ExitProc
    EndIf
    
    Clear sTftString
    sdwTemp = Abs(fDec)
    If fDec < 0 Then
        sTftString = "-"
    EndIf

    Select bSigDigits
        Case 1
            sTftString = sTftString + Str$(SDec1 sdwTemp) + "."
        Case 2
            sTftString = sTftString + Str$(SDec2 sdwTemp) + "."
        Case 3
            sTftString = sTftString + Str$(SDec3 sdwTemp) + "."
        Case 4
            sTftString = sTftString + Str$(SDec4 sdwTemp) + "."
        Case 5
            sTftString = sTftString + Str$(SDec5 sdwTemp) + "."
        Case 6
            sTftString = sTftString + Str$(SDec6 sdwTemp) + "."
        Case 7
            sTftString = sTftString + Str$(SDec7 sdwTemp) + "."
        Case 8
            sTftString = sTftString + Str$(SDec8 sdwTemp) + "."
        Case 9
            sTftString = sTftString + Str$(SDec9 sdwTemp) + "."
        Case 10
            sTftString = sTftString + Str$(SDec10 sdwTemp) + "."
        Case Else
            sTftString = sTftString + Str$(SDec sdwTemp) + "."
    EndSelect

    sdwTemp.Dword = Abs(fDec) 
    fDec = Abs(fDec) - sdwTemp.Dword 

    Select bDecDigits
        Case 2
            fDec = fDec * 100
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec2 sdwTemp.Dword)
        Case 3
            fDec = fDec * 1000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec3 sdwTemp.Dword)
        Case 4
            fDec = fDec * 10000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec4 sdwTemp.Dword)
        Case 5
            fDec = fDec * 100000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec5 sdwTemp.Dword)
        Case 6
            fDec = fDec * 1000000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec6 sdwTemp.Dword)
        Case 7
            fDec = fDec * 10000000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec7 sdwTemp.Dword)
        Case 8
            fDec = fDec * 100000000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec8 sdwTemp.Dword)
        Case 9
            fDec = fDec * 1000000000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec9 sdwTemp.Dword)
        Case 10
            fDec = fDec * 10000000000
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec10 sdwTemp.Dword)
        Case Else
            fDec = fDec * 10
            sdwTemp.Dword = fDec
            sTftString = sTftString + Str$(Dec1 sdwTemp.Dword)
    EndSelect

    TftPrintBdfString(sTftString, wX_Pos, wY_Pos, 0, 0, wForeColor, wBackColor, pTransparent)
EndProc

'Print a string with bdf font with parameters:
'sString = null-terminated string to print up to 80 characters
'swX_Pos = x position for the lower left corner of the start character
'swY_Pos = y position for the lower left corner of the start character   
'wEndOfLine = x position of the last character in line
'bBreakLine = how to break long words to new lines : 0 = do nothing 
'                                                    1 = break the line and overflow from swX_Pos
'                                                    2 = break the line and continue from swX_Pos and a new line (swY_Pos - 1 line) 
'                                                    3 = break the line and continue from x = 0
'                                                    4 = Break the Line and Continue from x = 0 and a new Line (swY_Pos - 1 Line) 
'wForeColor = character color (pixels, forming the character use this color)
'wBackColor = background color (pixels from the 10x10 box forming each character space will use this color)
'pTransparent = transparent font. Background color (wBackColor) will be ignored and only the pixels will be printed, this however is slower than using background color
'Example: TftPrintBdfString("TEST", 1, 1, 310, 0, WHITE, BLACK, 0) --> 
'Print string "TEST" ; at coordinates x=1 ; y=1 ; last character position 310, do not break line ; font color White ; Background color Black ; not transparent font

Proc TftPrintBdfString(sString As sTftString, swX_Pos As SWord, swY_Pos As SWord, wEndOfLine As Word, bBreakLine As Byte, wForeColor As Word, wBackColor As Word, pTransparent As Bit)
    Global Dim swCurrent_X_Position As SWord Shared
    Global Dim swCurrent_Y_Position As SWord Shared
    Global Dim NextGlyphOffsetX As Byte Shared
    
    Dim NextGlyphBbX As Byte 
    Dim wStringCounter As Byte
    
    If wEndOfLine <= swX_Pos Then wEndOfLine = wTftScreenWidth - 1
    
    swCurrent_X_Position = swX_Pos
    swCurrent_Y_Position = swY_Pos
    
    For wStringCounter = 0 To 71
        If sString[wStringCounter] <> 0 Then
            If sString[wStringCounter] = 0x0A Then
                swCurrent_X_Position = swX_Pos 'CR
                swCurrent_Y_Position = swCurrent_Y_Position - BoundingBoxHeight 'NL
                If swCurrent_Y_Position < 0 Then Break
            Else
                TftPrintBdfChar(sString[wStringCounter], swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent)
            EndIf
        Else
            Break
        EndIf
        
        If sString[wStringCounter + 1] <> 0 Then
            GlyphOffsetX = TftGlyphStepBbX(sString[wStringCounter + 1] - AsciiStartOffset) 
            NextGlyphOffsetX = TftGlyphStepBbX(sString[wStringCounter + 1] - AsciiStartOffset)  
            If swCurrent_X_Position + GlyphOffsetX + NextGlyphOffsetX >= wEndOfLine Then
                If bBreakLine = 4 Then
                    swCurrent_X_Position = 0 'CR
                    swCurrent_Y_Position = swCurrent_Y_Position - BoundingBoxHeight  'NL
                ElseIf bBreakLine = 3 Then
                    swCurrent_X_Position = 0 'CR
                ElseIf bBreakLine = 2 Then
                    swCurrent_X_Position = swX_Pos 'CR
                    swCurrent_Y_Position = swCurrent_Y_Position - BoundingBoxHeight  'NL
                ElseIf bBreakLine = 1 Then
                    swCurrent_X_Position = swX_Pos 'CR
                Else
                    Break
                EndIf
            EndIf
            If swCurrent_Y_Position < 0 Then Break
        EndIf
    Next      
EndProc

'Print a text from a Flash table with bdf font in virtual rectangle box top to bottom with parameters:
'dwFlashAddress = holds the address in Flash memory To start reading from
'swX_Pos = x position for the upper left corner of the virtual box
'swY_Pos = y position for the upper left corner of the virtual box
'wEndOfLine = x position for the lower right corner of the virtual box
'wEndOfPage = y position for the lower right corner of the virtual box
'pBreakLine = how to break long words to new lines : 0 = breaks the line if there's not enough space for the next character, new lines are 1character left trimmed 
'                                                       (could leave or translate 1 character at the end of the line)    
'                                                    1 = looks forward through and if the translation would result in one character at the end of the line or 
'                                                        one character being translated, will break the word to at least two characters or translate the word to a new line 
'wForeColor = character color (pixels, forming the character use this color)
'wBackColor = background color (pixels from the box forming each character space will use this color)
'pTransparent = transparent font. Background color (wBackColor) will be ignored and only the pixels will be printed, this however is slower than using background color
'bPrintMode = will select the way how the text is displayed if the text can not fit in the screen:
'             0 = print a page then stop 
'             1 to 60 = screen turn page with this number as delay in seconds 
'             61 to 100 = typewriter style when characters are printed with delay between them, delay is 5 * (bPrintMode - 60) ms
'             101 To 160 = screen turn page with delay this number *0.5 in seconds + typewriter style when characters are printed with delay between them, delay is 5 * (bPrintMode - 100) ms 
'Example: TftPrintBdfText(myText, 20, 220, 300, 20, 1, RED, BLACK, 1, 104) --> 
'Print text from Flash table "MyText" ; in box with coordinates x1=20 ; y1=220, x3=300, y3=20; break lines looking forward; font color RED; Background color Black ; transparent font, typewriter style with turning page

Proc TftPrintBdfText(ByRef dwFlashAddress As Dword, swX_Pos As SWord, swY_Pos As SWord, wEndOfLine As Word, wEndOfPage As Word, pBreakLine As Byte, wForeColor As Word, wBackColor As Word, pTransparent As Bit, bPrintMode As Byte)
    Global Dim swCurrent_X_Position As SWord Shared
    Global Dim swCurrent_Y_Position As SWord Shared
    Global Dim BitmapOffsetStart As Word Shared
    Global Dim BitmapOffsetEnd As Word Shared
    Global Dim NextGlyphOffsetX As Byte Shared
    Global Dim NextGlyphOffsetY As Byte Shared
    Global Dim GlyphBbX As Byte Shared
    Global Dim GlyphBbY As Byte Shared
    Global Dim GlyphOffsetX As SByte Shared
    Global Dim GlyphOffsetY As SByte Shared
    
    Dim pTestBit As Byte
    Dim bTempChar As Byte
    Dim wTableCounter As Word
    Dim wCounter As Word
    Dim wWordLen As Word
    Dim swSumX As SWord
    Dim bLastCount As Byte
    Dim bTemp As Byte
    Dim bTemp1 As Byte
    Dim wFirstLineEnd As Word
    Dim pLineEndSet As Byte 

    swCurrent_X_Position = swX_Pos 
    swCurrent_Y_Position = swY_Pos 
    wEndOfPage = wEndOfPage + 1
    wTableCounter = 0
           
PrintStart:    
    pLineEndSet = 0    
    bTempChar = CRead8 dwFlashAddress[wTableCounter]
    If bTempChar = 0 Then ExitProc
    While bTempChar <> 0
        If swCurrent_Y_Position < wEndOfPage Then Break 

        If pBreakLine = 0 Then
            If bTempChar = 0x0A Then
                GoSub NewLine  
                If swCurrent_Y_Position < wEndOfPage Then Break 
                Inc wTableCounter
                GoTo PrintTextJump
            EndIf

            NextGlyphOffsetX = TftGlyphStepBbX(bTempChar - AsciiStartOffset)
            GlyphOffsetX = TftGlyphStepBbOffX(bTempChar - AsciiStartOffset)
            If swCurrent_X_Position + NextGlyphOffsetX + GlyphOffsetX > wEndOfLine Then
                GoSub NewLine
                If swCurrent_Y_Position < wEndOfPage Then Break 
                If bTempChar = 0x20 Then 
                    Inc wTableCounter
                Else
                    bTempChar = CRead8 dwFlashAddress[wTableCounter]
                    Inc wTableCounter  
                    TftPrintDelay(bPrintMode)                                                
                    TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent)
                EndIf
            Else
                bTempChar = CRead8 dwFlashAddress[wTableCounter]
                Inc wTableCounter 
                TftPrintDelay(bPrintMode)
                TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent)
            EndIf
        EndIf
        
        If pBreakLine = 1 Then
            If bTempChar = 0x0A Then
                GoSub NewLine
                If swCurrent_Y_Position < wEndOfPage Then Break  
                Inc wTableCounter
                GoTo PrintTextJump
            EndIf
            
            wCounter = 0 : swSumX = 0
            Do 
                GoSub SumHoriz
                Inc wCounter 
            Loop Until bTempChar = 0 Or bTempChar = 0x20 Or bTempChar = 0x0A
            
            If bTempChar = 0 Then Dec wCounter
         
            wWordLen = wCounter
            
            If swCurrent_X_Position + swSumX < wEndOfLine Then
                For wCounter = 0 To wWordLen - 1
                    bTempChar = CRead8 dwFlashAddress[wTableCounter]
                    Inc wTableCounter
                    If bTempChar = 0 Then Break
                    If bTempChar = 0x0A Then
                        GoSub NewLine  
                        If swCurrent_Y_Position < wEndOfPage Then Break 
                    Else
                        TftPrintDelay(bPrintMode)
                        TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                    EndIf 
                Next
                If bTempChar = 0 Then Break
                GoTo PrintTextJump
            EndIf 
            
            If swCurrent_X_Position + swSumX >= wEndOfLine Then
                Select wWordLen
                    Case 1
                        bTempChar = CRead8 dwFlashAddress[wTableCounter]  
                        If bTempChar = 0 Then Break
                        GoSub NewLine
                        If swCurrent_Y_Position < wEndOfPage Then Break  
                        Inc wTableCounter
                        GoTo PrintTextJump
                    Case 2
                        bTempChar = CRead8 dwFlashAddress[wTableCounter]     
                        GlyphOffsetX = TftGlyphStepBbOffX(bTempChar - AsciiStartOffset)
                        NextGlyphOffsetX = TftGlyphStepBbX(bTempChar - AsciiStartOffset)
                        If swCurrent_X_Position + NextGlyphOffsetX + GlyphOffsetX < wEndOfLine Then 
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            Inc wTableCounter
                            TftPrintDelay(bPrintMode)
                            TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            If bTempChar = 0 Then 
                                Break
                            Else
                                GoSub NewLine
                                If swCurrent_Y_Position < wEndOfPage Then Break  
                                Inc wTableCounter
                            EndIf   
                        Else
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            Inc wTableCounter
                            TftPrintDelay(bPrintMode)
                            TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            If bTempChar = 0 Then 
                                Break
                            Else
                                bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                Inc wTableCounter
                                If bTempChar = 0x0A Then
                                    GoSub NewLine  
                                    If swCurrent_Y_Position < wEndOfPage Then Break 
                                Else
                                    TftPrintDelay(bPrintMode)
                                    TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                EndIf 
                            EndIf     
                        EndIf
                    Case 3, 4
                        swSumX = 0
                        For wCounter = 0 To wWordLen - 2
                            GoSub SumHoriz
                        Next
                        If swCurrent_X_Position + swSumX < wEndOfLine Then
                            For wCounter = 0 To wWordLen - 1
                                bTempChar = CRead8 dwFlashAddress[wTableCounter] 
                                If bTempChar = 0 Then Break 
                                Inc wTableCounter
                                If bTempChar = 0x20 Then Break
                                If bTempChar = 0x0A Then
                                    GoSub NewLine 
                                    If swCurrent_Y_Position < wEndOfPage Then Break 
                                Else
                                    TftPrintDelay(bPrintMode)
                                    TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                EndIf
                            Next
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                            If bTempChar = 0 Then Break
                        Else
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                            For wCounter = 0 To wWordLen - 1
                                bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                If bTempChar = 0 Then Break 
                                Inc wTableCounter
                                If bTempChar = 0x0A Then
                                    GoSub NewLine  
                                    If swCurrent_Y_Position < wEndOfPage Then Break 
                                Else
                                    TftPrintDelay(bPrintMode)
                                    TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                EndIf
                            Next
                            
                            If bTempChar = 0 Then Break 
                        EndIf
                        GoTo PrintTextJump
                    Case 5
                        bTempChar = CRead8 dwFlashAddress[wTableCounter + 3]  
                        pTestBit = 1    
                        Select bTempChar
                            Case 0x41 To 0x5A
                                pTestBit = 0
                            Case 0x61 To 0x7A
                                pTestBit = 0
                        EndSelect
                        
                        If pTestBit = 1 Then
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                            For wCounter = 0 To wWordLen - 1
                                bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                If bTempChar = 0 Then Break 
                                Inc wTableCounter
                                If bTempChar = 0x0A Then
                                    GoSub NewLine 
                                    If swCurrent_Y_Position < wEndOfPage Then Break 
                                Else
                                    TftPrintDelay(bPrintMode)
                                    TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                EndIf
                            Next
                            
                            If bTempChar = 0 Then Break 
                        Else
                            swSumX = 0
                            For wCounter = 0 To 3
                                GoSub SumHoriz
                            Next
                            If swCurrent_X_Position + swSumX < wEndOfLine Then
                                For wCounter = 0 To 3
                                    bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                    Inc wTableCounter
                                    If bTempChar = 0x0A Then
                                        GoSub NewLine  
                                        If swCurrent_Y_Position < wEndOfPage Then Break 
                                    Else
                                        TftPrintDelay(bPrintMode)
                                        TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                    EndIf
                                Next
                                GoSub NewLine
                                If swCurrent_Y_Position < wEndOfPage Then Break  
                                bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                Inc wTableCounter
                                If bTempChar = 0 Then Break 
                            Else
                                swSumX = 0
                                For wCounter = 0 To 1
                                    GoSub SumHoriz
                                Next 
                                If swCurrent_X_Position + swSumX < wEndOfLine Then
                                    For wCounter = 0 To 1
                                        bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                        Inc wTableCounter
                                        TftPrintDelay(bPrintMode)                                            
                                        TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                    Next
                                    GoSub NewLine  
                                    If swCurrent_Y_Position < wEndOfPage Then Break  
                                    For wCounter = 2 To wWordLen - 1
                                        bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                        If bTempChar = 0 Then Break 
                                        Inc wTableCounter
                                        If bTempChar = 0x0A Then
                                            GoSub NewLine 
                                            If swCurrent_Y_Position < wEndOfPage Then Break 
                                        Else
                                            TftPrintDelay(bPrintMode)
                                            TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                        EndIf
                                    Next
                                Else
                                    GoSub NewLine
                                    If swCurrent_Y_Position < wEndOfPage Then Break  
                                    For wCounter = 0 To wWordLen - 1
                                        bTempChar = CRead8 dwFlashAddress[wTableCounter]
                                        If bTempChar = 0 Then Break 
                                        Inc wTableCounter
                                        If bTempChar = 0x0A Then
                                            GoSub NewLine   
                                            If swCurrent_Y_Position < wEndOfPage Then Break 
                                        Else
                                            TftPrintDelay(bPrintMode)
                                            TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                                        EndIf
                                    Next
                            
                                    If bTempChar = 0 Then Break     
                                EndIf 
                            EndIf
                        EndIf 
                        GoTo PrintTextJump
                    Case Else
                        bTempChar = CRead8 dwFlashAddress[wTableCounter + wWordLen - 2]
                        bLastCount = 4   
                        Select bTempChar
                            Case 0x41 To 0x5A
                                bLastCount = 3
                            Case 0x61 To 0x7A
                                bLastCount = 3
                        EndSelect 
                        swSumX = 0
                        For wCounter = 0 To 1
                            GoSub SumHoriz
                        Next
                        If swCurrent_X_Position + swSumX >= wEndOfLine Then 
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                        EndIf
                        
                        For wCounter = 0 To wWordLen - bLastCount - 1
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            Inc wTableCounter
                            If bTempChar = 0 Then Break 
                            GlyphOffsetX = TftGlyphStepBbOffX(bTempChar - AsciiStartOffset)
                            NextGlyphOffsetX = TftGlyphStepBbX(bTempChar - AsciiStartOffset)
                            If swCurrent_X_Position + NextGlyphOffsetX + GlyphOffsetX >= wEndOfLine Then  
                                GoSub NewLine
                                If swCurrent_Y_Position < wEndOfPage Then Break  
                            EndIf
                            TftPrintDelay(bPrintMode)    
                            TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                        Next
                        If swCurrent_Y_Position < wEndOfPage Then GoTo PrintTextJump
                        
                        swSumX = 0
                        For wCounter = wWordLen - bLastCount To wWordLen - 1
                            GoSub SumHoriz
                        Next
                        If swCurrent_X_Position + swSumX >= wEndOfLine Then 
                            GoSub NewLine
                            If swCurrent_Y_Position < wEndOfPage Then Break  
                        EndIf
                        
                        For wCounter = wWordLen - bLastCount To wWordLen - 1
                            bTempChar = CRead8 dwFlashAddress[wTableCounter]
                            Inc wTableCounter
                            If bTempChar = 0 Then Break  
                            If bTempChar = 0x0A Then
                                GoSub NewLine  
                                If swCurrent_Y_Position < wEndOfPage Then Break 
                            Else
                                TftPrintDelay(bPrintMode)
                                TftPrintBdfChar(bTempChar, swCurrent_X_Position, swCurrent_Y_Position, wForeColor, wBackColor, pTransparent) 
                            EndIf
                        Next
                        
                        If bTempChar = 0 Then Break  
                EndSelect
            EndIf
        EndIf
        GoTo PrintTextJump 
SumHoriz:
        bTempChar = CRead8 dwFlashAddress[wTableCounter + wCounter]
        If bTempChar <> 0 Then
            GlyphOffsetX = TftGlyphStepBbOffX(bTempChar - AsciiStartOffset)
            NextGlyphOffsetX = TftGlyphStepBbX(bTempChar - AsciiStartOffset)
            swSumX = swSumX + NextGlyphOffsetX + GlyphOffsetX
        EndIf
        Return        
NewLine:
        swCurrent_X_Position = swX_Pos 
        swCurrent_Y_Position = swCurrent_Y_Position - BoundingBoxHeight 'NL 
        If pLineEndSet = 0 Then
            pLineEndSet = 1
            wFirstLineEnd = wTableCounter
        EndIf 
        Return                     
PrintTextJump:     
        If swCurrent_Y_Position < wEndOfPage Then Break          
        bTempChar = CRead8 dwFlashAddress[wTableCounter]
        If bTempChar = 0 Then Break
    Wend  
    
    If bPrintMode = 0 Or bTempChar = 0 Then ExitProc

    If bPrintMode > 0 And bPrintMode < 61 And bTempChar <> 0 Then
        For bTemp = 0 To bPrintMode
            DelayMS 1000
        Next
        swCurrent_X_Position = swX_Pos 
        swCurrent_Y_Position = swY_Pos 
        
        TftRectangleSNTC(swX_Pos, wEndOfPage - 1, wEndOfLine, swY_Pos + BoundingBoxHeight, wBackColor)
        bTempChar = CRead8 dwFlashAddress[wTableCounter]
        GoTo PrintStart        
    EndIf 
    
    If bPrintMode > 100 And bPrintMode < 161 And bTempChar <> 0 Then
        For bTemp = 0 To bPrintMode - 100
            DelayMS 500
        Next
        swCurrent_X_Position = swX_Pos 
        swCurrent_Y_Position = swY_Pos 
        
        TftRectangleSNTC(swX_Pos, wEndOfPage - 1, wEndOfLine, swY_Pos + BoundingBoxHeight, wBackColor)
        bTempChar = CRead8 dwFlashAddress[wTableCounter]
        GoTo PrintStart        
    EndIf 
EndProc


'Select the BDF font to be used as indexed tables and sets the parameters for this 
  
Proc TftSetBdfFont(bCurrentFont As Byte)
    Global Dim BoundingBoxWidth As Byte Shared
    Global Dim BoundingBoxHeight As Byte Shared
    Global Dim BoundingBoxX As SByte Shared
    Global Dim BoundingBoxY As SByte Shared
    Global Dim AsciiStartOffset As Byte Shared
    Global Dim FontSet As Byte Shared
    
    Select bCurrentFont
        Case 0
            $ifdef Font0
                BoundingBoxWidth = BoundingBoxWidth0
                BoundingBoxHeight = BoundingBoxHeight0
                BoundingBoxX = BoundingBoxX0
                BoundingBoxY = BoundingBoxY0
                AsciiStartOffset = AsciiStartOffset0
                FontSet = 0  
            $endif
        Case 1
            $ifdef Font1
                BoundingBoxWidth = BoundingBoxWidth1
                BoundingBoxHeight = BoundingBoxHeight1
                BoundingBoxX = BoundingBoxX1
                BoundingBoxY = BoundingBoxY1
                AsciiStartOffset = AsciiStartOffset1
                FontSet = 1 
            $endif
        Case 2
            $ifdef Font2
                BoundingBoxWidth = BoundingBoxWidth2
                BoundingBoxHeight = BoundingBoxHeight2
                BoundingBoxX = BoundingBoxX2
                BoundingBoxY = BoundingBoxY2
                AsciiStartOffset = AsciiStartOffset2
                FontSet = 2 
            $endif
       Case 3
            $ifdef Font3
                BoundingBoxWidth = BoundingBoxWidth3
                BoundingBoxHeight = BoundingBoxHeight3
                BoundingBoxX = BoundingBoxX3
                BoundingBoxY = BoundingBoxY3
                AsciiStartOffset = AsciiStartOffset3
                FontSet = 3 
            $endif
        Case 4
            $ifdef Font4
                BoundingBoxWidth = BoundingBoxWidth4
                BoundingBoxHeight = BoundingBoxHeight4
                BoundingBoxX = BoundingBoxX4
                BoundingBoxY = BoundingBoxY4
                AsciiStartOffset = AsciiStartOffset4
                FontSet = 4  
            $endif
        Case 5
            $ifdef Font5
                BoundingBoxWidth = BoundingBoxWidth5
                BoundingBoxHeight = BoundingBoxHeight5
                BoundingBoxX = BoundingBoxX5
                BoundingBoxY = BoundingBoxY5
                AsciiStartOffset = AsciiStartOffset5
                FontSet = 5 
            $endif  
        Case 6
            $ifdef Font6
                BoundingBoxWidth = BoundingBoxWidth6
                BoundingBoxHeight = BoundingBoxHeight6
                BoundingBoxX = BoundingBoxX6
                BoundingBoxY = BoundingBoxY6
                AsciiStartOffset = AsciiStartOffset6
                FontSet = 6 
            $endif
        Case 7
            $ifdef Font7
                BoundingBoxWidth = BoundingBoxWidth7
                BoundingBoxHeight = BoundingBoxHeight7
                BoundingBoxX = BoundingBoxX7
                BoundingBoxY = BoundingBoxY7
                AsciiStartOffset = AsciiStartOffset7
                FontSet = 7 
            $endif
        Case 8
            $ifdef Font8
                BoundingBoxWidth = BoundingBoxWidth8
                BoundingBoxHeight = BoundingBoxHeight8
                BoundingBoxX = BoundingBoxX8
                BoundingBoxY = BoundingBoxY8
                AsciiStartOffset = AsciiStartOffset8
                FontSet = 8 
            $endif
        Case 9
            $ifdef Font9
                BoundingBoxWidth = BoundingBoxWidth9
                BoundingBoxHeight = BoundingBoxHeight9
                BoundingBoxX = BoundingBoxX9
                BoundingBoxY = BoundingBoxY9
                AsciiStartOffset = AsciiStartOffset9
                FontSet = 9     
            $endif
    EndSelect    
EndProc

'Read glyph properties according selected font 

Proc TftGlyphProp(bChar As Byte)
    Dim wTemp As Word
    wTemp = 2 * bChar 
    Select FontSet
        Case 0
            $ifdef Font0
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset0[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset0[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset0[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset0[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX0[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY0[bChar] 
                GlyphBbX = CRead8 BbX0[bChar]
                GlyphBbY = CRead8 BbY0[bChar]
                GlyphOffsetX = CRead8 BBOffsetX0[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY0[bChar]
            $endif
        Case 1
            $ifdef Font1
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset1[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset1[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset1[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset1[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX1[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY1[bChar]
                GlyphBbX = CRead8 BbX1[bChar]
                GlyphBbY = CRead8 BbY1[bChar]
                GlyphOffsetX = CRead8 BBOffsetX1[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY1[bChar] 
            $endif
        Case 2
            $ifdef Font2
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset2[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset2[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset2[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset2[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX2[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY2[bChar] 
                GlyphBbX = CRead8 BbX2[bChar]
                GlyphBbY = CRead8 BbY2[bChar]
                GlyphOffsetX = CRead8 BBOffsetX2[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY2[bChar]
            $endif
        Case 3
            $ifdef Font3
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset3[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset3[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset3[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset3[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX3[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY3[bChar] 
                GlyphBbX = CRead8 BbX3[bChar]
                GlyphBbY = CRead8 BbY3[bChar]
                GlyphOffsetX = CRead8 BBOffsetX3[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY3[bChar]
            $endif
        Case 4
            $ifdef Font4
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset4[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset4[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset4[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset4[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX4[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY4[bChar] 
                GlyphBbX = CRead8 BbX4[bChar]
                GlyphBbY = CRead8 BbY4[bChar]
                GlyphOffsetX = CRead8 BBOffsetX4[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY4[bChar]
            $endif
        Case 5
            $ifdef Font5
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset5[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset5[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset5[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset5[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX5[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY5[bChar] 
                GlyphBbX = CRead8 BbX5[bChar]
                GlyphBbY = CRead8 BbY5[bChar]
                GlyphOffsetX = CRead8 BBOffsetX5[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY5[bChar]
            $endif
        Case 6      
            $ifdef Font6
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset6[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset6[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset6[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset6[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX6[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY6[bChar] 
                GlyphBbX = CRead8 BbX6[bChar]
                GlyphBbY = CRead8 BbY6[bChar]
                GlyphOffsetX = CRead8 BBOffsetX6[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY6[bChar]
            $endif
        Case 7
            $ifdef Font7
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset7[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset7[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset7[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset7[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX7[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY7[bChar] 
                GlyphBbX = CRead8 BbX7[bChar]
                GlyphBbY = CRead8 BbY7[bChar]
                GlyphOffsetX = CRead8 BBOffsetX7[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY7[bChar]
            $endif
        Case 8
            $ifdef Font8
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset8[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset8[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset8[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset8[wTemp + 3]
                NextGlyphOffsetX = CRead8 DwidthOffsetX8[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY8[bChar] 
                GlyphBbX = CRead8 BbX8[bChar]
                GlyphBbY = CRead8 BbY8[bChar]
                GlyphOffsetX = CRead8 BBOffsetX8[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY8[bChar]
            $endif
        Case 9
            $ifdef Font9
                BitmapOffsetStart.Byte0 = CRead8 BitmapOffset9[wTemp]
                BitmapOffsetStart.Byte1 = CRead8 BitmapOffset9[wTemp + 1]
                BitmapOffsetEnd.Byte0 = CRead8 BitmapOffset9[wTemp + 2] 
                BitmapOffsetEnd.Byte1 = CRead8 BitmapOffset9[wTemp + 3] 
                NextGlyphOffsetX = CRead8 DwidthOffsetX9[bChar] 
                NextGlyphOffsetY = CRead8 DwidthOffsetY9[bChar] 
                GlyphBbX = CRead8 BbX9[bChar]
                GlyphBbY = CRead8 BbY9[bChar]
                GlyphOffsetX = CRead8 BBOffsetX9[bChar] 
                GlyphOffsetY = CRead8 BBOffsetY9[bChar]
            $endif
    EndSelect   
EndProc

'Read font Bitmap data according selected font 

Proc TftBitmapRead(dwPosition As Dword), Byte
    Select FontSet
        Case 0
            $ifdef Font0
                Result  = CRead8 Bitmap0[dwPosition] 
            $endif
        Case 1
            $ifdef Font1
                Result  = CRead8 Bitmap1[dwPosition]  
            $endif
        Case 2
            $ifdef Font2
                Result  = CRead8 Bitmap2[dwPosition] 
            $endif 
        Case 3
            $ifdef Font3
                Result  = CRead8 Bitmap3[dwPosition] 
            $endif 
        Case 4
            $ifdef Font4
                Result  = CRead8 Bitmap4[dwPosition] 
            $endif
        Case 5
            $ifdef Font5
                Result  = CRead8 Bitmap5[dwPosition] 
            $endif
        Case 6
            $ifdef Font6
                Result  = CRead8 Bitmap6[dwPosition] 
            $endif
        Case 7
            $ifdef Font7
                Result  = CRead8 Bitmap7[dwPosition] 
            $endif
        Case 8
            $ifdef Font8
                Result  = CRead8 Bitmap8[dwPosition] 
            $endif
        Case 9
            $ifdef Font9
                Result  = CRead8 Bitmap9[dwPosition] 
            $endif
    EndSelect   
EndProc

'Read font glyph one step 

Proc TftGlyphStepBbX(bChar As Byte), Byte
    Select FontSet
        Case 0
            $ifdef Font0
                Result = CRead8 DwidthOffsetX0[bChar]
            $endif
        Case 1
            $ifdef Font1
                Result = CRead8 DwidthOffsetX1[bChar]
            $endif
        Case 2
            $ifdef Font2
                Result = CRead8 DwidthOffsetX2[bChar]
            $endif 
        Case 3
            $ifdef Font3
                Result = CRead8 DwidthOffsetX3[bChar]
            $endif 
        Case 4
            $ifdef Font4
                Result = CRead8 DwidthOffsetX4[bChar]
            $endif
        Case 5
            $ifdef Font5
                Result = CRead8 DwidthOffsetX5[bChar]
            $endif
        Case 6
            $ifdef Font6
                Result = CRead8 DwidthOffsetX6[bChar]
            $endif
        Case 7
            $ifdef Font7
                Result = CRead8 DwidthOffsetX7[bChar]
            $endif
        Case 8
            $ifdef Font8
                Result = CRead8 DwidthOffsetX8[bChar]
            $endif
        Case 9
            $ifdef Font9
                Result = CRead8 DwidthOffsetX9[bChar]
            $endif
    EndSelect 
EndProc

'Read font glyph one step 

Proc TftGlyphStepBbOffX(bChar As Byte), SByte
    Select FontSet
        Case 0
            $ifdef Font0
                Result = CRead8 BBOffsetX0[bChar] 
            $endif
        Case 1
            $ifdef Font1
                Result = CRead8 BBOffsetX1[bChar] 
            $endif
        Case 2
            $ifdef Font2
                Result = CRead8 BBOffsetX2[bChar] 
            $endif 
        Case 3
            $ifdef Font3
                Result = CRead8 BBOffsetX3[bChar] 
            $endif 
        Case 4
            $ifdef Font4
                Result = CRead8 BBOffsetX4[bChar] 
            $endif
        Case 5
            $ifdef Font5
                Result = CRead8 BBOffsetX5[bChar] 
            $endif
        Case 6
            $ifdef Font6
                Result = CRead8 BBOffsetX6[bChar] 
            $endif
        Case 7
            $ifdef Font7
                Result = CRead8 BBOffsetX7[bChar] 
            $endif
        Case 8
            $ifdef Font8
                Result = CRead8 BBOffsetX8[bChar] 
            $endif
        Case 9
            $ifdef Font9
                Result = CRead8 BBOffsetX9[bChar] 
            $endif
    EndSelect 
EndProc

Proc TftPrintDelay(bPrintMode As Byte)
    Dim bTemp As Byte
    If bPrintMode > 60 And bPrintMode < 101 Then
        For bTemp = 0 To bPrintMode - 60 
            DelayMS 5
        Next
    EndIf
    If bPrintMode > 100 And bPrintMode < 161 Then
        For bTemp = 0 To bPrintMode - 100 
            DelayMS 5
        Next
    EndIf
EndProc
