$if McuType = 0
Dim wTftCounter1_Bmp As Word        At sTftString#0 
Dim dwTftCounter1_Bmp As Dword      At sTftString#2
Dim dwTftTemp1_Bmp As Dword         At sTftString#2
Dim bTftTemp1_Bmp As Byte	        At sTftString#6
Dim bTftCounter1_Bmp As Byte	    At sTftString#6
Dim bTftTrim_Bmp As Byte	        At sTftString#7
Dim bTftCounter2_Bmp As Byte	    At sTftString#7
Dim dwTftOffset_Bmp As Dword        At sTftString#8
Dim wTftWidth_Bmp As Word	        At sTftString#12
Dim wTftHeight_Bmp As Word	        At sTftString#14
Dim dwTftSize_Bmp As Dword	        At sTftString#16
Dim wTftRowSize_Bmp As Word	        At sTftString#20
Dim wTftCounter2_Bmp As Word        At sTftString#22
Dim wTftCounter3_Bmp As Word        At sTftString#24
Dim wTftColor_Bmp As Word           At sTftString#26
Dim dwTftAddressStart_Bmp As Dword  At sTftString#28
Dim dwTftAddressStop_Bmp As Dword   At sTftString#32
Dim sTftTemp As String * 12         At sTftString#36
$else
Dim wTftCounter1_Bmp As Word        At sTftString_0 
Dim dwTftCounter1_Bmp As Dword      At sTftString_2
Dim dwTftTemp1_Bmp As Dword         At sTftString_2
Dim bTftTemp1_Bmp As Byte	        At sTftString_6
Dim bTftCounter1_Bmp As Byte	    At sTftString_6
Dim bTftTrim_Bmp As Byte	        At sTftString_7
Dim bTftCounter2_Bmp As Byte	    At sTftString_7
Dim dwTftOffset_Bmp As Dword        At sTftString_8
Dim wTftWidth_Bmp As Word	        At sTftString_12
Dim wTftHeight_Bmp As Word	        At sTftString_14
Dim dwTftSize_Bmp As Dword	        At sTftString_16
Dim wTftRowSize_Bmp As Word	        At sTftString_20
Dim wTftCounter2_Bmp As Word        At sTftString_22
Dim wTftCounter3_Bmp As Word        At sTftString_24
Dim wTftColor_Bmp As Word           At sTftString_26
Dim dwTftAddressStart_Bmp As Dword  At sTftString_28
Dim dwTftAddressStop_Bmp As Dword   At sTftString_32
Dim sTftTemp As String * 12         At sTftString_36
$endif


$ifndef MemoryType
    $define MemoryType 0
$endif

$if MemoryType = 2 
    Symbol MEM_MAX_PAGE_COUNT = (MEM_SECTOR_SIZE * MEM_SECTOR_COUNT) / MEM_PAGE_SIZE
    Symbol MEM_LAST_DATA_PAGE = MEM_MAX_PAGE_COUNT - ((8192 * (MEM_FILE_COUNT / 256)) / MEM_PAGE_SIZE)
    Include "TftLib\Memory\Flash.inc"
$endif


'Transfer BMP file from SD card to memory:
'sFileName = File name of the image to print, should be less than 13 characters, including dot and file extension
'Return parameter: 0 = No error
'                  1 = No response from card
'                  2 = Card not formatted with FAT16 Or FAT32
'                  3 = File not found
'                  4 = File is in use 
'                  5 = Read/Write error
'                  6 = Memory read/write error
'                  7 = Exceed memory size

'Example: TftBmpSdToMem("PIC001.BMP") --> copy file PIC001.BMP to memory

'Files are written sequentially and file names are kept through rudimentary file system. 
'BMP files should be 16b color depth and less than maximum screen size since there's no file post Or preprocessing.

'Note files can't be erased individually. There's a format function TftBmpMemFormat()
'that has to be issued first time you use the flash or any time you want to completely erase it.

Proc TftBmpSdToMem(sFileName As String * 12), Byte 
    $if MemoryType = 2
        Global Dim bMemPageArray[MEM_PAGE_SIZE] As Byte Shared
      
        Dim dwAddressStart As Dword 
        Dim dwAddressStop As Dword 
        Dim wCounter1 As Word      
        Dim wCounter2 As Word       
        Dim wFileSlot As Word 
        Dim wTempPage As Word 
        Dim bCounter1 As Byte   
        Dim bTemp1 As bCounter1     
    
        'Check memory for next free file slot
        wFileSlot = 0
        Do
            dwAddressStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 4)
            dwAddressStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 5)
            dwAddressStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 6)
            dwAddressStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 7)
            Inc wFileSlot
            If dwAddressStop = 0xFFFFFFFF Then 
                Dec wFileSlot
                Break
            EndIf
        Loop Until wFileSlot = MEM_FILE_COUNT
    
        If wFileSlot = MEM_FILE_COUNT Then
            Result = 7
            ExitProc
        EndIf
    
        If wFileSlot = 0 Then 
            dwAddressStart = 0
        Else
            dwAddressStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 12)
            dwAddressStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 11)
            dwAddressStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 10)
            dwAddressStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 9)
            dwAddressStart = (dwAddressStop / MEM_PAGE_SIZE + 1) * MEM_PAGE_SIZE 
        EndIf
        dwAddressStop = dwAddressStart
    
        'Initialize SD card 
        sFileName = ToUpper(sFileName)
        For wCounter1 = 0 To 4999
            Result = File_Init()
            If Result = cErrOK Then
                Break
            EndIf
            DelayMS 1
        Next 
        Select Result
            Case cErrNoResponse
                Result = 1
                ExitProc
            Case cErrInvalidFormat
                Result = 2
                ExitProc 
        EndSelect
    
        Result = File_Open(sFileName)
        Select Result
            Case cErrNotFound
                Result = 3
                ExitProc
            Case cErrInUse
                Result = 4
                ExitProc 
            Case cErrRWError
                Result = 5
                ExitProc    
        EndSelect
    
    
        'Start file transfer
        wTempPage = dwAddressStart / MEM_PAGE_SIZE
        Do
            Clear bMemPageArray
            For wCounter2 = 0 To MEM_PAGE_SIZE - 1
                bMemPageArray[wCounter2] = File_ReadByte()
                If File_tEOF = True Then
                    Break
                EndIf
                Inc dwAddressStop
            Next
                   
            $if MEM_COM = SPI_1 
                $if McuType = 0
                    DelayCS 32 
                    bTemp1 = SSP1BUF
                $else
                    DelayCS 64 
                    bTemp1 = SPI1BUF
                $endif
            $elseif MEM_COM = SPI_2
                $if McuType = 0
                    DelayCS 32
                    bTemp1 = SSP2BUF
                $else
                    DelayCS 64 
                    bTemp1 = SPI2BUF
                $endif
            $endif

            TftBmpFlashPageWrite(wTempPage)
            For wCounter2 = 0 To MEM_PAGE_SIZE - 1
                bTemp1 = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter2)
                If bMemPageArray[wCounter2] <> bTemp1 Then
                    Result = 6
                    ExitProc
                EndIf
            Next
        
            Inc wTempPage
            If wTempPage = MEM_LAST_DATA_PAGE Then
                Result = 7
                ExitProc
            EndIf
        Loop Until File_tEOF = True
    
        File_Close() 
        
        'Write file position 
        wTempPage = MEM_LAST_DATA_PAGE + (wFileSlot * 16) / MEM_PAGE_SIZE
        
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        bMemPageArray[(wFileSlot // 16) * 16 + 0] = dwAddressStart.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 1] = dwAddressStart.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 2] = dwAddressStart.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 3] = dwAddressStart.Byte3
        bMemPageArray[(wFileSlot // 16) * 16 + 4] = dwAddressStop.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 5] = dwAddressStop.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 6] = dwAddressStop.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 7] = dwAddressStop.Byte3
        TftBmpFlashPageWrite(wTempPage)
    
        'Write file name
        wTempPage = MEM_LAST_DATA_PAGE + ((8192 * (MEM_FILE_COUNT / 256)) / 2) / MEM_PAGE_SIZE + (wFileSlot * 16) / MEM_PAGE_SIZE
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        For bCounter1 = 0 To 12
            bMemPageArray[(wFileSlot // 16) * 16 + bCounter1] = sFileName[bCounter1]
        Next
        TftBmpFlashPageWrite(wTempPage)
    
        Result = 0
    $endif    
EndProc

'Takes a screenshot and saves it as BMP file to memory:
'sFileName = new file name where the screen shot will be written to. Should be 12 or less characters, including dot and file extension
'wX_Pos = x position for the lower left corner of the screenshot
'wY_Pos = y position for the lower left corner of the screenshot
'wWidth = screenshot width
'wHeight = screenshot height
'Return parameter: - File position in memory. 
'                  - if 0XFFFF then memory format error

'Example: TftBmpScreenshotMem("PIC001.BMP", 0,0, 320,240) --> Paste current screen screenshot to file PIC001.BMP at position 0,0, width and height 320x240

'Note files can't be erased individually. There's a format function TftBmpMemFormat()
'that has to be issued first time you use the flash or any time you want to completely erase it.
'Files are written sequentially and file names are kept through rudimentary file system. 

Proc TftBmpScreenshotMem(sFileName As String * 12, wX_Pos As Word, wY_Pos As Word, wWidth As Word, wHeight As Word), Word
    $if MemoryType = 2
        Global Dim bMemPageArray[MEM_PAGE_SIZE] As Byte Shared
      
        Dim dwAddStart As Dword 
        Dim dwAddStop As Dword 
        Dim wCounter1 As Word      
        Dim wCounter2 As Word       
        Dim wFileSlot As Word 
        Dim wTempPage As Word 
        Dim bCounter1 As Byte   
        Dim bTemp1 As bCounter1     
    
        'Check memory for next free file slot
        wFileSlot = 0
        Do
            dwAddStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 4)
            dwAddStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 5)
            dwAddStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 6)
            dwAddStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 7)
            Inc wFileSlot
            If dwAddStop = 0xFFFFFFFF Then 
                Dec wFileSlot
                Break
            EndIf
        Loop Until wFileSlot = MEM_FILE_COUNT
    
        If wFileSlot = MEM_FILE_COUNT Then
            Result = 0xFFFF
            ExitProc
        Else
            Result = wFileSlot 
        EndIf
    
        If wFileSlot = 0 Then 
            dwAddStart = 0
        Else
            dwAddStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 12)
            dwAddStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 11)
            dwAddStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 10)
            dwAddStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 9)
            dwAddStart = (dwAddStop / MEM_PAGE_SIZE + 1) * MEM_PAGE_SIZE 
        EndIf
        dwAddStop = dwAddStart
    
    
        'Start file transfer
        wTftCounter1_Bmp = wWidth * 2
        wTftColor_Bmp = wTftCounter1_Bmp // 4
        bTftTrim_Bmp = wTftColor_Bmp
    
        dwTftCounter1_Bmp = wWidth * wHeight
        dwTftCounter1_Bmp = dwTftCounter1_Bmp * 2
        dwTftCounter1_Bmp = dwTftCounter1_Bmp + wHeight * bTftTemp1_Bmp
        dwTftCounter1_Bmp = dwTftCounter1_Bmp + 66
        
        wTempPage = dwAddStart / MEM_PAGE_SIZE
        wCounter2 = 0 : Clear bMemPageArray
        
        bTemp1 = 0x42 : GoSub WMemB : bTemp1 = 0x4D : GoSub WMemB
        bTemp1 = dwTftCounter1_Bmp.Byte0 : GoSub WMemB : bTemp1 = dwTftCounter1_Bmp.Byte1 : GoSub WMemB 
        bTemp1 = dwTftCounter1_Bmp.Byte2 : GoSub WMemB : bTemp1 = dwTftCounter1_Bmp.Byte3 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 66 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 40 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = wWidth.Byte0 : GoSub WMemB : bTemp1 = wWidth.Byte1 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = wHeight.Byte0 : GoSub WMemB : bTemp1 = wHeight.Byte1 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 1 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 16 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 3 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        dwTftCounter1_Bmp = wWidth * wHeight
        dwTftCounter1_Bmp = dwTftCounter1_Bmp * 2
        bTemp1 = dwTftCounter1_Bmp.Byte0 : GoSub WMemB : bTemp1 = dwTftCounter1_Bmp.Byte1 : GoSub WMemB
        bTemp1 = dwTftCounter1_Bmp.Byte2 : GoSub WMemB : bTemp1 = dwTftCounter1_Bmp.Byte3 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0xF8 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0xE0 : GoSub WMemB : bTemp1 = 0x07 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0x1F : GoSub WMemB : bTemp1 = 0 : GoSub WMemB
        bTemp1 = 0 : GoSub WMemB : bTemp1 = 0 : GoSub WMemB

        $if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            $if TFT_IC = ST7796S
                wTftColor_Bmp = TftReadPixel(wX_Pos, wY_Pos)   
            $endif
            TftSetWindow(wX_Pos, wX_Pos + wWidth - 1, wY_Pos, wY_Pos + wHeight - 1)
            TftInitiateDataRamRead()
            $if TFT_IC = ILI9486
                TftReceive()
            $endif
            For wTftHeight_Bmp = 0 To wHeight - 1
                For wTftWidth_Bmp = 0 To wWidth - 1
                    wTftColor_Bmp = TftReceive()
                    bTemp1 = wTftColor_Bmp.Byte0 : GoSub WMemB
                    bTemp1 = wTftColor_Bmp.Byte1 : GoSub WMemB
                Next
                Select bTftTrim_Bmp
                    Case 1
                        bTemp1 = 0 : GoSub WMemB
                    Case 2
                        bTemp1 = 0 : GoSub WMemB 
                        bTemp1 = 0 : GoSub WMemB
                    Case 3
                        bTemp1 = 0 : GoSub WMemB 
                        bTemp1 = 0 : GoSub WMemB
                        bTemp1 = 0 : GoSub WMemB
                EndSelect
            Next
            TftStopDataRam()
        $elseif TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK  
                TftSetWindow(wX_Pos, wX_Pos + wWidth - 1, wY_Pos, wY_Pos + wHeight - 1)
                TftInitiateDataRamRead()
                TftReceive()
                For wTftHeight_Bmp = 0 To wHeight - 1
                    For wTftWidth_Bmp = 0 To wWidth - 1
                        wTftColor_Bmp = 0
                        bTftRed_Basic = TftReceive() >> 2 
                        wTftColor_Bmp.Byte1 = TftReceive() >> 2
                        bTftBlue_Basic = TftReceive() >> 2
                        bTftBlue_Basic = CRead8 Color6bTo5b[bTftBlue_Basic]
                        bTftRed_Basic = CRead8 Color6bTo5b[bTftRed_Basic]
                        wTftColor_Bmp = wTftColor_Bmp >> 3
                        wTftColor_Bmp.Byte0 = wTftColor_Bmp.Byte0 | bTftBlue_Basic
                        bTftRed_Basic = bTftRed_Basic << 3
                        wTftColor_Bmp.Byte1 = wTftColor_Bmp.Byte1 | bTftRed_Basic 
                        bTemp1 = wTftColor_Bmp.Byte0 : GoSub WMemB
                        bTemp1 = wTftColor_Bmp.Byte1 : GoSub WMemB
                    Next
                    Select bTftTrim_Bmp
                    Case 1
                        bTemp1 = 0 : GoSub WMemB
                    Case 2
                        bTemp1 = 0 : GoSub WMemB 
                        bTemp1 = 0 : GoSub WMemB
                    Case 3
                        bTemp1 = 0 : GoSub WMemB 
                        bTemp1 = 0 : GoSub WMemB
                        bTemp1 = 0 : GoSub WMemB
                EndSelect
                Next
                TftStopDataRam()   
            $else
                For wTftHeight_Bmp = 0 To wHeight - 1
                    For wTftWidth_Bmp = 0 To wWidth - 1
                        wTftColor_Bmp = TftReadPixel(wX_Pos + wTftWidth_Bmp, wY_Pos + wTftHeight_Bmp)     
                        bTemp1 = wTftColor_Bmp.Byte0 : GoSub WMemB
                        bTemp1 = wTftColor_Bmp.Byte1 : GoSub WMemB
                    Next
                    Select bTftTrim_Bmp
                        Case 1
                            bTemp1 = 0 : GoSub WMemB
                        Case 2
                            bTemp1 = 0 : GoSub WMemB 
                            bTemp1 = 0 : GoSub WMemB
                        Case 3
                            bTemp1 = 0 : GoSub WMemB 
                            bTemp1 = 0 : GoSub WMemB
                            bTemp1 = 0 : GoSub WMemB
                    EndSelect
                Next      
            $endif
        $endif
        
        If wCounter2 <> 0 Then
            TftBmpFlashPageWrite(wTempPage)
            For wCounter2 = 0 To MEM_PAGE_SIZE - 1
                bTemp1 = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter2)
                If bMemPageArray[wCounter2] <> bTemp1 Then
                    Result = 0xFFFF
                    ExitProc
                EndIf
            Next 
        EndIf 

        'Write file position 
        wTempPage = MEM_LAST_DATA_PAGE + (wFileSlot * 16) / MEM_PAGE_SIZE
        
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        bMemPageArray[(wFileSlot // 16) * 16 + 0] = dwAddStart.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 1] = dwAddStart.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 2] = dwAddStart.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 3] = dwAddStart.Byte3
        bMemPageArray[(wFileSlot // 16) * 16 + 4] = dwAddStop.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 5] = dwAddStop.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 6] = dwAddStop.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 7] = dwAddStop.Byte3
        TftBmpFlashPageWrite(wTempPage)
    
        'Write file name
        wTempPage = MEM_LAST_DATA_PAGE + ((8192 * (MEM_FILE_COUNT / 256)) / 2) / MEM_PAGE_SIZE + (wFileSlot * 16) / MEM_PAGE_SIZE
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        For bCounter1 = 0 To 12
            bMemPageArray[(wFileSlot // 16) * 16 + bCounter1] = sFileName[bCounter1]
        Next
        TftBmpFlashPageWrite(wTempPage)
    $endif 
    
    ExitProc
WMemB:
    bMemPageArray[wCounter2] = bTemp1
    Inc wCounter2 
    Inc dwAddStop
        
    If wCounter2 = MEM_PAGE_SIZE Then
        $if MEM_COM = SPI_1 
            $if McuType = 0
                DelayCS 32 
                bTemp1 = SSP1BUF
            $else
                DelayCS 64 
                bTemp1 = SPI1BUF
            $endif
        $elseif MEM_COM = SPI_2
            $if McuType = 0
                DelayCS 32
                bTemp1 = SSP2BUF
            $else
                DelayCS 64 
                bTemp1 = SPI2BUF
            $endif
        $endif   
      
        TftBmpFlashPageWrite(wTempPage)  
        For wCounter2 = 0 To MEM_PAGE_SIZE - 1
            bTemp1 = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter2)
            If bMemPageArray[wCounter2] <> bTemp1 Then
                Result = 0xFFFF
                ExitProc
            EndIf
        Next
        
        Inc wTempPage
        If wTempPage = MEM_LAST_DATA_PAGE Then
            Result = 0xFFFF
            ExitProc
        EndIf
        
        wCounter2 = 0
    EndIf
    Return    
EndProc


'Takes a screenshot using bi-directional SDA pin and saves it as BMP file to memory:
'sFileName = new file name where the screen shot will be written to. Should be 12 or less characters, including dot and file extension
'wX_Pos = x position for the lower left corner of the screenshot
'wY_Pos = y position for the lower left corner of the screenshot
'wWidth = screenshot width
'wHeight = screenshot height
'Return parameter: - File position in memory. 
'                  - if 0XFFFF then memory format error

'Example: TftBmpScreenshotMem1("PIC001.BMP", 0,0, 320,240) --> Paste current screen screenshot to file PIC001.BMP at position 0,0, width and height 320x240

'Note files can't be erased individually. There's a format function TftBmpMemFormat()
'that has to be issued first time you use the flash or any time you want to completely erase it.
'Files are written sequentially and file names are kept through rudimentary file system. 

Proc TftBmpScreenshotMem1(sFileName As String * 12, wX_Pos As Word, wY_Pos As Word, wWidth As Word, wHeight As Word), Word
    $if MemoryType = 2
        Global Dim bMemPageArray[MEM_PAGE_SIZE] As Byte Shared
      
        Dim dwAdStart As Dword 
        Dim dwAddStop As Dword 
        Dim wCounter1 As Word      
        Dim wCounter2 As Word       
        Dim wFileSlot As Word 
        Dim wTempPage As Word 
        Dim bCounter1 As Byte   
        Dim bTemp1 As bCounter1     
    
        'Check memory for next free file slot
        wFileSlot = 0
        Do
            dwAddStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 4)
            dwAddStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 5)
            dwAddStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 6)
            dwAddStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE + 7)
            Inc wFileSlot
            If dwAddStop = 0xFFFFFFFF Then 
                Dec wFileSlot
                Break
            EndIf
        Loop Until wFileSlot = MEM_FILE_COUNT
    
        If wFileSlot = MEM_FILE_COUNT Then
            Result = 0xFFFF
            ExitProc
        Else
            Result = wFileSlot 
        EndIf
    
        If wFileSlot = 0 Then 
            dwAdStart = 0
        Else
            dwAddStop.Byte0 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 12)
            dwAddStop.Byte1 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 11)
            dwAddStop.Byte2 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 10)
            dwAddStop.Byte3 = TftBmpFlashByteRead(wFileSlot * 16 + MEM_LAST_DATA_PAGE * MEM_PAGE_SIZE - 9)
            dwAdStart = (dwAddStop / MEM_PAGE_SIZE + 1) * MEM_PAGE_SIZE 
        EndIf
        dwAddStop = dwAdStart
    
    
        'Start file transfer
        wTftCounter1_Bmp = wWidth * 2
        wTftColor_Bmp = wTftCounter1_Bmp // 4
        bTftTrim_Bmp = wTftColor_Bmp
    
        dwTftCounter1_Bmp = wWidth * wHeight
        dwTftCounter1_Bmp = dwTftCounter1_Bmp * 2
        dwTftCounter1_Bmp = dwTftCounter1_Bmp + wHeight * bTftTemp1_Bmp
        dwTftCounter1_Bmp = dwTftCounter1_Bmp + 66
        
        wTempPage = dwAdStart / MEM_PAGE_SIZE
        wCounter2 = 0 : Clear bMemPageArray
        
        bTemp1 = 0x42 : GoSub WMemB1 : bTemp1 = 0x4D : GoSub WMemB1
        bTemp1 = dwTftCounter1_Bmp.Byte0 : GoSub WMemB1 : bTemp1 = dwTftCounter1_Bmp.Byte1 : GoSub WMemB1 
        bTemp1 = dwTftCounter1_Bmp.Byte2 : GoSub WMemB1 : bTemp1 = dwTftCounter1_Bmp.Byte3 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 66 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 40 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = wWidth.Byte0 : GoSub WMemB1 : bTemp1 = wWidth.Byte1 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = wHeight.Byte0 : GoSub WMemB1 : bTemp1 = wHeight.Byte1 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 1 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 16 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 3 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        dwTftCounter1_Bmp = wWidth * wHeight
        dwTftCounter1_Bmp = dwTftCounter1_Bmp * 2
        bTemp1 = dwTftCounter1_Bmp.Byte0 : GoSub WMemB1 : bTemp1 = dwTftCounter1_Bmp.Byte1 : GoSub WMemB1
        bTemp1 = dwTftCounter1_Bmp.Byte2 : GoSub WMemB1 : bTemp1 = dwTftCounter1_Bmp.Byte3 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0xF8 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0xE0 : GoSub WMemB1 : bTemp1 = 0x07 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0x1F : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1
        bTemp1 = 0 : GoSub WMemB1 : bTemp1 = 0 : GoSub WMemB1

        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            For wTftHeight_Bmp = 0 To wHeight - 1
                For wTftWidth_Bmp = 0 To wWidth - 1
                    wTftColor_Bmp = TftReadPixelSda(wX_Pos + wTftWidth_Bmp, wY_Pos + wTftHeight_Bmp)     
                    bTemp1 = wTftColor_Bmp.Byte0 : GoSub WMemB1
                    bTemp1 = wTftColor_Bmp.Byte1 : GoSub WMemB1
                Next
                Select bTftTrim_Bmp
                    Case 1
                        bTemp1 = 0 : GoSub WMemB1
                    Case 2
                        bTemp1 = 0 : GoSub WMemB1 
                        bTemp1 = 0 : GoSub WMemB1
                    Case 3
                        bTemp1 = 0 : GoSub WMemB1 
                        bTemp1 = 0 : GoSub WMemB1
                        bTemp1 = 0 : GoSub WMemB1
                EndSelect
            Next      
        $endif    
        
        If wCounter2 <> 0 Then
            TftBmpFlashPageWrite(wTempPage)
            For wCounter2 = 0 To MEM_PAGE_SIZE - 1
                bTemp1 = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter2)
                If bMemPageArray[wCounter2] <> bTemp1 Then
                    Result = 0xFFFF
                    ExitProc
                EndIf
            Next 
        EndIf    

        'Write file position 
        wTempPage = MEM_LAST_DATA_PAGE + (wFileSlot * 16) / MEM_PAGE_SIZE
        
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        bMemPageArray[(wFileSlot // 16) * 16 + 0] = dwAdStart.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 1] = dwAdStart.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 2] = dwAdStart.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 3] = dwAdStart.Byte3
        bMemPageArray[(wFileSlot // 16) * 16 + 4] = dwAddStop.Byte0
        bMemPageArray[(wFileSlot // 16) * 16 + 5] = dwAddStop.Byte1
        bMemPageArray[(wFileSlot // 16) * 16 + 6] = dwAddStop.Byte2
        bMemPageArray[(wFileSlot // 16) * 16 + 7] = dwAddStop.Byte3
        TftBmpFlashPageWrite(wTempPage)
    
        'Write file name
        wTempPage = MEM_LAST_DATA_PAGE + ((8192 * (MEM_FILE_COUNT / 256)) / 2) / MEM_PAGE_SIZE + (wFileSlot * 16) / MEM_PAGE_SIZE
        For wCounter1 = 0 To MEM_PAGE_SIZE - 1
            bMemPageArray[wCounter1] = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter1)  
        Next
    
        For bCounter1 = 0 To 12
            bMemPageArray[(wFileSlot // 16) * 16 + bCounter1] = sFileName[bCounter1]
        Next
        TftBmpFlashPageWrite(wTempPage)
    $endif  
    
    ExitProc
WMemB1:
    bMemPageArray[wCounter2] = bTemp1
    Inc wCounter2 
    Inc dwAddStop
        
    If wCounter2 = MEM_PAGE_SIZE Then
        $if MEM_COM = SPI_1 
            $if McuType = 0
                DelayCS 32 
                bTemp1 = SSP1BUF
            $else
                DelayCS 64 
                bTemp1 = SPI1BUF
            $endif
        $elseif MEM_COM = SPI_2
            $if McuType = 0
                DelayCS 32
                bTemp1 = SSP2BUF
            $else
                DelayCS 64 
                bTemp1 = SPI2BUF
            $endif
        $endif   
      
        TftBmpFlashPageWrite(wTempPage)  
        For wCounter2 = 0 To MEM_PAGE_SIZE - 1
            bTemp1 = TftBmpFlashByteRead(wTempPage * MEM_PAGE_SIZE + wCounter2)
            If bMemPageArray[wCounter2] <> bTemp1 Then
                Result = 0xFFFF
                ExitProc
            EndIf
        Next
        
        Inc wTempPage
        If wTempPage = MEM_LAST_DATA_PAGE Then
            Result = 0xFFFF
            ExitProc
        EndIf
        
        wCounter2 = 0
    EndIf
    Return    
EndProc






