$ifndef _FILESYS24_INC_
$define _FILESYS24_INC_
'   /\\\\\\\\\
'  /\\\///////\\\
'  \/\\\     \/\\\                                                 /\\\          /\\\
'   \/\\\\\\\\\\\/        /\\\\\     /\\\\\\\\\\     /\\\\\\\\   /\\\\\\\\\\\  /\\\\\\\\\\\  /\\\\\\\\\
'    \/\\\//////\\\      /\\\///\\\  \/\\\//////    /\\\/////\\\ \////\\\////  \////\\\////  \////////\\\
'     \/\\\    \//\\\    /\\\  \//\\\ \/\\\\\\\\\\  /\\\\\\\\\\\     \/\\\         \/\\\        /\\\\\\\\\\
'      \/\\\     \//\\\  \//\\\  /\\\  \////////\\\ \//\\///////      \/\\\ /\\     \/\\\ /\\   /\\\/////\\\
'       \/\\\      \//\\\  \///\\\\\/    /\\\\\\\\\\  \//\\\\\\\\\\    \//\\\\\      \//\\\\\   \//\\\\\\\\/\\
'        \///        \///     \/////     \//////////    \//////////      \/////        \/////     \////////\//
'                                  Let's find out together what makes a PIC Tick!
'
' FAT16/32 File system procedures
' Written by Les Johnson for the Positron16 BASIC compiler
'
' SD commands
'
    Symbol SD_cCMD0  = $40 + 0                              ' GO_IDLE_STATE
    Symbol SD_cCMD1  = $40 + 1                              ' SEND_OP_COND
    Symbol SD_cCMD8  = $40 + 8                              ' SEND_IF_COND
    Symbol SD_cCMD9  = $40 + 9                              ' SEND_CSD
    Symbol SD_cCMD10 = $40 + 10                             ' SEND_CID
    Symbol SD_cCMD12 = $40 + 12                             ' STOP_TRANSMISSION
    Symbol SD_cCMD16 = $40 + 16                             ' SET_BLOCKLEN
    Symbol SD_cCMD17 = $40 + 17                             ' READ_SINGLE_BLOCK
    Symbol SD_cCMD18 = $40 + 18                             ' READ_MULTIPLE_BLOCK
    Symbol SD_cCMD23 = $40 + 23                             ' SET_BLOCK_COUNT
    Symbol SD_cCMD24 = $40 + 24                             ' WRITE_BLOCK
    Symbol SD_cCMD25 = $40 + 25                             ' WRITE_MULTIPLE_BLOCK
    Symbol SD_cCMD41 = $40 + 41                             ' SEND_OP_COND (ASD_cCMD)
    Symbol SD_cCMD55 = $40 + 55                             ' APP_SD_cCMD
    Symbol SD_cCMD58 = $40 + 58                             ' READ_OCR

$define SD_cMissing 1
'
' Set a timeout limit based on the oscillator
'
    Symbol SD_cTimeOutLimit = _xtal * 40
'
' Dir Search & Rename types
'
    $define FAT_cFile 0
    $define FAT_cDirectory 1
'
' Dir search directions
'
    $define FAT_cDirFirst 0
    $define FAT_cDirNext 1
    $define FAT_cDirPrevious 2
'
' ChDir commands
'
    $define FAT_cCdUp 0                         ' Change to parent directory
    $define FAT_cCdRoot 1                       ' Change to Root Directory
'
' Error codes
'
    $define cErrOK            $00
    $define cErrDiskFull      $01
    $define cErrNotFound      $02
    $define cErrRootDirFull   $03
    $define cErrDirNotEmpty   $04
    $define cErrExists        $05
    $define cErrInUse         $06
    $define cErrRWError       $07
    $define cErrFileNotOpen   $08
    $define cErrBeyondEOF     $09
    $define cErrNoResponse    $0A
    $define cErrInvalidFormat $0B
    $define cErrInvalidPath   $0C
'
' Card types
'
    $define SD_cMMC 1                           ' Multi Media Card (MMC)
    $define SD_cSD 2                            ' Secure Digital Card (SD)
    $define SD_cSDHC 4                          ' High Capacity Secure Digital Card (SDHC)
'
' FAT types
'
    $define FAT_cFAT16 1
    $define FAT_cFAT32 2
    

    Dim Global_wSecRWIndex As Word
    Dim Global_bSecRWTimeOut As Byte
    Dim Global_tSecRWError As Byte

    Dim Global_bDay As Byte = 1
    Dim Global_bMonth As Byte = 1
    Dim Global_bYear As Byte = 24
    Dim Global_bHours As Byte = 0
    Dim Global_bMinutes As Byte = 0
    Dim Global_bSeconds As Byte = 0

    Dim Global_sUpFileName As String * 12
    Dim Global_sFileName As String * 12
    $if McuType = 1
        Dim Global_sFileName_Ext As String * 3 At Global_sFileName_8
        Dim Global_sUpFileName_Ext As String * 3 At Global_sUpFileName_8
    $else
        Dim Global_sFileName_Ext As String * 3 At Global_sFileName#8
        Dim Global_sUpFileName_Ext As String * 3 At Global_sUpFileName#8
    $endif

    Dim Global_bFileFlags As Byte = 0

    Dim File_tEOF As Global_bFileFlags.0
    Dim File_tIsOpen As Global_bFileFlags.1
    Dim File_tRW As Global_bFileFlags.2                   ' 0 = Write, 1 = Read

    Dim File_dFileEntryDirSector As Dword
    Dim File_wFileEntryDirSectorPos As Word
    Dim File_dFirstCluster As Dword
    Dim File_dFATSector As Dword
    Dim File_wFATSectorPos As Word
    Dim File_wClusterSequenceIndex As Word
    Dim File_wClusterSequenceNumber As Word
    Dim File_bCurrentSectorInCluster As Byte
    Dim File_dCurrentSector As Dword
    Dim File_wCurrentSectorPos As Word
    Dim File_dSize As Dword
    Dim File_dBytesRead As Dword
    Dim File_wRecordLength As Word

    Dim Disk_tIsFull As Global_bFileFlags.3
    Dim Disk_tRWError As Global_bFileFlags.4
    Dim Disk_tIsDirty As Global_bFileFlags.5
    Dim Disk_tIsRootDirectory As Global_bFileFlags.6
    Dim Disk_tSearchFileOrDirectory As Global_bFileFlags.7
    Dim Disk_bSectorsPerCluster As Byte
    Dim Disk_dFAT1 As Dword
    Dim Disk_dFAT2 As Dword
    Dim Disk_dSectorsPerFAT As Dword
    Dim Disk_dRootDirectory As Dword
    Dim Disk_wSectorsInRoot As Word
    Dim Disk_dData As Dword
    Dim Disk_dLastCluster As Dword
    Dim Disk_bCardType As Byte
    Dim Disk_bFATType As Byte
    Dim Disk_tSlowSPI As Bit
    Dim Disk_dDirectoryStartSector As Dword
    Dim Disk_swFileSearchNumber As Word
    
    Dim Global_bSectorBuffer[512] As Byte                   ' Sector buffer
    
    $if McuType = 0
        Dim WREG13 As Word
        Dim WREG12 As Word
        Dim WREG4 As Word
        Dim WREG3 As Word
        Dim WREG2 As Word
        Dim WREG0 As Byte
    $endif
   
$ifdef SD_Detect                                            ' Are we using the SD detect switch?
    Dim SD_tInserted As Bit                                 ' False if the SD card is removed or missing
$endif    

$ifndef True
    $define True 1
$endif
$ifndef False
    $define False 0
$endif

'--------------------------------------------------------------------------------------------------------------------------
' Receive a byte from the card using a software SPI interface.
' Input     : None
' Return    : Returns the byte read from the SPI bus
' Notes     : None
'
$if McuType = 1
Proc SD_ReceiveByte(), WREG0.Byte0              
$else
Proc SD_ReceiveByte(), WREG0              
$endif
    $if SD_COM = SPI_1 Or SD_COM = SPI_2
        If Disk_tSlowSPI = True Then
            PinSet SD_SDO
            PinSet SD_CLK : DelayUS 4 : WREG0.7 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.6 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.5 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.4 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.3 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.2 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.1 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.0 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
        Else
            $if SD_COM = SPI_1
                $if McuType = 1
                    SPI1BUF = 0xFF
                    While SPI1STAT.0 = 0 : Wend
                    WREG0.Byte0 = SPI1BUF  
                $else
                    SSP1BUF = 0xFF
                    While SSP1STAT.0 = 0 : Wend
                    WREG0 = SSP1BUF
                $endif
            $elseif SD_COM = SPI_2
                $if McuType = 1
                    SPI2BUF = 0xFF
                    While SPI2STAT.0 = 0 : Wend
                    WREG0.Byte0 = SPI2BUF  
                $else
                    SSP2BUF = 0xFF
                    While SSP2STAT.0 = 0 : Wend
                    WREG0 = SSP2BUF
                $endif
            $endif
        EndIf
    $elseif SD_COM = SPI_SW
        If Disk_tSlowSPI = True Then
            PinSet SD_SDO
            PinSet SD_CLK : DelayUS 4 : WREG0.7 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.6 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.5 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.4 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.3 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.2 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.1 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            PinSet SD_CLK : DelayUS 4 : WREG0.0 = SD_SDI : DelayUS 4 : PinClear SD_CLK : DelayUS 4
        Else
            PinSet SD_SDO
            PinSet SD_CLK : WREG0.7 = SD_SDI : PinClear SD_CLK 
            PinSet SD_CLK : WREG0.6 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.5 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.4 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.3 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.2 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.1 = SD_SDI : PinClear SD_CLK
            PinSet SD_CLK : WREG0.0 = SD_SDI : PinClear SD_CLK
        EndIf
    $endif
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Send a byte to the card using a software SPI interface.
' Input     : pByte holds teh byte to write to the SPI bus
' Return    : None
' Notes     : None
'

$if McuType = 1
Proc SD_SendByte(pByte As WREG0.Byte0)           
$else
Proc SD_SendByte(pByte As WREG0)            
$endif
    Dim bDummy As Byte
    
    $if SD_COM = SPI_1 Or SD_COM = SPI_2
        If Disk_tSlowSPI = True Then
            SD_SDO = WREG0.7 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.6 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.5 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.4 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.3 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.2 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.1 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.0 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
        Else
            $if SD_COM = SPI_1
                $if McuType = 1
                    SPI1BUF = pByte
                    While SPI1STAT.0 = 0 : Wend
                    bDummy = SPI1BUF 
                $else
                    SSP1BUF = pByte
                    While SSP1STAT.0 = 0 : Wend
                    bDummy = SSP1BUF
                $endif 
            $elseif SD_COM = SPI_2  
                $if McuType = 1
                    SPI2BUF = pByte
                    While SPI2STAT.0 = 0 : Wend
                    bDummy = SPI2BUF 
                $else
                    SSP2BUF = pByte
                    While SSP2STAT.0 = 0 : Wend
                    bDummy = SSP2BUF
                $endif 
            $endif
        EndIf
    $elseif SD_COM = SPI_SW
        If Disk_tSlowSPI = True Then
            SD_SDO = WREG0.7 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.6 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.5 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.4 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.3 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.2 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.1 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4
            SD_SDO = WREG0.0 : DelayUS 4 : PinSet SD_CLK : DelayUS 4 : PinClear SD_CLK : DelayUS 4 
        Else
            SD_SDO = WREG0.7 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.6 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.5 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.4 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.3 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.2 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.1 : PinSet SD_CLK : PinClear SD_CLK 
            SD_SDO = WREG0.0 : PinSet SD_CLK : PinClear SD_CLK 
        EndIf 
    $endif
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Wait for a specified response from card
' Input     : pRequired holds the response wo wait for
' Return    : Returns the response from the SD card
' Notes     :
'
Proc SD_SeekResponse(pRequired As WREG3.Byte0), Byte
    Dim wTimeout As WREG2 = $FFFF
              
    Repeat
        Result = SD_ReceiveByte()
        Dec wTimeout
        If wTimeout = 0 Then Break
    Until Result = pRequired
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Send a command to card using SPI interface
' Input     : pCommand holds the command
'           : pValue holds the value associated with the command
' Return    :
' Notes     :
'
Proc SD_SendCmd(pCommand As Byte, pValue As Dword), Byte
    Dim wIndex As Word

$ifdef SD_Detect                                            ' Are we using the SD detect switch?
    If SD_Detect = SD_cMissing Then                         ' Is the SD insterted?
        SD_tInserted = False                                ' No. Set the flag
    EndIf
$endif
    PinSet SD_CS                                            ' Select card and wait for ready
    PinClear SD_CLK
    PinClear SD_CS
        
    For wIndex = 0 To 9999
        If SD_SeekResponse($FF) <> $FF Then                 ' Wait for ready
            Result = $FF
        Else 
            Break  
        EndIf           
    Next
         
    If Result = $FF Then ExitProc
              
    SD_SendByte(pCommand)                               ' Send the Command
    SD_SendByte(pValue.Byte3)                           ' \
    SD_SendByte(pValue.Byte2)                           ' | Send the value associated with the command
    SD_SendByte(pValue.Byte1)                           ' |
    SD_SendByte(pValue.Byte0)                           ' /
    If pCommand = SD_cCMD0 Then
        SD_SendByte($95)			                    ' CRC for SD_cCMD0($0000)
    ElseIf pCommand = SD_cCMD8 Then
        SD_SendByte($87)			                    ' CRC for SD_cCMD8($01AA)
    Else
        SD_SendByte($FF)                                ' Default CRC byte
    EndIf
    wIndex = 10000
    Repeat                                              ' Receive the command's response
        Result = SD_ReceiveByte()
        Dec wIndex
        If wIndex = 0 Then Break
    Until Result.7 = 0                                    ' Wait for a valid response in timeout of 100 attempts
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Sends Cmd 55 followed by 41
' Input     : pHCSBitSet
' Return    :
' Notes     :
'
Proc SD_Cmd5541(pHCSBitSet As Bit), Byte
    Result = SD_SendCmd(SD_cCMD55, 0)
    If Result > 1 Then
        ExitProc
    Else
        If pHCSBitSet = True Then
            Result = SD_SendCmd(SD_cCMD41, $40000000)
        Else
            Result = SD_SendCmd(SD_cCMD41, $00000000)
        EndIf
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' SD_Init SD or MMC card.
' Input     : None
' Return    : 0 = Success, 1 = Fail/card not present
' Notes     : Sets Input/Output pins and switches card to SPI mode.
'
Proc SD_InitSequence(), Bit
    Dim wIndex As Word
    Dim wOCR As Word
    Dim bSdDummy As Byte
    
    Disk_tSlowSPI = True                                                ' Set SPI to slow mode for initialisation
    
    $if SD_COM = SPI_1 Or SD_COM = SPI_2
        $if SD_COM = SPI_1
            $if McuType = 1
                SPI1STAT.15 = 0  
            $else
                SSP1CON1.5 = 0 
            $endif
        $elseif SD_COM = SPI_2
            $if McuType = 1
                SPI2STAT.15 = 0  
            $else
                SSP2CON1.5 = 0 
            $endif
        $endif   
        Output SD_CS : Input SD_SDI : Output SD_CLK : Output SD_SDO
        PinHigh SD_CS : PinLow SD_SDO : PinLow SD_CLK 
        SD_SendByte(0xFF)
    $endif
    
    PinHigh SD_CS
    PinLow SD_SDO
    PinLow SD_CLK
    PinInput SD_SDI
$ifdef SD_Detect                                                        ' Are we using an SD detect switch?
    PinInput SD_Detect                                                  ' Yes. So make it an input
    SD_tInserted = True                                                 ' Set the flag to true
$endif

$ifdef SD_Power                                                         ' Do we need to power cycle the SD card?
    PinHigh SD_Power                                                    ' Yes. So turn off the power to the SD card
    DelayMS 500                                                         ' For a while
    PinClear SD_Power                                                   ' Turn on the power to the SD card
    DelayMS 500                                                         ' Wait for stabilisation
$endif

    Result = False
    Disk_bCardType = 0
    PinSet SD_CS                                                        ' Pull SD_CS high
    PinLow SD_CLK
'
' Clock the SD for a minimum of 80 cycles
'
    wIndex = 100
    Repeat
        SD_SendByte($FF)
        Dec wIndex
    Until wIndex = 0    
     
    PinClear SD_CLK               
    PinClear SD_CS                                                      ' Pull the SD_CS low
    
    SD_SendByte(SD_cCMD0)                               ' Send the Command
    SD_SendByte(0x00)                                   ' \
    SD_SendByte(0x00)                                   ' | Send the value associated with the command
    SD_SendByte(0x00)                                   ' |
    SD_SendByte(0x00)                                   ' /
    SD_SendByte($95)			                         ' CRC for SD_cCMD0($0000)
    
    wIndex = 10000
    Repeat                                              ' Receive the command's response
        bSdDummy = SD_ReceiveByte()
        Dec wIndex
        If wIndex = 0 Then Break
    Until bSdDummy.7 = 0                                ' Wait for a valid response in timeout of 100 attempts
    
    If bSdDummy.7 <> 0  Then ExitProc
    
    
    If SD_SendCmd(SD_cCMD8, $000001AA) = 1 Then                     ' SDC Version 2+
        SD_ReceiveByte()
        SD_ReceiveByte()
        wOCR.Byte0 = SD_ReceiveByte()
        wOCR.Byte1 = SD_ReceiveByte()
        If wOCR.Byte0 = $01 Then
            If wOCR.Byte1 = $AA Then                                ' SD Vdd range of 2.7 - 3.6 volts
                wIndex = SD_cTimeOutLimit
                Repeat
                    Dec wIndex
                    If wIndex = 0 Then Break
                Until SD_Cmd5541(True) = 0
                If wIndex > 0 Then                                  ' Cmd 55/41 successful with HCS bit set
                    If SD_SendCmd(SD_cCMD58, $00000000) = 0 Then    ' Send Cmd 58
                        wOCR.Byte0 = SD_ReceiveByte()
                        SD_ReceiveByte()                            ' \
                        SD_ReceiveByte()                            ' | Padding reads
                        SD_ReceiveByte()                            ' /
                        If wOCR.6 = 1 Then                          ' Is CCS[30] bit in the OCR set?
                            Disk_bCardType = SD_cSDHC               ' Init successful - SDHC (3)
                        Else
                            Disk_bCardType = SD_cSD                 ' Init successful - SD (2)
                        EndIf
                    EndIf
                EndIf
            EndIf
        EndIf
    Else
        If SD_Cmd5541(False) <= 1 Then
            Disk_bCardType = SD_cSD                                 ' Init successful - SD (2)
            wIndex = SD_cTimeOutLimit
            Repeat
                Dec wIndex
                If wIndex = 0 Then Break
            Until SD_Cmd5541(True) = 0                              ' Wait for leaving idle state
        Else
            Disk_bCardType = SD_cMMC                                ' Init successful - MMC (1)
            wIndex = SD_cTimeOutLimit
            Repeat
                Dec wIndex
                If wIndex = 0 Then Break
            Until SD_SendCmd(SD_cCMD1, $00) = 0                     ' Wait for leaving idle state
        EndIf
        If wIndex = 0 Then
            Disk_bCardType = 0
        EndIf
    EndIf

    
    PinSet SD_CS
    SD_SendByte($FF)                                                    ' Clock SD/MMC to complete
       
    If Disk_bCardType > 0 Then
        Result = True
        Disk_tSlowSPI = False                                           ' Set SPI to fast mode
        $if SD_COM = SPI_1 Or SD_COM = SPI_2
            $if SD_COM = SPI_1
                $if McuType = 1
                    SPI1STAT.15 = 1 
                $else
                    SSP1CON1.5 = 1 
                $endif
            $elseif SD_COM = SPI_2
                $if McuType = 1
                    SPI2STAT.15 = 1  
                $else
                    SSP2CON1.5 = 1 
                $endif
            $endif
            Output SD_CS : Input SD_SDI : Output SD_CLK : Output SD_SDO
        $endif
    EndIf
    
    If Disk_bCardType <> SD_cSDHC Then
        PinSet SD_CS 
        PinClear SD_CLK 
        PinClear SD_CS
    
        wSdExitCounter = 9999
        $if McuType = 1
            Repeat 
                bSdDummy = SD_ReceiveByte()
                Dec wSdExitCounter
            Until bSdDummy = $FF Or wSdExitCounter = 0
        $else
            Repeat 
                Dec wSdExitCounter
            Until SD_ReceiveByte() = $FF Or wSdExitCounter = 0
        $endif 
    
        SD_SendByte(SD_cCMD16)  
        SD_SendByte(0x00)
        SD_SendByte(0x00)
        SD_SendByte(0x02)
        SD_SendByte(0x00)
        SD_SendByte($FF)
    
        wSdExitCounter = 9999
        $if McuType = 1
            Repeat 
                bSdDummy = SD_ReceiveByte()
                Dec wSdExitCounter
            Until bSdDummy = $00 Or wSdExitCounter = 0
        $else
            Repeat 
                Dec wSdExitCounter
            Until SD_ReceiveByte() = $00 Or wSdExitCounter = 0
        $endif
     
        PinSet SD_CS 
     EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Initialise sector for reading.
' Input     :
' Return    :
' Notes     :
'
$define SD_SectorInitRead(pSector) '
    File_wCurrentSectorPos = 0     '
    SD_ReadSector(pSector)
    
'--------------------------------------------------------------------------------------------------------------------------
' Read a full sector from card to buffer.
' Input     : pSector holds the secor of interest
' Return    :
' Notes     :
'
Proc SD_ReadSector(pSector As Dword)
    'Dim Bytein As Byte
'
' If RW error has occurred, prevent further reading from disk
'
    If Disk_tRWError = True Then ExitProc
    Global_bSecRWTimeOut = 0
    Global_tSecRWError = True
'
' MMC or SD - byte addressing (SDHC use block addressing)
'
    If Disk_bCardType.2 = 0 Then
        pSector = pSector << 9
    EndIf
    Repeat
        PinClear SD_CS
        If SD_SendCmd(SD_cCMD17, pSector) = $00 Then                ' Send Cmd 17
            If SD_SeekResponse($FE) = $FE Then                      ' Read start token
                Global_wSecRWIndex = 512
                WREG13 = AddressOf(Global_bSectorBuffer)
                Repeat                                              ' Read data block
                    Ptr8(WREG13++) = SD_ReceiveByte()
                    Dec Global_wSecRWIndex
                Until Global_wSecRWIndex = 0
                SD_ReceiveByte()                                    ' Read dummy CRC to conclude data block
                SD_ReceiveByte()
                Global_tSecRWError = False                          ' Read completed successfully
            EndIf
        EndIf
        PinSet SD_CS
        SD_SendByte($FF)                                            ' Clock SD/MMC to complete read
        Inc Global_bSecRWTimeOut
        If Global_bSecRWTimeOut > 1 Then Break
    Until Global_tSecRWError = False
'
' Set RWError flag - can only be cleared using SD_Init()
'
    Disk_tRWError = Global_tSecRWError
EndProc

Proc SD_ReadSector_F(pSector As Dword) 
    Dim bTftDummy As Byte 
    
    If Disk_bCardType.2 = 0 Then
        pSector = pSector << 9
    EndIf
    
    PinSet SD_CS  
    PinClear SD_CS
    
    wSdExitCounter = 9999
    $if McuType = 1
        Repeat 
            bTftDummy = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy = $FF Or wSdExitCounter = 0
    $else
        Repeat 
            Dec wSdExitCounter
        Until SD_ReceiveByte() = $FF Or wSdExitCounter = 0
    $endif 
    
    SD_SendByte(SD_cCMD17)  
    SD_SendByte(pSector.Byte3)
    SD_SendByte(pSector.Byte2)
    SD_SendByte(pSector.Byte1)
    SD_SendByte(pSector.Byte0)
    SD_SendByte($FF)
    
    wSdExitCounter = 9999
    $if McuType = 1
        Repeat 
            bTftDummy = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy = $FE Or wSdExitCounter = 0
    $else
        Repeat 
            Dec wSdExitCounter
        Until SD_ReceiveByte() = $FE Or wSdExitCounter = 0
    $endif 
    
    Global_wSecRWIndex = 512
    WREG13 = AddressOf(Global_bSectorBuffer)
    Repeat                                              ' Read data block
        Ptr8(WREG13++) = SD_ReceiveByte()
        Dec Global_wSecRWIndex
    Until Global_wSecRWIndex = 0
    SD_ReceiveByte()                                    ' Read dummy CRC to conclude data block
    SD_ReceiveByte()
    PinSet SD_CS
    SD_SendByte($FF)                                            ' Clock SD/MMC to complete read    
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Initialise sector for writing.
' Input     : None
' Return    : None
' Notes     : None
'
Proc SD_SectorInitWrite()
    File_wCurrentSectorPos = 0
    Clear Global_bSectorBuffer
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Write a full sector from buffer to card
' Input     : pSector hols the sector to write into
' Return    : None
' Notes     : None
'
Proc SD_WriteSector(pSector As Dword)
    Dim bResponse As Global_wSecRWIndex.Byte0
'
' If RW error has occurred, prevent further writing to disk loop until reinitialised
'
    If Disk_tRWError = True Then ExitProc
    Global_bSecRWTimeOut = 0
    Global_tSecRWError = True
'
' MMC or SD - byte addressing (SDHC use block addressing)
'
    If Disk_bCardType.2 = 0 Then
        pSector = pSector << 9
    EndIf
    Repeat
        PinClear SD_CS                                              ' Send Cmd 24
        If SD_SeekResponse($FF) = $FF Then                          ' Wait for ready
            If SD_SendCmd(SD_cCMD24, pSector) = $00 Then
                SD_SendByte($FE)                                    ' Write start token
                Global_wSecRWIndex = 512
                WREG12 = AddressOf(Global_bSectorBuffer)
                Repeat  
                    $if McuType = 1
                        WREG0.Byte0 = Ptr8(WREG12++)
                        SD_SendByte(WREG0.Byte0)
                    $else
                        WREG0 = Ptr8(WREG12++)
                        SD_SendByte(WREG0)
                    $endif                                            ' Write data block
                    Dec Global_wSecRWIndex
                Until Global_wSecRWIndex = 0
                SD_SendByte($FF)                                    ' Send dummy CRC to conclude data block
                SD_SendByte($FF)
                bResponse = SD_ReceiveByte()                        ' Data response token
                bResponse = bResponse & $0F
                If bResponse = $05 Then
                    Global_tSecRWError = False
                EndIf
            EndIf
        EndIf
        PinSet SD_CS
        SD_SendByte($FF)                                            ' Complete SPI transaction
        Inc Global_bSecRWTimeOut
        If Global_bSecRWTimeOut > 63 Then Break
    Until Global_tSecRWError = False
'
' Set RWError flag - can only be cleared using SD_Init()
'
    Disk_tRWError = Global_tSecRWError
EndProc   

'--------------------------------------------------------------------------------------------------------------------------
' Write a byte to current sector
' Input     : pByte holds teh byte to write to the sector
' Return    : None
' Notes     : None
'
Proc FAT_WriteSectorByte(pByte As Byte)
    If File_wCurrentSectorPos = 512 Then
        File_wCurrentSectorPos = 0
    EndIf

    Global_bSectorBuffer[File_wCurrentSectorPos] = pByte
    Disk_tIsDirty = True
    If File_wCurrentSectorPos = $01FF Then
        SD_WriteSector(File_dCurrentSector)
        Disk_tIsDirty = False
    EndIf
    Inc File_wCurrentSectorPos
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Read an entry from the FAT
' Input     :
' Return    : None
' Notes     : None
'
Proc FAT_ReadFATEntry(pSectorPos As WREG13), Dword
    WREG12 = AddressOf(Global_bSectorBuffer)
    WREG12 = WREG12 + pSectorPos

    Result.Byte0 = Ptr8(WREG12++)
    Result.Byte1 = Ptr8(WREG12++)
    If Disk_bFATType = FAT_cFAT16 Then                          ' FAT16?
        Result.Byte2 = 0
        Result.Byte3 = 0
    Else                                                        ' Otherwise... FAT32
        Result.Byte2 = Ptr8(WREG12++)
        Result.Byte3 = Ptr8(WREG12++)
        Result.Byte3 = Result.Byte3 & $0F                       ' Clear high 4 bits for 28 bit FAT entry
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Calculate cluster number based on FAT sector/position
' Input     :
' Return    :
' Notes     : FAT16 and FAT32
'
Proc FAT_SectorToCluster(), Dword
    Result = File_wFATSectorPos / (2 * Disk_bFATType)
    Result = Result + (File_dFATSector * 256 / Disk_bFATType)
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Calculate FAT Sector/position based on cluster Number
' Input     :
' Return    :
' Notes     :
'
Proc FAT_ClusterToFATSector(pClust As Dword)
    If Disk_bFATType = FAT_cFAT16 Then
        File_dFATSector = pClust / 256                     ' Find FAT16 position for existing cluster
        File_wFATSectorPos = pClust // 256
        File_wFATSectorPos = File_wFATSectorPos * 2
    Else
        File_dFATSector = pClust / 128                     ' Find FAT32 position for existing cluster
        File_wFATSectorPos = pClust // 128
        File_wFATSectorPos = File_wFATSectorPos * 4
    EndIf
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Calculate cluster number based on data sector
' Input     :
' Return    :
' Notes     : FAT16 and FAT32
'
Proc FAT_DataToCluster(), Dword
    Result = (File_dCurrentSector - Disk_dData) / Disk_bSectorsPerCluster
    Result = Result + 2
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Calculate data sector based on cluster number
' Input     :
' Return    :
' Notes     : FAT16 and  FAT32
'
Proc FAT_ClusterToData(pClust As Dword), Dword
    Result = (pClust - 2) * Disk_bSectorsPerCluster
    Result = Result + Disk_dData
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Find a free cluster in the FAT
' Input     :
' Return    :
' Notes     :
'
Proc FAT_FindFreeCluster(), Byte
    Dim dScanSec As Dword
    Dim wScanSePos As Word
    Dim dFATEntry As Dword
    Dim dCluster As Dword
    Dim bNumOfSca As Byte
    Dim wScSePosNew As Word
    Dim dMaxScSe As Dword
    Dim tReUsSec As Bit

    Result = 1                                                   ' Scan FAT1 for free cluster address
    dScanSec = (Disk_dFAT1 + File_dFATSector)
'
' Jump over reserved clusters to start of where free clusters might exist
'
    wScSePosNew = File_wFATSectorPos + ((2 * Disk_bFATType) * File_wClusterSequenceNumber)
    wScanSePos = wScSePosNew

    bNumOfSca = 0
    dMaxScSe = Disk_dFAT1 + Disk_dSectorsPerFAT
    Repeat
        Repeat
            SD_SectorInitRead(dScanSec)                      ' Set sector & read sector to buffer
            While wScanSePos < 512
                dFATEntry = FAT_ReadFATEntry(wScanSePos)
                If dFATEntry = $00 Then
                    Result = 0
                    Break
                EndIf
                wScanSePos = wScanSePos + (2 * Disk_bFATType)
            Wend

            If Result > 0 Then                                  ' Not found, so Inc dScanSec and re-init wScanSePos
                Inc dScanSec
                wScanSePos = $00
            Else
                Break
            EndIf
        Until dScanSec = dMaxScSe

        If Result > 0 Then
            dScanSec = Disk_dFAT1                             ' Re-start at beginning of FAT to pick up any clusters that have become available since opening file
            dMaxScSe = Disk_dFAT1 + File_dFATSector + 1     ' On second pass, stop at current sector
            Inc bNumOfSca
        EndIf
        If bNumOfSca = 2 Then Break
    Until Result = 0

    tReUsSec = False
    If bNumOfSca = 1 Then
        If dScanSec = (Disk_dFAT1 + File_dFATSector) Then
            tReUsSec = True
        EndIf
    EndIf
'
' No free cluster, or on second pass, has refound reserved clusters
'
    If Result = 1 Then
        ExitProc
    EndIf
    If tReUsSec = True Then
        If wScanSePos >= File_wFATSectorPos Then
            ExitProc
        EndIf
    EndIf

    dCluster = wScanSePos / (2 * Disk_bFATType)
    dCluster = dCluster + ((dScanSec - Disk_dFAT1) * (256 / Disk_bFATType))
    If dCluster > Disk_dLastCluster Then                          ' Check resulting cluster (hence sector) not greater than number on card
        Result = 1
    Else
        File_dFATSector = dScanSec - Disk_dFAT1                 ' Store FAT sector
        File_wFATSectorPos = wScanSePos                       ' Store buffer position

        If tReUsSec = True Then
            File_wClusterSequenceNumber = 1                      ' If re-using sector, then limit sequence to 1 to prevent possible overwrite of reserved clusters
        Else
            File_wClusterSequenceNumber = 0
            Repeat
                dFATEntry = FAT_ReadFATEntry(wScanSePos)
                If dFATEntry = $00 Then
                    Inc File_wClusterSequenceNumber              ' Number of empty clusters in sector
                Else
                    Break
                EndIf
                wScanSePos = wScanSePos + (2 * Disk_bFATType)
            Until wScanSePos > $1FF
        EndIf
        File_wClusterSequenceIndex = 1                           ' Initialise the cluster sequence
        If (dCluster + File_wClusterSequenceNumber - 1) > Disk_dLastCluster Then
            File_wClusterSequenceNumber = Disk_dLastCluster - dCluster + 1
        EndIf
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Finds next sector in FAT chain
' Input     : None
' Return    : Tru = Success, False = End of cluster chain reached
' Notes     : None
'
Proc FAT_IncrementSector(), Bit
    Dim dCluster As Dword

    Result = True
    Inc File_bCurrentSectorInCluster
    If File_bCurrentSectorInCluster > Disk_bSectorsPerCluster Then
        File_dCurrentSector = File_dCurrentSector - (Disk_bSectorsPerCluster - 1)
        dCluster = FAT_DataToCluster()
        FAT_ClusterToFATSector(dCluster)                         ' Find FAT position for existing cluster
        File_dCurrentSector = Disk_dFAT1 + File_dFATSector
        SD_ReadSector(File_dCurrentSector)
        dCluster = FAT_ReadFATEntry(File_wFATSectorPos)
        If Disk_bFATType = FAT_cFAT16 Then
            If dCluster = $FFFF Then ExitProc
        EndIf
        If Disk_bFATType = FAT_cFAT32 Then
            If dCluster = $0FFFFFFF Then ExitProc
        EndIf
        File_dCurrentSector = FAT_ClusterToData(dCluster)
        File_bCurrentSectorInCluster = 1
        Result = False
        FAT_ClusterToFATSector(dCluster)                         ' Update FAT positions
    Else
        Inc File_dCurrentSector
        Result = False
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Returns a byte from position pPos in Root Directory entry
' Input     : pPos holds the position within the sector array
' Return    : Byte read from the sector array
' Notes     :
'

$if McuType = 1
Proc FAT_RootDirPosition(pPos As WREG0.Byte0), Byte           
$else
Proc FAT_RootDirPosition(pPos As WREG0), Byte            
$endif
    Result = Global_bSectorBuffer[File_wCurrentSectorPos + pPos]
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Check type and status of entry in directory
' Input     : pFileDir = 0 for file, 1 for directory
' Return    : Returns true if entry is a file or directory, and not a deleted file,
'           : long filename, system, hidden or volume entry
' Notes     :
'
Proc FAT_CheckFileEntryStatus(pFileDir As Bit), Bit
    Dim bByte00 As Byte
    Dim bByte0B As Byte

    Result = False                                      ' Default to a false result
    bByte00 = FAT_RootDirPosition($00)
    bByte0B = FAT_RootDirPosition($0B)
    If (bByte0B | %11110000) <> $FF Then                ' Not long filename entry
        If bByte00 <> $00 Then                          ' Not empty entry
            If bByte00 <> $E5 Then                      ' Not deleted entry
                If (bByte0B & %00001110) = 0 Then       ' Not system, hidden or volume
                                                        ' File attributes (00ADVSHR)
                                                        '   0: unused bit, A: archive bit, D: Dir bit,
                                                        '   V: volume bit, S: system bit, R: read-only bit)
                    If (bByte0B.4 ^ pFileDir) = 0 Then  ' Check if file or directory
                        Result = True                   ' Return a true result
                    EndIf
                EndIf
            EndIf
        EndIf
    EndIf
EndProc

'----------------------------------------------------------------------------------

Proc File_ChDirUp(), Bit
    Result = FAT_ChDir("..")
EndProc

'------------------------------------------------------------------------------------------------
' Modify the string addressed by pFileNaAdd to suit the FAT table
' Input     : pFileNaAdd holds the address of the string to be modified
' Return    : The string pointed to by pFileNaAdd will be modified
' Notes     : None
'
Proc FAT_ModifyFileName()
    Dim bCounter As Byte
    Dim bCounter1 As Byte
    Dim bIndex As Byte
    Dim bTemp As Byte
    Dim pFile As Bit
    
    Global_sUpFileName = "           "
    
    If Global_sFileName[0] = "." Then
        If Global_sFileName[1] = "." Then
            Global_sUpFileName = "..         "
            ExitProc
        EndIf
    EndIf
    
    pFile = 0
    For bIndex = 0 To 11
        If Global_sFileName[bIndex] = "." Then
            pFile = 1
            Break
        EndIf      
    Next
    
    If pFile = 1 Then
        bIndex = 0 : bCounter = 0 
        Repeat
            bTemp = Global_sFileName[bIndex] 
            If bTemp = "." Then 
                Inc bIndex
                Break
            EndIf
            Select bTemp
                Case 48 To 57 
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 64 To 90
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 94 To 123
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 32,33,35,36,37,38,39,40,41,45,125,126
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Else Else
                    Global_sUpFileName[bCounter] = "_"
                    Inc bCounter  
            EndSelect
            Inc bIndex
        Until bIndex = 8
        
        bCounter = 8
        Repeat
            bTemp = Global_sFileName[bIndex]
            If bTemp = 0 Then Break
            Select bTemp
                Case 48 To 57 
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 64 To 90
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 94 To 123
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 32,33,35,36,37,38,39,40,41,45,125,126
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Else Else
                    Global_sUpFileName[bCounter] = "_"
                    Inc bCounter  
            EndSelect
            Inc bIndex
         Until bCounter = 11
    Else
        bIndex = 0 : bCounter = 0
        Repeat
            bTemp = Global_sFileName[bIndex]
            If bTemp = 0 Then Break
            Select bTemp
                Case 48 To 57 
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 64 To 90
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 94 To 123
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Case 32,33,35,36,37,38,39,40,41,45,125,126
                    Global_sUpFileName[bCounter] = bTemp
                    Inc bCounter 
                Else Else
                    Global_sUpFileName[bCounter] = "_"
                    Inc bCounter  
            EndSelect          
            Inc bIndex       
        Until bIndex = 8
    EndIf

    Clear Global_sFileName
    Global_sFileName = Global_sUpFileName
    Global_sUpFileName = ToUpper(Global_sFileName)
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Load the variable File_dSize with the size of the file
' Input     : None
' Output    : File_dSize
' Notes     : None
'
Proc FAT_GetFileSize()
    File_dSize.Byte0 = FAT_RootDirPosition($1C)     ' \
    File_dSize.Byte1 = FAT_RootDirPosition($1D)     ' | Obtain the file size (in bytes)
    File_dSize.Byte2 = FAT_RootDirPosition($1E)     ' |
    File_dSize.Byte3 = FAT_RootDirPosition($1F)     ' /
EndProc

Proc File_Size(pFileName As Global_sFileName), Dword
    Result = 0
    If File_tIsOpen = 1 Then ExitProc
    
    If FAT_OpenFile(pFileName) = cErrOK Then
        Result = File_dSize
        FAT_CloseFile()
    EndIf
EndProc

Proc File_SizeOpen(), Dword
    Result = 0
    If File_tIsOpen = 0 Then ExitProc
    Result = File_dSize
EndProc

Proc File_ListReset()
    Disk_swFileSearchNumber = 1
EndProc

Proc File_ListDir(), String * 8
    Clear Result 
    Clear Global_sFileName
    If FAT_FindRootDirEntry(2, FAT_cDirectory) = True Then
        Result = Global_sFileName
        Inc Disk_swFileSearchNumber
    EndIf
EndProc

Proc File_ListFile(), String * 12
    Dim bCounter1 As Byte
    Dim bCounter2 As Byte
    Clear Result 
    Clear Global_sUpFileName
    Clear Global_sFileName
    
    bCounter2 = 0
    If FAT_FindRootDirEntry(2, FAT_cFile) = True Then
        For bCounter1 = 0 To 7
            If Global_sFileName[bCounter1] <> " " Then    
                Global_sUpFileName[bCounter2] = Global_sFileName[bCounter1]
                Inc bCounter2
            EndIf
        Next
        Global_sUpFileName[bCounter2] = "."
        Inc bCounter2
        For bCounter1 = 8 To 10
            If Global_sFileName[bCounter1] <> " " Then 
                Global_sUpFileName[bCounter2] = Global_sFileName[bCounter1]
                Inc bCounter2
            EndIf
        Next
        
        Result = Global_sUpFileName
        Inc Disk_swFileSearchNumber
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Search for free root directory entry, search for file, or search for files using Dir
' Input     : pType: 0 = Free position, 1 = Existing File/Dir, 2 = Dir command, 3 = GetVolumeLabel
'           : pFileDir: 0 = Find file, 1 = Find directory
' Return    : True = Success, False = Fail
'           : Global variable File_dSize holds the size of a file or directory
' Notes     : None
'
Proc FAT_FindRootDirEntry(pType As Byte, pFileDir As Bit), Bit
    Dim bTemp As Byte
    Dim bRDirFPos As Byte
    Dim wRDirFNum As Word
    Dim tNullFl As Bit
    Dim dCluster As Dword
    Dim bResponse As Byte

    wRDirFNum = 0
    Result = False                                              ' Default result
    File_dCurrentSector = Disk_dDirectoryStartSector
    File_bCurrentSectorInCluster = 1

    Repeat
        If Disk_tRWError = True Then
            Result = False
            ExitProc
        EndIf
        SD_SectorInitRead(File_dCurrentSector)                  ' Read sector to buffer
        File_wCurrentSectorPos = $0000
        Repeat
            Select pType
                '
                ' Search for free position
                '
                Case 0
                    If FAT_RootDirPosition(0) = 0 Then
                        Result = True
                    EndIf
                    If FAT_RootDirPosition(0) = $E5 Then
                        Result = True
                    EndIf
                '
                ' Search for file or directory by name
                '
                Case 1
                    If FAT_RootDirPosition(0) = 0 Then          ' Once found first $00 entry, must have reached end of valid files in directory
                        ExitProc
                    EndIf
                    tNullFl = False
                    bRDirFPos = 0
                    Repeat    
                        bTemp = FAT_RootDirPosition(bRDirFPos)                  'Check file/dir name
                        If bTemp > 96 And bTemp < 123 Then bTemp = bTemp - 32
                        If bTemp <> Global_sUpFileName[bRDirFPos] Then
                            tNullFl = True
                            Break
                        EndIf
                        Inc bRDirFPos
                    Until bRDirFPos = 8

                    bRDirFPos = 8
                    Repeat                                      
                        bTemp = FAT_RootDirPosition(bRDirFPos)      ' Check file/dir extension
                        If bTemp > 96 And bTemp < 123 Then bTemp = bTemp - 32
                        If bTemp <> Global_sUpFileName[bRDirFPos] Then
                            tNullFl = True
                            Break
                        EndIf
                        Inc bRDirFPos
                    Until bRDirFPos = 11

                    If tNullFl = False Then
                        If FAT_CheckFileEntryStatus(pFileDir) = True Then
                            dCluster.Byte0 = FAT_RootDirPosition($1A)       ' Locate cluster number
                            dCluster.Byte1 = FAT_RootDirPosition($1B)
                            dCluster.Byte2 = FAT_RootDirPosition($14)       ' High byte for FAT32
                            dCluster.Byte3 = FAT_RootDirPosition($15)
                            FAT_GetFileSize()                               ' Obtain the file size (in bytes)
                            File_ReadTimeMod()                              ' get date/tim modified
                            Result = True
                        EndIf
                    EndIf
                '
                ' Dir command
                '
                Case 2
                    '
                    ' Once found first $00 entry, must have reached end of valid files in directory
                    '
                    If FAT_RootDirPosition(0) = 0 Then ExitProc

                    If FAT_CheckFileEntryStatus(pFileDir) = True Then
                        Inc wRDirFNum
                        '
                        ' Found required entry in directory
                        '
                        If wRDirFNum = Disk_swFileSearchNumber Then
                            '
                            ' Transfer file name
                            '
                            bRDirFPos = 0
                            Repeat
                                Global_sFileName[bRDirFPos] = FAT_RootDirPosition(bRDirFPos)
                                Inc bRDirFPos
                            Until bRDirFPos = 8
                            '
                            ' Transfer file extension
                            '
                            Global_sUpFileName[8] = 0                            ' String terminator
                            Repeat
                                Global_sFileName[bRDirFPos] = FAT_RootDirPosition(bRDirFPos)
                                Inc bRDirFPos
                            Until bRDirFPos = 11
                            Global_sFileName[11] = 0                           ' String terminator
                            FAT_GetFileSize()                               ' Obtain the file size (in bytes)
                            File_ReadTimeMod()                              ' get date/tim modified
                            Result = True
                        EndIf
                    EndIf
                '
                ' GetVolumeLabel() command
                '
                Case 3
                    '
                    ' Once found first $00 entry, must have reached end of valid files in directory
                    '
                    If FAT_RootDirPosition(0) = 0 Then ExitProc

                    If FAT_RootDirPosition($0B) = %00001000 Then        ' Volume label (VolumeID bit only set)
                        If FAT_RootDirPosition($0B) <> $E5 Then         ' Not deleted entry
                            Result = True
                        EndIf
                    EndIf
            EndSelect
            File_wCurrentSectorPos = File_wCurrentSectorPos + 32
            If Result = True Then Break
        Until File_wCurrentSectorPos > $01FF

        File_wCurrentSectorPos = File_wCurrentSectorPos - 32
        If Result = False Then
            If Disk_tIsRootDirectory = 1 Then
                Inc File_dCurrentSector
                If File_dCurrentSector < (Disk_dRootDirectory + Disk_wSectorsInRoot) Then
                    bResponse = 0
                Else
                    bResponse = 1
                EndIf
            Else
                bResponse = FAT_IncrementSector()
            EndIf
        EndIf
        If bResponse = 1 Then Break
    Until Result = True

    If Result = False Then
        ExitProc
    EndIf
    File_dFileEntryDirSector = File_dCurrentSector              ' Store root directory position
    File_wFileEntryDirSectorPos = File_wCurrentSectorPos        ' Store buffer position
    If pType = 1 Then                                           ' Only perform if searching for specific entry
        If dCluster = 0 Then                                    ' Only true when using ChDir to return to Root Directory using FAT_cCdUp
            File_dCurrentSector = Disk_dRootDirectory
        Else
            File_dCurrentSector = FAT_ClusterToData(dCluster)
        EndIf
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Insert a byte into the buffer array
' Input     : pSectorPos holds the position within the buffer
'           : pByte holds the byte to write into the buffer array
' Return    : None
' Notes     : None
'
$define FAT_InsertByteIntoBuffer(pSectorPos, pByte) Global_bSectorBuffer[pSectorPos] = pByte

'--------------------------------------------------------------------------------------------------------------------------
' Write an entry into the FAT
' Input     :
' Return    : None
' Notes     : None
'
Proc FAT_WriteFATEntry(pClust As Dword, pFATSectorPos As Word)
    FAT_InsertByteIntoBuffer(pFATSectorPos, pClust.Byte0)
    Inc pFATSectorPos
    FAT_InsertByteIntoBuffer(pFATSectorPos, pClust.Byte1)
    Inc pFATSectorPos
    If Disk_bFATType = FAT_cFAT32 Then
        FAT_InsertByteIntoBuffer(pFATSectorPos, pClust.Byte2)
        Inc pFATSectorPos
        '
        ' Keep high 4 bits of FAT cluster and Or with high byte of new cluster (28 bit cluster address)
        '
        FAT_InsertByteIntoBuffer(pFATSectorPos, (Global_bSectorBuffer[pFATSectorPos] & $F0) | pClust.Byte3)
        Inc pFATSectorPos
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Update FAT sector after cluster sequence written.
' Input     : pType: 0 = End continue, 1 = End close
' Return    : None
' Notes     : None
'
Proc FAT_AssembleFATSector(pFATSePr As Dword, pFATSPP As Word, pClSeNuPr As Word, pType As Bit)
    Dim dCluster As Dword

    dCluster = (pFATSePr * 256) / Disk_bFATType                 ' Derive first cluster number
    dCluster = dCluster + (pFATSPP / (2 * Disk_bFATType))
    Inc dCluster
    While pClSeNuPr > 1
        FAT_WriteFATEntry(dCluster, pFATSPP)
        pFATSPP = pFATSPP + 2
        If Disk_bFATType = FAT_cFAT32 Then                                ' FAT32?
            pFATSPP = pFATSPP + 2
        EndIf
        Inc dCluster
        Dec pClSeNuPr
    Wend
    If pType = 0 Then
        FAT_WriteFATEntry(FAT_SectorToCluster(), pFATSPP)
    Else
        If Disk_bFATType = FAT_cFAT16 Then
            FAT_WriteFATEntry($FFFF, pFATSPP)             ' FAT16?
        Else
            FAT_WriteFATEntry($0FFFFFFF, pFATSPP)         ' Otherwise... FAT32
        EndIf
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Write a single byte to File_
' Input     : The byte to write to the file
' Return    : None
' Notes     : Disk_tIsFull = True when disk full
'
Proc FAT_WriteByte(pByte As Byte)
    Dim dFATSecPrev As Dword
    Dim wFATSecPosPrev As Word
    Dim wClurSeqNumPrev As Word

    If Disk_tIsFull = True Then ExitProc
    If File_tIsOpen = False Then ExitProc

    Inc File_dBytesRead
    If File_tEOF = True Then                                    ' Extending file size
        Inc File_dSize
        File_tEOF = True
    ElseIf File_dBytesRead > File_dSize Then                    ' Extending file size
        Inc File_dSize
        File_tEOF = True
    EndIf

    If File_wCurrentSectorPos > $01FF Then
        If File_tEOF = False Then                              ' Not extending file
            FAT_IncrementSector()
        Else
            '
            ' Extending file
            '
            Inc File_dCurrentSector
            Inc File_bCurrentSectorInCluster
            If File_bCurrentSectorInCluster > Disk_bSectorsPerCluster Then
                Inc File_wClusterSequenceIndex
                If File_wClusterSequenceIndex > File_wClusterSequenceNumber Then
                    dFATSecPrev = File_dFATSector
                    wFATSecPosPrev = File_wFATSectorPos
                    wClurSeqNumPrev = File_wClusterSequenceNumber
                    If FAT_FindFreeCluster() = 1 Then
                        Dec File_wClusterSequenceIndex
                        File_dFATSector = dFATSecPrev
                        File_wFATSectorPos = wFATSecPosPrev
                        File_wClusterSequenceNumber = wClurSeqNumPrev
                        Disk_tIsFull = True
                        Dec File_dSize
                        Dec File_dBytesRead
                        ExitProc
                    EndIf
                    SD_ReadSector(Disk_dFAT1 + dFATSecPrev)
                    FAT_AssembleFATSector(dFATSecPrev, wFATSecPosPrev, wClurSeqNumPrev, 0)
                    SD_WriteSector(Disk_dFAT1 + dFATSecPrev)      ' Write Disk_dFAT1
                    SD_WriteSector(Disk_dFAT2 + dFATSecPrev)      ' Write Disk_dFAT2
                    File_dCurrentSector = FAT_ClusterToData(FAT_SectorToCluster())
                    SD_SectorInitWrite()
                EndIf
                File_bCurrentSectorInCluster = 1
            EndIf
        EndIf
        SD_ReadSector(File_dCurrentSector)
    EndIf
    FAT_WriteSectorByte(pByte)
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Determines if a disk is full when writing to File_
' Input     : None
' Return    : False = Disk not yet full, True = Disk is full
' Notes     : None
'
$define FAT_DiskFull() Disk_tIsFull

'--------------------------------------------------------------------------------------------------------------------------
' Check for File
' Input     : pFileNaAdd holds the address of the string holding the file's name
' Return    : True = File found, False = File not found
' Notes     : None
'
Proc FAT_FileExists(pFileNaAdd As Global_sFileName), Bit
    FAT_ModifyFileName()
    Result = FAT_FindRootDirEntry(1, 0)
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Check for directory.
' Input     : pDirNameAddress holds the address of the string holding the directory's name
' Return    : True = Dir found, False = Dir not found
' Notes     : None
'
Proc FAT_DirExists(), Bit
    Result = FAT_FindRootDirEntry(1, 1)
EndProc

Proc File_DirExists(pFileName As Global_sFileName), Bit 
    FAT_ModifyFileName() 
    Result = FAT_DirExists()
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Read a byte from current sector.
' Input     : None
' Return    : Byte read from the sector
' Notes     : None
'
Proc FAT_ReadSectorByte(), Byte
    If File_wCurrentSectorPos > $01FF Then       ' Increment sector if beyond the end of the previous sector
        Inc File_dCurrentSector
        SD_SectorInitRead(File_dCurrentSector)
    EndIf
    Result = Global_bSectorBuffer[File_wCurrentSectorPos]
    Inc File_wCurrentSectorPos
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Set modified time & date for file
' Input     : Global variables contain the date and time
' Return    : pSectorPos
' Notes     : None
'
Proc FAT_SetFileTimeModified(pSecPos As Word)
    Dim wTemp1 As Word
    Dim wTemp2 As Word
    
    wTemp1 = Global_bSeconds / 2
    wTemp2 = Global_bMinutes << 5
    FAT_InsertByteIntoBuffer(pSecPos, wTemp1 | wTemp2)                                   ' Create time & date - Seconds/Minutes
    Inc pSecPos
    
    wTemp1 = Global_bMinutes >> 3
    wTemp2 = Global_bHours << 3
    FAT_InsertByteIntoBuffer(pSecPos, wTemp1 | wTemp2)                                   ' Create time & date - Minutes/Hours
    Inc pSecPos
    
    wTemp1 = Global_bDay
    wTemp2 = Global_bMonth << 5
    FAT_InsertByteIntoBuffer(pSecPos, wTemp1 | wTemp2)                                  ' Create time & date - Day/Month
    Inc pSecPos
    
    wTemp1 = Global_bMonth >> 3
    wTemp2 = Global_bYear + 20
    wTemp2 = wTemp2 << 1
    FAT_InsertByteIntoBuffer(pSecPos, wTemp1 | wTemp2)                                  ' Create time & date - Month/Year
EndProc

Proc File_TimeModified(bDay As Byte, bMonth As Byte, bYear As Byte, bHours As Byte, bMinutes As Byte, bSeconds As Byte)
    Global_bDay = bDay
    Global_bMonth = bMonth
    Global_bYear = bYear
    Global_bHours = bHours
    Global_bMinutes = bMinutes
    Global_bSeconds = bSeconds    
EndProc

Proc File_ReadTimeMod()
    Dim wTimeData As Word
    Dim wDateData As Word
    Dim wTemp As Word
    
    wTimeData.Byte0 = FAT_RootDirPosition(22)
    wTimeData.Byte1 = FAT_RootDirPosition(23)
    wDateData.Byte0 = FAT_RootDirPosition(24)
    wDateData.Byte1 = FAT_RootDirPosition(25)

    ' Extract Seconds (bits 0-4) and multiply by 2
    wTemp =  wTimeData & 0x1F
    Global_bSeconds = wTemp * 2

    ' Extract Minutes: Lower 5 bits (bits 5-9) from wTimeData
    wTemp = wTimeData >> 5
    wTemp = wTemp & 0x3F 
    Global_bMinutes = wTemp  

    ' Extract Hours (bits 11-15)
    wTemp = wTimeData >> 11
    wTemp = wTemp & 0x1F 
    Global_bHours = wTemp  
    
    ' Extract Day (bits 0-4)
    wTemp = wDateData & 0x1F
    Global_bDay = wTemp

    ' Extract Month (bits 5-8)
    wTemp = wDateData >> 5
    wTemp = wTemp & 0x0F 
    Global_bMonth = wTemp  

    ' Extract Year (bits 9-15), subtracting 20 to get actual year (0 = 1980)
    wTemp = wDateData >> 9
    wTemp = wTemp & 0x7F        
    Global_bYear = wTemp - 20
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Set create time & date for file
' Input     : Global variables contain the date and time
' Return    :
' Notes     :
'
Proc FAT_SetFileTimeCreate(pSectorPos As Word)
    FAT_InsertByteIntoBuffer(pSectorPos, 0)                             ' Zero Milliseconds
    Inc pSectorPos
    FAT_SetFileTimeModified(pSectorPos)                                 ' Write Global_bDay, Global_bMonth, Global_bYear, Global_bHours, Global_bMinutes, Global_bSeconds)
EndProc

Proc File_TimeCreated(bDay As Byte, bMonth As Byte, bYear As Byte, bHours As Byte, bMinutes As Byte, bSeconds As Byte)
    Global_bDay = bDay
    Global_bMonth = bMonth
    Global_bYear = bYear
    Global_bHours = bHours
    Global_bMinutes = bMinutes
    Global_bSeconds = bSeconds    
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Close file
' Input     : None
' Return    : None
' Notes     : None
'
Proc FAT_CloseFile()
    Dim bIsDirectory As Byte

    If File_tIsOpen = True Then                                             ' \ File must be open for writing
        If File_tRW = 0 Then                                                ' /
            If File_tEOF = True Then                                        ' If at EOF, need to fill rest of sector with zeros, then will automatically write sector at end
                While File_wCurrentSectorPos < 512
                    FAT_WriteSectorByte($00)
                Wend
            Else
                SD_WriteSector(File_dCurrentSector)
            EndIf

            SD_ReadSector(File_dFileEntryDirSector)
            bIsDirectory = Global_bSectorBuffer[File_wFileEntryDirSectorPos + $0B]
            bIsDirectory = bIsDirectory & %00010000                                                 ' Check if it is a directory being closed
            FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1C, File_dSize.Byte0)           ' File size
            FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1D, File_dSize.Byte1)
            FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1E, File_dSize.Byte2)
            FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1F, File_dSize.Byte3)

            If File_dSize > 0 Or bIsDirectory.4 = 1 Then
                bIsDirectory = $00
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1A, File_dFirstCluster.Byte0) ' Cluster number
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1B, File_dFirstCluster.Byte1)
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $14, File_dFirstCluster.Byte2) ' High byte for FAT32
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $15, File_dFirstCluster.Byte3)
            Else
                bIsDirectory = $FF
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1A, $00)                   ' Zero cluster number for empty file
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $1B, $00)
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $14, $00)                   ' High byte for FAT32
                FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $15, $00)
            EndIf
            FAT_SetFileTimeModified(File_wFileEntryDirSectorPos + $16)                             ' Set file modified time & date
            SD_WriteSector(File_dFileEntryDirSector)

            If File_tEOF = True Then
                SD_ReadSector(Disk_dFAT1 + File_dFATSector)
                If bIsDirectory = $00 Then
                    FAT_AssembleFATSector(File_dFATSector, File_wFATSectorPos, File_wClusterSequenceIndex, 1)
                Else
                    FAT_WriteFATEntry($00000000, File_wFATSectorPos)                                ' Clear first cluster entry if zero length file
                EndIf
                SD_WriteSector(Disk_dFAT1 + File_dFATSector)
                SD_WriteSector(Disk_dFAT2 + File_dFATSector)
            EndIf
        EndIf
    EndIf
    File_dSize = 0
    File_tIsOpen = False
    Disk_tIsDirty = False
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Initialise SD or MMC card and read FAT16/32 file system
' Input     : None
' Return    : cErrOK = Success, cErrNoResponse = No response from card, cErrInvalidFormat = Card not formatted with FAT16 or FAT32,
'           : cErrRWError = Read/write error
' Notes     : Sets Input/Output pins and switches card to SPI mode, then reads parameters of Master Boot Record & Boot Record.
'
Proc FAT_Init(), Byte
    Dim dBootRecord As Dword
    Dim wBytesPerSector As Word
    Dim wReservedSectors As Word
    Dim bNumberOfFATs As Byte
    Dim wNumberOfRootEntries As Word
    Dim dNumberOfSectors As Dword

    Dim wPartitionOffset As wBytesPerSector
    Dim tPartitionFound As wReservedSectors.0
    Dim bIndex As bNumberOfFATs

    Disk_tRWError = False                                     ' clear read/write error flag to allow a re-initialise after failure
'
' Init SD/MMC
'
    If SD_InitSequence() = False Then
        Disk_tRWError = True
        Result = cErrNoResponse
        ExitProc
    EndIf
'
' Find the Boot Record
'
    Result = cErrOK
    SD_SectorInitRead($00)                                          ' Read Master Boot Record
    dBootRecord = $00000000
    $if McuType = 1
        If Global_bSectorBuffer_0 = $EB Then                            ' \
            If Global_bSectorBuffer_2 = $90 Then GoTo FAT_InitContinue   ' / Locate Boot Record - Sector 0 is Boot Record (no MBR)
        EndIf
        If Global_bSectorBuffer_0 = $E9 Then GoTo FAT_InitContinue       ' Locate Boot Record - Sector 0 is Boot Record (no MBR)
    $else
        If Global_bSectorBuffer#0 = $EB Then                            ' \
            If Global_bSectorBuffer#2 = $90 Then GoTo FAT_InitContinue   ' / Locate Boot Record - Sector 0 is Boot Record (no MBR)
        EndIf
        If Global_bSectorBuffer#0 = $E9 Then GoTo FAT_InitContinue       ' Locate Boot Record - Sector 0 is Boot Record (no MBR)
    $endif

    bIndex = 0
    tPartitionFound = False
    While
        wPartitionOffset = $01C2 + (bIndex * 16)
        Select Global_bSectorBuffer[wPartitionOffset]
            Case 4, 6, 14, 11, 12                           ' Check valid FAT16 or FAT32 partition
                tPartitionFound = True
                Break
        EndSelect
        Inc bIndex
        If bIndex = 4 Then Break
    Wend
'
' Locate the Boot Record
'
    If tPartitionFound = True Then
        dBootRecord.Byte0 = Global_bSectorBuffer[wPartitionOffset + 4]
        dBootRecord.Byte1 = Global_bSectorBuffer[wPartitionOffset + 5]
        dBootRecord.Byte2 = Global_bSectorBuffer[wPartitionOffset + 6]
        dBootRecord.Byte3 = Global_bSectorBuffer[wPartitionOffset + 7]
    Else
        Disk_tRWError = True
        Result = cErrInvalidFormat
        ExitProc
    EndIf
FAT_InitContinue:

    SD_SectorInitRead(dBootRecord)
'
' Read bytes per sector
'
    wBytesPerSector.Byte0 = Global_bSectorBuffer[11]
    wBytesPerSector.Byte1 = Global_bSectorBuffer[12]

    Disk_tRWError = True
    Result = cErrInvalidFormat
    If wBytesPerSector <> 512 Then ExitProc
    $if McuType = 1
        If Global_bSectorBuffer_0 <> $EB Then
            If Global_bSectorBuffer_2 <> $90 Then
                Return
            EndIf
        EndIf
        If Global_bSectorBuffer_0 <> $E9 Then
            If Global_bSectorBuffer_510 <> $55 Then
                If Global_bSectorBuffer_511 <> $AA Then
                    ExitProc
                EndIf
            EndIf
        EndIf
    $else
        If Global_bSectorBuffer#0 <> $EB Then
            If Global_bSectorBuffer#2 <> $90 Then
                Return
            EndIf
        EndIf
        If Global_bSectorBuffer#0 <> $E9 Then
            If Global_bSectorBuffer#510 <> $55 Then
                If Global_bSectorBuffer#511 <> $AA Then
                    ExitProc
                EndIf
            EndIf
        EndIf
    $endif
    
    Disk_tRWError = False
    Result = cErrOK

    Disk_bSectorsPerCluster = Global_bSectorBuffer[13]  ' Read sectors per cluster

    wReservedSectors.Byte0 = Global_bSectorBuffer[14]   ' Read number of reserved sectors
    wReservedSectors.Byte1 = Global_bSectorBuffer[15]
    bNumberOfFATs = Global_bSectorBuffer[16]            ' Read number of FATs
'
' Read number of Root Entries
'
    wNumberOfRootEntries.Byte0 = Global_bSectorBuffer[17]
    wNumberOfRootEntries.Byte1 = Global_bSectorBuffer[18]
'
' Read sectors Per FAT - FAT16
'
    Disk_dSectorsPerFAT = 0
    Disk_dSectorsPerFAT.Byte0 = Global_bSectorBuffer[$16]
    Disk_dSectorsPerFAT.Byte1 = Global_bSectorBuffer[$17]
'
' Read sectors Per FAT - FAT32
'
    If Disk_dSectorsPerFAT = 0 Then
        Disk_dSectorsPerFAT.Byte0 = Global_bSectorBuffer[$24]
        Disk_dSectorsPerFAT.Byte1 = Global_bSectorBuffer[$25]
        Disk_dSectorsPerFAT.Byte2 = Global_bSectorBuffer[$26]
        Disk_dSectorsPerFAT.Byte3 = Global_bSectorBuffer[$27]
    EndIf
'
' Read number of sectors - 16 bit version
'
    dNumberOfSectors = 0
    dNumberOfSectors.Byte0 = Global_bSectorBuffer[$13]
    dNumberOfSectors.Byte1 = Global_bSectorBuffer[$14]
'
' Read number of sectors - 32 bit version
'
    If dNumberOfSectors = 0 Then
        dNumberOfSectors.Byte0 = Global_bSectorBuffer[$20]
        dNumberOfSectors.Byte1 = Global_bSectorBuffer[$21]
        dNumberOfSectors.Byte2 = Global_bSectorBuffer[$22]
        dNumberOfSectors.Byte3 = Global_bSectorBuffer[$23]
    EndIf

    Disk_dFAT1 = dBootRecord + wReservedSectors                         ' Locate FAT1
    Disk_dFAT2 = Disk_dFAT1 + Disk_dSectorsPerFAT                       ' Locate FAT2

    Disk_dRootDirectory = bNumberOfFATs * Disk_dSectorsPerFAT           ' Locate Root Directory
    Disk_dRootDirectory = Disk_dRootDirectory + dBootRecord + wReservedSectors

    Disk_wSectorsInRoot = wNumberOfRootEntries * 32                     ' Calculate sectors in Root Directory
    Disk_wSectorsInRoot = Disk_wSectorsInRoot / wBytesPerSector

    Disk_dData = Disk_dRootDirectory + Disk_wSectorsInRoot              ' Locate start of data cluster 2
    File_dCurrentSector = dBootRecord + dNumberOfSectors                ' Locate last sector (File_dCurrentSector = dBootRecord + dNumberOfSectors - 1) & add 1 to count full clusters correctly with FAT_DataToCluster
    Disk_dLastCluster = FAT_DataToCluster()                             ' \ Proctract 1 to correct result from FAT_DataToCluster when used to find number of complete clusters
    Disk_dLastCluster = Disk_dLastCluster - 1                           ' /

    Disk_swFileSearchNumber = 0                                         ' Set Dir to read first file on first call
    Disk_tSearchFileOrDirectory = 0                                     ' Set Dir to look for file, not directory, by default
    File_tIsOpen = False
    Disk_tIsDirty = False
    Disk_tIsFull = False

    If (Disk_dLastCluster - 1) < 4085 Then                              ' Determine FAT type
        Disk_bFATType = 0
        Disk_tRWError = True
        Result = cErrInvalidFormat
        ExitProc
    EndIf
    If (Disk_dLastCluster - 1) < 65525 Then
        Disk_bFATType = FAT_cFAT16                                      ' Allow FAT16
        Disk_tIsRootDirectory = True
    Else
        Disk_bFATType = FAT_cFAT32                                      ' FAT32
        Disk_dRootDirectory.Byte0 = Global_bSectorBuffer[$2C]           ' Read Root Cluster for FAT32
        Disk_dRootDirectory.Byte1 = Global_bSectorBuffer[$2D]
        Disk_dRootDirectory.Byte2 = Global_bSectorBuffer[$2E]
        Disk_dRootDirectory.Byte3 = Global_bSectorBuffer[$2F]
        Disk_dRootDirectory = FAT_ClusterToData(Disk_dRootDirectory)    ' Convert to first sector of Root Cluster
        Disk_tIsRootDirectory = False                                   ' For FAT32, start off as if not in root directory; code will now follow cluster chain as for folders with FAT16
    EndIf
    Disk_dDirectoryStartSector = Disk_dRootDirectory                    ' Start off in root directory

    Result = cErrOK
    If Disk_tRWError = True Then
        Result = cErrRWError
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Open an existing file.
' Input     : pFileNaAdd holds the address of the string holding the file's name
' Return    : cErrOK = Success, cErrNotFound = File not found,
'           : cErrInUse = File number in use, cErrRWError = Read/write error
' Notes     :
'
Proc FAT_OpenFile(pFileNaAdd As Global_sFileName), Byte
    FAT_ModifyFileName()                       ' Transfer the parameter filename string into the global filename string

    If Disk_tRWError > 0 Then
        Result = cErrRWError
        ExitProc
    EndIf
    If File_tIsOpen = True Then
        Result = cErrInUse
        ExitProc
    EndIf
    If FAT_FindRootDirEntry(1, 0) = False Then    ' check if file exists
        Result = cErrNotFound                                        ' error - file does not exist
        ExitProc
    EndIf
    SD_SectorInitRead(File_dCurrentSector)
    File_bCurrentSectorInCluster = 1
    File_wCurrentSectorPos = 0                                       ' set start position for sector
    File_dBytesRead = 0                                              ' zero sequential read marker
    File_tEOF = True
    If File_dSize > 0 Then
        File_tEOF = False
    EndIf
    File_tIsOpen = True
    File_tRW = 1
    Result = cErrOK                                                  ' Success - file open for reading
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Read a single byte from an existing file
' Input     : None
' Return    : The byte read from the open file
' Notes     : File_tEOF = True when EOF condition met
'
Proc FAT_ReadByte(), Byte
    If File_tEOF = True Then
        Result = 0
        ExitProc
    EndIf
    Inc File_dBytesRead
    If File_dBytesRead >= File_dSize Then
        File_tEOF = True
    EndIf
    If File_wCurrentSectorPos > $01FF Then
        '
        ' If bytes have been written in current sector, write sector back to SD card and reset Disk_tIsDirty
        '
        If Disk_tIsDirty = True Then
            SD_WriteSector(File_dCurrentSector)
            Disk_tIsDirty = False
        EndIf
      FAT_IncrementSector()
      SD_SectorInitRead(File_dCurrentSector)
    EndIf
    Result = Global_bSectorBuffer[File_wCurrentSectorPos]
    File_wCurrentSectorPos = File_wCurrentSectorPos + 1
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Determines if a file opened for reading has reached the end of file (EOF),
' or if RWError to prevent blocking loop when reading
' Input     :
' Return    : False = EOF not yet reached, True = EOF reached
' Notes     :
'
Proc FAT_EOF(), Bit
    Result = True
    If File_tEOF = True Then ExitProc
    If Disk_tRWError = True Then ExitProc
    Result = False
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Read file names from SD/MMC card.
' Input     : pDirDirection: FAT_cDirFirst = First, FAT_cDirNext = Next, FAT_cDirPrevious = Previous
'           : pFileDir: FAT_cFile = Find file, FAT_cDirectory = Find directory
' Return    : The first byte of the string will be null if end of Directories or Files reached
' Notes     : Name and Extension will be padded to 8 and 3 characters with spaces
'
Proc FAT_Dir(pDirDirection As Byte, pFileDir As Bit), String * 12
'
' If swap from from searching for file to directory or vice versa, reset file number
'
    If pFileDir <> Disk_tSearchFileOrDirectory Then
        Disk_swFileSearchNumber = 0
        Disk_tSearchFileOrDirectory = pFileDir
    EndIf

    Select pDirDirection
        Case 0
            Disk_swFileSearchNumber = 1
        Case 1
            Inc Disk_swFileSearchNumber
        Case 2
            Dec Disk_swFileSearchNumber
    EndSelect

    Clear Result
    If FAT_FindRootDirEntry(Result, 2, pFileDir) = False Then
        ExitProc
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Traverse cluster chain in FAT
' Input     :
' Return    :
' Notes     :
'
Proc FAT_TraverseClusters(pNumBTT As Dword)
    Dim dCluster As Dword

    dCluster = File_dFirstCluster
    File_dCurrentSector = 0
    While pNumBTT > (Disk_bSectorsPerCluster * 512)
        FAT_ClusterToFATSector(dCluster)                            ' Find FAT position for cluster
        If File_dCurrentSector <> (Disk_dFAT1 + File_dFATSector) Then
            File_dCurrentSector = Disk_dFAT1 + File_dFATSector
            SD_SectorInitRead(File_dCurrentSector)
        EndIf
        dCluster = FAT_ReadFATEntry(File_wFATSectorPos)
        pNumBTT = pNumBTT - (Disk_bSectorsPerCluster * 512)
    Wend
    FAT_ClusterToFATSector(dCluster)                                ' Find FAT position for last cluster
    If pNumBTT = 0 Then                                 ' Test for zero length file - others will not meet this condition,
                                                                    ' Because 1 or more bytes will be left after while - end while loop
        File_bCurrentSectorInCluster = 0
    Else
        File_bCurrentSectorInCluster = (pNumBTT - 1) / 512
    EndIf
    File_dCurrentSector = FAT_ClusterToData(dCluster)               ' Set append sector for data
    File_dCurrentSector = File_dCurrentSector + File_bCurrentSectorInCluster
    File_bCurrentSectorInCluster = File_bCurrentSectorInCluster + 1
    SD_SectorInitRead(File_dCurrentSector)
    File_wCurrentSectorPos = pNumBTT // 512             ' Set append position for sector
    If File_wCurrentSectorPos = 0 Then
        If pNumBTT > 0 Then                             ' Test not zero length file - others will meet this condition
            File_wCurrentSectorPos = 512
        EndIf
    EndIf
    File_wClusterSequenceIndex = 1
    File_wClusterSequenceNumber = 1
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Seeks position in open file using pFilePtr.
' Input     : pFilePtr
' Return    : cErrOK = Success, cErrRWError = Read/Write error,
'           : cErrFileNotOpen = File not open, cErrBeyondEOF = Failed attempt to
'           : seek position beyond end of file
' Notes     :
'
Proc FAT_Seek(pFilePtr As Dword), Byte
    If Disk_tRWError = True Then
        Result = cErrRWError
    ElseIf File_tIsOpen = False Then
        Result = cErrFileNotOpen
    Else
        '
        ' If bytes have been written in current sector, write sector back to SD card and reset Disk_tIsDirty
        '
        If Disk_tIsDirty = True Then
            SD_WriteSector(File_dCurrentSector)
            Disk_tIsDirty = False
        EndIf

        If File_tEOF = True Then                    ' Are at end or have extended file?
            Push File_dSize                         ' Save File_dSize on the stack
            FAT_CloseFile()
            Pop File_dSize                          ' Restore File_dSize from the stack
            File_tIsOpen = True
        EndIf
        If pFilePtr > File_dSize Then
            Result = cErrBeyondEOF
        Else
            FAT_TraverseClusters(pFilePtr)
            File_dBytesRead = pFilePtr
            If pFilePtr = File_dSize Then
                File_tEOF = True
            Else
                File_tEOF = False
            EndIf
            Result = cErrOK                          ' Success - file seek OK
        EndIf
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Open an existing file for reading & writing
' Input     : pFileNaAdd holds teh address of the string holding the file's name
' Return    : cErrOK = Success, cErrNotFound = File not found,
'           : cErrDiskFull = Disk full, cErrInUse = File in use,
'           : cErrRWError = Read/write error
' Notes     :
'
Proc FAT_OpenFileRW(pRecordLength As Word), Byte
    If Disk_tRWError = True Then
        Result = cErrRWError
    ElseIf File_tIsOpen = True Then
        Result = cErrInUse
    ElseIf FAT_FindRootDirEntry(1, 0) = False Then    ' Check if file exists & loads info regarding file
        Result = cErrNotFound                                           ' Error - file does not exist
    Else
        If File_dSize = 0 Then
            File_dFATSector = 0
            File_wFATSectorPos = 0
            File_wClusterSequenceNumber = 0
            If FAT_FindFreeCluster() = 1 Then                           ' Disk full error
                Result = cErrDiskFull
                Disk_tIsFull = True
                ExitProc
            EndIf
            File_dFirstCluster = FAT_SectorToCluster()                  ' Store first cluster
            File_dCurrentSector = FAT_ClusterToData(FAT_SectorToCluster()) ' Set start sector for data
            SD_SectorInitWrite()
            File_bCurrentSectorInCluster = 1
            File_wCurrentSectorPos = 0
            File_tEOF = True
        Else
            File_dFirstCluster = FAT_DataToCluster()
            FAT_TraverseClusters(0)                                     ' Move to start of file
            File_tEOF = False
        EndIf

        File_tIsOpen = True
        File_tRW = 0
        File_dBytesRead = 0
        Disk_tIsDirty = False
        File_wRecordLength = pRecordLength
        Result = cErrOK                                                 ' Success - file open for appending
    EndIf
EndProc
'--------------------------------------------------------------------------------------------------------------------------
' Open an existing file for writing to end of file
' Input     : pFileNaAdd holds teh address of the string holding the file's name
' Return    : cErrOK = Success, cErrNotFound = File Not found,
'           : cErrDiskFull = Disk full, cErrInUse = File in use,
'           : cErrRWError = Read/Write error
' Notes     :
'
Proc FAT_AppendFile(pFileNaAdd As Global_sFileName), Byte
    FAT_ModifyFileName()
    Result = FAT_OpenFileRW(1)
    FAT_Seek(File_dSize)
EndProc

Proc File_OpenAt(pFileNaAdd As Global_sFileName, dAddress As Dword), Byte
    FAT_ModifyFileName()
    Result = FAT_OpenFileRW(1)
    If Result <> cErrOK Then
        ExitProc   
    Else
        Result = FAT_Seek(dAddress)
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Find size of SD/MMC card (in KB)
' Input     :
' Return    : The size of the SD/MMc card
' Notes     :
'
Proc FAT_DiskSizeKB(), Dword
    Result = (Disk_dLastCluster - 1) * Disk_bSectorsPerCluster
    Result = Result / 2
EndProc

$define File_DiskSizeKB() FAT_DiskSizeKB()

'--------------------------------------------------------------------------------------------------------------------------
' Find free space on SD/MMC card (in KB)
' Input     :
' Return    : The amount of free space on the SD/MMC card
' Notes     :
'
Proc FAT_FreeSpaceKB(), Dword
    Dim dFClNumber As Result
    Dim dScanSec As Dword
    Dim wScanSePos As Word
    Dim wCorrection As dScanSec
'
' Scan FAT1 for free clusters
'
    dFClNumber = 0
    For dScanSec = Disk_dFAT1 To (Disk_dFAT1 + Disk_dSectorsPerFAT - 1)
        File_dCurrentSector = dScanSec
        SD_SectorInitRead(File_dCurrentSector)
        wScanSePos = $0000
        Repeat
            If FAT_ReadFATEntry(wScanSePos) = $00000000 Then
                Inc dFClNumber
            EndIf
            If Disk_bFATType = FAT_cFAT16 Then
                wScanSePos = wScanSePos + 2
            Else
                wScanSePos = wScanSePos + 4
            EndIf
        Until wScanSePos > $01FF
    Next
    wCorrection = Disk_dSectorsPerFAT * 256 / Disk_bFATType
    wCorrection = wCorrection - Disk_dLastCluster - 1
    Result = dFClNumber - wCorrection
    Result = Result * Disk_bSectorsPerCluster
    Result = Result / 2
EndProc

$define File_FreeSpaceKB() FAT_FreeSpaceKB()

'--------------------------------------------------------------------------------------------------------------------------
' Updates a FAT sector in Delete function
' Input     :
' Return    :
' Notes     :
'
Proc FAT_UpdateFATSector()
    SD_WriteSector(File_dCurrentSector)
    File_dCurrentSector = File_dCurrentSector - Disk_dFAT1          ' Copy FAT1 sector to FAT2
    File_dCurrentSector = File_dCurrentSector + Disk_dFAT2
    SD_WriteSector(File_dCurrentSector)
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Erase FAT chain from pClust to end
' Input     : pClust holds the cluster of interest
' Return    : None
' Notes     :
'
Proc FAT_EraseFATChain(pClust As Dword)
    Dim tFirstPass As Bit = True                                    ' Use as flag for first pass through do-until loop
    File_dCurrentSector = 0                                         ' Ensure loads sector on first run through loop
    Do
        FAT_ClusterToFATSector(pClust)                            ' Find next FAT position
        If File_dCurrentSector <> (Disk_dFAT1 + File_dFATSector) Then
           If tFirstPass = False Then
              FAT_UpdateFATSector()                                 ' Write FAT1 & FAT2 sectors before read next sector, except on first pass
           EndIf
           File_dCurrentSector = Disk_dFAT1 + File_dFATSector
           tFirstPass = False
           SD_SectorInitRead(File_dCurrentSector)
        EndIf
        pClust = FAT_ReadFATEntry(File_wFATSectorPos)
        FAT_WriteFATEntry($00000000, File_wFATSectorPos)             ' Clear FAT entry
        If Disk_bFATType = FAT_cFAT16 Then
            If pClust = $FFFF Then
                Break
            EndIf
        EndIf
        If Disk_bFATType = FAT_cFAT32 Then
            If pClust = $0FFFFFFF Then
                Break
            EndIf
        EndIf
    Loop
    FAT_UpdateFATSector()                                           ' Write last FAT1 & FAT2 sectors
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Delete an existing file or directory.
' Input     : pFileNaAdd holds the address of the filename string
' Return    : pIsFile = 0 for File, 1 for Directory
' Notes     :
'
Proc FAT_Delete(pFileNaAdd As Global_sFileName, pIsFile As Bit), Bit
    Dim tResponse As Bit

    FAT_ModifyFileName()
    Result = True                                                   ' Default to success - file deleted
    If pIsFile = False Then
        tResponse = FAT_FindRootDirEntry(1, 0)    ' Check if file exists
    Else
        tResponse = FAT_DirExists()                 ' Check if directory exists
    EndIf
    If tResponse = False Then
        Result = False                                              ' Error - file/directory does not exist
        ExitProc
    EndIf
    FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos, $E5)
    SD_WriteSector(File_dFileEntryDirSector)

    If File_dSize = 0 Then                                           ' \
        If pIsfile = True Then                                      ' / Zero-length file - no need to modify FAT
            ExitProc
        EndIf
    EndIf
    FAT_EraseFATChain(FAT_DataToCluster())
    Disk_tIsFull = False
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Write all of buffer to file and update file size & FAT clusters.
' Input     : None
' Return    : True = Success, False = Read/write error
' Notes     : If the disk is removed, the file should be safe.
'           : It has the same effect as closing the file and re-opening with AppendFile,
'           : except that is works much works quicker.
'
Proc FAT_FlushFile(), Bit
    Result = False
    If File_tIsOpen = True Then
        If Disk_tRWError = True Then
            Result = False
            ExitProc
        EndIf
        Push File_dSize                                 ' Save File_dSize on the stack
        Push File_wCurrentSectorPos                     ' Save File_wCurrentSectorPos on the stack
        Push File_dCurrentSector                        ' Save File_dCurrentSector on the stack
        FAT_CloseFile()                                 ' Close the file
        File_tIsOpen = True                             ' Signal that the file is still open
        Pop File_dCurrentSector                         ' Restore File_dCurrentSector from the stack
        SD_ReadSector(File_dCurrentSector)              ' Recover the buffer contents
        Pop File_wCurrentSectorPos                      ' Restore File_wCurrentSectorPos from the stack
        Pop File_dSize                                  ' Restore File_dSize from the stack
    EndIf
    Result = True
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Find size of file (in Bytes)
' Input     : None
' Return    : The file's size in Kb
' Notes     : None
'
$define FAT_FileSize() File_dSize

'--------------------------------------------------------------------------------------------------------------------------
' Change to directory in current directory.
' Input     : pDirNameAddress holds the address of the string containing the directory's name
' Return    : True = Success, False = Directory not found
' Notes     :
'
Proc FAT_ChDir(pDirNameAddress As Global_sFileName), Bit
    FAT_ModifyFileName()

    If FAT_DirExists() = False Then                         ' Check if directory exists
        Result = False                                      ' Error - directory does not exist
        ExitProc
    EndIf
    Disk_dDirectoryStartSector = File_dCurrentSector
'
' Only set IsRootDirectory = True for FAT16, keep as false for FAT32, even when in root cluster
'
    Disk_tIsRootDirectory = False
    If Disk_dDirectoryStartSector = Disk_dRootDirectory Then
        If Disk_bFATType = FAT_cFAT16 Then
            Disk_tIsRootDirectory = True
        EndIf
   EndIf
   Disk_swFileSearchNumber = 0                                ' Reset file pointer for Dir
   Result = True                                            ' Success - directory swapped
EndProc

$define File_ChDir(pFileName) FAT_ChDir(pFileName)

'--------------------------------------------------------------------------------------------------------------------------
' Determines if the current directory is the Root Directory.
' Input     : None
' Return    : False = Not Root Directory, True = Is Root Directory
' Notes     : None
'
Proc FAT_IsRootDir(), Bit
    Result = False
    If Disk_dDirectoryStartSector = Disk_dRootDirectory Then
        Result = True
    EndIf
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Create a new file or directory
' Input     : pFileNaAdd holds the address of the String containing the file's name
'           : pIsFile: True = file, False = directory
' Return    : cErrOK = Success, cErrExists = File already exists,
'           : cErrDiskFull = Disk full, cErrRootDirFull = Root Directory full,
'           : cErrInUse = File number in use
' Notes     :
'
Proc FAT_DoNew(pIsFile As Bit), Byte
    Dim bResponse As Byte
    Dim tResponse As bResponse.0
    Dim dCluster As Dword
    Dim dNewDirSector As Dword
    Dim bIndex As Byte
    Dim bRDirFPos As bIndex

    If Disk_tRWError = True Then
        Result = cErrRWError
        ExitProc
    EndIf
    If File_tIsOpen = True Then
        Result = cErrInUse
        ExitProc
    EndIf
    If pIsFile = True Then
        tResponse = FAT_FindRootDirEntry(1, 0)    ' Check if file exists
    Else
        tResponse = FAT_DirExists()                 ' Check if directory exists
    EndIf
    If tResponse = True Then
        Result = cErrExists                                          ' Error - file already exists
        ExitProc
    EndIf
    Repeat
        File_dFATSector = 0
        File_wFATSectorPos = 0
        File_wClusterSequenceNumber = 0
        bResponse = FAT_FindFreeCluster()
        If bResponse = 1 Then                                        ' Disk full error
            Result = cErrDiskFull
            Disk_tIsFull = True
            ExitProc
        EndIf
        dCluster = FAT_SectorToCluster()
        If FAT_FindRootDirEntry(0, 0) = False Then ' No free directory entry
            If Disk_tIsRootDirectory = True Then                    ' Is Root Directory - no possibility of expansion
                Result = cErrRootDirFull
                ExitProc
            Else                                                    ' Expand directory with free cluster already found
                FAT_WriteFATEntry(dCluster, File_wFATSectorPos)       ' Point end of existing cluster chain to new cluster FAT sector set & read by FAT_IncrementSector in FAT_FindRootDirEntry
                SD_WriteSector(Disk_dFAT1 + File_dFATSector)         ' Write to FAT1
                SD_WriteSector(Disk_dFAT2 + File_dFATSector)         ' Write to FAT2
                FAT_ClusterToFATSector(dCluster)                     ' Find position of new cluster entry
                SD_ReadSector(Disk_dFAT1 + File_dFATSector)
                FAT_WriteFATEntry($0FFFFFFF, File_wFATSectorPos)     ' End cluster chain
                SD_WriteSector(Disk_dFAT1 + File_dFATSector)         ' Write to FAT1
                SD_WriteSector(Disk_dFAT2 + File_dFATSector)         ' Write to FAT2
                Clear Global_bSectorBuffer
                dNewDirSector = FAT_ClusterToData(dCluster)
                bIndex = 0
                Repeat
                    SD_WriteSector(dNewDirSector + bIndex)
                    Inc bIndex
                Until bIndex = Disk_bSectorsPerCluster
            EndIf
        Else
            FAT_ClusterToFATSector(dCluster)                         ' Reset FAT sector parameters to file parameters, not directory parameters
        EndIf
    Until bResponse = 0                                              ' Do finding free cluster and directory entry if dir expanded
    SD_ReadSector(File_dFileEntryDirSector)
'
' Insert the filename into the directory entry in the buffer
'
    File_wCurrentSectorPos = File_wFileEntryDirSectorPos
    bRDirFPos = 0
    Repeat
        FAT_InsertByteIntoBuffer(File_wCurrentSectorPos, Global_sUpFileName[bRDirFPos])
        Inc File_wCurrentSectorPos
        Inc bRDirFPos
    Until bRDirFPos = 11

    File_wCurrentSectorPos = File_wFileEntryDirSectorPos + $0B
    bRDirFPos = $0B
    Repeat                                                          ' Erase Root Directory position
        FAT_InsertByteIntoBuffer(File_wCurrentSectorPos, 0)
        Inc File_wCurrentSectorPos
        Inc bRDirFPos
    Until bRDirFPos > $1F

    If pIsFile = True Then
        FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $0B, %00100000)
                                                                    ' File attributes (00ADVSHR)
                                                                    '   0: unused bit, A: archive bit,
                                                                    '   D: Dir bit, V: volume bit,
                                                                    '   S: system bit, R: read-only bit
    Else
        FAT_InsertByteIntoBuffer(File_wFileEntryDirSectorPos + $0B, %00010000)
                                                                    ' File attributes (00ADVSHR)
                                                                    '   0: unused bit, A: archive bit,
                                                                    '   D: Dir bit, V: volume bit,
                                                                    '   S: system bit, R: read-only bit
    EndIf

    FAT_SetFileTimeCreate(File_wFileEntryDirSectorPos + $0D)        ' Set file create time & date
    File_dFirstCluster = dCluster                                   ' Store first cluster
    SD_WriteSector(File_dFileEntryDirSector)
    File_dCurrentSector = FAT_ClusterToData(dCluster)               ' Set start sector for data
    SD_SectorInitWrite()
    File_bCurrentSectorInCluster = 1
    File_wCurrentSectorPos = 0                                      ' Set start pos for sector buffer
    File_dSize = 0
    File_dBytesRead = 0
    File_tEOF = True
    File_tIsOpen = True
    File_tRW = 0
    Result = cErrOK
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Create a new file
' Input     : pFileNaAdd holds the address of the string holding the file's name
' Return    : cErrOK = Success, cErrExists = File already exists,
'           : cErrDiskFull = Disk full, cErrRootDirFull = Root Directory full,
'           : cErrInUse = File number in use, cErrRWError = Read/write error
' Notes     :
'
Proc FAT_NewFile(pFileNaAdd As Global_sFileName), Byte
    FAT_ModifyFileName()
    Result = FAT_DoNew(True)
EndProc

'--------------------------------------------------------------------------------------------------------------------------
' Make a new directory
' Input     : pDirNameAddress holds the address of the String containing the directory's name
' Return    : cErrOK = Success, cErrExists = Directory already exists,
'           : cErrDiskFull = Disk full, cErrRootDirFull = Root Directory full,
'           : cErrInUse = File number in use, cErrRWError = Read/write error
' Notes     :
'
Proc FAT_MkDir(pDirNameAddress As Global_sFileName), Byte
    Dim bIndex As Byte
    Dim dCluster As Dword
    Dim dTempCurrentSector As Dword

    FAT_ModifyFileName()
    Global_sUpFileName_Ext = "   "

    Result = FAT_DoNew(False)
    If Result > 0 Then
        ExitProc
    EndIf
    Clear Global_bSectorBuffer
    bIndex = $00
    Repeat
        FAT_InsertByteIntoBuffer(bIndex, $20)                    ' Write 11 spaces to clear first directory entries (for ".")
        Inc bIndex
    Until bIndex > $0A
    bIndex = $20
    Repeat
        FAT_InsertByteIntoBuffer(bIndex, $20)                    ' Write 11 spaces to clear second directory entries (for "..")
        Inc bIndex
    Until bIndex > $2A
    FAT_InsertByteIntoBuffer($00,$2E)                           ' "."
    FAT_InsertByteIntoBuffer($20,$2E)                           ' ".."
    FAT_InsertByteIntoBuffer($21,$2E)
    FAT_InsertByteIntoBuffer($0B,$10)                           ' Dir attribute for "."
    FAT_InsertByteIntoBuffer($2B,$10)                           ' Dir attribute for ".."

    FAT_SetFileTimeCreate($0D)                                  ' Set file create time & date for "."
    FAT_SetFileTimeCreate($2D)                                  ' Set file create time & date for ".."
    FAT_SetFileTimeModified($16)                                ' Set file modified time & date for "."
    FAT_SetFileTimeModified($36)                                ' Set file modified time & date for ".."

    dCluster = FAT_DataToCluster()
    FAT_InsertByteIntoBuffer($1A, dCluster.Byte0)                ' Cluster number for "."
    FAT_InsertByteIntoBuffer($1B, dCluster.Byte1)
    FAT_InsertByteIntoBuffer($14, dCluster.Byte2)                ' High byte for FAT32
    FAT_InsertByteIntoBuffer($15, dCluster.Byte3)
    dTempCurrentSector = File_dCurrentSector
    If Disk_dDirectoryStartSector = Disk_dRootDirectory Then     ' Set to point to cluster 0 if parent is root directory if using FAT16 or FAT32
        dCluster = 0
    Else
        File_dCurrentSector = Disk_dDirectoryStartSector
        dCluster = FAT_DataToCluster()
        File_dCurrentSector = dTempCurrentSector
    EndIf
    FAT_InsertByteIntoBuffer($3A, dCluster.Byte0)                ' Cluster number for ".."
    FAT_InsertByteIntoBuffer($3B, dCluster.Byte1)
    FAT_InsertByteIntoBuffer($34, dCluster.Byte2)                ' High byte for FAT32
    FAT_InsertByteIntoBuffer($35, dCluster.Byte3)
    File_wCurrentSectorPos = $01FF                               ' Leave CurrentSectorPos as $1FF to force sector write
    FAT_CloseFile()
    Clear Global_bSectorBuffer
    bIndex = 1
'
' Clear remaining sectors of first cluster in directory
'
    Repeat
        SD_WriteSector(dTempCurrentSector + bIndex)
        Inc bIndex
    Until bIndex = Disk_bSectorsPerCluster
EndProc

'----------------------------------------------------------------------------------------------------------------------------------------
' Rename a file from pOldName to pNewName.
' Input     : pFileDir: sdFile = renaming file, sdDirectory = renaming directory
' Output    : cEerrOK = Success, cErrExists = new file/dir name already
'           : exists, cErrNotFound = old file/dir name not found,
'           : cErrRWError = Read/write error
' Notes     : None
'
Proc FAT_Rename(pOldName As String * 12, pNewName As String * 12, pFileDir As Bit), Byte
   Dim bRDirFPos As Byte = 0

   If Disk_tRWError = True Then
      Result = cErrRWError
      ExitProc
   EndIf
   
   Clear Global_sFileName
   Global_sFileName = pNewName
   FAT_ModifyFileName()

   If FAT_FindRootDirEntry(1, pFileDir) = True Then   ' Check new name does not already exist
      Result = cErrExists
      Return
   EndIf
   
   Clear Global_sFileName
   Global_sFileName = pOldName
   FAT_ModifyFileName()
   
   If FAT_FindRootDirEntry(1, pFileDir) = False Then  ' Check old name does exist; also loads File_wFileEntryDirSectorPos & File_wCurrentSectorPos
      Result = cErrNotFound
      ExitProc
   EndIf

   Clear Global_sFileName
   Global_sFileName = pNewName
   FAT_ModifyFileName()
   
   SD_ReadSector(File_dFileEntryDirSector)
'
' Overwrite with new name
'
   File_wCurrentSectorPos = File_wFileEntryDirSectorPos

   bRDirFPos = 0
   Repeat
      FAT_InsertByteIntoBuffer(File_wCurrentSectorPos, Global_sUpFileName[bRDirFPos])
      Inc File_wCurrentSectorPos
      Inc bRDirFPos
   Until bRDirFPos = 11

   SD_WriteSector(File_dFileEntryDirSector)
 
   Result = cErrOK
EndProc


'----------------------------------------------------------------------------------------------------------------------------------------
'
' Create some defines to the procedures
'
$define File_Init() FAT_Init()
$define File_GetDir() FAT_Dir(1, FAT_cDirectory)
$define File_CreateDir(pDirName) FAT_MkDir(pDirName)
$define File_DeleteDir(pFileName) FAT_Delete(pFileName, FAT_cDirectory)
$define File_RenameDir(pOldName, pNewName) FAT_Rename(pOldName, pNewName, FAT_cDirectory)
$define File_GetFile() FAT_Dir(1, FAT_cFile)
$define File_Exists(pFileName) FAT_FileExists(pFileName)
$define File_Create(pFileName) FAT_NewFile(pFileName)
$define File_Open(pFileName) FAT_OpenFile(pFileName)
$define File_Append(pFileName) FAT_AppendFile(pFileName)
$define File_Seek(pFilePtr) FAT_Seek(pFilePtr)
$define File_ReadByte() FAT_ReadByte()
$define File_WriteByte(pBytein) FAT_WriteByte(pBytein)
$define File_Flush() FAT_FlushFile()
$define File_DeleteFile(pFileName) FAT_Delete(pFileName, FAT_cFile)
$define File_Close() FAT_CloseFile()
$define File_Rename(pOldName, pNewName) FAT_Rename(pOldName, pNewName, FAT_cFile)
$define File_EOF() FAT_EOF()
$define File_DiskFull() FAT_DiskFull()

$define File_Write OutReserve1
$define File_Read InReserve1

'-----------------------------------------------------------------------------------------------

#ifSym __SYSCOM_OUTRESERVE1_REQ_, __SYSCOM_INRESERVE1_REQ_
    GoTo _FileSys24_Main
#endIfSym
'-----------------------------------------------------------------------------------------------
' Write to an open file
' Input     : WREG0.Byte0
' Output    : WREG0.Byte0 still holds the byte written
' Notes     :
'
$ifndef cFAT_ReadOnly
#ifSym __SYSCOM_OUTRESERVE1_REQ_
__reserved__out1:
    Push.d WREG0                ' Save WREG0 and WREG1
    Push.d WREG2                ' Save WREG2 and WREG3
    Push.d WREG4                ' Save WREG4 and WREG5
    File_WriteByte(WREG0.Byte0) ' Write a byte to the file
    Pop.d WREG4                 ' Restore WREG4 and WREG5
    Pop.d WREG2                 ' Restore WREG2 and WREG3
    Pop.d WREG0                 ' Restore WREG0 and WREG1
    Return
#endIfSym
$endif
'-----------------------------------------------------------------------------------------------
' Read from an open file
' Input     : None
' Output    : WREG0.Byte0 holds the byte read
' Notes     :
'
$ifndef cFAT_WriteOnly
#ifSym __SYSCOM_INRESERVE1_REQ_
__reserved__in1:
    Push WREG1                      ' Save WREG1
    Push.d WREG2                    ' Save WREG2 and WREG3
    Push.d WREG4                    ' Save WREG4 and WREG5
    $if McuType = 1
        WREG0.Byte0 = File_ReadByte()   ' Read a byte from the file    
    $else
        WREG0 = File_ReadByte()   ' Read a byte from the file       
    $endif
    Pop.d WREG4                     ' Restore WREG4 and WREG5
    Pop.d WREG2                     ' Restore WREG2 and WREG3
    Pop WREG1                       ' Restore WREG1
    Return
#endIfSym
$endif
'-----------------------------------------------------------------------------------------------
_FileSys24_Main:

$endif  ' _FILESYS24_INC_



 
