$if McuType = 0
Dim dwTftCounter1_Rgb As Dword          At sTftString#0 
Dim wTempHeight_Rgb As Word             At sTftString#0 
Dim wTempWidth_Rgb As Word              At sTftString#2 
Dim bTftCounter1_Rgb As Byte            At sTftString#4 
Dim bTftDummy_Rgb As Byte               At sTftString#5 
Dim wTftCounter1_Rgb As Word            At sTftString#4 
Dim wTftTemp1 As Word                   At sTftString#4
Dim dwTftCounter2_Rgb As Dword          At sTftString#6
Dim wTftColor_Rgb As Word               At sTftString#6
Dim dwTftTemp1_Rgb As Dword             At sTftString#10
Dim dwTftTemp2_Rgb As Dword             At sTftString#14
Dim bTftCounter2_Rgb As Byte            At sTftString#18
Dim bTemp1_Rgb As Byte                  At sTftString#19 
$else
Dim dwTftCounter1_Rgb As Dword          At sTftString_0 
Dim wTempHeight_Rgb As Word             At sTftString_0 
Dim wTempWidth_Rgb As Word              At sTftString_2
Dim bTftCounter1_Rgb As Byte            At sTftString_4 
Dim bTftDummy_Rgb As Byte               At sTftString_5 
Dim wTftCounter1_Rgb As Word            At sTftString_4
Dim wTftTemp1 As Word                   At sTftString_4
Dim dwTftCounter2_Rgb As Dword          At sTftString_6
Dim wTftColor_Rgb As Word               At sTftString_6
Dim dwTftTemp1_Rgb As Dword             At sTftString_10
Dim dwTftTemp2_Rgb As Dword             At sTftString_14
Dim bTftCounter2_Rgb As Byte            At sTftString_18
Dim bTemp1_Rgb As Byte                  At sTftString_19 
$endif

Dim bSdExitCounter As Byte
Dim wSdExitCounter As Word
Dim bInitiated As Byte

$ifndef SDCardFatUsed
    $define SDCardFatUsed 0
$endif

$if SDCardUsed = 1
    Output SD_CS : Output SD_SDO : Output SD_CLK
    Input SD_SDI : PinSet SD_CLK
$endif

$if SDCardFatUsed = 0
    Global Dim dwGlobalSector As Dword Shared 
    dwGlobalSector = 0xFFFFFFFF
    Include "TftLib\SdCard\NoFat.inc"
$elseif SDCardFatUsed = 1
    Include "TftLib\SdCard\Fat.inc"
$endif

Proc _______TFT_FAT_____()
EndProc

'Take a screenshot using bi-directional SDA Pin and paste it to a BMP file in SD Card
'sFileName = new file name where the screen shot will be written to. should be less than 13 characters, including dot and file extension
'wX_Pos = x position for the lower left corner of the screenshot
'wY_Pos = y position for the lower left corner of the screenshot
'wWidth = screenshot width
'wHeight = screenshot height
'Return parameter: 0 = No error
'                  1 = No response from card
'                  2 = Card not formatted with FAT16 Or FAT32
'                  3 = File not found
'                  4 = File is in use 
'                  5 = Read/Write error
'Example: TftBmpScreenshotSd("PIC001.BMP", 0,0, 320,240) --> Paste current screen screenshot to file PIC001.BMP at position 0,0, width and height 320x240
 Proc TftBmpScreenshotSd1(sFileName As String * 12, wX_Pos As Word, wY_Pos As Word, wWidth As Word, wHeight As Word), Byte
    sFileName = ToUpper(sFileName)
    For wTftCounter1_Bmp = 0 To 999
        Result = File_Init()
        If Result = cErrOK Then
            Break
        EndIf
        DelayMS 1
    Next 
            
    Select Result
        Case cErrNoResponse
            Result = 1
            ExitProc
        Case cErrInvalidFormat
            Result = 2
            ExitProc 
    EndSelect
    
    If File_Exists(sFileName) = 1 Then
        Result = 5
        ExitProc  
    EndIf
     
    If File_Create(sFileName) <> cErrOK Then
        Result = 5
        ExitProc 
    EndIf
    
    wTftCounter1_Rgb = wWidth * 2
    wTftColor_Rgb = wTftCounter1_Rgb // 4
    bTemp1_Rgb = wTftColor_Rgb
    
    dwTftCounter1_Rgb = wWidth * wHeight
    dwTftCounter1_Rgb = dwTftCounter1_Rgb * 2
    dwTftCounter1_Rgb = dwTftCounter1_Rgb + wHeight * bTemp1_Rgb
    dwTftCounter1_Rgb = dwTftCounter1_Rgb + 66
    
    File_WriteByte(0x42) : File_WriteByte(0x4D)                                         
    File_WriteByte(dwTftCounter1_Rgb.Byte0) : File_WriteByte(dwTftCounter1_Rgb.Byte1)    
    File_WriteByte(dwTftCounter1_Rgb.Byte2) : File_WriteByte(dwTftCounter1_Rgb.Byte3)
    File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)       
    File_WriteByte(66) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)      
    File_WriteByte(40) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)      
    File_WriteByte(wWidth.Byte0) : File_WriteByte(wWidth.Byte1)                         
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(wHeight.Byte0) : File_WriteByte(wHeight.Byte1)                       
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(1) : File_WriteByte(0)                                               
    File_WriteByte(16) : File_WriteByte(0)                                              
    File_WriteByte(3) : File_WriteByte(0)                                               
    File_WriteByte(0) : File_WriteByte(0)  
    dwTftCounter1_Rgb = wWidth * wHeight
    dwTftCounter1_Rgb = dwTftCounter1_Rgb * 2
    File_WriteByte(dwTftCounter1_Rgb.Byte0) : File_WriteByte(dwTftCounter1_Rgb.Byte1)    
    File_WriteByte(dwTftCounter1_Rgb.Byte2) : File_WriteByte(dwTftCounter1_Rgb.Byte3)     
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0x00) : File_WriteByte(0xF8) : File_WriteByte(0x00) : File_WriteByte(0x00)
    File_WriteByte(0xE0) : File_WriteByte(0x07) : File_WriteByte(0x00) : File_WriteByte(0x00)
    File_WriteByte(0x1F) : File_WriteByte(0x00) : File_WriteByte(0x00) : File_WriteByte(0x00)

    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        For wTempHeight_Rgb = 0 To wHeight - 1
            For wTempWidth_Rgb = 0 To wWidth - 1
                wTftTemp1 = TftReadPixel(wX_Pos + wTempWidth_Rgb, wY_Pos + wTempHeight_Rgb)     
                File_WriteByte(wTftTemp1.Byte0)  
                File_WriteByte(wTftTemp1.Byte1) 
            Next
            Select bTemp1_Rgb
                Case 1
                    File_WriteByte(0)
                Case 2
                    File_WriteByte(0)
                    File_WriteByte(0)  
                Case 3
                    File_WriteByte(0)
                    File_WriteByte(0)
                    File_WriteByte(0)
            EndSelect
        Next      
    $endif

    File_Close() 
    Result = 0
EndProc

'Take a screenshot and paste it to a BMP file in SD Card
'sFileName = new file name where the screen shot will be written to. should be less than 13 characters, including dot and file extension
'wX_Pos = x position for the lower left corner of the screenshot
'wY_Pos = y position for the lower left corner of the screenshot
'wWidth = screenshot width
'wHeight = screenshot height
'Return parameter: 0 = No error
'                  1 = No response from card
'                  2 = Card not formatted with FAT16 Or FAT32
'                  3 = File not found
'                  4 = File is in use 
'                  5 = Read/Write error
'Example: TftBmpScreenshotSd("PIC001.BMP", 0,0, 320,240) --> Paste current screen screenshot to file PIC001.BMP at position 0,0, width and height 320x240

Proc TftBmpScreenshotSd(sFileName As String * 12, wX_Pos As Word, wY_Pos As Word, wWidth As Word, wHeight As Word), Byte
    sFileName = ToUpper(sFileName)
    For wTftCounter1_Bmp = 0 To 999
        Result = File_Init()
        If Result = cErrOK Then
            Break
        EndIf
        DelayMS 1
    Next 
            
    Select Result
        Case cErrNoResponse
            Result = 1
            ExitProc
        Case cErrInvalidFormat
            Result = 2
            ExitProc 
    EndSelect
    
    If File_Exists(sFileName) = 1 Then
        Result = 5
        ExitProc  
    EndIf
     
    If File_Create(sFileName) <> cErrOK Then
        Result = 5
        ExitProc 
    EndIf
    
    wTftCounter1_Rgb = wWidth * 2
    wTftColor_Rgb = wTftCounter1_Rgb // 4
    bTemp1_Rgb = wTftColor_Rgb
    
    dwTftCounter1_Rgb = wWidth * wHeight
    dwTftCounter1_Rgb = dwTftCounter1_Rgb * 2
    dwTftCounter1_Rgb = dwTftCounter1_Rgb + wHeight * bTemp1_Rgb
    dwTftCounter1_Rgb = dwTftCounter1_Rgb + 66
    
    File_WriteByte(0x42) : File_WriteByte(0x4D)                                         
    File_WriteByte(dwTftCounter1_Rgb.Byte0) : File_WriteByte(dwTftCounter1_Rgb.Byte1)    
    File_WriteByte(dwTftCounter1_Rgb.Byte2) : File_WriteByte(dwTftCounter1_Rgb.Byte3)
    File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)       
    File_WriteByte(66) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)      
    File_WriteByte(40) : File_WriteByte(0) : File_WriteByte(0) : File_WriteByte(0)      
    File_WriteByte(wWidth.Byte0) : File_WriteByte(wWidth.Byte1)                         
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(wHeight.Byte0) : File_WriteByte(wHeight.Byte1)                       
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(1) : File_WriteByte(0)                                               
    File_WriteByte(16) : File_WriteByte(0)                                              
    File_WriteByte(3) : File_WriteByte(0)                                               
    File_WriteByte(0) : File_WriteByte(0)  
    dwTftCounter1_Rgb = wWidth * wHeight
    dwTftCounter1_Rgb = dwTftCounter1_Rgb * 2
    File_WriteByte(dwTftCounter1_Rgb.Byte0) : File_WriteByte(dwTftCounter1_Rgb.Byte1)    
    File_WriteByte(dwTftCounter1_Rgb.Byte2) : File_WriteByte(dwTftCounter1_Rgb.Byte3)     
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0) : File_WriteByte(0)                                                 
    File_WriteByte(0) : File_WriteByte(0)
    File_WriteByte(0x00) : File_WriteByte(0xF8) : File_WriteByte(0x00) : File_WriteByte(0x00)
    File_WriteByte(0xE0) : File_WriteByte(0x07) : File_WriteByte(0x00) : File_WriteByte(0x00)
    File_WriteByte(0x1F) : File_WriteByte(0x00) : File_WriteByte(0x00) : File_WriteByte(0x00)

    $if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        $if TFT_IC = ST7796S
            wTftTemp1 = TftReadPixel(wX_Pos, wY_Pos)   
        $endif
        TftSetWindow(wX_Pos, wX_Pos + wWidth - 1, wY_Pos, wY_Pos + wHeight - 1)
        TftInitiateDataRamRead()
        $if TFT_IC = ILI9486
            TftReceive()
        $endif
        For wTempHeight_Rgb = 0 To wHeight - 1
            For wTempWidth_Rgb = 0 To wWidth - 1
                wTftTemp1 = TftReceive()
                File_WriteByte(wTftTemp1.Byte0)  
                File_WriteByte(wTftTemp1.Byte1) 
            Next
            Select bTemp1_Rgb
                Case 1
                    File_WriteByte(0)
                Case 2
                    File_WriteByte(0)
                    File_WriteByte(0)  
                Case 3
                    File_WriteByte(0)
                    File_WriteByte(0)
                    File_WriteByte(0)
            EndSelect
        Next
        TftStopDataRam()
    $elseif TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK 
            TftSetWindow(wX_Pos, wX_Pos + wWidth - 1, wY_Pos, wY_Pos + wHeight - 1)
            TftInitiateDataRamRead()
            TftReceive()
            For wTempHeight_Rgb = 0 To wHeight - 1
                For wTempWidth_Rgb = 0 To wWidth - 1
                    wTftTemp1 = 0
                    bTftRed_Basic = TftReceive() >> 2 
                    wTftTemp1.Byte1 = TftReceive() >> 2
                    bTftBlue_Basic = TftReceive() >> 2
                    bTftBlue_Basic = CRead8 Color6bTo5b[bTftBlue_Basic]
                    bTftRed_Basic = CRead8 Color6bTo5b[bTftRed_Basic]
                    wTftTemp1 = wTftTemp1 >> 3
                    wTftTemp1.Byte0 = wTftTemp1.Byte0 | bTftBlue_Basic
                    bTftRed_Basic = bTftRed_Basic << 3
                    wTftTemp1.Byte1 = wTftTemp1.Byte1 | bTftRed_Basic 
                    File_WriteByte(wTftTemp1.Byte0)  
                    File_WriteByte(wTftTemp1.Byte1) 
                Next
                Select bTemp1_Rgb
                    Case 1
                        File_WriteByte(0)
                    Case 2
                        File_WriteByte(0)
                        File_WriteByte(0)  
                    Case 3
                        File_WriteByte(0)
                        File_WriteByte(0)
                        File_WriteByte(0)
                EndSelect
            Next
            TftStopDataRam()   
        $else
            For wTempHeight_Rgb = 0 To wHeight - 1
                For wTempWidth_Rgb = 0 To wWidth - 1
                    wTftTemp1 = TftReadPixel(wX_Pos + wTempWidth_Rgb, wY_Pos + wTempHeight_Rgb)     
                    File_WriteByte(wTftTemp1.Byte0)  
                    File_WriteByte(wTftTemp1.Byte1) 
                Next
                Select bTemp1_Rgb
                    Case 1
                        File_WriteByte(0)
                    Case 2
                        File_WriteByte(0)
                        File_WriteByte(0)  
                    Case 3
                        File_WriteByte(0)
                        File_WriteByte(0)
                        File_WriteByte(0)
                EndSelect
            Next      
        $endif
    $endif

    File_Close() 
    Result = 0
EndProc

'Print a BMP file from a SD card
'sFileName = File name of the image to print, should be less than 13 characters, including dot and file extension
'wX_Pos = x position for the lower left corner of the image
'wY_Pos = y position for the lower left corner of the image
'Return parameter: 0 = No error
'                  1 = No response from card
'                  2 = Card not formatted with FAT16 Or FAT32
'                  3 = File not found
'                  4 = File is in use 
'                  5 = Read/Write error
'                  99 = Out of screen borders
'Example: TftBmpFromSD("PIC001.BMP", 0,0) --> Print file PIC001.BMP at position 0,0

'Note: there's no image processing so the BMP file should be:
'      - smaller than the screen width and height
'      - the color depth should be 16 bit RGB (565)
'      - the row direction is bottom to top (default)
'      - no compression
'You can use different tools to conver the file, one such tool is: 
'https://online-converting.com/image/convert2bmp/#
'Select the correct format, then drop the files, wait and download the converted file 
'Or you can use the included Library converter tool

Proc TftBmpFromSD(sFileName As String * 12, wX_Pos As Word, wY_Pos As Word), Byte 
    sFileName = ToUpper(sFileName)
    For wTftCounter1_Bmp = 0 To 999
        Result = File_Init()
        If Result = cErrOK Then
            Break
        EndIf
        DelayMS 1
    Next 
            
    Select Result
        Case cErrNoResponse
            Result = 1
            ExitProc
        Case cErrInvalidFormat
            Result = 2
            ExitProc 
    EndSelect
    
    Result = File_Open(sFileName)
    
    Select Result
        Case cErrNotFound
            Result = 3
            ExitProc
        Case cErrInUse
            Result = 4
            ExitProc 
        Case cErrRWError
            Result = 5
            ExitProc    
    EndSelect
    
    File_ReadByte()
    bTftTemp1_Bmp = File_ReadByte()
    
    dwTftCounter1_Bmp = 2
    While dwTftCounter1_Bmp < 10
        File_ReadByte()
        Inc dwTftCounter1_Bmp
    Wend 
    dwTftOffset_Bmp.Byte0 = File_ReadByte()  
    dwTftOffset_Bmp.Byte1 = File_ReadByte() 
    dwTftOffset_Bmp.Byte2 = File_ReadByte() 
    dwTftOffset_Bmp.Byte3 = File_ReadByte()
    Inc dwTftCounter1_Bmp, 4 
    
    While dwTftCounter1_Bmp < 18
        File_ReadByte()
        Inc dwTftCounter1_Bmp
    Wend 
    
    If bTftTemp1_Bmp = "M" Then
        wTftWidth_Bmp.Byte0 = File_ReadByte()  
        wTftWidth_Bmp.Byte1 = File_ReadByte()
        File_ReadByte()
        File_ReadByte()
        Inc dwTftCounter1_Bmp, 4 
        wTftHeight_Bmp.Byte0 = File_ReadByte() 
        wTftHeight_Bmp.Byte1 = File_ReadByte() 
        Inc dwTftCounter1_Bmp, 2 
    Else
        wTftWidth_Bmp.Byte0 = File_ReadByte()  
        wTftWidth_Bmp.Byte1 = File_ReadByte() 
        wTftHeight_Bmp.Byte0 = File_ReadByte() 
        wTftHeight_Bmp.Byte1 = File_ReadByte() 
        Inc dwTftCounter1_Bmp, 4 
    EndIf 
    
    While dwTftCounter1_Bmp < 34
        File_ReadByte()
        Inc dwTftCounter1_Bmp
    Wend
    dwTftSize_Bmp.Byte0 = File_ReadByte()
    dwTftSize_Bmp.Byte1 = File_ReadByte()
    dwTftSize_Bmp.Byte2 = File_ReadByte()
    dwTftSize_Bmp.Byte3 = File_ReadByte()
    Inc dwTftCounter1_Bmp, 4 
    
    bTftTrim_Bmp = (wTftWidth_Bmp + wTftWidth_Bmp) // 4
    
    While dwTftCounter1_Bmp < dwTftOffset_Bmp
        File_ReadByte()
        Inc dwTftCounter1_Bmp
    Wend
    
    $if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        $if TftPixelCheck = 1
            If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
                pOutOfScreen = 0
                wTempHorizontal = wX_Pos + wTftWidth_Bmp - 1 : wTempVertical = wY_Pos + wTftHeight_Bmp - 1
                If wTempHorizontal >= TftScreenWidth Then 
                    wTempHorizontal = TftScreenWidth - 1
                    pOutOfScreen = 1
                EndIf
                If wTempVertical >= TftScreenHeight Then 
                    wTempVertical = TftScreenHeight - 1
                    pOutOfScreen = 1
                EndIf
                TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)        
            Else
                File_Close()
                Result = 99
                pOutOfScreen = 1
                ExitProc                                 
            EndIf
        $else
            TftSetWindow(wX_Pos, wX_Pos + wTftWidth_Bmp - 1, wY_Pos, wY_Pos + wTftHeight_Bmp - 1)
        $endif
        TftInitiateDataRam()
    $endif
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK
            Dim wTemp As Word
            Dim bTemp As Byte
            Dim bTemp0 As wTemp.Byte0
            Dim bTemp1 As wTemp.Byte1
            $if TftPixelCheck = 1
                If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
                    pOutOfScreen = 0
                    wTempHorizontal = wX_Pos + wTftWidth_Bmp - 1 : wTempVertical = wY_Pos + wTftHeight_Bmp - 1
                    If wTempHorizontal >= TftScreenWidth Then 
                        wTempHorizontal = TftScreenWidth - 1
                        pOutOfScreen = 1
                    EndIf
                    If wTempVertical >= TftScreenHeight Then 
                        wTempVertical = TftScreenHeight - 1
                        pOutOfScreen = 1
                    EndIf
                    TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)  
                Else
                    File_Close()
                    Result = 99
                    pOutOfScreen = 1
                    ExitProc                                 
                EndIf
            $else
                TftSetWindow(wX_Pos, wX_Pos + wTftWidth_Bmp - 1, wY_Pos, wY_Pos + wTftHeight_Bmp - 1)
            $endif
            TftInitiateDataRam()
        $endif   
    $endif
    
    bInitiated = 0
    For wTftCounter1_Bmp = 0 To wTftHeight_Bmp - 1
        wTftCounter2_Bmp = 0
        Do 
            $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
                $if _TFT_MOSI = _SD_SDO Or _TFT_MISO = _SD_SDI Or _TFT_SCLK = _SD_CLK
                    wTftColor_Bmp.Byte0 = File_ReadByte()
                    wTftColor_Bmp.Byte1 = File_ReadByte()
                    TftPixel(wTftCounter2_Bmp + wX_Pos, wTftCounter1_Bmp + wY_Pos, wTftColor_Bmp)
                $else
                    bTemp0 = File_ReadByte()
                    bTemp1 = File_ReadByte()
                    $if TFT_COM = SPI_1
                        $if TFT_IC = ILI9488 
                            Rgb16ToRgb18(wTemp) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0) 
                        $else
                            $if McuType = 0
                                If bInitiated = 0 Then
                                    bInitiated = 1
                                Else
                                    While SSP1STAT.0 = 0 : Wend 
                                EndIf
                                bTemp = SSP1BUF
                                SSP1BUF = bTemp1
                                While SSP1STAT.0 = 0 : Wend  
                                bTemp = SSP1BUF
                                SSP1BUF = bTemp0
                            $else
                                If bInitiated = 0 Then
                                    bInitiated = 1
                                Else
                                    While SPI1STAT.0 = 0 : Wend
                                EndIf
                                bTemp = SPI1BUF
                                SPI1BUF = bTemp1
                                While SPI1STAT.0 = 0 : Wend
                                bTemp = SPI1BUF
                                SPI1BUF = bTemp0
                            $endif
                        $endif
                    $elseif TFT_COM = SPI_2 
                        $if TFT_IC = ILI9488 
                            Rgb16ToRgb18(wTemp) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0)  
                        $else
                            $if McuType = 0
                                If bInitiated = 0 Then
                                    bInitiated = 1
                                Else
                                    While SSP2STAT.0 = 0 : Wend
                                EndIf
                                bTemp = SSP2BUF
                                SSP2BUF = bTemp1
                                While SSP2STAT.0 = 0 : Wend
                                bTemp = SSP2BUF
                                SSP2BUF = bTemp0
                            $else
                                If bInitiated = 0 Then
                                    bInitiated = 1
                                Else
                                    While SPI2STAT.0 = 0 : Wend
                                EndIf
                                bTemp = SPI2BUF
                                SPI2BUF = bTemp1
                                While SPI2STAT.0 = 0 : Wend
                                bTemp = SPI2BUF
                                SPI2BUF = bTemp0
                            $endif   
                        $endif
                    $elseif TFT_COM = SPI_SW 
                        $if TFT_IC = ILI9488 
                            Rgb16ToRgb18(wTemp) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0)
                        $else
                            TftSend(bTemp1)
                            TftSend(bTemp0)
                        $endif
                    $endif
                $endif
            $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
                $if McuType = 0
                    TftDataLowByte = File_ReadByte()
                    TftDataHighByte = File_ReadByte()
                $else
                    TftDataWord.Byte0 = File_ReadByte()
                    TftDataWord.Byte1 = File_ReadByte()
                $endif
                PinClear TFT_WR : PinSet TFT_WR 
            $endif
            Inc wTftCounter2_Bmp   
        Loop While wTftCounter2_Bmp < wTftWidth_Bmp 
        Select bTftTrim_Bmp
            Case 1
                File_ReadByte()
            Case 2
                File_ReadByte()
                File_ReadByte()
            Case 3
                File_ReadByte()
                File_ReadByte()
                File_ReadByte()
        EndSelect          
    Next
    
    $if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        TftStopDataRam()
    $endif
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK
            TftStopDataRam()
        $endif  
        DelayUS 100
        $if TFT_IC = ILI9488
            'do nothing
        $else
            $if McuType = 0
                $if TFT_COM = SPI_1 
                    bTemp = SSP1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SSP2BUF
                $endif
            $else
                $if TFT_COM = SPI_1 
                    bTemp = SPI1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SPI2BUF
                $endif
            $endif
        $endif
    $endif
    
    File_Close()
    Result = 0 
EndProc

Proc _______TFT_RAW_____()
EndProc


'Play a RGB movie file from SD card where the files are written sequentially without any file system
'wX_Pos = x position for the lower left corner of the movie frame
'wY_Pos = y position for the lower left corner of the movie frame
'wRgbWidth = movie width
'wRgbHeight = movie height
'dwStartSector = file start sector on SD card
'dwStopSector = file end sector on SD card
'wFrameDelayUs = delay in micro seconds between frames to adjust frame rate

'Example: TftRgbFromSdRaw(80,40,320,240, 3243300,4153799,10)

'You can use different tools to conver the file, one such tool is:
'- included SdCardWriteRGB565.exe

Proc TftRgbFromSdRaw(wX_Pos As Word, wY_Pos As Word, wRgbWidth As Word, wRgbHeight As Word, dwStartSector As Dword, dwStopSector As Dword, wFrameDelayUs As Word), Byte
    Global Dim bCardSpiInitOk As Byte Shared
    Dim wTemp As Word
    Dim bTemp As Byte 
    Dim bTemp0 As wTemp.Byte0
    Dim bTemp1 As wTemp.Byte1
   
    Result = 255

    If bCardSpiInitOk <> 253 Then
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bCardSpiInitOk = SD_InitSequence()
            Dec wSdExitCounter
        Until bCardSpiInitOk = 1 Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then 
            Result = 0
        Else
            bCardSpiInitOk = 253  
        EndIf
    EndIf
    
    dwTftTemp1_Rgb = wRgbWidth * wRgbHeight
    dwTftTemp2_Rgb = dwStopSector - dwStartSector 
    dwTftCounter2_Rgb = 0
    bTemp = 0

$if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW 
    $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK 
        $if TftPixelCheck = 1
            If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
                pOutOfScreen = 0
                wTempHorizontal = wX_Pos + wRgbWidth - 1 : wTempVertical = wY_Pos + wRgbHeight - 1
                If wTempHorizontal >= TftScreenWidth Then 
                    wTempHorizontal = TftScreenWidth - 1
                    pOutOfScreen = 1
                EndIf
                If wTempVertical >= TftScreenHeight Then 
                    wTempVertical = TftScreenHeight - 1
                    pOutOfScreen = 1
                EndIf
                TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)        
            Else
                Result = 99
                pOutOfScreen = 1
                ExitProc                                 
            EndIf
        $else
            TftSetWindow(wX_Pos, wX_Pos + wRgbWidth - 1, wY_Pos, wY_Pos + wRgbHeight - 1)
        $endif 
        TftInitiateDataRam()
        
        PinSet SD_CS 
        PinClear SD_CLK 
        PinClear SD_CS
   
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 1
    
        If Disk_bCardType <> SD_cSDHC Then
            dwStartSector = dwStartSector << 9
        EndIf
    
        SD_SendByte(SD_cCMD18)  
        SD_SendByte(dwStartSector.Byte3)
        SD_SendByte(dwStartSector.Byte2)
        SD_SendByte(dwStartSector.Byte1)
        SD_SendByte(dwStartSector.Byte0)
        SD_SendByte($FF)
    
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $FE Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 2
        
        For dwTftCounter1_Rgb = 0 To dwTftTemp2_Rgb
            $if SD_COM = SPI_1  
                $if TFT_IC = ILI9488 
                    $if McuType = 1
                        For bTftCounter1_Rgb = 0 To 255
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTemp1 = SPI1BUF
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTemp0 = SPI1BUF
                            
                            Rgb16ToRgb18(wColor) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0)
    
                            Inc dwTftCounter2_Rgb
                            If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                dwTftCounter2_Rgb = 0
                                DelayUS wFrameDelayUs
                            EndIf
                        Next
                        
                        SPI1BUF = 0xFF
                        While SPI1STAT.1 = 1 : Wend
                        bTftDummy_Rgb = SPI1BUF
                        SPI1BUF = 0xFF
                        While SPI1STAT.1 = 1 : Wend
                        bTftDummy_Rgb = SPI1BUF
                        Repeat 
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                        Until SPI1BUF = $FE
                    $else
                        For bTftCounter1_Rgb = 0 To 255
                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTemp1 = SPI1BUF
                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTemp0 = SPI1BUF
                            
                            Rgb16ToRgb18(wColor) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0)
                                
                            Inc dwTftCounter2_Rgb
                            If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                dwTftCounter2_Rgb = 0
                                DelayUS wFrameDelayUs
                            EndIf
                        Next

                        SSP1BUF = 0xFF
                        While SSP1STAT.0 = 0 : Wend
                        bTftDummy_Rgb = SSP1BUF
                        SSP1BUF = 0xFF
                        While SSP1STAT.0 = 0 : Wend
                        bTftDummy_Rgb = SSP1BUF
                        Repeat 
                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                        Until SSP1BUF = $FE
                    $endif 
                $else
                    $if TFT_COM = SPI_2
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                SPI1BUF = 0xFF
                                bTemp0 = SPI2BUF
                                While SPI1STAT.1 = 1 : Wend
                                SPI2BUF = SPI1BUF
                                SPI1BUF = 0xFF
                                bTemp0 = SPI2BUF
                                While SPI1STAT.1 = 1 : Wend
                                SPI2BUF = SPI1BUF
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI1BUF
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI1BUF
                            Repeat 
                                SPI1BUF = 0xFF
                                While SPI1STAT.1 = 1 : Wend
                            Until SPI1BUF = $FE
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                SSP1BUF = 0xFF
                                bTemp0 = SSP2BUF
                                While SSP1STAT.0 = 0 : Wend
                                SSP2BUF = SSP1BUF
                                SSP1BUF = 0xFF
                                bTemp0 = SSP2BUF
                                While SSP1STAT.0 = 0 : Wend
                                SSP2BUF = SSP1BUF
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP1BUF
                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP1BUF
                            Repeat 
                                SSP1BUF = 0xFF
                                While SSP1STAT.0 = 0 : Wend
                            Until SSP1BUF = $FE
                        $endif
                    $elseif TFT_COM = SPI_SW
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                SPI1BUF = 0xFF
                                While SPI1STAT.1 = 1 : Wend
                                TftSend(SPI1BUF)
                                SPI1BUF = 0xFF
                                While SPI1STAT.1 = 1 : Wend
                                TftSend(SPI1BUF)
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next
                        
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI1BUF
                            SPI1BUF = 0xFF
                            While SPI1STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI1BUF
                            Repeat 
                                SPI1BUF = 0xFF
                                While SPI1STAT.1 = 1 : Wend
                            Until SPI1BUF = $FE
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                SSP1BUF = 0xFF
                                While SSP1STAT.0 = 0 : Wend
                                TftSend(SSP1BUF)
                                SSP1BUF = 0xFF
                                While SSP1STAT.0 = 0 : Wend
                                TftSend(SSP1BUF)
                                
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP1BUF
                            SSP1BUF = 0xFF
                            While SSP1STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP1BUF
                            Repeat 
                                SSP1BUF = 0xFF
                                While SSP1STAT.0 = 0 : Wend
                            Until SSP1BUF = $FE
                        $endif
                    $endif 
                $endif
            $elseif SD_COM = SPI_2
                $if TFT_IC = ILI9488 
                    $if McuType = 1
                        For bTftCounter1_Rgb = 0 To 255
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTemp1 = SPI2BUF
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTemp0 = SPI2BUF
                            
                            Rgb16ToRgb18(wTemp) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0) 
    
                            Inc dwTftCounter2_Rgb
                            If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                dwTftCounter2_Rgb = 0
                                DelayUS wFrameDelayUs
                            EndIf
                        Next
                        
                        SPI2BUF = 0xFF
                        While SPI2STAT.1 = 1 : Wend
                        bTftDummy_Rgb = SPI2BUF
                        SPI2BUF = 0xFF
                        While SPI2STAT.1 = 1 : Wend
                        bTftDummy_Rgb = SPI2BUF
                        Repeat 
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                        Until SPI2BUF = $FE
                    $else
                        For bTftCounter1_Rgb = 0 To 255
                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTemp1 = SSP2BUF
                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTemp0 = SSP2BUF
                            
                            Rgb16ToRgb18(wTemp) 
                            TftSend(dColor.Byte2)
                            TftSend(dColor.Byte1)
                            TftSend(dColor.Byte0)
    
                            Inc dwTftCounter2_Rgb
                            If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                dwTftCounter2_Rgb = 0
                                DelayUS wFrameDelayUs
                            EndIf
                        Next

                        SSP2BUF = 0xFF
                        While SSP2STAT.0 = 0 : Wend
                        bTftDummy_Rgb = SSP2BUF
                        SSP2BUF = 0xFF
                        While SSP2STAT.0 = 0 : Wend
                        bTftDummy_Rgb = SSP2BUF
                        Repeat 
                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                        Until SSP2BUF = $FE
                    $endif
                $else
                    $if TFT_COM = SPI_1
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                SPI2BUF = 0xFF
                                bTemp0 = SPI1BUF
                                While SPI2STAT.1 = 1 : Wend
                                SPI1BUF = SPI2BUF
                                SPI2BUF = 0xFF
                                bTemp0 = SPI1BUF
                                While SPI2STAT.1 = 1 : Wend
                                SPI1BUF = SP21BUF
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI2BUF
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI2BUF
                            Repeat 
                                SPI2BUF = 0xFF
                                While SPI2STAT.1 = 1 : Wend
                            Until SPI2BUF = $FE
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                SSP2BUF = 0xFF
                                bTemp0 = SSP1BUF
                                While SSP2STAT.0 = 0 : Wend
                                SSP1BUF = SSP2BUF
                                SSP2BUF = 0xFF
                                bTemp0 = SSP1BUF
                                While SSP2STAT.0 = 0 : Wend
                                SSP1BUF = SSP2BUF
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP2BUF
                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP2BUF
                            Repeat 
                                SSP2BUF = 0xFF
                                While SSP2STAT.0 = 0 : Wend
                            Until SSP2BUF = $FE
                        $endif
                    $elseif TFT_COM = SPI_SW
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                SPI2BUF = 0xFF
                                While SPI2STAT.1 = 1 : Wend
                                TftSend(SPI2BUF)
                                SPI2BUF = 0xFF
                                While SPI2STAT.1 = 1 : Wend
                                TftSend(SPI2BUF)
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next
                        
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI2BUF
                            SPI2BUF = 0xFF
                            While SPI2STAT.1 = 1 : Wend
                            bTftDummy_Rgb = SPI2BUF
                            Repeat 
                                SPI2BUF = 0xFF
                                While SPI2STAT.1 = 1 : Wend
                            Until SPI2BUF = $FE
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                SSP2BUF = 0xFF
                                While SSP2STAT.0 = 0 : Wend
                                TftSend(SSP2BUF)
                                SSP2BUF = 0xFF
                                While SSP2STAT.0 = 0 : Wend
                                TftSend(SSP2BUF)
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP2BUF
                            SSP2BUF = 0xFF
                            While SSP2STAT.0 = 0 : Wend
                            bTftDummy_Rgb = SSP2BUF
                            Repeat 
                                SSP2BUF = 0xFF
                                While SSP2STAT.0 = 0 : Wend
                            Until SSP2BUF = $FE
                        $endif
                    $endif
                $endif 
            $elseif SD_COM = SPI_SW
                $if TFT_IC = ILI9488
                    For bTftCounter1_Rgb = 0 To 255
                        bTemp1 = SD_ReceiveByte()
                        bTemp0 = SD_ReceiveByte()
                        
                        Rgb16ToRgb18(wTemp)
                        TftSend(dColor.Byte2)
                        TftSend(dColor.Byte1)
                        TftSend(dColor.Byte0) 
            
                        Inc dwTftCounter2_Rgb
                        If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                            dwTftCounter2_Rgb = 0
                            DelayUS wFrameDelayUs
                        EndIf
                    Next

                    SD_ReceiveByte()
                    SD_ReceiveByte()
                    Repeat 
                        bTftDummy_Rgb = SD_ReceiveByte()
                    Until bTftDummy_Rgb = $FE 
                $else
                    $if TFT_COM = SPI_1
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SPI1BUF
                                SPI1BUF = bTemp0
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SPI1BUF
                                SPI1BUF = bTemp0
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SD_ReceiveByte()
                            SD_ReceiveByte()
                            Repeat 
                                bTftDummy_Rgb = SD_ReceiveByte()
                            Until bTftDummy_Rgb = $FE
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SSP1BUF
                                SSP1BUF = bTemp0
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SSP1BUF
                                SSP1BUF = bTemp0
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SD_ReceiveByte()
                            SD_ReceiveByte()
                            Repeat 
                                bTftDummy_Rgb = SD_ReceiveByte()
                            Until bTftDummy_Rgb = $FE 
                        $endif
                    $elseif TFT_COM = SPI_2
                        $if McuType = 1
                            For bTftCounter1_Rgb = 0 To 255
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SPI2BUF
                                SPI2BUF = bTemp0
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SPI2BUF
                                SPI2BUF = bTemp0
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SD_ReceiveByte()
                            SD_ReceiveByte()
                            Repeat 
                                bTftDummy_Rgb = SD_ReceiveByte()
                            Until bTftDummy_Rgb = $FE 
                        $else
                            For bTftCounter1_Rgb = 0 To 255
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SSP2BUF
                                SSP2BUF = bTemp0
                                bTemp0 = SD_ReceiveByte()
                                bTemp1 = SSP2BUF
                                SSP2BUF = bTemp0
    
                                Inc dwTftCounter2_Rgb
                                If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                    dwTftCounter2_Rgb = 0
                                    DelayUS wFrameDelayUs
                                EndIf
                            Next

                            SD_ReceiveByte()
                            SD_ReceiveByte()
                            Repeat 
                                bTftDummy_Rgb = SD_ReceiveByte()
                            Until bTftDummy_Rgb = $FE 
                        $endif
                    $elseif TFT_COM = SPI_SW
                        For bTftCounter1_Rgb = 0 To 255
                            TftSend(SD_ReceiveByte())
                            TftSend(SD_ReceiveByte())
    
                            Inc dwTftCounter2_Rgb
                            If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                                dwTftCounter2_Rgb = 0
                                DelayUS wFrameDelayUs
                            EndIf
                        Next

                        SD_ReceiveByte()
                        SD_ReceiveByte()
                        Repeat 
                            bTftDummy_Rgb = SD_ReceiveByte()
                        Until bTftDummy_Rgb = $FE 
                    $endif
                $endif  
            $endif  
        Next 
        
        SD_SendByte(SD_cCMD12)  
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte($FF)
        SD_ReceiveByte()
        
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $00 Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 3
    
        For bTftCounter1_Rgb = 0 To 31
            wSdExitCounter = SD_cTimeOutLimit
            Repeat 
                bTftDummy_Rgb = SD_ReceiveByte()
                Dec wSdExitCounter
            Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
        Next
        If wSdExitCounter = 0 Then Result = 4
        
        PinSet SD_CS  
        TftStopDataRam()
        
        $if TFT_IC = ILI9488 
            'Do nothing
        $else
            $if McuType = 0
                $if TFT_COM = SPI_1 
                    bTemp = SSP1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SSP2BUF
                $endif
            $else
                $if TFT_COM = SPI_1 
                    bTemp = SPI1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SPI2BUF
                $endif
            $endif  
        $endif 
    $else
        (*
        When SPI pins are shared between the TFT screen and the SD card, one can't use a window mode 
        to send a full frame in a burst mode because if the CS line is held Low clock from one peripheral 
        device will interfere with the other. Thus each frame has to be built pixels by pixel toggling 
        back and forward with lots of overhead between the TFT screen and the SD card.
            
        It is certainly possible to display sequence of frames but would be extremely slow 
        in 8-bit devices and useless for any practical conciderations. 
        *)  
        wTempHeight_Rgb = 0 
        wTempWidth_Rgb = 0
        
        Do
            SD_ReadSector(dwStartSector)  
            Inc dwStartSector
        
            For wTftCounter1_Rgb = 0 To 510 Step 2
                wTftColor_Rgb.Byte1 = SectorBuffer[wTftCounter1_Rgb + 0]
                wTftColor_Rgb.Byte0 = SectorBuffer[wTftCounter1_Rgb + 1]  
                TftPixel(wTempWidth_Rgb + wX_Pos, wTempHeight_Rgb + wY_Pos, wTftColor_Rgb)
            
                Inc wTempWidth_Rgb 
                If wTempWidth_Rgb = wRgbWidth Then
                    wTempWidth_Rgb = 0
                    Inc wTempHeight_Rgb
                EndIf  
                If wTempHeight_Rgb = wRgbHeight Then
                    wTempHeight_Rgb = 0
                    DelayUS wFrameDelayUs
                EndIf 
            Next
        Loop Until dwStartSector > dwStopSector
    $endif  
$endif   

$if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
    $if TftPixelCheck = 1
            If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
                pOutOfScreen = 0
                wTempHorizontal = wX_Pos + wRgbWidth - 1 : wTempVertical = wY_Pos + wRgbHeight - 1
                If wTempHorizontal >= TftScreenWidth Then 
                    wTempHorizontal = TftScreenWidth - 1
                    pOutOfScreen = 1
                EndIf
                If wTempVertical >= TftScreenHeight Then 
                    wTempVertical = TftScreenHeight - 1
                    pOutOfScreen = 1
                EndIf
                TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)        
            Else
                Result = 99
                pOutOfScreen = 1
                ExitProc                                 
            EndIf
    $else
        TftSetWindow(wX_Pos, wX_Pos + wRgbWidth - 1, wY_Pos, wY_Pos + wRgbHeight - 1)
    $endif 
    TftInitiateDataRam()

    PinSet SD_CS 
    PinClear SD_CLK 
    PinClear SD_CS
    
    wSdExitCounter = SD_cTimeOutLimit
    Repeat 
        bTftDummy_Rgb = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 1
    
    If Disk_bCardType <> SD_cSDHC Then
        dwStartSector = dwStartSector << 9
    EndIf
    
    SD_SendByte(SD_cCMD18)  
    SD_SendByte(dwStartSector.Byte3)
    SD_SendByte(dwStartSector.Byte2)
    SD_SendByte(dwStartSector.Byte1)
    SD_SendByte(dwStartSector.Byte0)
    SD_SendByte($FF)
    
    wSdExitCounter = SD_cTimeOutLimit
    Repeat 
        bTftDummy_Rgb = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftDummy_Rgb = $FE Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 2

    For dwTftCounter1_Rgb = 0 To dwTftTemp2_Rgb
        $if SD_COM = SPI_1
            $if McuType = 1
                For bTftCounter1_Rgb = 0 To 255
                    SPI1BUF = 0xFF 
                    While SPI1STAT.1 = 1 : Wend 
                    TftDataWord.Byte1 = SPI1BUF
                    SPI1BUF = 0xFF 
                    While SPI1STAT.1 = 1 : Wend
                    TftDataWord.Byte0 = SPI1BUF
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SPI1BUF = 0xFF
                While SPI1STAT.1 = 1 : Wend
                bTftDummy_Rgb = SPI1BUF
                SPI1BUF = 0xFF
                While SPI1STAT.1 = 1 : Wend
                bTftDummy_Rgb = SPI1BUF
                Repeat 
                    SPI1BUF = 0xFF
                    While SPI1STAT.1 = 1 : Wend
                Until SPI1BUF = $FE
            $else
                For bTftCounter1_Rgb = 0 To 255
                    SSP1BUF = 0xFF 
                    While SSP1STAT.0 = 0 : Wend
                    TftDataHighByte = SSP1BUF
                    SSP1BUF = 0xFF 
                    While SSP1STAT.0 = 0 : Wend
                    TftDataLowByte = SSP1BUF
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SSP1BUF = 0xFF
                While SSP1STAT.0 = 0 : Wend
                bTftDummy_Rgb = SSP1BUF
                SSP1BUF = 0xFF
                While SSP1STAT.0 = 0 : Wend
                bTftDummy_Rgb = SSP1BUF
                Repeat 
                    SSP1BUF = 0xFF
                    While SSP1STAT.0 = 0 : Wend
                Until SSP1BUF = $FE
            $endif   
        $elseif SD_COM = SPI_2
            $if McuType = 1
                For bTftCounter1_Rgb = 0 To 255
                    SPI2BUF = 0xFF 
                    While SPI2STAT.1 = 1 : Wend 
                    TftDataWord.Byte1 = SPI2BUF
                    SPI2BUF = 0xFF 
                    While SPI2STAT.1 = 1 : Wend
                    TftDataWord.Byte0 = SPI2BUF
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SPI2BUF = 0xFF
                While SPI2STAT.1 = 1 : Wend
                bTftDummy_Rgb = SPI2BUF
                SPI2BUF = 0xFF
                While SPI2STAT.1 = 1 : Wend
                bTftDummy_Rgb = SPI2BUF
                Repeat 
                    SPI2BUF = 0xFF
                    While SPI2STAT.1 = 1 : Wend
                Until SPI2BUF = $FE
            $else
                For bTftCounter1_Rgb = 0 To 255
                    SSP2BUF = 0xFF 
                    While SSP2STAT.0 = 0 : Wend
                    TftDataHighByte = SSP2BUF
                    SSP2BUF = 0xFF 
                    While SSP2STAT.0 = 0 : Wend
                    TftDataLowByte = SSP2BUF
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SSP2BUF = 0xFF
                While SSP2STAT.0 = 0 : Wend
                bTftDummy_Rgb = SSP2BUF
                SSP2BUF = 0xFF
                While SSP2STAT.0 = 0 : Wend
                bTftDummy_Rgb = SSP2BUF
                Repeat 
                    SSP2BUF = 0xFF
                    While SSP2STAT.0 = 0 : Wend
                Until SSP2BUF = $FE
            $endif   
        $elseif SD_COM = SPI_SW
            $if McuType = 1
                For bTftCounter1_Rgb = 0 To 255
                    TftDataWord.Byte1 = SD_ReceiveByte()
                    TftDataWord.Byte0 = SD_ReceiveByte()
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SD_ReceiveByte()
                SD_ReceiveByte()
                Repeat 
                    bTftDummy_Rgb = SD_ReceiveByte()
                Until bTftDummy_Rgb = $FE 
            $else
                For bTftCounter1_Rgb = 0 To 255
                    TftDataHighByte = SD_ReceiveByte()
                    TftDataLowByte = SD_ReceiveByte()
                    PinClear TFT_WR : PinSet TFT_WR 
                    
                    Inc dwTftCounter2_Rgb
                    If dwTftCounter2_Rgb = dwTftTemp1_Rgb Then
                        dwTftCounter2_Rgb = 0
                        DelayUS wFrameDelayUs
                    EndIf
                Next
                
                SD_ReceiveByte()
                SD_ReceiveByte()
                Repeat 
                    bTftDummy_Rgb = SD_ReceiveByte()
                Until bTftDummy_Rgb = $FE 
            $endif  
        $endif
    Next 

    SD_SendByte(SD_cCMD12)  
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte($FF)
    SD_ReceiveByte()

    wSdExitCounter = SD_cTimeOutLimit
    Repeat 
        bTftDummy_Rgb = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftDummy_Rgb = $00 Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 3
    
    For bTftCounter1_Rgb = 0 To 31
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
    Next
    If wSdExitCounter = 0 Then Result = 4

    PinSet SD_CS  
    TftStopDataRam()  
$endif  

$if McuType = 0
    $if TFT_COM = SPI_1 
        SSP1CON1.5 = 0
        SSP1CON1.5 = 1
    $elseif TFT_COM = SPI_2 
        SSP1CON2.5 = 0
        SSP1CON2.5 = 1
    $endif
$else
    $if TFT_COM = SPI_1 
        SPI1STAT.15 = 0
        SPI1STAT.15 = 1
    $elseif TFT_COM = SPI_2 
        SPI2STAT.15 = 0
        SPI2STAT.15 = 1
    $endif
$endif
EndProc

'Print a BMP file from RAW SD card (without file System) 
'wX_Pos = x position for the lower left corner of the image
'wY_Pos = y position for the lower left corner of the image
'dwFileStartSector = File start sector (zero-based) in SD card memory

'Example: TftBmpFromSdRaw(20,30,8) --> Print file starting sector 8 at position 20,30

'Note: there's no image processing so the BMP file should be:
'      - smaller than the screen width and height
'      - the color depth should be 16 bit RGB (565)
'      - the row direction is bottom to top (default)
'      - no compression
'You can use different tools to conver the file, one such tool is:
'- included SdCardWriteRGB565.exe
'or you can use on-line converters such as: 
'https://online-converting.com/image/convert2bmp/#
'Select the correct format, then drop the files, wait and download the converted file 
'or you can use included PictureConvertRGB.exe to convert any picture to BMP file with RGB565 pixel format

Proc TftBmpFromSdRaw(wX_Pos As Word, wY_Pos As Word, dwStartSector As Dword), Byte
    Global Dim bCardSpiInitOk As Byte Shared
    Dim wTemp As Word
    Dim bTemp As Byte
    Dim bTemp0 As wTemp.Byte0
    Dim bTemp1 As wTemp.Byte1
    
    Result = 255
    
    If bCardSpiInitOk <> 253 Then
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bCardSpiInitOk = SD_InitSequence()
            Dec wSdExitCounter
        Until bCardSpiInitOk = 1 Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then
            Result = 0
        Else
            bCardSpiInitOk = 253
        EndIf
    EndIf
    
$if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW    
    $if _TFT_MOSI <> _SD_SDO And _TFT_MISO <> _SD_SDI And _TFT_SCLK <> _SD_CLK  
        PinSet SD_CS
        PinClear SD_CLK   
        PinClear SD_CS
    
        wSdExitCounter = SD_cTimeOutLimit
        Repeat
            bTftTemp1_Bmp = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftTemp1_Bmp = $FF Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 1 
   
        If Disk_bCardType <> SD_cSDHC Then
            dwStartSector = dwStartSector << 9
        EndIf
    
        SD_SendByte(SD_cCMD18)  
        SD_SendByte(dwStartSector.Byte3)
        SD_SendByte(dwStartSector.Byte2)
        SD_SendByte(dwStartSector.Byte1)
        SD_SendByte(dwStartSector.Byte0)
        SD_SendByte($FF)
                        
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftTemp1_Bmp = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftTemp1_Bmp = $FE Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 2
                    
        SD_ReceiveByte()
        bTftTemp1_Bmp = SD_ReceiveByte() 
    
        wTftCounter3_Bmp = 2
        While wTftCounter3_Bmp < 10
            SD_ReceiveByte()
            Inc wTftCounter3_Bmp
        Wend 
        dwTftOffset_Bmp.Byte0 = SD_ReceiveByte()  
        dwTftOffset_Bmp.Byte1 = SD_ReceiveByte()
        dwTftOffset_Bmp.Byte2 = SD_ReceiveByte()
        dwTftOffset_Bmp.Byte3 = SD_ReceiveByte()
        Inc wTftCounter3_Bmp, 4 
    
        While wTftCounter3_Bmp < 18
            SD_ReceiveByte()
            Inc wTftCounter3_Bmp
        Wend 
    
        If bTftTemp1_Bmp = "M" Then
            wTftWidth_Bmp.Byte0 = SD_ReceiveByte() 
            wTftWidth_Bmp.Byte1 = SD_ReceiveByte()
            SD_ReceiveByte()
            SD_ReceiveByte()
            Inc wTftCounter3_Bmp, 4 
            wTftHeight_Bmp.Byte0 = SD_ReceiveByte()
            wTftHeight_Bmp.Byte1 = SD_ReceiveByte()
            Inc wTftCounter3_Bmp, 2 
        Else
            wTftWidth_Bmp.Byte0 = SD_ReceiveByte()
            wTftWidth_Bmp.Byte1 = SD_ReceiveByte()
            wTftHeight_Bmp.Byte0 = SD_ReceiveByte()
            wTftHeight_Bmp.Byte1 = SD_ReceiveByte()
            Inc wTftCounter3_Bmp, 4 
        EndIf 
               
        While wTftCounter3_Bmp < 34
            SD_ReceiveByte()
            Inc wTftCounter3_Bmp
        Wend
        dwTftSize_Bmp.Byte0 = SD_ReceiveByte()
        dwTftSize_Bmp.Byte1 = SD_ReceiveByte()
        dwTftSize_Bmp.Byte2 = SD_ReceiveByte()
        dwTftSize_Bmp.Byte3 = SD_ReceiveByte()
        Inc wTftCounter3_Bmp, 4 
    
        bTftTrim_Bmp = (wTftWidth_Bmp + wTftWidth_Bmp) // 4
    
        While wTftCounter3_Bmp < dwTftOffset_Bmp
            SD_ReceiveByte()
            Inc wTftCounter3_Bmp
        Wend
        
        $if TFT_COM = SPI_1
            $if McuType = 0
                bTemp = SSP1BUF
            $else
                bTemp = SPI1BUF
            $endif
        $elseif TFT_COM = SPI_2 
            $if McuType = 0
                bTemp = SSP2BUF
            $else
                bTemp = SPI2BUF
            $endif   
        $endif
               
        $if TftPixelCheck = 1
            If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
                pOutOfScreen = 0
                wTempHorizontal = wX_Pos + wTftWidth_Bmp - 1 : wTempVertical = wY_Pos + wTftHeight_Bmp - 1
                If wTempHorizontal >= TftScreenWidth Then 
                    wTempHorizontal = TftScreenWidth - 1
                    pOutOfScreen = 1
                EndIf
                If wTempVertical >= TftScreenHeight Then 
                    wTempVertical = TftScreenHeight - 1
                    pOutOfScreen = 1
                EndIf
                TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)        
            Else
                Result = 99
                pOutOfScreen = 1
                ExitProc                                 
            EndIf
        $else
            TftSetWindow(wX_Pos, wX_Pos + wTftWidth_Bmp - 1, wY_Pos, wY_Pos + wTftHeight_Bmp - 1)
        $endif   
        TftInitiateDataRam()
                 
        bInitiated = 0
        For wTftCounter1_Bmp = 0 To wTftHeight_Bmp - 1
            wTftCounter2_Bmp = 0  
            Do 
                bTemp0 = SD_RecByteBmp() 
                bTemp1 = SD_RecByteBmp()  
                
                $if TFT_COM = SPI_1
                    $if TFT_IC = ILI9488 
                        Rgb16ToRgb18(wTemp) 
                        TftSend(dColor.Byte2)
                        TftSend(dColor.Byte1)
                        TftSend(dColor.Byte0)
                    $else
                        $if McuType = 1
                            If bInitiated = 0 Then
                                bInitiated = 1
                            Else
                                While SPI1STAT.0 = 0 : Wend      
                            EndIf
                            bTemp = SPI1BUF
                            SPI1BUF = bTemp1
                            While SPI1STAT.0 = 0 : Wend
                            bTemp = SPI1BUF
                            SPI1BUF = bTemp0
                        $else
                            If bInitiated = 0 Then
                                bInitiated = 1
                            Else
                                While SSP1STAT.0 = 0 : Wend       
                            EndIf
                            bTemp = SSP1BUF
                            SSP1BUF = bTemp1
                            While SSP1STAT.0 = 0 : Wend  
                            bTemp = SSP1BUF
                            SSP1BUF = bTemp0
                        $endif
                    $endif
                $elseif TFT_COM = SPI_2
                    $if TFT_IC = ILI9488
                        Rgb16ToRgb18(wTemp) 
                        TftSend(dColor.Byte2)
                        TftSend(dColor.Byte1)
                        TftSend(dColor.Byte0)
                    $else
                        $if McuType = 1
                            If bInitiated = 0 Then
                                bInitiated = 1
                            Else
                                While SPI2STAT.0 = 0 : Wend     
                            EndIf
                            bTemp = SPI2BUF
                            SPI2BUF = bTemp1
                            While SPI2STAT.0 = 0 : Wend
                            bTemp = SPI2BUF
                            SPI2BUF = bTemp0
                        $else
                            If bInitiated = 0 Then
                                bInitiated = 1
                            Else
                                While SSP2STAT.0 = 0 : Wend        
                            EndIf
                            bTemp = SSP2BUF
                            SSP2BUF = bTemp1
                            While SSP2STAT.0 = 0 : Wend  
                            bTemp = SSP2BUF
                            SSP2BUF = bTemp0
                        $endif
                    $endif
                $elseif TFT_COM = SPI_SW
                    $if TFT_IC = ILI9488 
                        Rgb16ToRgb18(wTemp) 
                        TftSend(dColor.Byte2)
                        TftSend(dColor.Byte1)
                        TftSend(dColor.Byte0)
                    $else
                        TftSend(bTemp1)
                        TftSend(bTemp0)
                    $endif
                $endif
                Inc wTftCounter2_Bmp   
            Loop While wTftCounter2_Bmp < wTftWidth_Bmp 
            Select bTftTrim_Bmp
                Case 1
                    SD_RecByteBmp()
                Case 2
                    SD_RecByteBmp()
                    SD_RecByteBmp()
                Case 3
                    SD_RecByteBmp()
                    SD_RecByteBmp()
                    SD_RecByteBmp()
            EndSelect          
        Next
        
        SD_SendByte(SD_cCMD12)  
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte(0xFF)
        SD_SendByte($FF)
        SD_ReceiveByte()

        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $00 Or wSdExitCounter = 0
        If wSdExitCounter = 0 Then Result = 3
   
        For bTftCounter1_Rgb = 0 To 31
            wSdExitCounter = SD_cTimeOutLimit
            Repeat 
                bTftDummy_Rgb = SD_ReceiveByte()
                Dec wSdExitCounter
            Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
        Next
        If wSdExitCounter = 0 Then Result = 4

        PinSet SD_CS 
        TftStopDataRam()
        $if TFT_IC = ILI9488 
            'Do nothing
        $else
            $if McuType = 0
                $if TFT_COM = SPI_1 
                    bTemp = SSP1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SSP2BUF
                $endif
            $else
                $if TFT_COM = SPI_1 
                    bTemp = SPI1BUF
                $elseif TFT_COM = SPI_2 
                    bTemp = SPI2BUF
                $endif
            $endif
        $endif
    $else
        dwTftCounter1_Bmp = dwStartSector
        SD_ReadSector(dwTftCounter1_Bmp)  

        bTftTemp1_Bmp = SectorBuffer[1]
        dwTftOffset_Bmp.Byte0 = SectorBuffer[10]  
        dwTftOffset_Bmp.Byte1 = SectorBuffer[11]
        dwTftOffset_Bmp.Byte2 = SectorBuffer[12]
        dwTftOffset_Bmp.Byte3 = SectorBuffer[13]
    
        If bTftTemp1_Bmp = "M" Then
            wTftWidth_Bmp.Byte0 = SectorBuffer[18] 
            wTftWidth_Bmp.Byte1 = SectorBuffer[19]
            wTftHeight_Bmp.Byte0 = SectorBuffer[22]
            wTftHeight_Bmp.Byte1 = SectorBuffer[23]
        Else
            wTftWidth_Bmp.Byte0 = SectorBuffer[18]
            wTftWidth_Bmp.Byte1 = SectorBuffer[19]
            wTftHeight_Bmp.Byte0 = SectorBuffer[20]
            wTftHeight_Bmp.Byte1 = SectorBuffer[21]
        EndIf 
    
        dwTftSize_Bmp.Byte0 = SectorBuffer[34]
        dwTftSize_Bmp.Byte1 = SectorBuffer[35]
        dwTftSize_Bmp.Byte2 = SectorBuffer[36]
        dwTftSize_Bmp.Byte3 = SectorBuffer[37]
    
        bTftTrim_Bmp = (wTftWidth_Bmp + wTftWidth_Bmp) // 4
        wTftCounter3_Bmp = dwTftOffset_Bmp
    
        For wTftCounter1_Bmp = 0 To wTftHeight_Bmp - 1
            wTftCounter2_Bmp = 0
            Do             
                wTftColor_Bmp.Byte0 = SectorBuffer[wTftCounter3_Bmp]
                Inc wTftCounter3_Bmp
                TftBmpNewSector()
                wTftColor_Bmp.Byte1 = SectorBuffer[wTftCounter3_Bmp]
                Inc wTftCounter3_Bmp
                TftBmpNewSector()
                TftPixel(wTftCounter2_Bmp + wX_Pos, wTftCounter1_Bmp + wY_Pos, wTftColor_Bmp)
                Inc wTftCounter2_Bmp      
            Loop While wTftCounter2_Bmp < wTftWidth_Bmp 
        
            Select bTftTrim_Bmp
                Case 1
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
                Case 2
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
                Case 3
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
                    Inc wTftCounter3_Bmp
                    TftBmpNewSector()
            EndSelect          
        Next
    $endif
$elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b    
    PinSet SD_CS
    PinClear SD_CLK   
    PinClear SD_CS
    
    wSdExitCounter = SD_cTimeOutLimit
    Repeat
        bTftTemp1_Bmp = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftTemp1_Bmp = $FF Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 1 
   
    If Disk_bCardType <> SD_cSDHC Then
        dwStartSector = dwStartSector << 9
    EndIf
    
    SD_SendByte(SD_cCMD18)  
    SD_SendByte(dwStartSector.Byte3)
    SD_SendByte(dwStartSector.Byte2)
    SD_SendByte(dwStartSector.Byte1)
    SD_SendByte(dwStartSector.Byte0)
    SD_SendByte($FF)
    
    wSdExitCounter = SD_cTimeOutLimit
    Repeat 
        bTftTemp1_Bmp = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftTemp1_Bmp = $FE Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 2
     
    SD_ReceiveByte()
    bTftTemp1_Bmp = SD_ReceiveByte() 
    
    wTftCounter3_Bmp = 2
    While wTftCounter3_Bmp < 10
        SD_ReceiveByte()
        Inc wTftCounter3_Bmp
    Wend 
    dwTftOffset_Bmp.Byte0 = SD_ReceiveByte()  
    dwTftOffset_Bmp.Byte1 = SD_ReceiveByte()
    dwTftOffset_Bmp.Byte2 = SD_ReceiveByte()
    dwTftOffset_Bmp.Byte3 = SD_ReceiveByte()
    Inc wTftCounter3_Bmp, 4 
    
    While wTftCounter3_Bmp < 18
        SD_ReceiveByte()
        Inc wTftCounter3_Bmp
    Wend 
    
    If bTftTemp1_Bmp = "M" Then
        wTftWidth_Bmp.Byte0 = SD_ReceiveByte() 
        wTftWidth_Bmp.Byte1 = SD_ReceiveByte()
        SD_ReceiveByte()
        SD_ReceiveByte()
        Inc wTftCounter3_Bmp, 4 
        wTftHeight_Bmp.Byte0 = SD_ReceiveByte()
        wTftHeight_Bmp.Byte1 = SD_ReceiveByte()
        Inc wTftCounter3_Bmp, 2 
    Else
        wTftWidth_Bmp.Byte0 = SD_ReceiveByte()
        wTftWidth_Bmp.Byte1 = SD_ReceiveByte()
        wTftHeight_Bmp.Byte0 = SD_ReceiveByte()
        wTftHeight_Bmp.Byte1 = SD_ReceiveByte()
        Inc wTftCounter3_Bmp, 4 
    EndIf 
    
    While wTftCounter3_Bmp < 34
        SD_ReceiveByte()
        Inc wTftCounter3_Bmp
    Wend
    dwTftSize_Bmp.Byte0 = SD_ReceiveByte()
    dwTftSize_Bmp.Byte1 = SD_ReceiveByte()
    dwTftSize_Bmp.Byte2 = SD_ReceiveByte()
    dwTftSize_Bmp.Byte3 = SD_ReceiveByte()
    Inc wTftCounter3_Bmp, 4 
    
    bTftTrim_Bmp = (wTftWidth_Bmp + wTftWidth_Bmp) // 4
    
    While wTftCounter3_Bmp < dwTftOffset_Bmp
        SD_ReceiveByte()
        Inc wTftCounter3_Bmp
    Wend
    
    $if TftPixelCheck = 1
        If wX_Pos < TftScreenWidth And wY_Pos < TftScreenHeight Then
            pOutOfScreen = 0
            wTempHorizontal = wX_Pos + wTftWidth_Bmp - 1 : wTempVertical = wY_Pos + wTftHeight_Bmp - 1
            If wTempHorizontal >= TftScreenWidth Then 
                wTempHorizontal = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            If wTempVertical >= TftScreenHeight Then 
                wTempVertical = TftScreenHeight - 1
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_Pos, wTempHorizontal, wY_Pos, wTempVertical)        
        Else
            Result = 99
            pOutOfScreen = 1
            ExitProc                                 
        EndIf
    $else
        TftSetWindow(wX_Pos, wX_Pos + wTftWidth_Bmp - 1, wY_Pos, wY_Pos + wTftHeight_Bmp - 1)
    $endif
    TftInitiateDataRam()
    
    For wTftCounter1_Bmp = 0 To wTftHeight_Bmp - 1
        wTftCounter2_Bmp = 0  
        Do 
            $if McuType = 1
                TftDataWord.Byte0 = SD_RecByteBmp()
                TftDataWord.Byte1 = SD_RecByteBmp()
            $else
                TftDataLowByte = SD_RecByteBmp()
                TftDataHighByte = SD_RecByteBmp()
            $endif
            PinClear TFT_WR : PinSet TFT_WR 
            Inc wTftCounter2_Bmp   
        Loop While wTftCounter2_Bmp < wTftWidth_Bmp 
        Select bTftTrim_Bmp
            Case 1
                SD_RecByteBmp()
            Case 2
                SD_RecByteBmp()
                SD_RecByteBmp()
            Case 3
                SD_RecByteBmp()
                SD_RecByteBmp()
                SD_RecByteBmp()
        EndSelect          
    Next
        
    SD_SendByte(SD_cCMD12)  
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte(0xFF)
    SD_SendByte($FF)
    SD_ReceiveByte()

    wSdExitCounter = SD_cTimeOutLimit
    Repeat 
        bTftDummy_Rgb = SD_ReceiveByte()
        Dec wSdExitCounter
    Until bTftDummy_Rgb = $00 Or wSdExitCounter = 0
    If wSdExitCounter = 0 Then Result = 3
   
    For bTftCounter1_Rgb = 0 To 31
        wSdExitCounter = SD_cTimeOutLimit
        Repeat 
            bTftDummy_Rgb = SD_ReceiveByte()
            Dec wSdExitCounter
        Until bTftDummy_Rgb = $FF Or wSdExitCounter = 0
    Next
    If wSdExitCounter = 0 Then Result = 4

    PinSet SD_CS 
    TftStopDataRam()
$endif

$if McuType = 0
    $if TFT_COM = SPI_1 
        SSP1CON1.5 = 0
        SSP1CON1.5 = 1
    $elseif TFT_COM = SPI_2 
        SSP1CON2.5 = 0
        SSP1CON2.5 = 1
    $endif
$else
    $if TFT_COM = SPI_1 
        SPI1STAT.15 = 0
        SPI1STAT.15 = 1
    $elseif TFT_COM = SPI_2 
        SPI2STAT.15 = 0
        SPI2STAT.15 = 1
    $endif
$endif
EndProc

