Proc _______TFT_ARCS_____()
EndProc

$if McuType = 0
Dim bTftTemp1_Arc As Byte          At sTftString#25 
Dim dwTftTemp1_Arc As Dword        At sTftString#26 
Dim dwTftTemp2_Arc As Dword        At sTftString#30 
Dim fTftfTemp7_Arc As Float        At sTftString#30 
Dim fTftfTemp1_Arc As Float        At sTftString#34 
Dim fTftfTemp2_Arc As Float        At sTftString#38 
Dim fTftfTemp3_Arc As Float        At sTftString#42 
Dim fTftfTemp4_Arc As Float        At sTftString#46 
Dim fTftfTemp5_Arc As Float        At sTftString#50 
Dim fTftfTemp6_Arc As Float        At sTftString#54 
Dim swTftTemp1_Arc As SWord        At sTftString#58 
Dim swTftTemp2_Arc As SWord        At sTftString#60 
Dim swTftTemp3_Arc As SWord        At sTftString#62 
Dim swTftTemp4_Arc As SWord        At sTftString#64 
Dim wTftTemp1_Arc As Word          At sTftString#66 
Dim bTftTemp2_Arc As Byte          At sTftString#68 
Dim bCounter1_Arc As Byte          At sTftString#69 
Dim wCounter1_Arc As Word          At sTftString#70 
$else
Dim bTftTemp1_Arc As Byte          At sTftString_25 
Dim dwTftTemp1_Arc As Dword        At sTftString_26 
Dim dwTftTemp2_Arc As Dword        At sTftString_30 
Dim fTftfTemp7_Arc As Float        At sTftString_30 
Dim fTftfTemp1_Arc As Float        At sTftString_34 
Dim fTftfTemp2_Arc As Float        At sTftString_38 
Dim fTftfTemp3_Arc As Float        At sTftString_42 
Dim fTftfTemp4_Arc As Float        At sTftString_46 
Dim fTftfTemp5_Arc As Float        At sTftString_50 
Dim fTftfTemp6_Arc As Float        At sTftString_54 
Dim swTftTemp1_Arc As SWord        At sTftString_58 
Dim swTftTemp2_Arc As SWord        At sTftString_60 
Dim swTftTemp3_Arc As SWord        At sTftString_62 
Dim swTftTemp4_Arc As SWord        At sTftString_64 
Dim wTftTemp1_Arc As Word          At sTftString_66 
Dim bTftTemp2_Arc As Byte          At sTftString_68 
Dim bCounter1_Arc As Byte          At sTftString_69 
Dim wCounter1_Arc As Word          At sTftString_70
$endif

'Print an arc with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wRadius = arc radius (should be more than the distance between the Start and Stop coordinate)
'pCurve = looking from the origin: 0 = Concave, 1 = Convex
'wColor = 16b color in 565 RGB format 
'bWidth = arc thickness in pixels
'sbDirection = which direction the additional pixels will be added to with respect the center point
'              1 = Outward ; -1 = Inward ; Else = Ignored (no additional width)
'bFillFactor = additional pixels fill factor. Due to floating point math rounding, some pixels can be missing, which might be especially visible
'              when thicker arcs are printed. To fill those pixels intermittent values are necessary, however this increases computational time.
'              0 = 200% additional Pixel values to compute
'              1 = 100% additional pixel values to compute
'              2, 3 ... = 1/2 = 50% , 1/3 = 33% ... additional pixels to compute     
'Example: TftArc(30,80, 290,80, 200, 0, GREEN, 2, 1, 1) -->
'Print an arc with Start point:(30,80) ; End point:(290,80) ; Radius: 200 ; Concave ; Color:GREEN ; 2 pixel thick, additional pixels outwards, +100% arc pixels fill

Proc TftArc(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wRadius As Word, pCurve As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte, bFillFactor As Byte)
    TftArcHelper(wX_Start, wY_Start, wX_Stop, wY_Stop, wRadius, pCurve)
   
    If bFillFactor > 100 Then bFillFactor = 100
   
    If bFillFactor = 0 Then
        dwTftTemp1_Arc = fTftfTemp1_Arc + fTftfTemp1_Arc * 2            
    Else
        dwTftTemp1_Arc = fTftfTemp1_Arc + fTftfTemp1_Arc / bFillFactor       
    EndIf
    fTftfTemp1_Arc = (fTftfTemp3_Arc - fTftfTemp2_Arc) / dwTftTemp1_Arc       
    
    TftPixelRatio(wRadius + bWidth)
    bTftTemp1_Arc = dwTftdwPixelRatio.Byte0
    bTftTemp2_Arc = dwTftdwPixelRatio.Byte1
    
    If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
        bWidth = 1
        sbDirection = 1
    EndIf
    
    For wCounter1_Arc = 0 To dwTftTemp1_Arc * bTftTemp2_Arc Step bTftTemp1_Arc
        fTftfTemp6_Arc = fTftfTemp2_Arc + wCounter1_Arc * fTftfTemp1_Arc / bTftTemp2_Arc
        fTftfTemp3_Arc = Cos(fTftfTemp6_Arc)
        fTftfTemp7_Arc = Sin(fTftfTemp6_Arc)
 
        For bCounter1_Arc = 0 To bWidth - 1
            If sbDirection = 1 Then
                fTftfTemp6_Arc = fTftfTemp3_Arc * (wRadius + bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp4_Arc
                swTftTemp1_Arc = fRound(fTftfTemp6_Arc)
                fTftfTemp6_Arc = fTftfTemp7_Arc * (wRadius + bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp5_Arc
                swTftTemp2_Arc = fRound(fTftfTemp6_Arc) 
            Else
                fTftfTemp6_Arc = fTftfTemp3_Arc * (wRadius - bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp4_Arc
                swTftTemp1_Arc = fRound(fTftfTemp6_Arc)
                fTftfTemp6_Arc = fTftfTemp7_Arc * (wRadius - bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp5_Arc
                swTftTemp2_Arc = fRound(fTftfTemp6_Arc) 
            EndIf   
            TftPixel(swTftTemp1_Arc, swTftTemp2_Arc, wColor) 
        Next
    Next
EndProc

'Print an arc using gradient color with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wRadius = arc radius (should be more than the distance between the Start and Stop coordinate)
'pCurve = looking from the origin: 0 = Concave, 1 = Convex
'wStartColor = Start color for gradient - 16b color in 565 RGB format
'wEndColor = End color for gradient - 16b color in 565 RGB format
'bWidth = arc thickness in pixels
'sbDirection = which direction the additional pixels will be added to with respect the center point
'              1 = Outward ; -1 = Inward ; Else = Ignored (no additional width)
'Example: TftArcG(30,80, 290,80, 200, 0, YELLOW, BROWN, 2, 0) -->
'Print an arc with Start point:(30,80) ; End point:(290,80) ; Radius: 200 ; Concave ; Color: YELLOW TO BROWN ; 2 pixel thick, extra pixels outwards

'Note: This procedure is extremely computational demanding and it is drawn pixel by pixel which means this method is very slow

Proc TftArcG(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wRadius As Word, pCurve As Bit, wStartColor As Word, wEndColor As Word, bWidth As Byte, sbDirection As SByte)
    TftArcHelper(wX_Start, wY_Start, wX_Stop, wY_Stop, wRadius, pCurve)  

    dwTftTemp1_Arc = fTftfTemp1_Arc + fTftfTemp1_Arc * 2  
    fTftfTemp1_Arc = (fTftfTemp3_Arc - fTftfTemp2_Arc) / dwTftTemp1_Arc   
    TftSetGradient(wStartColor, wEndColor, dwTftTemp1_Arc)    
    
    TftPixelRatio(wRadius + bWidth)
    bTftTemp1_Arc = dwTftdwPixelRatio.Byte0
    bTftTemp2_Arc = dwTftdwPixelRatio.Byte1
    
    If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
        bWidth = 1
        sbDirection = 1
    EndIf
    
    For wCounter1_Arc = 0 To dwTftTemp1_Arc * bTftTemp2_Arc Step bTftTemp1_Arc
        fTftfTemp6_Arc = fTftfTemp2_Arc + wCounter1_Arc * fTftfTemp1_Arc / bTftTemp2_Arc
        fTftfTemp3_Arc = Cos(fTftfTemp6_Arc)
        fTftfTemp7_Arc = Sin(fTftfTemp6_Arc)
 
        For bCounter1_Arc = 0 To bWidth - 1
            If sbDirection = 1 Then
                fTftfTemp6_Arc = fTftfTemp3_Arc * (wRadius + bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp4_Arc
                swTftTemp1_Arc = fRound(fTftfTemp6_Arc)
                fTftfTemp6_Arc = fTftfTemp7_Arc * (wRadius + bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp5_Arc
                swTftTemp2_Arc = fRound(fTftfTemp6_Arc) 
            Else
                fTftfTemp6_Arc = fTftfTemp3_Arc * (wRadius - bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp4_Arc
                swTftTemp1_Arc = fRound(fTftfTemp6_Arc)
                fTftfTemp6_Arc = fTftfTemp7_Arc * (wRadius - bCounter1_Arc)
                fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp5_Arc
                swTftTemp2_Arc = fRound(fTftfTemp6_Arc) 
            EndIf   
            swTftTemp3_Arc = wCounter1_Arc / bTftTemp2_Arc
            TftPixel(swTftTemp1_Arc, swTftTemp2_Arc, TftBuildGradient(swTftTemp3_Arc)) 
        Next
    Next
EndProc

'Print a segment of 1 pixel thick arc with parameters:
'wX_Start = X full arc start coordinate
'wY_Start = Y full start coordinate
'wX_Stop = X full stop coordinate
'wY_Stop = Y full stop coordinate
'wRadius = arc radius (should be more than the distance between the Start and Stop coordinate)
'pCurve = looking from the origin: 0 = Concave, 1 = Convex
'wColor = 16b color in 565 RGB format 
'fStartSegment = arc segment start position in the arc as fraction (0 to 1)
'fEndSegment = arc segment end position in the arc as fraction (0 to 1)
'sbOffset = offset the arc segment along the radius by sbOffset pixels, thus creating a parallel arc segment to the original
'Example: TftArcS(30,80, 290,80, 200, 0, GREEN, 0.25, 0.5, -2) -->
'Print an arc with Start point:(30,80) ; End point:(290,80) ; Radius: 200 ; Concave ; Color:GREEN ; Start drawing from 1/4 of the arc ; Stop drawing at 1/2 of the arc ; offset 2 pixels down

Proc TftArcS(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wRadius As Word, pCurve As Bit, wColor As Word, fStartSegment As Float, fEndSegment As Float, sbOffset As SByte)
    TftArcHelper(wX_Start, wY_Start, wX_Stop, wY_Stop, wRadius, pCurve)
    
    If fStartSegment > fEndSegment Then Swap fStartSegment, fEndSegment
    If fEndSegment > 1 Then fEndSegment = 1
    If fEndSegment < 0 Then fEndSegment = 0
    If fStartSegment > 1 Then fStartSegment = 1
    If fStartSegment < 0 Then fStartSegment = 0
    
    fTftfTemp6_Arc = fTftfTemp3_Arc - fTftfTemp2_Arc
    fTftfTemp3_Arc = fTftfTemp2_Arc + fTftfTemp6_Arc * fEndSegment 
    fTftfTemp2_Arc = fTftfTemp2_Arc + fTftfTemp6_Arc * fStartSegment
   
    fTftfTemp6_Arc = fEndSegment - fStartSegment
    fTftfTemp6_Arc = fTftfTemp1_Arc * fTftfTemp6_Arc 
    fTftfTemp6_Arc = fTftfTemp6_Arc * 2
    
    dwTftTemp1_Arc = fTftfTemp6_Arc    
    fTftfTemp1_Arc = fTftfTemp3_Arc - fTftfTemp2_Arc                 
    fTftfTemp1_Arc = fTftfTemp1_Arc / fTftfTemp6_Arc      
    
    'TftPixelRatio(wRadius.SWord + sbOffset)
    'bTftTemp1_Arc = dwTftdwPixelRatio.Byte0
    'bTftTemp2_Arc = dwTftdwPixelRatio.Byte1
    
    For wCounter1_Arc = 0 To dwTftTemp1_Arc '* bTftTemp2_Arc Step bTftTemp1_Arc
        fTftfTemp3_Arc = wCounter1_Arc * fTftfTemp1_Arc
        fTftfTemp3_Arc = fTftfTemp3_Arc '/ bTftTemp2_Arc
        fTftfTemp3_Arc = fTftfTemp2_Arc + fTftfTemp3_Arc
        
        fTftfTemp6_Arc = Cos(fTftfTemp3_Arc)
        fTftfTemp6_Arc = fTftfTemp6_Arc * (wRadius + sbOffset)
        fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp4_Arc
        swTftTemp1_Arc = fRound(fTftfTemp6_Arc)
        fTftfTemp6_Arc = Sin(fTftfTemp3_Arc)
        fTftfTemp6_Arc = fTftfTemp6_Arc * (wRadius + sbOffset)
        fTftfTemp6_Arc = fTftfTemp6_Arc + fTftfTemp5_Arc
        swTftTemp2_Arc = fRound(fTftfTemp6_Arc) 
        TftPixel(swTftTemp1_Arc, swTftTemp2_Arc, wColor) 
    Next
EndProc

'Print a line of 1 pixel along the vector from arc center towards arc segment (angle) with parameters:
'wX_Start = X full start coordinate
'wY_Start = Y full start coordinate
'wX_Stop = X full stop coordinate
'wY_Stop = Y full stop coordinate
'wRadius = arc radius (should be more than the distance between the Start and Stop coordinate)
'pCurve = looking from the origin: 0 = Concave, 1 = Convex
'wColor = 16b color in 565 RGB format 
'swStartOffset = offset from the arc, where the radius line will be printed from 
'swEndOffset = offset from the arc, where the radius Line will be printed to 
'fSegment = arc position at which the radius line will be pointed to (0 to 1) where 0 is start of the arc, 1 is end of the arc, 0.5 is middle of the arc
'Example: TftArcRL(30,80, 290,80, 200, 0, GREEN, -1, -10, 0.5) -->
'Print radius line for an arc with Start point:(30,80) ; End point:(290,80) ; Radius: 200 ; Concave ; Color:GREEN ; 
'      Start drawing -1 pixel from the arc ; Stop drawing -10 pixel from the arc ; pointing at arc middle 

Proc TftArcRL(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wRadius As Word, pCurve As Bit, wColor As Word, swStartOffset As SWord, swEndOffset As SWord, fSegment As Float)
    Global Dim TftArcRLWidth As Byte Shared
    
    TftArcHelper(wX_Start, wY_Start, wX_Stop, wY_Stop, wRadius, pCurve)
   
    If fSegment > 1 Then fSegment = 1
    If fSegment < 0 Then fSegment = 0
   
    fTftfTemp1_Arc = fTftfTemp2_Arc + (fTftfTemp3_Arc - fTftfTemp2_Arc) * fSegment
    fTftfTemp2_Arc = Cos(fTftfTemp1_Arc)
    fTftfTemp3_Arc = Sin(fTftfTemp1_Arc)
    
    fTftfTemp1_Arc = fTftfTemp2_Arc * (wRadius + swStartOffset)
    fTftfTemp1_Arc = fTftfTemp1_Arc + fTftfTemp4_Arc
    swTftTemp1_Arc = fRound(fTftfTemp1_Arc)
    fTftfTemp1_Arc = fTftfTemp3_Arc * (wRadius + swStartOffset)
    fTftfTemp1_Arc = fTftfTemp1_Arc + fTftfTemp5_Arc
    swTftTemp2_Arc = fRound(fTftfTemp1_Arc)
    fTftfTemp1_Arc = fTftfTemp2_Arc * (wRadius + swEndOffset)
    fTftfTemp1_Arc = fTftfTemp1_Arc + fTftfTemp4_Arc
    swTftTemp3_Arc = fRound(fTftfTemp1_Arc)
    fTftfTemp1_Arc = fTftfTemp3_Arc * (wRadius + swEndOffset)
    fTftfTemp1_Arc = fTftfTemp1_Arc + fTftfTemp5_Arc
    swTftTemp4_Arc = fRound(fTftfTemp1_Arc)

    TftLine(swTftTemp1_Arc, swTftTemp2_Arc, swTftTemp3_Arc, swTftTemp4_Arc, wColor, TftArcRLWidth, 1)
EndProc

'Change TftArcRL line thickness

Proc TftArcRLThickness (bThickness As Byte)
    Global Dim TftArcRLWidth As Byte Shared
    TftArcRLWidth = bThickness    
EndProc

'Saves some flash space

Proc TftArcHelper(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wRadius As Word, pCurve As Bit)
    dwTftTemp1_Arc.SDword = wX_Stop.SWord - wX_Start.SWord 
    dwTftTemp1_Arc = dwTftTemp1_Arc.SDword * dwTftTemp1_Arc.SDword
    dwTftTemp2_Arc.SDword = wY_Stop.SWord - wY_Start.SWord 
    dwTftTemp2_Arc = dwTftTemp2_Arc.SDword * dwTftTemp2_Arc.SDword
    fTftfTemp1_Arc = Sqr(dwTftTemp1_Arc + dwTftTemp2_Arc)  
    
    dwTftTemp1_Arc = 2 * wRadius
    If fTftfTemp1_Arc > dwTftTemp1_Arc Then ExitProc 
    fTftfTemp3_Arc = dwTftTemp1_Arc / fTftfTemp1_Arc
    fTftfTemp2_Arc = fTftfTemp3_Arc * fTftfTemp3_Arc
    fTftfTemp3_Arc = fTftfTemp2_Arc - 1
    fTftfTemp2_Arc = Sqr(fTftfTemp3_Arc)  
    
    swTftTemp1_Arc = wX_Stop + wX_Start   
    swTftTemp2_Arc = wY_Stop - wY_Start
    swTftTemp3_Arc = wX_Stop - wX_Start    
    swTftTemp4_Arc = wY_Stop + wY_Start  
     
    
    fTftfTemp4_Arc = swTftTemp2_Arc / 2
    fTftfTemp3_Arc = fTftfTemp4_Arc * fTftfTemp2_Arc 
    fTftfTemp4_Arc = swTftTemp1_Arc / 2
    If pCurve = 0 Then
        fTftfTemp4_Arc = fTftfTemp4_Arc + fTftfTemp3_Arc 
    Else
        fTftfTemp4_Arc = fTftfTemp4_Arc - fTftfTemp3_Arc  
    EndIf
     
    fTftfTemp5_Arc = swTftTemp3_Arc / 2  
    fTftfTemp3_Arc = fTftfTemp5_Arc * fTftfTemp2_Arc
    fTftfTemp5_Arc = swTftTemp4_Arc / 2
    If pCurve = 0 Then
        fTftfTemp5_Arc = fTftfTemp5_Arc - fTftfTemp3_Arc 
    Else
        fTftfTemp5_Arc = fTftfTemp5_Arc + fTftfTemp3_Arc 
    EndIf
    
    fTftfTemp2_Arc = TftArcTan2(wY_Start - fTftfTemp5_Arc, wX_Start - fTftfTemp4_Arc)
    fTftfTemp3_Arc = TftArcTan2(wY_Stop - fTftfTemp5_Arc, wX_Stop - fTftfTemp4_Arc)    
    If fTftfTemp2_Arc > fTftfTemp3_Arc Then Swap fTftfTemp2_Arc, fTftfTemp3_Arc
EndProc

Proc ______TFT_CIRCLE_____()
EndProc

$if McuType = 0
Dim bTftCounter1_Circle As Byte  At sTftString#25 
Dim bTftTemp1_Circle As Byte     At sTftString#26  
Dim sdwTftTemp1_Circle As SDword At sTftString#26 
Dim bTftTemp2_Circle As Byte     At sTftString#27  
Dim wTftTemp1_Circle As Word     At sTftString#28
Dim swTftTemp1_Circle As SWord   At sTftString#28  
Dim wTftCounter1_Circle As Word  At sTftString#30 
Dim fTftTemp1_Circle As Float    At sTftString#32 
Dim fTftTemp2_Circle As Float    At sTftString#36 
Dim wTftTemp2_Circle As Word     At sTftString#40 
Dim swTftTemp5_Circle As SWord   At sTftString#40 
Dim wTftTemp3_Circle As Word     At sTftString#42 
Dim swTftTemp6_Circle As SWord   At sTftString#42 
Dim wTftTemp4_Circle As Word     At sTftString#44 
Dim wTftTemp5_Circle As Word     At sTftString#46 
Dim swTftTemp2_Circle As SWord   At sTftString#48 
Dim swTftTemp3_Circle As SWord   At sTftString#50 
Dim swTftTemp4_Circle As SWord   At sTftString#52 
Dim wTftCounter2_Circle As Word  At sTftString#54 
Dim sdwTftTemp2_Circle As SDword At sTftString#58 
Dim dwTftTemp1_Circle As Dword   At sTftString#62 
Dim dwTftTemp2_Circle As Dword   At sTftString#66 
$else
Dim bTftCounter1_Circle As Byte  At sTftString_25 
Dim bTftTemp1_Circle As Byte     At sTftString_26  
Dim sdwTftTemp1_Circle As SDword At sTftString_26 
Dim bTftTemp2_Circle As Byte     At sTftString_27  
Dim wTftTemp1_Circle As Word     At sTftString_28
Dim swTftTemp1_Circle As SWord   At sTftString_28  
Dim wTftCounter1_Circle As Word  At sTftString_30 
Dim fTftTemp1_Circle As Float    At sTftString_32 
Dim fTftTemp2_Circle As Float    At sTftString_36 
Dim wTftTemp2_Circle As Word     At sTftString_40 
Dim swTftTemp5_Circle As SWord   At sTftString_40 
Dim wTftTemp3_Circle As Word     At sTftString_42 
Dim swTftTemp6_Circle As SWord   At sTftString_42 
Dim wTftTemp4_Circle As Word     At sTftString_44 
Dim wTftTemp5_Circle As Word     At sTftString_46 
Dim swTftTemp2_Circle As SWord   At sTftString_48 
Dim swTftTemp3_Circle As SWord   At sTftString_50 
Dim swTftTemp4_Circle As SWord   At sTftString_52 
Dim wTftCounter2_Circle As Word  At sTftString_54 
Dim sdwTftTemp2_Circle As SDword At sTftString_58 
Dim dwTftTemp1_Circle As Dword   At sTftString_62 
Dim dwTftTemp2_Circle As Dword   At sTftString_66 
$endif

'Print an empty circle with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftCircleNE(100,50, 20, GREEN) -->
'Print empty circle with Center point:(100,50) ; Radius:20 ; Color:GREEN  

Proc TftCircleNE(wX_Center As Word, wY_Center As Word, bRadius As Byte, wColor As Word)
    TftPixelRatio(bRadius)
    bTftTemp1_Circle = dwTftdwPixelRatio.Byte0
    bTftTemp2_Circle = dwTftdwPixelRatio.Byte1
    wTftTemp1_Circle = dwTftdwPixelRatio.Word1
    
    For wTftCounter1_Circle = 0 To wTftTemp1_Circle Step bTftTemp1_Circle
        fTftTemp2_Circle = wTftCounter1_Circle * 0.0174533 
        fTftTemp2_Circle = fTftTemp2_Circle / bTftTemp2_Circle
        fTftTemp1_Circle = Cos(fTftTemp2_Circle)
        fTftTemp1_Circle = fTftTemp1_Circle * bRadius
        wTftTemp2_Circle = fRound(fTftTemp1_Circle)
        fTftTemp1_Circle = Sin(fTftTemp2_Circle)
        fTftTemp1_Circle = fTftTemp1_Circle * bRadius
        wTftTemp3_Circle = fRound(fTftTemp1_Circle)
                
        TftPixel(wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
        TftPixel(wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)
        TftPixel(wX_Center - wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
        TftPixel(wX_Center - wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor) 
    Next
EndProc

'Print a solid color circle with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftCircleNS(100,50, 20, GREEN) -->
'Print solid color circle with Center point:(100,50) ; Radius:20 ; Color:GREEN  

Proc TftCircleNS(wX_Center As Word, wY_Center As Word, bRadius As Byte, wColor As Word)
    TftPixelRatio(bRadius)
    bTftTemp1_Circle = dwTftdwPixelRatio.Byte0
    bTftTemp2_Circle = dwTftdwPixelRatio.Byte1
    wTftTemp1_Circle = dwTftdwPixelRatio.Word1
    
    For wTftCounter1_Circle = 0 To wTftTemp1_Circle Step bTftTemp1_Circle
        fTftTemp2_Circle = wTftCounter1_Circle * 0.0174533 
        fTftTemp2_Circle = fTftTemp2_Circle / bTftTemp2_Circle
        fTftTemp1_Circle = Cos(fTftTemp2_Circle)
        fTftTemp1_Circle = fTftTemp1_Circle * bRadius
        wTftTemp2_Circle = fRound(fTftTemp1_Circle)
        fTftTemp1_Circle = Sin(fTftTemp2_Circle)
        fTftTemp1_Circle = fTftTemp1_Circle * bRadius
        wTftTemp3_Circle = fRound(fTftTemp1_Circle)
        
        TftLineHN(wX_Center - wTftTemp2_Circle, wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
        TftLineHN(wX_Center - wTftTemp2_Circle, wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)  
    Next
EndProc

'Print a circle with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'pSolid = Circle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = circle additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the circle:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftCircleN(100,50, 20, 0, GREEN, 2, -1) -->
'Print circle with Center point:(100,50) ; Radius:20 ; No Fill ; Color:GREEN ; 2+1=3 pixel wide ; -1=additional pixels are inward 

Proc TftCircleN(wX_Center As Word, wY_Center As Word, bRadius As Byte, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If pSolid = 1 Then
        Select sbDirection
            Case 1
                bRadius = bRadius + bWidth
            Case -1
                bRadius = bRadius - bWidth
        EndSelect
        
        TftCircleNS(wX_Center, wY_Center, bRadius, wColor)
        ExitProc
    Else
        For bTftCounter1_Circle = 0 To bWidth
            Select sbDirection
                Case 1
                    bTftTemp1_Circle = bRadius + bTftCounter1_Circle
                Case -1
                    bTftTemp1_Circle = bRadius - bTftCounter1_Circle
                Case Else
                    bTftTemp1_Circle = bRadius
            EndSelect
            
            TftCircleNE(wX_Center, wY_Center, bTftTemp1_Circle, wColor)
        Next
    EndIf     
EndProc

'Print an empty circle using quick routines with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftCircleQE(100,50, 20, GREEN) -->
'Print empty circle with Center point:(100,50) ; Radius:20 ; Color:GREEN  

'Note: this routine is less computationally intensive, however the smaller the radius the deformed the circle is being drawn,
'      also Width parameter is less accurate which will result in missing pixels.  

Proc TftCircleQE(wX_Center As Word, wY_Center As Word, bRadius As Byte, wColor As Word)
    wTftTemp2_Circle = 0
    wTftTemp3_Circle = bRadius
    swTftTemp1_Circle = 3 - 2 * bRadius
    
    TftPixel(wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
    TftPixel(wX_Center - wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
    TftPixel(wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)
    TftPixel(wX_Center - wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)
    TftPixel(wX_Center + wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wColor)
    TftPixel(wX_Center - wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wColor)
    TftPixel(wX_Center + wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wColor)
    TftPixel(wX_Center - wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wColor)  
    
    While wTftTemp3_Circle >= wTftTemp2_Circle
        Inc wTftTemp2_Circle
        If swTftTemp1_Circle > 0 Then
            wTftTemp3_Circle = wTftTemp3_Circle - 1
            swTftTemp1_Circle = swTftTemp1_Circle + 4 * (wTftTemp2_Circle - wTftTemp3_Circle) + 10
        Else
            swTftTemp1_Circle = swTftTemp1_Circle + 4 * wTftTemp2_Circle + 6
        EndIf
        
        TftPixel(wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
        TftPixel(wX_Center - wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor)
        TftPixel(wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)
        TftPixel(wX_Center - wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor)
        TftPixel(wX_Center + wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wColor)
        TftPixel(wX_Center - wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wColor)
        TftPixel(wX_Center + wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wColor)
        TftPixel(wX_Center - wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wColor)
    Wend   
EndProc

'Print a solid color circle using quick routines with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftCircleQS(100,50, 20, GREEN) -->
'Print solid color circle with Center point:(100,50) ; Radius:20 ; Color:GREEN  

'Note: this routine is less computationally intensive, however the smaller the radius the deformed the circle is being drawn,
'      also Width parameter is less accurate which will result in missing pixels.  

Proc TftCircleQS(wX_Center As Word, wY_Center As Word, bRadius As Byte, wColor As Word)
    wTftTemp2_Circle = 0
    wTftTemp3_Circle = bRadius
    swTftTemp1_Circle = 3 - (2 * bRadius)
        
    TftLine(wX_Center - bRadius, wY_Center, wX_Center + bRadius, wY_Center, wColor, 0, 0)
        
    While wTftTemp3_Circle >= wTftTemp2_Circle
        wTftTemp2_Circle = wTftTemp2_Circle + 1

        If swTftTemp1_Circle > 0 Then
            wTftTemp3_Circle = wTftTemp3_Circle - 1
            swTftTemp1_Circle = swTftTemp1_Circle + 4 * (wTftTemp2_Circle - wTftTemp3_Circle) + 10
        Else
            swTftTemp1_Circle = swTftTemp1_Circle + 4 * wTftTemp2_Circle + 6
        EndIf

        TftLine(wX_Center - wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, wColor, 0, 0)
        TftLine(wX_Center - wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wColor, 0, 0)
        TftLine(wX_Center - wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wX_Center + wTftTemp3_Circle, wY_Center + wTftTemp2_Circle, wColor, 0, 0)
        TftLine(wX_Center - wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wX_Center + wTftTemp3_Circle, wY_Center - wTftTemp2_Circle, wColor, 0, 0)
    Wend
EndProc

'Print a circle using quick routines with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'pSolid = Circle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = circle additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the circle:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftCircleQ(100,50, 20, 0, GREEN, 2, -1) -->
'Print circle Center point:(100,50) ; Radius:20 ; No Fill ; Color:GREEN ; 2+1=3 pixel wide ; -1=additional pixels are inward 

'Note: this routine is less computationally intensive, however the smaller the radius the deformed the circle is being drawn,
'      also Width parameter is less accurate which will result in missing pixels.      

Proc TftCircleQ(wX_Center As Word, wY_Center As Word, bRadius As Byte, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If pSolid = 1 Then
        Select sbDirection
            Case 1
                bRadius = bRadius + bWidth
            Case -1
                bRadius = bRadius - bWidth
        EndSelect
        
        TftCircleQS(wX_Center, wY_Center, bRadius, wColor)
        ExitProc
    Else
        For bTftCounter1_Circle = 0 To bWidth
            Select sbDirection
                Case 1
                    bTftTemp1_Circle = bRadius + bTftCounter1_Circle
                Case -1
                    bTftTemp1_Circle = bRadius - bTftCounter1_Circle
                Case Else
                    bTftTemp1_Circle = bRadius
            EndSelect
            
            TftCircleQE(wX_Center, wY_Center, bTftTemp1_Circle, wColor)
        Next
    EndIf 
EndProc 

'Print a solid gradient color circle with parameters:
'wX_Center = Circle's center X coordinate
'wY_Center = Circle's center Y coordinate
'bRadius = Circle radius in pixels
'wStartColor = Start color for gradient - 16b color in 565 RGB format
'wEndColor = End color for gradient - 16b color in 565 RGB format
'bGradient = direction for the gradient color:
'            0 = Horizontal (Left to Right)
'            1 = Vertical (Bottom to top)
'            2 = Radial (Center to Peripheral) 
'            Note: Radial gradient is extremely computational demanding and it is drawn pixel by pixel which means this method is very slow
'Example: TftCircleG(170,100, 30, YELLOW, BROWN, 1) -->
'Print solid circle with center:(170,100) ; Radius 30 ; gradient color bottom to top from YELLOW to BROWN  

Proc TftCircleG(wX_Center As Word, wY_Center As Word, bRadius As Byte, wStartColor As Word, wEndColor As Word, bGradient As Byte)
    If bGradient = 0 Then 
        TftPixelRatio(bRadius)
        bTftTemp1_Circle = dwTftdwPixelRatio.Byte0
        bTftTemp2_Circle = dwTftdwPixelRatio.Byte1
        wTftTemp1_Circle = dwTftdwPixelRatio.Word1
     
        TftSetGradient(wStartColor, wEndColor, 2 * bRadius)
        wTftTemp5_Circle = wX_Center + bRadius
        wTftTemp4_Circle = 0
        For wTftCounter1_Circle = 0 To wTftTemp1_Circle Step bTftTemp1_Circle 
            GoSub CalcTftCircleG
        
            If wX_Center + wTftTemp2_Circle < wTftTemp5_Circle Then
                TftLineVN(wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wY_Center + wTftTemp3_Circle, TftBuildGradient(2 * bRadius - wTftTemp4_Circle))
                TftLineVN(wX_Center - wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, wY_Center + wTftTemp3_Circle, TftBuildGradient(wTftTemp4_Circle))
                wTftTemp5_Circle = wX_Center + wTftTemp2_Circle
                Inc wTftTemp4_Circle
            EndIf 
        Next
        ExitProc
    EndIf
    
    If bGradient = 1 Then
        TftPixelRatio(bRadius)
        bTftTemp1_Circle = dwTftdwPixelRatio.Byte0
        bTftTemp2_Circle = dwTftdwPixelRatio.Byte1
        wTftTemp1_Circle = dwTftdwPixelRatio.Word1
        
        TftSetGradient(wStartColor, wEndColor, 2 * bRadius)
        wTftTemp5_Circle = wY_Center + bRadius    
        wTftTemp4_Circle = 0
        For wTftCounter1_Circle = wTftTemp1_Circle DownTo 0 Step -bTftTemp1_Circle 
            GoSub CalcTftCircleG
        
            If wY_Center + wTftTemp3_Circle < wTftTemp5_Circle Then
                TftLineHN(wX_Center - wTftTemp2_Circle, wX_Center + wTftTemp2_Circle, wY_Center + wTftTemp3_Circle, TftBuildGradient(2 * bRadius - wTftTemp4_Circle))
                TftLineHN(wX_Center - wTftTemp2_Circle, wX_Center + wTftTemp2_Circle, wY_Center - wTftTemp3_Circle, TftBuildGradient(wTftTemp4_Circle))
                wTftTemp5_Circle = wY_Center + wTftTemp3_Circle  
                Inc wTftTemp4_Circle
            EndIf 
        Next
        ExitProc
    EndIf
    
    If bGradient = 2 Then
        TftSetGradient(wStartColor, wEndColor, 100)
        swTftTemp2_Circle = bTftRedEnd_Helper - bTftRedStart_Helper
        swTftTemp3_Circle = bTftGreenEnd_Helper - bTftGreenStart_Helper
        swTftTemp4_Circle = bTftBlueEnd_Helper - bTftBlueStart_Helper
        
        For wTftCounter1_Circle = wY_Center - bRadius To wY_Center + bRadius 
            For wTftCounter2_Circle = wX_Center - bRadius To wX_Center + bRadius
                sdwTftTemp1_Circle = wTftCounter2_Circle.SWord - wX_Center
                sdwTftTemp1_Circle = sdwTftTemp1_Circle * sdwTftTemp1_Circle
                sdwTftTemp2_Circle = wTftCounter1_Circle.SWord - wY_Center
                sdwTftTemp2_Circle = sdwTftTemp2_Circle * sdwTftTemp2_Circle

                If sdwTftTemp1_Circle + sdwTftTemp2_Circle <= bRadius * bRadius + 4 Then
                    swTftTemp5_Circle = wTftCounter2_Circle - wX_Center
                    swTftTemp6_Circle = wTftCounter1_Circle - wY_Center
                    dwTftTemp1_Circle = swTftTemp5_Circle * swTftTemp5_Circle
                    dwTftTemp2_Circle = swTftTemp6_Circle * swTftTemp6_Circle 
                    fTftTemp2_Circle = Sqr(dwTftTemp1_Circle + dwTftTemp2_Circle)
                    fTftTemp1_Circle = fTftTemp2_Circle / bRadius
                    If fTftTemp1_Circle > 1 Then fTftTemp1_Circle = 1
                    TftPixel(wTftCounter2_Circle, wTftCounter1_Circle, TftPixelGradient(swTftTemp2_Circle, swTftTemp3_Circle, swTftTemp4_Circle, fTftTemp1_Circle))
                EndIf
            Next 
        Next 
        ExitProc    
    EndIf
    
    ExitProc
CalcTftCircleG:    
    fTftTemp2_Circle = wTftCounter1_Circle * 0.0174533 
    fTftTemp2_Circle = fTftTemp2_Circle / bTftTemp2_Circle
    fTftTemp1_Circle = Cos(fTftTemp2_Circle)
    fTftTemp1_Circle = fTftTemp1_Circle * bRadius
    wTftTemp2_Circle = fRound(fTftTemp1_Circle)
    fTftTemp1_Circle = Sin(fTftTemp2_Circle)
    fTftTemp1_Circle = fTftTemp1_Circle * bRadius
    wTftTemp3_Circle = fRound(fTftTemp1_Circle)
    Return
EndProc

Proc _______TFT_ELIPSE_____()
EndProc

$if McuType = 0
Dim bTftCounter1_Ellipse As Byte  At sTftString#25 
Dim bTftTemp1_Ellipse As Byte     At sTftString#26  
Dim bTftTemp2_Ellipse As Byte     At sTftString#27  
Dim wTftTemp1_Ellipse As Word     At sTftString#28
Dim wTftCounter1_Ellipse As Word  At sTftString#30  
Dim fTftTemp1_Ellipse As Float    At sTftString#32  
Dim fTftTemp2_Ellipse As Float    At sTftString#36 
Dim wTftTemp2_Ellipse As Word     At sTftString#40 
Dim wTftTemp3_Ellipse As Word     At sTftString#42 
Dim wTftTemp4_Ellipse As Word     At sTftString#44 
Dim wTftTemp5_Ellipse As Word     At sTftString#46 
Dim wTftTemp6_Ellipse As Word     At sTftString#48 
Dim swTftTemp1_Ellipse As SWord   At sTftString#48
Dim wTftTemp7_Ellipse As Word     At sTftString#50 
Dim fTftTemp3_Ellipse As Float    At sTftString#52 
Dim fTftTemp4_Ellipse As Float    At sTftString#56  
Dim fTftTemp5_Ellipse As Float    At sTftString#60 
Dim wTftTemp8_Ellipse As Word     At sTftString#62 
Dim swTftTemp2_Ellipse As SWord   At sTftString#62
Dim wTftCounter2_Ellipse As Word  At sTftString#64 
Dim swTftTemp9_Ellipse As SWord   At sTftString#66 
Dim swTftTemp10_Ellipse As SWord  At sTftString#68 
Dim swTftTemp11_Ellipse As SWord  At sTftString#70
$else
Dim bTftCounter1_Ellipse As Byte  At sTftString_25 
Dim bTftTemp1_Ellipse As Byte     At sTftString_26  
Dim bTftTemp2_Ellipse As Byte     At sTftString_27  
Dim wTftTemp1_Ellipse As Word     At sTftString_28
Dim wTftCounter1_Ellipse As Word  At sTftString_30  
Dim fTftTemp1_Ellipse As Float    At sTftString_32  
Dim fTftTemp2_Ellipse As Float    At sTftString_36 
Dim wTftTemp2_Ellipse As Word     At sTftString_40 
Dim wTftTemp3_Ellipse As Word     At sTftString_42 
Dim wTftTemp4_Ellipse As Word     At sTftString_44 
Dim wTftTemp5_Ellipse As Word     At sTftString_46 
Dim wTftTemp6_Ellipse As Word     At sTftString_48 
Dim swTftTemp1_Ellipse As SWord   At sTftString_48
Dim wTftTemp7_Ellipse As Word     At sTftString_50 
Dim fTftTemp3_Ellipse As Float    At sTftString_52 
Dim fTftTemp4_Ellipse As Float    At sTftString_56  
Dim fTftTemp5_Ellipse As Float    At sTftString_60 
Dim wTftTemp8_Ellipse As Word     At sTftString_62 
Dim swTftTemp2_Ellipse As SWord   At sTftString_62
Dim wTftCounter2_Ellipse As Word  At sTftString_64 
Dim swTftTemp9_Ellipse As SWord   At sTftString_66 
Dim swTftTemp10_Ellipse As SWord  At sTftString_68 
Dim swTftTemp11_Ellipse As SWord  At sTftString_70
$endif 

'Print an empty ellipse with parameters:
'wX_Center = ellipse center X coordinate
'wY_Center = ellipse center Y coordinate
'bRadiusH = ellipse horizontal radius in pixels
'bRadiusV = ellipse vertical radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftEllipseE(160,120, 80, 40, GREEN) -->
'Print empty ellipse with Center point:(160,120) ; RadiusH:80 ; RadiusV:40 ; Color:GREEN  

Proc TftEllipseE(wX_Center As Word, wY_Center As Word, bRadiusH As Byte, bRadiusV As Byte, wColor As Word)
    If bRadiusH >= bRadiusV Then
        bTftTemp1_Ellipse = bRadiusH
    Else
        bTftTemp1_Ellipse = bRadiusV
    EndIf
    
    TftPixelRatio(bTftTemp1_Ellipse)
    bTftTemp1_Ellipse = dwTftdwPixelRatio.Byte0
    bTftTemp2_Ellipse = dwTftdwPixelRatio.Byte1
    wTftTemp1_Ellipse = dwTftdwPixelRatio.Word1
    
    For wTftCounter1_Ellipse = 0 To wTftTemp1_Ellipse Step bTftTemp1_Ellipse
        fTftTemp1_Ellipse = wTftCounter1_Ellipse * 0.0174533 
        fTftTemp1_Ellipse = fTftTemp1_Ellipse / bTftTemp2_Ellipse
        fTftTemp2_Ellipse = Cos(fTftTemp1_Ellipse)
        fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusH
        wTftTemp2_Ellipse = fRound(fTftTemp2_Ellipse)
        fTftTemp2_Ellipse = Sin(fTftTemp1_Ellipse)
        fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusV
        wTftTemp3_Ellipse = fRound(fTftTemp2_Ellipse)
                
        TftPixel(wX_Center + wTftTemp2_Ellipse, wY_Center + wTftTemp3_Ellipse, wColor)
        TftPixel(wX_Center + wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, wColor)
        TftPixel(wX_Center - wTftTemp2_Ellipse, wY_Center + wTftTemp3_Ellipse, wColor)
        TftPixel(wX_Center - wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, wColor) 
    Next
EndProc


'Print a solid ellipse with parameters:
'wX_Center = ellipse center X coordinate
'wY_Center = ellipse center Y coordinate
'bRadiusH = ellipse horizontal radius in pixels
'bRadiusV = ellipse vertical radius in pixels
'wColor = 16b color in 565 RGB format 
'Example: TftEllipseS(160,120, 80, 40, GREEN) -->
'Print solid ellipse with Center point:(160,120) ; RadiusH:80 ; RadiusV:40 ; Color:GREEN 

Proc TftEllipseS(wX_Center As Word, wY_Center As Word, bRadiusH As Byte, bRadiusV As Byte, wColor As Word)
    If bRadiusH >= bRadiusV Then
        bTftTemp1_Ellipse = bRadiusH
    Else
        bTftTemp1_Ellipse = bRadiusV
    EndIf
    
    TftPixelRatio(bTftTemp1_Ellipse)
    bTftTemp1_Ellipse = dwTftdwPixelRatio.Byte0
    bTftTemp2_Ellipse = dwTftdwPixelRatio.Byte1
    wTftTemp1_Ellipse = dwTftdwPixelRatio.Word1
    
    For wTftCounter1_Ellipse = 0 To wTftTemp1_Ellipse Step bTftTemp1_Ellipse
        fTftTemp1_Ellipse = wTftCounter1_Ellipse * 0.0174533 
        fTftTemp1_Ellipse = fTftTemp1_Ellipse / bTftTemp2_Ellipse
        fTftTemp2_Ellipse = Cos(fTftTemp1_Ellipse)
        fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusH
        wTftTemp2_Ellipse = fRound(fTftTemp2_Ellipse)
        fTftTemp2_Ellipse = Sin(fTftTemp1_Ellipse)
        fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusV
        wTftTemp3_Ellipse = fRound(fTftTemp2_Ellipse)
        
        TftLineHN(wX_Center - wTftTemp2_Ellipse, wX_Center + wTftTemp2_Ellipse, wY_Center + wTftTemp3_Ellipse, wColor)
        TftLineHN(wX_Center - wTftTemp2_Ellipse, wX_Center + wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, wColor)  
    Next
EndProc


'Print an ellipse with parameters:
'wX_Center = ellipse center X coordinate
'wY_Center = ellipse center Y coordinate
'bRadiusH = ellipse horizontal radius in pixels
'bRadiusV = ellipse vertical radius in pixels
'pSolid = Ellipse fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = ellipse additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the ellipse:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftEllipse(160,120, 80, 40, 0, GREEN, 2, -1) -->
'Print ellipse with Center point:(160,120) ; RadiusH:80 ; RadiusV:40 ; No Fill ; Color:GREEN ; 2+1=3 pixel wide ; -1=additional pixels are inward 

Proc TftEllipse(wX_Center As Word, wY_Center As Word, bRadiusH As Byte, bRadiusV As Byte, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If pSolid = 1 Then
        Select sbDirection
            Case 1
                bRadiusH = bRadiusH + bWidth
                bRadiusV = bRadiusV + bWidth
            Case -1
                bRadiusH = bRadiusH - bWidth
                bRadiusV = bRadiusV - bWidth
        EndSelect
        
        TftEllipseS(wX_Center, wY_Center, bRadiusH, bRadiusV, wColor)
        ExitProc
    Else
        For bTftCounter1_Ellipse = 0 To bWidth
            Select sbDirection
                Case 1
                    wTftTemp4_Ellipse = bRadiusH + bTftCounter1_Ellipse
                    wTftTemp5_Ellipse = bRadiusV + bTftCounter1_Ellipse
                Case -1
                    wTftTemp4_Ellipse = bRadiusH - bTftCounter1_Ellipse
                    wTftTemp5_Ellipse = bRadiusV - bTftCounter1_Ellipse
                Case Else
                    wTftTemp4_Ellipse = bRadiusH
                    wTftTemp5_Ellipse = bRadiusV
            EndSelect
            
            TftEllipseE(wX_Center, wY_Center, wTftTemp4_Ellipse, wTftTemp5_Ellipse, wColor)
        Next
    EndIf     
EndProc

'Print a solid ellipse with parameters:
'wX_Center = ellipse center X coordinate
'wY_Center = ellipse center Y coordinate
'bRadiusH = ellipse horizontal radius in pixels
'bRadiusV = ellipse vertical radius in pixels
'wStartColor = Start color for gradient - 16b color in 565 RGB format
'wEndColor = End color for gradient - 16b color in 565 RGB format
'bGradient = direction for the gradient color:
'            0 = Horizontal (Left to Right)
'            1 = Vertical (Bottom to top)
'            2 = Radial (Center to Peripheral) 
'            Note: Radial gradient is extremely computational demanding and it is drawn pixel by pixel which means this method is very slow
'Example: TftEllipseG(160,120, 80, 40, ORANGE,VIOLET, 0) -->
'Print solid gradient color ellipse with center:(160,120) ; RadiusH 80 ; RadiusV 40 gradient color left to right from YELLOW to BROWN 

Proc TftEllipseG(wX_Center As Word, wY_Center As Word, bRadiusH As Byte, bRadiusV As Byte, wStartColor As Word, wEndColor As Word, bGradient As Byte)
    If bRadiusH >= bRadiusV Then
        bTftTemp1_Ellipse = bRadiusH
    Else
        bTftTemp1_Ellipse = bRadiusV
    EndIf
    
    TftPixelRatio(bTftTemp1_Ellipse)
    bTftTemp1_Ellipse = dwTftdwPixelRatio.Byte0
    bTftTemp2_Ellipse = dwTftdwPixelRatio.Byte1
    wTftTemp1_Ellipse = dwTftdwPixelRatio.Word1

    If bGradient = 0 Then 
        wTftTemp6_Ellipse = wX_Center + bRadiusH
        TftSetGradient(wStartColor, wEndColor, 2 * bRadiusH)
        wTftTemp7_Ellipse = 0
        For wTftCounter1_Ellipse = 0 To wTftTemp1_Ellipse Step bTftTemp1_Ellipse
            GoSub CalcTftEllipseG
        
            If wX_Center + wTftTemp2_Ellipse < wTftTemp6_Ellipse Then
                TftLineVN(wX_Center + wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, wY_Center + wTftTemp3_Ellipse, TftBuildGradient(2 * bRadiusH - wTftTemp7_Ellipse))
                TftLineVN(wX_Center - wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, wY_Center + wTftTemp3_Ellipse, TftBuildGradient(wTftTemp7_Ellipse))
                wTftTemp6_Ellipse = wX_Center + wTftTemp2_Ellipse
                Inc wTftTemp7_Ellipse
            EndIf 
        Next
        ExitProc
    EndIf
    
    If bGradient = 1 Then
        wTftTemp6_Ellipse = wY_Center + bRadiusV  
        TftSetGradient(wStartColor, wEndColor, 2 * bRadiusV) 
        wTftTemp7_Ellipse = 0 
        For wTftCounter1_Ellipse = wTftTemp1_Ellipse DownTo 0 Step -bTftTemp1_Ellipse
            GoSub CalcTftEllipseG
        
            If wY_Center + wTftTemp3_Ellipse < wTftTemp6_Ellipse Then
                TftLineHN(wX_Center - wTftTemp2_Ellipse, wX_Center + wTftTemp2_Ellipse, wY_Center + wTftTemp3_Ellipse, TftBuildGradient(2 * bRadiusV - wTftTemp7_Ellipse))
                TftLineHN(wX_Center - wTftTemp2_Ellipse, wX_Center + wTftTemp2_Ellipse, wY_Center - wTftTemp3_Ellipse, TftBuildGradient(wTftTemp7_Ellipse))
                wTftTemp6_Ellipse = wY_Center + wTftTemp3_Ellipse  
                Inc wTftTemp7_Ellipse
            EndIf 
        Next
        ExitProc
    EndIf
    
    If bGradient = 2 Then
        TftSetGradient(wStartColor, wEndColor, 100)
        fTftTemp1_Ellipse = bRadiusH * bRadiusH
        fTftTemp3_Ellipse = bRadiusV * bRadiusV
        fTftTemp4_Ellipse = fTftTemp1_Ellipse + fTftTemp3_Ellipse
        fTftTemp1_Ellipse = Sqr(fTftTemp4_Ellipse) 
        
        swTftTemp9_Ellipse = bTftRedEnd_Helper - bTftRedStart_Helper
        swTftTemp10_Ellipse = bTftGreenEnd_Helper - bTftGreenStart_Helper
        swTftTemp11_Ellipse = bTftBlueEnd_Helper - bTftBlueStart_Helper
        
        For wTftCounter1_Ellipse = wY_Center - bRadiusV To wY_Center + bRadiusV 
            For wTftCounter2_Ellipse = wX_Center - bRadiusH To wX_Center + bRadiusH
                swTftTemp1_Ellipse = wTftCounter2_Ellipse - wX_Center
                fTftTemp5_Ellipse = swTftTemp1_Ellipse * swTftTemp1_Ellipse
                wTftTemp1_Ellipse = bRadiusH
                fTftTemp4_Ellipse = wTftTemp1_Ellipse * wTftTemp1_Ellipse
                fTftTemp3_Ellipse = fTftTemp5_Ellipse / fTftTemp4_Ellipse
                
                swTftTemp2_Ellipse = wTftCounter1_Ellipse - wY_Center
                fTftTemp5_Ellipse = swTftTemp2_Ellipse * swTftTemp2_Ellipse
                wTftTemp1_Ellipse = bRadiusV
                fTftTemp4_Ellipse = wTftTemp1_Ellipse * wTftTemp1_Ellipse
                fTftTemp5_Ellipse = fTftTemp5_Ellipse / fTftTemp4_Ellipse
                
                If fTftTemp3_Ellipse + fTftTemp5_Ellipse <= 1 Then
                    swTftTemp1_Ellipse = wTftCounter2_Ellipse - wX_Center
                    swTftTemp2_Ellipse = wTftCounter1_Ellipse - wY_Center
                    fTftTemp4_Ellipse = swTftTemp1_Ellipse
                    fTftTemp4_Ellipse = fTftTemp4_Ellipse / bRadiusH 
                    fTftTemp4_Ellipse = fTftTemp4_Ellipse * fTftTemp4_Ellipse 
                    fTftTemp5_Ellipse = swTftTemp2_Ellipse / bRadiusV 
                    fTftTemp5_Ellipse = fTftTemp5_Ellipse * fTftTemp5_Ellipse
                    fTftTemp3_Ellipse = Sqr(fTftTemp4_Ellipse + fTftTemp5_Ellipse)   
                    If fTftTemp3_Ellipse > 1 Then fTftTemp3_Ellipse = 1
                    TftPixel(wTftCounter2_Ellipse, wTftCounter1_Ellipse, TftPixelGradient(swTftTemp9_Ellipse, swTftTemp10_Ellipse, swTftTemp11_Ellipse, fTftTemp3_Ellipse))
                EndIf
            Next 
        Next 
        ExitProc    
    EndIf
    
    ExitProc
CalcTftEllipseG:    
    fTftTemp1_Ellipse = wTftCounter1_Ellipse * 0.0174533 
    fTftTemp1_Ellipse = fTftTemp1_Ellipse / bTftTemp2_Ellipse
    fTftTemp2_Ellipse = Cos(fTftTemp1_Ellipse)
    fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusH
    wTftTemp2_Ellipse = fRound(fTftTemp2_Ellipse)
    fTftTemp2_Ellipse = Sin(fTftTemp1_Ellipse)
    fTftTemp2_Ellipse = fTftTemp2_Ellipse * bRadiusV
    wTftTemp3_Ellipse = fRound(fTftTemp2_Ellipse)
    Return
EndProc

Proc _______TFT_POLYGON_____()
EndProc

$if McuType = 0
Dim fTftTemp1_Polygon As Float   At sTftString#16  
Dim fTftTemp2_Polygon As Float   At sTftString#20  
Dim fTftTemp3_Polygon As Float   At sTftString#24  
Dim fTftTemp4_Polygon As Float   At sTftString#30  
Dim fTftTemp5_Polygon As Float   At sTftString#34  
Dim wTftTemp1_Polygon As Word    At sTftString#38  
Dim wTftTemp2_Polygon As Word    At sTftString#40  
Dim wTftTemp3_Polygon As Word    At sTftString#42  
Dim wTftTemp4_Polygon As Word    At sTftString#44  
Dim wTftTemp5_Polygon As Word    At sTftString#46  
Dim wTftTemp6_Polygon As Word    At sTftString#48  
Dim wTftTemp7_Polygon As Word    At sTftString#50  
Dim wTftTemp8_Polygon As Word    At sTftString#52  
Dim wTftTemp9_Polygon As Word    At sTftString#54  
Dim wTftCounter1_Polygon As Word At sTftString#56  
$else
Dim fTftTemp1_Polygon As Float   At sTftString_16  
Dim fTftTemp2_Polygon As Float   At sTftString_20  
Dim fTftTemp3_Polygon As Float   At sTftString_24  
Dim fTftTemp4_Polygon As Float   At sTftString_30  
Dim fTftTemp5_Polygon As Float   At sTftString_34  
Dim wTftTemp1_Polygon As Word    At sTftString_38  
Dim wTftTemp2_Polygon As Word    At sTftString_40  
Dim wTftTemp3_Polygon As Word    At sTftString_42  
Dim wTftTemp4_Polygon As Word    At sTftString_44  
Dim wTftTemp5_Polygon As Word    At sTftString_46  
Dim wTftTemp6_Polygon As Word    At sTftString_48  
Dim wTftTemp7_Polygon As Word    At sTftString_50  
Dim wTftTemp8_Polygon As Word    At sTftString_52  
Dim wTftTemp9_Polygon As Word    At sTftString_54  
Dim wTftCounter1_Polygon As Word At sTftString_56
$endif


'Print a regular polygon with parameters:
'wX_Center = polygon center X coordinate
'wY_Center = polygon center Y coordinate
'bRadius = polygon radius from center to vertex
'bVertexCount = number of vertices - should be more than 3
'bStartAngle = starting angle from the Y-axis for the first vertex then clockwise
'pSolid = parallelogram fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = polygon additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the parallelogram:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftPolygon(70,80, 45, 9, 0, 0, GREEN, 0, 0) -->
'Print empty polygon with Center point:(70,80) ; Radius:45 ; Vertex Count:9 ; StartAngle = 0 degrees ; No fill ; Color:GREEN ; 1 pixel thick ; no additional pixels 

Proc TftPolygon(wX_Center As Word, wY_Center As Word, bRadius As Byte, bVertexCount As Byte, bStartAngle As Byte, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    Dim pTestBit1 As Bit
    Dim pTestBit2 As Bit
    
    If bVertexCount < 3 Then ExitProc
    fTftTemp4_Polygon = 360 / bVertexCount 
    
    If pSolid = 0 Then
        pTestBit2 = 0
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            fTftTemp3_Polygon = bRadius
            GoSub CalcTftPolygon1
            ExitProc 
        Else   
            wTftTemp1_Polygon = bWidth * 3
            wTftTemp2_Polygon = wTftTemp1_Polygon - 1
            For wTftCounter1_Polygon = 0 To wTftTemp2_Polygon
                fTftTemp3_Polygon = wTftCounter1_Polygon / 3
                If sbDirection = 1 Then
                    fTftTemp3_Polygon = bRadius + fTftTemp3_Polygon
                Else
                    fTftTemp3_Polygon = bRadius - fTftTemp3_Polygon
                EndIf    
                GoSub CalcTftPolygon1
            Next
            ExitProc   
        EndIf
    EndIf
    
    If pSolid = 1 Then
        pTestBit2 = 1
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            fTftTemp3_Polygon = bRadius
            GoSub CalcTftPolygon1
            ExitProc 
        Else   
            If sbDirection = 1 Then
                fTftTemp3_Polygon = bRadius + bWidth
            Else
                fTftTemp3_Polygon = bRadius - bWidth
            EndIf    
            GoSub CalcTftPolygon1 
            ExitProc 
        EndIf    
    EndIf 
    ExitProc
CalcTftPolygon1:
    For wTftTemp3_Polygon = 0 To bVertexCount - 1
        If wTftTemp3_Polygon = 0 Then
            pTestBit1 = 0
            GoSub CalcTftPolygon2
            pTestBit1 = 1
        Else
            wTftTemp4_Polygon = wTftTemp5_Polygon
            wTftTemp6_Polygon = wTftTemp7_Polygon 
        EndIf
        GoSub CalcTftPolygon2 
        wTftTemp5_Polygon = wTftTemp8_Polygon
        wTftTemp7_Polygon = wTftTemp9_Polygon
        If pTestBit2 = 0 Then
            TftLine(wTftTemp4_Polygon, wTftTemp6_Polygon, wTftTemp5_Polygon, wTftTemp7_Polygon, wColor, 0, 0)
        Else
            TftTriangleNS(wX_Center, wY_Center, wTftTemp4_Polygon, wTftTemp6_Polygon, wTftTemp5_Polygon, wTftTemp7_Polygon, wColor)
        EndIf
    Next
    Return 
CalcTftPolygon2: 
    If pTestBit1 = 0 Then
        fTftTemp1_Polygon = fTftTemp4_Polygon * wTftTemp3_Polygon
    Else
        fTftTemp1_Polygon = fTftTemp4_Polygon * (wTftTemp3_Polygon + 1)
    EndIf
    fTftTemp5_Polygon = bStartAngle + fTftTemp1_Polygon 
    fTftTemp1_Polygon = fTftTemp5_Polygon * 0.0174533
    fTftTemp5_Polygon = Sin(fTftTemp1_Polygon)
    fTftTemp2_Polygon = fTftTemp3_Polygon * fTftTemp5_Polygon
    fTftTemp5_Polygon = fTftTemp2_Polygon + wX_Center
    If pTestBit1 = 0 Then
        wTftTemp4_Polygon = fRound(fTftTemp5_Polygon)
    Else
        wTftTemp8_Polygon = fRound(fTftTemp5_Polygon)
    EndIf
    fTftTemp5_Polygon = Cos(fTftTemp1_Polygon)
    fTftTemp2_Polygon = fTftTemp3_Polygon * fTftTemp5_Polygon
    fTftTemp5_Polygon = fTftTemp2_Polygon + wY_Center
    If pTestBit1 = 0 Then
        wTftTemp6_Polygon = fRound(fTftTemp5_Polygon) 
    Else
        wTftTemp9_Polygon = fRound(fTftTemp5_Polygon)
    EndIf
    Return         
EndProc

Proc _____TFT_TRIANGLE_____()
EndProc 

$if McuType = 0
Dim fTftTemp1_Triangle As Float   At sTftString#16  
Dim fTftTemp2_Triangle As Float   At sTftString#20  
Dim fTftTemp3_Triangle As Float   At sTftString#24  
Dim fTftTemp4_Triangle As Float   At sTftString#28  
Dim fTftTemp5_Triangle As Float   At sTftString#32  
Dim fTftTemp6_Triangle As Float   At sTftString#36 
Dim fTftTemp7_Triangle As Float   At sTftString#40  
Dim bTftTemp1_Triangle As Byte    At sTftString#44  
Dim bTftCounter1_Triangle As Byte At sTftString#45  
Dim wTftTemp1_Triangle As Word    At sTftString#46  
Dim wTftTemp2_Triangle As Word    At sTftString#48  
Dim wTftTemp3_Triangle As Word    At sTftString#50  
Dim wTftTemp4_Triangle As Word    At sTftString#52  
Dim wTftTemp5_Triangle As Word    At sTftString#54  
Dim wTftTemp6_Triangle As Word    At sTftString#56 
$else
Dim fTftTemp1_Triangle As Float   At sTftString_16  
Dim fTftTemp2_Triangle As Float   At sTftString_20  
Dim fTftTemp3_Triangle As Float   At sTftString_24  
Dim fTftTemp4_Triangle As Float   At sTftString_28  
Dim fTftTemp5_Triangle As Float   At sTftString_32  
Dim fTftTemp6_Triangle As Float   At sTftString_36 
Dim fTftTemp7_Triangle As Float   At sTftString_40  
Dim bTftTemp1_Triangle As Byte    At sTftString_44  
Dim bTftCounter1_Triangle As Byte At sTftString_45  
Dim wTftTemp1_Triangle As Word    At sTftString_46  
Dim wTftTemp2_Triangle As Word    At sTftString_48  
Dim wTftTemp3_Triangle As Word    At sTftString_50  
Dim wTftTemp4_Triangle As Word    At sTftString_52  
Dim wTftTemp5_Triangle As Word    At sTftString_54  
Dim wTftTemp6_Triangle As Word    At sTftString_56 
$endif 


'Print a triangle with parameters:
'wX_0 = Corner 0 X coordinate
'wY_0 = Corner 0 Y coordinate
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_2 = Corner 2 X coordinate
'wY_2 = Corner 2 Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftTriangleNE(10,20, 30,70, 60,40, GREEN) -->
'Print triangle with points:(10,20)(30,70)(60,40) ; No Fill ; Color:GREEN ; 1 pixel wide

Proc TftTriangleNE(wX_0 As Word, wY_0 As Word, wX_1 As Word, wY_1 As Word, wX_2 As Word, wY_2 As Word, wColor As Word)
    TftLine(wX_0, wY_0, wX_1, wY_1, wColor, 0, 0)
    TftLine(wX_0, wY_0, wX_2, wY_2, wColor, 0, 0)
    TftLine(wX_1, wY_1, wX_2, wY_2, wColor, 0, 0)
EndProc

'Print a solid color triangle with parameters:
'wX_0 = Corner 0 X coordinate
'wY_0 = Corner 0 Y coordinate
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_2 = Corner 2 X coordinate
'wY_2 = Corner 2 Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftTriangleNS(10,20, 30,70, 60,40, GREEN) -->
'Print triangle with points:(10,20)(30,70)(60,40) ; Solid Fill ; Color:GREEN 

Proc TftTriangleNS(wX_0 As Word, wY_0 As Word, wX_1 As Word, wY_1 As Word, wX_2 As Word, wY_2 As Word, wColor As Word)
    If wY_0 > wY_1 Then
        Swap wY_0, wY_1
        Swap wX_0, wX_1
    EndIf
    If wY_1 > wY_2 Then
        Swap wY_1, wY_2
        Swap wX_1, wX_2
    EndIf
    If wY_0 > wY_1 Then
        Swap wY_0, wY_1
        Swap wX_0, wX_1
    EndIf
    TftTriangleNE(wX_0,wY_0, wX_1,wY_1, wX_2,wY_2, wColor)  
    TftQuadS(wX_0, wY_0, wX_1, wY_1, wX_2, wY_2, wX_2, wY_2, wColor)
EndProc

'Print a triangle with parameters:
'wX_0 = Corner 0 X coordinate
'wY_0 = Corner 0 Y coordinate
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_2 = Corner 2 X coordinate
'wY_2 = Corner 2 Y coordinate
'pSolid = Triangle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = triangle additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the triangle:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftTriangle(10,20, 30,70, 60,40, 0, GREEN, 2, -1) -->
'Print triangle with points:(10,20)(30,70)(60,40) ; No Fill ; Color:GREEN ; 2+1=3 pixel wide ; -1=additional pixels are inward 

Proc TftTriangle(wX_0 As Word, wY_0 As Word, wX_1 As Word, wY_1 As Word, wX_2 As Word, wY_2 As Word, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    Dim bTestBit As Bit
    
    If pSolid = 0 Then
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftTriangleNE(wX_0,wY_0, wX_1,wY_1, wX_2,wY_2, wColor)
            ExitProc 
        Else   
            bTestBit = 0
            GoSub CalcTftTriangle
            ExitProc
        EndIf
    EndIf
    
    If pSolid = 1 Then
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftTriangleNS(wX_0,wY_0, wX_1,wY_1, wX_2,wY_2, wColor)
            ExitProc 
        Else   
            bTestBit = 1
            GoSub CalcTftTriangle
            ExitProc 
        EndIf    
    EndIf 
    
    ExitProc
CalcTftTriangle:
    fTftTemp1_Triangle = (wX_0 + wX_1 + wX_2) / 3
    fTftTemp2_Triangle = (wY_0 + wY_1 + wY_2) / 3 
            
    fTftTemp6_Triangle = (wX_0 - fTftTemp1_Triangle) * (wX_0 - fTftTemp1_Triangle) + (wY_0 - fTftTemp2_Triangle) * (wY_0 - fTftTemp2_Triangle) 
    fTftTemp3_Triangle = Sqr(fTftTemp6_Triangle)
    fTftTemp6_Triangle = (wX_1 - fTftTemp1_Triangle) * (wX_1 - fTftTemp1_Triangle) + (wY_1 - fTftTemp2_Triangle) * (wY_1 - fTftTemp2_Triangle) 
    fTftTemp4_Triangle = Sqr(fTftTemp6_Triangle)
    fTftTemp6_Triangle = (wX_2 - fTftTemp1_Triangle) * (wX_2 - fTftTemp1_Triangle) + (wY_2 - fTftTemp2_Triangle) * (wY_2 - fTftTemp2_Triangle) 
    fTftTemp5_Triangle = Sqr(fTftTemp6_Triangle)
            
    fTftTemp6_Triangle = (fTftTemp3_Triangle + fTftTemp4_Triangle + fTftTemp5_Triangle) / 3
    fTftTemp3_Triangle =  bWidth / fTftTemp6_Triangle
    If bTestBit = 0 Then
        fTftTemp7_Triangle = fTftTemp3_Triangle / (bWidth + 4)
        bTftTemp1_Triangle = bWidth + 3
    Else
        bTftTemp1_Triangle = 0
    EndIf


    If bTestBit = 0 Then
        For bTftCounter1_Triangle = 0 To bTftTemp1_Triangle
            If sbDirection = 1 Then
                fTftTemp6_Triangle = 1 + fTftTemp7_Triangle * bTftCounter1_Triangle 
            Else
                fTftTemp6_Triangle = 1 - fTftTemp7_Triangle * bTftCounter1_Triangle 
            EndIf
                
            wTftTemp1_Triangle = fRound(fTftTemp1_Triangle + (wX_0 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
            wTftTemp2_Triangle = fRound(fTftTemp2_Triangle + (wY_0 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
            wTftTemp3_Triangle = fRound(fTftTemp1_Triangle + (wX_1 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
            wTftTemp4_Triangle = fRound(fTftTemp2_Triangle + (wY_1 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
            wTftTemp5_Triangle = fRound(fTftTemp1_Triangle + (wX_2 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
            wTftTemp6_Triangle = fRound(fTftTemp2_Triangle + (wY_2 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
            TftTriangleNE(wTftTemp1_Triangle,wTftTemp2_Triangle, wTftTemp3_Triangle,wTftTemp4_Triangle, wTftTemp5_Triangle,wTftTemp6_Triangle, wColor)
        Next
    Else
        For bTftCounter1_Triangle = 0 To bTftTemp1_Triangle
            If sbDirection = 1 Then
                fTftTemp6_Triangle = 1 + fTftTemp3_Triangle
            Else
                fTftTemp6_Triangle = 1 - fTftTemp3_Triangle
            EndIf      
        Next
        wTftTemp1_Triangle = fRound(fTftTemp1_Triangle + (wX_0 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
        wTftTemp2_Triangle = fRound(fTftTemp2_Triangle + (wY_0 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
        wTftTemp3_Triangle = fRound(fTftTemp1_Triangle + (wX_1 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
        wTftTemp4_Triangle = fRound(fTftTemp2_Triangle + (wY_1 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
        wTftTemp5_Triangle = fRound(fTftTemp1_Triangle + (wX_2 - fTftTemp1_Triangle) * fTftTemp6_Triangle)
        wTftTemp6_Triangle = fRound(fTftTemp2_Triangle + (wY_2 - fTftTemp2_Triangle) * fTftTemp6_Triangle)
        TftTriangleNS(wTftTemp1_Triangle,wTftTemp2_Triangle, wTftTemp3_Triangle,wTftTemp4_Triangle, wTftTemp5_Triangle,wTftTemp6_Triangle, wColor)         
    EndIf
    Return     
EndProc

Proc _______TFT_QUAD_____()    
EndProc

'Temp variables Quads
$if McuType = 0
Dim bTftTemp1_Quad As Byte    At sTftString#0  
Dim bTftTemp2_Quad As Byte    At sTftString#1  
Dim fTftTemp1_Quad As Float   At sTftString#2  
Dim wTftTemp1_Quad As Word    At sTftString#6  
Dim wTftTemp2_Quad As Word    At sTftString#8  
Dim wTftTemp3_Quad As Word    At sTftString#10 
Dim wTftTemp4_Quad As Word    At sTftString#12 
Dim wTftCounter1_Quad As Word At sTftString#14 
Dim fTftTemp2_Quad As Float   At sTftString#16 
Dim fTftTemp3_Quad As Float   At sTftString#20 
$else
Dim bTftTemp1_Quad As Byte    At sTftString_0  
Dim bTftTemp2_Quad As Byte    At sTftString_1  
Dim fTftTemp1_Quad As Float   At sTftString_2  
Dim wTftTemp1_Quad As Word    At sTftString_6  
Dim wTftTemp2_Quad As Word    At sTftString_8  
Dim wTftTemp3_Quad As Word    At sTftString_10 
Dim wTftTemp4_Quad As Word    At sTftString_12 
Dim wTftCounter1_Quad As Word At sTftString_14 
Dim fTftTemp2_Quad As Float   At sTftString_16 
Dim fTftTemp3_Quad As Float   At sTftString_20 
$endif

'Print a parallelogram with parameters:
'wX_Corner = Corner1 X coordinate
'wY_Corner = Corner1 Y coordinate
'wSideH = Length of horizontal side
'wSideD = Length of inclined side
'wAngle = angle between horizontal and inclined side in degrees
'pSolid = parallelogram fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'Example: TftParallelogramNTS(50,40, 70, 30, 25, 0, GREEN) -->
'Print empty parallelogram with corner point:(50,40) ; horizontal side:70 ; inclined side:30 ; Angle between sided = 25 degrees ; No fill ; Color:GREEN 

Proc TftParallelogramNTS(wX_Corner As Word, wY_Corner As Word, wSideH As Word, wSideI As Word, wAngle As Word, pSolid As Bit, wColor As Word)
    fTftTemp1_Quad = (wAngle) * 0.0174533     
    fTftTemp2_Quad = Cos(fTftTemp1_Quad)
    fTftTemp3_Quad = fTftTemp2_Quad * wSideI
    wTftTemp1_Quad = fRound(fTftTemp3_Quad)    
    fTftTemp2_Quad = Sin(fTftTemp1_Quad)
    fTftTemp3_Quad = fTftTemp2_Quad * wSideI
    wTftTemp2_Quad = fRound(fTftTemp3_Quad)    
    
    TftQuadN(wX_Corner,wY_Corner, wX_Corner + wTftTemp1_Quad,wY_Corner + wTftTemp2_Quad, wX_Corner + wSideH + wTftTemp1_Quad,wY_Corner + wTftTemp2_Quad, wX_Corner + wSideH,wY_Corner ,pSolid, wColor) 
EndProc
 
'Print a quadrangle by given four vertices with parameters:
'wX_0 = Corner 0 X coordinate
'wY_0 = Corner 0 Y coordinate
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_2 = Corner 2 X coordinate
'wY_2 = Corner 2 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'pSolid = Rectangle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'Example: TftQuadN(100,50, 170,80, 200,60, 130,20, 0, GREEN) -->
'Print empty quadrangle with corners:(100,50)(170,80)(20,60)(130,20) ; No fill ; Color:GREEN 
'Note: the order in which vertices are entered is important because the quad is built as four lines connecting each vertex sequentially
                   
Proc TftQuadN(wX_0 As Word, wY_0 As Word, wX_1 As Word, wY_1 As Word, wX_2 As Word, wY_2 As Word, wX_3 As Word, wY_3 As Word, pSolid As Bit, wColor As Word)
    TftLine(wX_0, wY_0, wX_1, wY_1, wColor, 0, 0)
    TftLine(wX_1, wY_1, wX_2, wY_2, wColor, 0, 0)
    TftLine(wX_2, wY_2, wX_3, wY_3, wColor, 0, 0)
    TftLine(wX_3, wY_3, wX_0, wY_0, wColor, 0, 0)
    
    If pSolid = 1 Then
        TftQuadS(wX_0, wY_0, wX_1, wY_1, wX_2, wY_2, wX_3, wY_3, wColor)
    EndIf
EndProc

'Print a solid fill quadrangle by given four vertices with parameters:
'wX_0 = Corner 0 X coordinate
'wY_0 = Corner 0 Y coordinate
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_2 = Corner 2 X coordinate
'wY_2 = Corner 2 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftQuadS(100,50, 170,80, 200,60, 130,20, GREEN) -->
'Print a solid fill quadrangle with corners:(100,50)(170,80)(20,60)(130,20) ; Fill Color:GREEN 

Proc TftQuadS(wX_0 As Word, wY_0 As Word, wX_1 As Word, wY_1 As Word, wX_2 As Word, wY_2 As Word, wX_3 As Word, wY_3 As Word, wColor As Word)
    If wY_0 > wY_1 Then
        Swap wY_0, wY_1
        Swap wX_0, wX_1
    EndIf
    If wY_2 > wY_3 Then
        Swap wY_2, wY_3
        Swap wX_2, wX_3
    EndIf
    If wY_1 > wY_3 Then
        Swap wY_1, wY_3
        Swap wX_1, wX_3
    EndIf
    If wY_0 > wY_2 Then
        Swap wY_0, wY_2
        Swap wX_0, wX_2
    EndIf
    If wY_1 > wY_2 Then
        Swap wY_1, wY_2
        Swap wX_1, wX_2
    EndIf
        
    bTftTemp1_Quad = 0 : bTftTemp2_Quad = 0
        
    fTftTemp1_Quad = (wX_3 - wX_0) * (wY_1 - wY_0) 
    fTftTemp1_Quad = wX_0 + fTftTemp1_Quad / (wY_3 - wY_0)
    wTftTemp1_Quad = fRound(fTftTemp1_Quad)
    fTftTemp1_Quad = (wX_3 - wX_0) * (wY_2 - wY_0)
    fTftTemp1_Quad = wX_0 + fTftTemp1_Quad / (wY_3 - wY_0)
    wTftTemp2_Quad = fRound(fTftTemp1_Quad) 

    If wTftTemp1_Quad > wX_1 Then bTftTemp1_Quad = 1
    If wTftTemp2_Quad > wX_2 Then bTftTemp2_Quad = 1
        
    If bTftTemp1_Quad = bTftTemp2_Quad Then
        Swap wX_2, wTftTemp2_Quad
    Else
        fTftTemp1_Quad = (wX_2 - wX_0) * (wY_1 - wY_0) 
        fTftTemp1_Quad = wX_0 + fTftTemp1_Quad / (wY_2 - wY_0)
        wTftTemp1_Quad = fRound(fTftTemp1_Quad)  
        fTftTemp1_Quad = (wX_3 - wX_1) * (wY_2 - wY_1) 
        fTftTemp1_Quad = wX_1 + fTftTemp1_Quad / (wY_3 - wY_1)
        wTftTemp2_Quad = fRound(fTftTemp1_Quad) 
    EndIf

    For wTftCounter1_Quad = wY_0 To wY_1
        fTftTemp1_Quad = (wTftTemp1_Quad - wX_0) * (wTftCounter1_Quad - wY_0) 
        fTftTemp1_Quad = wX_0 + fTftTemp1_Quad / (wY_1 - wY_0)
        wTftTemp3_Quad = fRound(fTftTemp1_Quad)
        fTftTemp1_Quad = (wX_1 - wX_0) * (wTftCounter1_Quad - wY_0) 
        fTftTemp1_Quad = wX_0 + fTftTemp1_Quad / (wY_1 - wY_0)
        wTftTemp4_Quad = fRound(fTftTemp1_Quad)
        If wTftTemp3_Quad > wTftTemp4_Quad Then Swap wTftTemp3_Quad, wTftTemp4_Quad
        If wY_0 <> wY_1 Then
            TftLineHN(wTftTemp3_Quad, wTftTemp4_Quad, wTftCounter1_Quad, wColor)
        EndIf
    Next

    For wTftCounter1_Quad = wY_1 To wY_2
        fTftTemp1_Quad = (wX_2 - wTftTemp1_Quad) * (wTftCounter1_Quad - wY_1) 
        fTftTemp1_Quad = wTftTemp1_Quad + fTftTemp1_Quad / (wY_2 - wY_1)
        wTftTemp3_Quad = fRound(fTftTemp1_Quad)
        fTftTemp1_Quad = (wTftTemp2_Quad - wX_1) * (wTftCounter1_Quad - wY_1) 
        fTftTemp1_Quad = wX_1 + fTftTemp1_Quad / (wY_2 - wY_1)
        wTftTemp4_Quad = fRound(fTftTemp1_Quad)
        If wTftTemp3_Quad > wTftTemp4_Quad Then Swap wTftTemp3_Quad, wTftTemp4_Quad
        TftLineHN(wTftTemp3_Quad, wTftTemp4_Quad, wTftCounter1_Quad, wColor)
    Next

    If wY_2 = wY_3 Or wX_2 = wX_3 Then
        ExitProc
    EndIf
    
    For wTftCounter1_Quad = wY_2 To wY_3
        fTftTemp1_Quad = (wX_3 - wX_2) * (wTftCounter1_Quad - wY_2) 
        fTftTemp1_Quad = wX_2 + fTftTemp1_Quad / (wY_3 - wY_2)
        wTftTemp3_Quad = fRound(fTftTemp1_Quad)
        fTftTemp1_Quad = (wX_3 - wTftTemp2_Quad) * (wTftCounter1_Quad - wY_2) 
        fTftTemp1_Quad = wTftTemp2_Quad + fTftTemp1_Quad / (wY_3 - wY_2)
        wTftTemp4_Quad = fRound(fTftTemp1_Quad)
        If wTftTemp3_Quad > wTftTemp4_Quad Then Swap wTftTemp3_Quad, wTftTemp4_Quad
        TftLineHN(wTftTemp3_Quad, wTftTemp4_Quad, wTftCounter1_Quad, wColor)
    Next
EndProc

Proc ____TFT_RECTANGLE___()
EndProc

$if McuType = 0
Dim wTftTemp1_Rectangle As Word         At sTftString#4
Dim wTftTemp2_Rectangle As Word         At sTftString#6
Dim wTftTemp3_Rectangle As Word         At sTftString#8
Dim wTftTemp4_Rectangle As Word         At sTftString#10
Dim fTftTemp1_Rectangle As Float        At sTftString#12
Dim fTftTemp2_Rectangle As Float        At sTftString#16
Dim bTftTemp1_Rectangle As Byte         At sTftString#20
Dim bTftTemp2_Rectangle As Byte         At sTftString#21
Dim wTftTemp5_Rectangle As Word         At sTftString#22
Dim wTftCounter1_Rectangle As Word      At sTftString#26  
Dim swTftCounter1_Rectangle As SWord    At sTftString#26 
Dim wTftTemp7_Rectangle As Word         At sTftString#28  
Dim wTftTemp6_Rectangle As Word         At sTftString#30  
Dim fTftTemp3_Rectangle As Float        At sTftString#32 
Dim fTftTemp4_Rectangle As Float        At sTftString#36 
Dim fTftTemp5_Rectangle As Float        At sTftString#40 
Dim swTftTemp1_Rectangle As SWord       At sTftString#44 
Dim swTftTemp2_Rectangle As SWord       At sTftString#46
Dim swTftTemp3_Rectangle As SWord       At sTftString#48 
Dim wTftCounter2_Rectangle As Word      At sTftString#50 
Dim swTftTemp4_Rectangle As SWord       At sTftString#52 
Dim swTftTemp5_Rectangle As SWord       At sTftString#54 
Dim fTftTemp6_Rectangle As Float        At sTftString#56 
Dim bTftTemp3_Rectangle As Byte         At sTftString#60
Dim bTftTemp4_Rectangle As Byte         At sTftString#61
Dim dwTftTemp1_Rectangle As Dword       At sTftString#60 
Dim dwTftTemp2_Rectangle As Dword       At sTftString#64 
Dim dwTftTemp3_Rectangle As Dword       At sTftString#68 
$else
Dim wTftTemp1_Rectangle As Word         At sTftString_4
Dim wTftTemp2_Rectangle As Word         At sTftString_6
Dim wTftTemp3_Rectangle As Word         At sTftString_8
Dim wTftTemp4_Rectangle As Word         At sTftString_10
Dim fTftTemp1_Rectangle As Float        At sTftString_12
Dim fTftTemp2_Rectangle As Float        At sTftString_16
Dim bTftTemp1_Rectangle As Byte         At sTftString_20
Dim bTftTemp2_Rectangle As Byte         At sTftString_21
Dim wTftTemp5_Rectangle As Word         At sTftString_22
Dim wTftCounter1_Rectangle As Word      At sTftString_26  
Dim swTftCounter1_Rectangle As SWord    At sTftString_26 
Dim wTftTemp7_Rectangle As Word         At sTftString_28  
Dim wTftTemp6_Rectangle As Word         At sTftString_30  
Dim fTftTemp3_Rectangle As Float        At sTftString_32 
Dim fTftTemp4_Rectangle As Float        At sTftString_36 
Dim fTftTemp5_Rectangle As Float        At sTftString_40 
Dim swTftTemp1_Rectangle As SWord       At sTftString_44 
Dim swTftTemp2_Rectangle As SWord       At sTftString_46
Dim swTftTemp3_Rectangle As SWord       At sTftString_48 
Dim wTftCounter2_Rectangle As Word      At sTftString_50 
Dim swTftTemp4_Rectangle As SWord       At sTftString_52 
Dim swTftTemp5_Rectangle As SWord       At sTftString_54 
Dim fTftTemp6_Rectangle As Float        At sTftString_56 
Dim bTftTemp3_Rectangle As Byte         At sTftString_60
Dim bTftTemp4_Rectangle As Byte         At sTftString_61
Dim dwTftTemp1_Rectangle As Dword       At sTftString_60 
Dim dwTftTemp2_Rectangle As Dword       At sTftString_64 
Dim dwTftTemp3_Rectangle As Dword       At sTftString_68
$endif


'Print a rectangle by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'pSolid = Rectangle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = Rectangle additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the rectangle:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftRectangle(100,50, 170,80, 0, GREEN, 3, 1) -->
'Print rectangle with corners:(100,50)(170,80) ; No fill ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are outward

Proc TftRectangle(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If pSolid = 0 Then
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftRectangleENTC(wX_1, wY_1, wX_3, wY_3, wColor)
            ExitProc 
        EndIf
        
        If sbDirection = 1 Then
            TftRectangleETTCO(wX_1, wY_1, wX_3, wY_3, wColor, bWidth)
            ExitProc 
        EndIf
        
        If sbDirection = -1 Then
            TftRectangleETTCI(wX_1, wY_1, wX_3, wY_3, wColor, bWidth)
            ExitProc 
        EndIf
    EndIf
    
    If pSolid = 1 Then
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftRectangleSNTC(wX_1, wY_1, wX_3, wY_3, wColor)
            ExitProc 
        EndIf
        
        If sbDirection = 1 Then
            TftRectangleSNTC(wX_1 - bWidth, wY_1 - bWidth, wX_3 + bWidth, wY_3 + bWidth, wColor)
            ExitProc 
        EndIf
        
        If sbDirection = -1 Then
            TftRectangleSNTC(wX_1 + bWidth, wY_1 + bWidth, wX_3 - bWidth, wY_3 - bWidth, wColor)
            ExitProc 
        EndIf
    EndIf
EndProc

'Print an empty rectangle by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftRectangleENTC(100,50, 170,80, GREEN) -->
'Print empty rectangle with corners:(100,50)(170,80) ; Color:GREEN  

Proc TftRectangleENTC(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, wColor As Word)
    TftLineHN(wX_1, wX_3, wY_3, wColor)  
    TftLineVN(wX_1, wY_1, wY_3, wColor)
    TftLineHN(wX_1, wX_3, wY_1, wColor)   
    TftLineVN(wX_3, wY_1, wY_3, wColor)   
EndProc  

'Print a thick outwards empty rectangle by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = Rectangle additional width in pixels, 0 = no additional width i.e. 1 Pixel wide 
'Example: TftRectangleETTCO(100,50, 170,80, GREEN, 3) -->
'Print empty rectangle with corners:(100,50)(170,80) ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are outward 

Proc TftRectangleETTCO(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, wColor As Word, bWidth As Byte)
    Global Dim bTftCounter1_Rectangle As Byte Shared
    
    If wX_1 > wX_3 Then Swap wX_1, wX_3 
    If wY_1 > wY_3 Then Swap wY_1, wY_3 
    For bTftCounter1_Rectangle = 0 To bWidth
        TftRectangleENTC(wX_1 - bTftCounter1_Rectangle, wY_1 - bTftCounter1_Rectangle, wX_3 + bTftCounter1_Rectangle, wY_3 + bTftCounter1_Rectangle, wColor) 
    Next      
EndProc

'Print a thick inwards empty rectangle by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = Rectangle additional width in pixels, 0 = no additional width i.e. 1 Pixel wide 
'Example: TftRectangleETTCI(100,50, 170,80, GREEN, 3) -->
'Print empty rectangle with corners:(100,50)(170,80) ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are inward 

Proc TftRectangleETTCI(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, wColor As Word, bWidth As Byte)
    Global Dim bTftCounter1_Rectangle As Byte Shared
    
    If wX_1 > wX_3 Then Swap wX_1, wX_3 
    If wY_1 > wY_3 Then Swap wY_1, wY_3 
    For bTftCounter1_Rectangle = 0 To bWidth
        TftRectangleENTC(wX_1 + bTftCounter1_Rectangle, wY_1 + bTftCounter1_Rectangle, wX_3 - bTftCounter1_Rectangle, wY_3 - bTftCounter1_Rectangle, wColor) 
    Next      
EndProc

'Print a solid rectangle by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftRectangleSNTC(100,50, 170,80, GREEN) -->
'Print solid rectangle with corners:(100,50)(170,80) ; Color:GREEN  

Proc TftRectangleSNTC(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, wColor As Word)
    If wX_3 < wX_1 Then Swap wX_3, wX_1 
    If wY_3 < wY_1 Then Swap wY_3, wY_1 
    
    $if TftPixelCheck = 1
        If wX_1 < TftScreenWidth And wY_1 < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_3 >= TftScreenWidth Then 
                wX_3 = TftScreenWidth - 1 
                pOutOfScreen = 1
            EndIf
            If wY_3 >= TftScreenHeight Then 
                wY_3 = TftScreenHeight - 1 
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_1, wX_3, wY_1, wY_3)
        Else
            pOutOfScreen = 1
            ExitProc                      
        EndIf
    $else
        TftSetWindow(wX_1, wX_3, wY_1, wY_3)
    $endif
    TftInitiateDataRam()
    wTftTemp1_Rectangle = (wX_3 - wX_1) + 2
    wTftTemp2_Rectangle = (wY_3 - wY_1) + 2
    For dwTftTemp1_Rectangle = 0 To (wTftTemp1_Rectangle * wTftTemp2_Rectangle) 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()      
EndProc

'Print an empty rectangle by given a center point, height and width with parameters:
'wX_Center = Center point X coordinate
'wY_Center = Center point Y coordinate
'wRWidth = Rectangle width
'wRHeight = Rectangle height
'wColor = 16b color in 565 RGB format 
'Example: TftRectangleENCP(100,120, 20, 30, GREEN) -->
'Print empty rectangle with center point:(100,120) ;  Width:20 ; Height:30 ; Color:GREEN  

Proc TftRectangleENCP(wX_Center As Word, wY_Center As Word, wRWidth As Word, wRHeight As Word, wColor As Word)
    wTftTemp1_Rectangle = wX_Center - (wRWidth >> 1)
    wTftTemp2_Rectangle = wY_Center - (wRHeight >> 1)
    wTftTemp3_Rectangle = wX_Center + (wRWidth >> 1)
    wTftTemp4_Rectangle = wY_Center + (wRHeight >> 1)    
    TftRectangleENTC(wTftTemp1_Rectangle, wTftTemp2_Rectangle, wTftTemp3_Rectangle, wTftTemp4_Rectangle, wColor) 
EndProc

'Print a thick outwards empty rectangle by given a center point, height and width with parameters:
'wX_Center = Center point X coordinate
'wY_Center = Center point Y coordinate
'wRWidth = Rectangle width
'wRHeight = Rectangle height
'wColor = 16b color in 565 RGB format 
'bWidth = Rectangle additional width in pixels, 0 = no additional width i.e. 1 Pixel wide 
'Example: TftRectangleETCPO(100,120, 30, 20, GREEN, 3) -->
'Print empty rectangle with center point:(100,120) ; Height:30 ; Width:20 ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are outward

Proc TftRectangleETCPO(wX_Center As Word, wY_Center As Word, wRWidth As Word, wRHeight As Word, wColor As Word, bWidth As Byte)
    Global Dim bTftCounter1_Rectangle As Byte Shared
    
    wTftTemp1_Rectangle = wX_Center - (wRWidth >> 1)
    wTftTemp2_Rectangle = wY_Center - (wRHeight >> 1)
    wTftTemp3_Rectangle = wX_Center + (wRWidth >> 1)
    wTftTemp4_Rectangle = wY_Center + (wRHeight >> 1)   
    
    For bTftCounter1_Rectangle = 0 To bWidth
        TftRectangleENTC(wTftTemp1_Rectangle - bTftCounter1_Rectangle, wTftTemp2_Rectangle - bTftCounter1_Rectangle, wTftTemp3_Rectangle + bTftCounter1_Rectangle, wTftTemp4_Rectangle + bTftCounter1_Rectangle, wColor) 
    Next 
EndProc

'Print a thick inwards empty rectangle by given a center point, height and width with parameters:
'X_Center = Center point X coordinate
'Y_Center = Center point Y coordinate
'RWidth = Rectangle width
'RHeight = Rectangle height
'wColor = 16b color in 565 RGB format 
'Width = Rectangle additional width in pixels, 0 = no additional width i.e. 1 Pixel wide 
'Example: TftRectangleETCPI(100,120, 30, 20, GREEN, 3) -->
'Print empty rectangle with center point:(100,120) ; Height:30 ; Width:20 ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are inward

Proc TftRectangleETCPI(wX_Center As Word, wY_Center As Word, wRWidth As Word, wRHeight As Word, wColor As Word, bWidth As Byte)
    Global Dim bTftCounter1_Rectangle As Byte Shared
    
    wTftTemp1_Rectangle = wX_Center - (wRWidth >> 1)
    wTftTemp2_Rectangle = wY_Center - (wRHeight >> 1)
    wTftTemp3_Rectangle = wX_Center + (wRWidth >> 1)
    wTftTemp4_Rectangle = wY_Center + (wRHeight >> 1)    
    
    For bTftCounter1_Rectangle = 0 To bWidth
        TftRectangleENTC(wTftTemp1_Rectangle + bTftCounter1_Rectangle, wTftTemp2_Rectangle + bTftCounter1_Rectangle, wTftTemp3_Rectangle - bTftCounter1_Rectangle, wTftTemp4_Rectangle - bTftCounter1_Rectangle, wColor) 
    Next 
EndProc

'Print a solid rectangle by given a center point, height and width with parameters:
'wX_Center = Center point X coordinate
'wY_Center = Center point Y coordinate
'wRWidth = Rectangle width
'wRHeight = Rectangle height
'wColor = 16b color in 565 RGB format 
'Example: TftRectangleSNCP(100,120, 30, 20, GREEN) -->
'Print solid rectangle with center point:(100,120) ; Height:30 ; Width:20 ; Color:GREEN  

Proc TftRectangleSNCP(wX_Center As Word, wY_Center As Word, wRWidth As Word, wRHeight As Word, wColor As Word)
    wTftTemp1_Rectangle = wX_Center - (wRWidth >> 1) 
    wTftTemp2_Rectangle = wY_Center - (wRHeight >> 1) 
    wTftTemp3_Rectangle = wX_Center + (wRWidth >> 1) 
    wTftTemp4_Rectangle = wY_Center + (wRHeight >> 1)    
    TftRectangleSNTC(wTftTemp1_Rectangle, wTftTemp2_Rectangle, wTftTemp3_Rectangle, wTftTemp4_Rectangle, wColor) 
EndProc

'Print a rectangle with rounded corners by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'bRadius = corner radius
'pSolid = Rectangle fill : 0 = No fill ; 1 = Fill
'wColor = 16b color in 565 RGB format 
'bWidth = Rectangle additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the rectangle:
'            1 = Outward ; -1 = Inward ; Else = Ignored (no additional width) 
'Example: TftRectangleRC(100,50, 170,80, 4, 0, GREEN, 0, 0) -->
'Print a rectangle with corners:(100,50)(170,80) ; No fill ; Color:GREEN ; 3+1=4 Pixel wide ; additional pixels are outward

Proc TftRectangleRC(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, bRadius As Byte, pSolid As Bit, wColor As Word, bWidth As Byte, sbDirection As SByte)
    Global Dim bTftCounter1_Rectangle As Byte Shared
    Dim pTestBit1 As Bit
    
    If wX_1 > wX_3 Then Swap wX_1, wX_3
    If wY_1 > wY_3 Then Swap wY_1, wY_3
    wTftTemp1_Rectangle = Abs(wX_3 - wX_1) / 2
    wTftTemp2_Rectangle = Abs(wY_3 - wY_1) / 2
    If wTftTemp1_Rectangle > wTftTemp2_Rectangle Then Swap wTftTemp1_Rectangle, wTftTemp2_Rectangle
    If bRadius >= wTftTemp1_Rectangle Then bRadius = wTftTemp1_Rectangle 
    wTftTemp2_Rectangle = bRadius
    
    If pSolid = 0 Then
        pTestBit1 = 0
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            GoSub CalcTftRectangleRC
            ExitProc 
        Else   
            For bTftCounter1_Rectangle = 1 To bWidth + 1
                GoSub CalcTftRectangleRC  
                If sbDirection = 1 Then
                    bRadius = wTftTemp2_Rectangle + bTftCounter1_Rectangle
                    wX_1 = wX_1 - 1
                    wX_3 = wX_3 + 1
                    wY_1 = wY_1 - 1
                    wY_3 = wY_3 + 1
                Else
                    bRadius = wTftTemp2_Rectangle - bTftCounter1_Rectangle
                    wX_1 = wX_1 + 1
                    wX_3 = wX_3 - 1
                    wY_1 = wY_1 + 1
                    wY_3 = wY_3 - 1
                EndIf 
            Next
            ExitProc   
        EndIf
    EndIf
    
    If pSolid = 1 Then
        pTestBit1 = 1
        If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            'Nothing   
        Else  
            bWidth = bWidth + 1
            If sbDirection = 1 Then
                bRadius = bRadius + bWidth 
                wX_1 = wX_1 - bWidth 
                wX_3 = wX_3 + bWidth 
                wY_1 = wY_1 - bWidth 
                wY_3 = wY_3 + bWidth 
            Else
                bRadius = bRadius - bWidth 
                wX_1 = wX_1 + bWidth
                wX_3 = wX_3 - bWidth 
                wY_1 = wY_1 + bWidth 
                wY_3 = wY_3 - bWidth
            EndIf
        EndIf
        TftRectangleSNTC(wX_1, wY_1 + bRadius, wX_3, wY_3 - bRadius, wColor)
        GoSub CalcTftRectangleRC
        ExitProc 
    EndIf
    
    ExitProc
CalcTftRectangleRC: 
    If pTestBit1 = 0 Then     
        TftLineHN(wX_1 + bRadius, wX_3 - bRadius, wY_1, wColor)
        TftLineHN(wX_1 + bRadius, wX_3 - bRadius, wY_3, wColor)
        TftLineVN(wX_1, wY_1 + bRadius, wY_3 - bRadius, wColor)
        TftLineVN(wX_3, wY_1 + bRadius, wY_3 - bRadius, wColor)
    EndIf
    
    TftPixelRatio(bRadius)
    bTftTemp1_Rectangle = dwTftdwPixelRatio.Byte0
    bTftTemp2_Rectangle = dwTftdwPixelRatio.Byte1
    wTftTemp5_Rectangle = dwTftdwPixelRatio.Word1

    For wTftTemp1_Rectangle = 0 To wTftTemp5_Rectangle Step bTftTemp1_Rectangle
        fTftTemp1_Rectangle = wTftTemp1_Rectangle * 0.0174533 / bTftTemp2_Rectangle
        fTftTemp2_Rectangle = Cos(fTftTemp1_Rectangle)
        fTftTemp2_Rectangle = fTftTemp2_Rectangle * bRadius
        wTftTemp3_Rectangle = fRound(fTftTemp2_Rectangle)
        fTftTemp2_Rectangle = Sin(fTftTemp1_Rectangle)
        fTftTemp2_Rectangle = fTftTemp2_Rectangle * bRadius
        wTftTemp4_Rectangle = fRound(fTftTemp2_Rectangle)
         
        If pTestBit1 = 0 Then        
            TftPixel(wX_1 + bRadius - wTftTemp3_Rectangle, wY_1 + bRadius - wTftTemp4_Rectangle, wColor)
            TftPixel(wX_3 - bRadius + wTftTemp3_Rectangle, wY_3 - bRadius + wTftTemp4_Rectangle, wColor)
            TftPixel(wX_1 + bRadius - wTftTemp3_Rectangle, wY_3 - bRadius + wTftTemp4_Rectangle, wColor)
            TftPixel(wX_3 - bRadius + wTftTemp3_Rectangle, wY_1 + bRadius - wTftTemp4_Rectangle, wColor)
        Else
            TftLineHN(wX_1 + bRadius - wTftTemp3_Rectangle, wX_3 - bRadius + wTftTemp3_Rectangle, wY_1 + bRadius - wTftTemp4_Rectangle, wColor)
            TftLineHN(wX_1 + bRadius - wTftTemp3_Rectangle, wX_3 - bRadius + wTftTemp3_Rectangle, wY_3 - bRadius + wTftTemp4_Rectangle, wColor)
        EndIf
    Next
    Return
EndProc

'Print a solid rectangle with a gradient color by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'wStartColor = Start color for gradient - 16b color in 565 RGB format
'wEndColor = End color for gradient - 16b color in 565 RGB format
'bGradient = direction for the gradient color:
'                     0 = Horizontal (Left to Right)
'                     1 = Vertical (Bottom to top)
'                     2 = Radial (Center to Peripheral) 
'                     Note: Radial gradient is extremely computational demanding and it is drawn pixel by pixel which means this method is very slow
'Example: TftRectangleTCG(20,30, 170,100, YELLOW, BROWN, 1) -->
'Print solid rectangle with corners:(20,30)(170,100) ; gradient color bottom to top from YELLOW to BROWN

Proc TftRectangleTCG(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, wStartColor As Word, wEndColor As Word, bGradient As Byte)
    If wX_3 < wX_1 Then Swap wX_3, wX_1 
    If wY_3 < wY_1 Then Swap wY_3, wY_1 
    
    If bGradient = 0 Then
        TftSetGradient(wStartColor, wEndColor, wX_3 - wX_1)
        For wTftCounter1_Rectangle = 0 To wX_3 - wX_1 
            TftLineVN(wX_1 + wTftCounter1_Rectangle, wY_1, wY_3, TftBuildGradient(wTftCounter1_Rectangle))   
        Next
        ExitProc
    EndIf   
    
    If bGradient = 1 Then
        TftSetGradient(wStartColor, wEndColor, wY_3 - wY_1)
        For wTftCounter1_Rectangle = 0 To wY_3 - wY_1 
            TftLineHN(wX_1, wX_3, wY_1 + wTftCounter1_Rectangle, TftBuildGradient(wTftCounter1_Rectangle))   
        Next
        ExitProc
    EndIf 
    
    If bGradient = 2 Then
        wTftTemp7_Rectangle = (wX_3 - wX_1) / 2  
        wTftTemp6_Rectangle = (wY_3 - wY_1) / 2  
        fTftTemp3_Rectangle = wTftTemp7_Rectangle * wTftTemp7_Rectangle
        fTftTemp4_Rectangle = wTftTemp6_Rectangle * wTftTemp6_Rectangle
        fTftTemp5_Rectangle = fTftTemp3_Rectangle + fTftTemp4_Rectangle
        fTftTemp3_Rectangle = Sqr(fTftTemp5_Rectangle) 
        wTftTemp7_Rectangle = (wX_3 + wX_1) / 2 
        wTftTemp6_Rectangle = (wY_3 + wY_1) / 2
        TftSetGradient(wStartColor, wEndColor, 100) 
        swTftTemp1_Rectangle = bTftRedEnd_Helper - bTftRedStart_Helper
        swTftTemp2_Rectangle = bTftGreenEnd_Helper - bTftGreenStart_Helper
        swTftTemp3_Rectangle = bTftBlueEnd_Helper - bTftBlueStart_Helper
        
        For wTftCounter1_Rectangle = wY_1 To wY_3 
            For wTftCounter2_Rectangle = wX_1 To wX_3 
                swTftTemp4_Rectangle = wTftCounter2_Rectangle - wTftTemp7_Rectangle
                swTftTemp5_Rectangle = wTftCounter1_Rectangle - wTftTemp6_Rectangle
                fTftTemp4_Rectangle = swTftTemp4_Rectangle * swTftTemp4_Rectangle
                fTftTemp5_Rectangle = swTftTemp5_Rectangle * swTftTemp5_Rectangle 
                fTftTemp6_Rectangle = Sqr(fTftTemp4_Rectangle + fTftTemp5_Rectangle)
                fTftTemp4_Rectangle = fTftTemp6_Rectangle / fTftTemp3_Rectangle
                If fTftTemp4_Rectangle > 1 Then fTftTemp4_Rectangle = 1
                TftPixel(wTftCounter2_Rectangle, wTftCounter1_Rectangle, TftPixelGradient(swTftTemp1_Rectangle, swTftTemp2_Rectangle, swTftTemp3_Rectangle, fTftTemp4_Rectangle)) 
            Next 
        Next 
    EndIf     
EndProc

'Print a solid rectangle with rounded corners and a gradient color by given two opposite vertices (corner 1 and corner 3) with parameters:
'wX_1 = Corner 1 X coordinate
'wY_1 = Corner 1 Y coordinate
'wX_3 = Corner 3 X coordinate
'wY_3 = Corner 3 Y coordinate
'bRadius = corner radius
'wStartColor = Start color for gradient - 16b color in 565 RGB format
'wEndColor = End color for gradient - 16b color in 565 RGB format
'bGradient = direction for the gradient color:
'                     0 = Horizontal (Left to Right)
'                     1 = Vertical (Bottom to top)
'                     2 = Radial (Center to Peripheral) 
'                     Note: Radial gradient is extremely computational demanding and it is drawn pixel by pixel which means this method is very slow
'Example: TftRectangleRCG(20,30, 170,100, 8, YELLOW, BROWN, 1) -->
'Print solid rectangle with corners:(20,30)(170,100) ; 8 pixel rounded corners ; gradient color bottom to top from YELLOW to BROWN

Proc TftRectangleRCG(wX_1 As Word, wY_1 As Word, wX_3 As Word, wY_3 As Word, bRadius As Byte, wStartColor As Word, wEndColor As Word, bGradient As Byte)
    Dim pTestBit1 As Bit
    
    If wX_1 > wX_3 Then Swap wX_1, wX_3
    If wY_1 > wY_3 Then Swap wY_1, wY_3
    wTftTemp1_Rectangle = wX_3 - wX_1 
    wTftTemp1_Rectangle = wTftTemp1_Rectangle / 2
    wTftTemp2_Rectangle = wY_3 - wY_1 
    wTftTemp2_Rectangle = wTftTemp2_Rectangle / 2
    If wTftTemp1_Rectangle > wTftTemp2_Rectangle Then Swap wTftTemp1_Rectangle, wTftTemp2_Rectangle
    If bRadius >= wTftTemp1_Rectangle Then bRadius = wTftTemp1_Rectangle 
    
    If bGradient = 0 Then
        wTftTemp2_Rectangle = wX_3 - wX_1
        TftSetGradient(wStartColor, wEndColor, wTftTemp2_Rectangle)
        wTftCounter2_Rectangle = 0
        wTftTemp7_Rectangle = wX_1
        
        TftPixelRatio(bRadius)
        bTftTemp3_Rectangle = dwTftdwPixelRatio.Byte0
        bTftTemp4_Rectangle = dwTftdwPixelRatio.Byte1
        wTftTemp6_Rectangle = dwTftdwPixelRatio.Word1
    
        For wTftCounter1_Rectangle = 0 To wTftTemp6_Rectangle Step bTftTemp3_Rectangle
            GoSub TftRectangleRG1
            
            If wX_1 + bRadius - swTftTemp1_Rectangle > wTftTemp7_Rectangle Then
                TftLineVN(wTftTemp7_Rectangle, wY_1 + bRadius - swTftTemp2_Rectangle, wY_3 - bRadius + swTftTemp2_Rectangle, TftBuildGradient(wTftCounter2_Rectangle))
                wTftTemp7_Rectangle = wX_1 + bRadius - swTftTemp1_Rectangle
                Inc wTftCounter2_Rectangle
            EndIf
        Next
        
        For wTftCounter1_Rectangle = wTftTemp7_Rectangle To wX_3 - bRadius
            TftLineVN(wTftCounter1_Rectangle, wY_1, wY_3, TftBuildGradient(wTftCounter2_Rectangle))
            Inc wTftCounter2_Rectangle
        Next
        
        wTftTemp7_Rectangle = wX_3 - bRadius 
        For swTftCounter1_Rectangle = wTftTemp6_Rectangle DownTo 0 Step -bTftTemp3_Rectangle
            GoSub TftRectangleRG1
            
            If wX_3 - bRadius + swTftTemp1_Rectangle > wTftTemp7_Rectangle Then
                TftLineVN(wTftTemp7_Rectangle, wY_1 + bRadius - swTftTemp2_Rectangle, wY_3 - bRadius + swTftTemp2_Rectangle, TftBuildGradient(wTftCounter2_Rectangle))
                wTftTemp7_Rectangle = wX_3 - bRadius + swTftTemp1_Rectangle 
                Inc wTftCounter2_Rectangle
            EndIf   
        Next
        ExitProc
    EndIf   
    
    If bGradient = 1 Then
        wTftTemp2_Rectangle = wY_3 - wY_1
        TftSetGradient(wStartColor, wEndColor, wTftTemp2_Rectangle)
        wTftCounter2_Rectangle = 0
        wTftTemp7_Rectangle = wY_1
        
        TftPixelRatio(bRadius)
        bTftTemp3_Rectangle = dwTftdwPixelRatio.Byte0
        bTftTemp4_Rectangle = dwTftdwPixelRatio.Byte1
        wTftTemp6_Rectangle = dwTftdwPixelRatio.Word1
        
        For wTftCounter1_Rectangle = wTftTemp6_Rectangle DownTo 0 Step -bTftTemp3_Rectangle
            GoSub TftRectangleRG1
            
            If wY_1 + bRadius - swTftTemp2_Rectangle > wTftTemp7_Rectangle Then
                TftLineHN(wX_1 + bRadius - swTftTemp1_Rectangle, wX_3 - bRadius + swTftTemp1_Rectangle, wTftTemp7_Rectangle, TftBuildGradient(wTftCounter2_Rectangle))
                wTftTemp7_Rectangle = wY_1 + bRadius - swTftTemp2_Rectangle
                Inc wTftCounter2_Rectangle
            EndIf
        Next
        
        For wTftCounter1_Rectangle = wTftTemp7_Rectangle To wY_3 - bRadius
            TftLineHN(wX_1, wX_3, wTftCounter1_Rectangle, TftBuildGradient(wTftCounter2_Rectangle))
            Inc wTftCounter2_Rectangle
        Next
        
        wTftTemp7_Rectangle = wY_3 - bRadius
        For wTftCounter1_Rectangle = 0 To wTftTemp6_Rectangle Step bTftTemp3_Rectangle 
            GoSub TftRectangleRG1
            
            If wY_3 - bRadius + swTftTemp2_Rectangle > wTftTemp7_Rectangle Then
                TftLineHN(wX_1 + bRadius - swTftTemp1_Rectangle, wX_3 - bRadius + swTftTemp1_Rectangle, wTftTemp7_Rectangle, TftBuildGradient(wTftCounter2_Rectangle))
                wTftTemp7_Rectangle = wY_3 - bRadius + swTftTemp2_Rectangle
                Inc wTftCounter2_Rectangle
            EndIf   
        Next
        ExitProc
    EndIf
    
    If bGradient = 2 Then 
        wTftTemp7_Rectangle = (wX_3 - wX_1) / 2  
        wTftTemp6_Rectangle = (wY_3 - wY_1) / 2  
        fTftTemp3_Rectangle = wTftTemp7_Rectangle * wTftTemp7_Rectangle
        fTftTemp4_Rectangle = wTftTemp6_Rectangle * wTftTemp6_Rectangle
        fTftTemp5_Rectangle = fTftTemp3_Rectangle + fTftTemp4_Rectangle
        fTftTemp3_Rectangle = Sqr(fTftTemp5_Rectangle)   
        wTftTemp7_Rectangle = (wX_3 + wX_1) / 2 
        wTftTemp6_Rectangle = (wY_3 + wY_1) / 2 
        TftSetGradient(wStartColor, wEndColor, 100)
        swTftTemp1_Rectangle = bTftRedEnd_Helper - bTftRedStart_Helper
        swTftTemp2_Rectangle = bTftGreenEnd_Helper - bTftGreenStart_Helper
        swTftTemp3_Rectangle = bTftBlueEnd_Helper - bTftBlueStart_Helper
        
        For wTftCounter1_Rectangle = wY_1 To wY_3 
            For wTftCounter2_Rectangle = wX_1 To wX_3 
                GoSub TftRectangleRG2
                If pTestBit1 = 1 Then
                    swTftTemp4_Rectangle = wTftCounter2_Rectangle - wTftTemp7_Rectangle
                    swTftTemp5_Rectangle = wTftCounter1_Rectangle - wTftTemp6_Rectangle
                    fTftTemp4_Rectangle = swTftTemp4_Rectangle * swTftTemp4_Rectangle
                    fTftTemp5_Rectangle = swTftTemp5_Rectangle * swTftTemp5_Rectangle 
                    fTftTemp6_Rectangle = Sqr(fTftTemp4_Rectangle + fTftTemp5_Rectangle)
                    fTftTemp4_Rectangle = fTftTemp6_Rectangle / fTftTemp3_Rectangle
                    If fTftTemp4_Rectangle > 1 Then fTftTemp4_Rectangle = 1
                    TftPixel(wTftCounter2_Rectangle, wTftCounter1_Rectangle, TftPixelGradient(swTftTemp1_Rectangle, swTftTemp2_Rectangle, swTftTemp3_Rectangle, fTftTemp4_Rectangle))
                EndIf 
            Next 
        Next   
    EndIf
    
    ExitProc
TftRectangleRG1:
    fTftTemp3_Rectangle = wTftCounter1_Rectangle * 0.0174533 
    fTftTemp3_Rectangle = fTftTemp3_Rectangle / bTftTemp4_Rectangle
    fTftTemp4_Rectangle = Cos(fTftTemp3_Rectangle)
    fTftTemp4_Rectangle = fTftTemp4_Rectangle * bRadius
    swTftTemp1_Rectangle = fRound(fTftTemp4_Rectangle)
    fTftTemp4_Rectangle = Sin(fTftTemp3_Rectangle)
    fTftTemp4_Rectangle = fTftTemp4_Rectangle * bRadius
    swTftTemp2_Rectangle = fRound(fTftTemp4_Rectangle)    
    Return
TftRectangleRG2:
    If wTftCounter2_Rectangle < wX_1 + bRadius And wTftCounter1_Rectangle < wY_1 + bRadius Then ' Bottom-left corner
        dwTftTemp3_Rectangle = (wTftCounter2_Rectangle - wX_1 - bRadius) * (wTftCounter2_Rectangle - wX_1 - bRadius)
        dwTftTemp1_Rectangle = (wTftCounter1_Rectangle - wY_1 - bRadius) * (wTftCounter1_Rectangle - wY_1 - bRadius)
        dwTftTemp2_Rectangle = dwTftTemp3_Rectangle + dwTftTemp1_Rectangle
        dwTftTemp3_Rectangle = bRadius * bRadius + 4
        If dwTftTemp2_Rectangle > dwTftTemp3_Rectangle Then
            pTestBit1 = 0
        Else
            pTestBit1 = 1
        EndIf  
    Else If wTftCounter2_Rectangle > wX_3 - bRadius And wTftCounter1_Rectangle < wY_1 + bRadius Then ' Bottom-right corner
        dwTftTemp3_Rectangle = (wTftCounter2_Rectangle - wX_3 + bRadius) * (wTftCounter2_Rectangle - wX_3 + bRadius)
        dwTftTemp1_Rectangle = (wTftCounter1_Rectangle - wY_1 - bRadius) * (wTftCounter1_Rectangle - wY_1 - bRadius)
        dwTftTemp2_Rectangle = dwTftTemp3_Rectangle + dwTftTemp1_Rectangle
        dwTftTemp3_Rectangle = bRadius * bRadius + 4
        If dwTftTemp2_Rectangle > dwTftTemp3_Rectangle Then
            pTestBit1 = 0
        Else
            pTestBit1 = 1
        EndIf 
    Else If wTftCounter2_Rectangle > wX_3 - bRadius And wTftCounter1_Rectangle > wY_3 - bRadius Then ' Top-right corner
        dwTftTemp3_Rectangle = (wTftCounter2_Rectangle - wX_3 + bRadius) * (wTftCounter2_Rectangle - wX_3 + bRadius)
        dwTftTemp1_Rectangle = (wTftCounter1_Rectangle - wY_3 + bRadius) * (wTftCounter1_Rectangle - wY_3 + bRadius)
        dwTftTemp2_Rectangle = dwTftTemp3_Rectangle + dwTftTemp1_Rectangle
        dwTftTemp3_Rectangle = bRadius * bRadius + 4
        If dwTftTemp2_Rectangle > dwTftTemp3_Rectangle Then
            pTestBit1 = 0
        Else
            pTestBit1 = 1
        EndIf 
    Else If wTftCounter2_Rectangle < wX_1 + bRadius And wTftCounter1_Rectangle > wY_3 - bRadius Then ' Top-left corner
        dwTftTemp3_Rectangle = (wTftCounter2_Rectangle - wX_1 - bRadius) * (wTftCounter2_Rectangle - wX_1 - bRadius)
        dwTftTemp1_Rectangle = (wTftCounter1_Rectangle - wY_3 + bRadius) * (wTftCounter1_Rectangle - wY_3 + bRadius)
        dwTftTemp2_Rectangle = dwTftTemp3_Rectangle + dwTftTemp1_Rectangle
        dwTftTemp3_Rectangle = bRadius * bRadius + 4
        If dwTftTemp2_Rectangle > dwTftTemp3_Rectangle Then
            pTestBit1 = 0
        Else
            pTestBit1 = 1
        EndIf 
    Else
        pTestBit1 = 1
    EndIf 
    Return    
EndProc

Proc _____TFT_LINE____()
EndProc

$if McuType = 0
Dim fTftTemp1_Line As Float         At sTftString#0
Dim fTftTemp2_Line As Float         At sTftString#4
Dim fTftTemp3_Line As Float         At sTftString#8
Dim wTftTemp1_Line As Word          At sTftString#12	
Dim wTftTemp2_Line As Word          At sTftString#14	
Dim fVectorY_Line As Float          At sTftString#16
Dim fVectorX_Line As Float          At sTftString#20
Dim dwTftTemp1_Line As Dword        At sTftString#24
Dim wTftCounter1_Line As Word       At sTftString#28
Dim swTftTemp4_Line As SWord        At sTftString#28	
Dim bTftCounter1_Line As Byte       At sTftString#30
Dim dwTftTemp2_Line As Dword        At sTftString#32
Dim swTftTemp1_Line As SWord        At sTftString#36	
Dim swTftTemp2_Line As SWord        At sTftString#38    
Dim fTftTemp4_Line As Float         At sTftString#40
Dim wTftTemp3_Line As Word          At sTftString#44
Dim swTftTemp3_Line As SWord        At sTftString#44	
Dim fTftTemp5_Line As Float         At sTftString#46
Dim fTftTemp6_Line As Float         At sTftString#50
$else
Dim fTftTemp1_Line As Float         At sTftString_0
Dim fTftTemp2_Line As Float         At sTftString_4
Dim fTftTemp3_Line As Float         At sTftString_8
Dim wTftTemp1_Line As Word          At sTftString_12	
Dim wTftTemp2_Line As Word          At sTftString_14	
Dim fVectorY_Line As Float          At sTftString_16
Dim fVectorX_Line As Float          At sTftString_20
Dim dwTftTemp1_Line As Dword        At sTftString_24
Dim wTftCounter1_Line As Word       At sTftString_28
Dim swTftTemp4_Line As SWord        At sTftString_28	
Dim bTftCounter1_Line As Byte       At sTftString_30
Dim dwTftTemp2_Line As Dword        At sTftString_32
Dim swTftTemp1_Line As SWord        At sTftString_36	
Dim swTftTemp2_Line As SWord        At sTftString_38    
Dim fTftTemp4_Line As Float         At sTftString_40
Dim wTftTemp3_Line As Word          At sTftString_44
Dim swTftTemp3_Line As SWord        At sTftString_44	
Dim fTftTemp5_Line As Float         At sTftString_46
Dim fTftTemp6_Line As Float         At sTftString_50
$endif

'Print a line with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the line direction:
'   Horizontal line: -1 = Expand Under ; 1 = Expand Over ; Else = Ignored (no additional width) 
'   Vertical line: -1 = Expand Left ; 1 = Expand Right ; Else = Ignored (no additional width) 
'   Diagonal line: -1 = Expand Left ; 1 = Expand Right ; Else = Ignored (no additional width) 
'Example: TftLine(10,5, 120,20, GREEN, 2, -1) -->
'Print line Start point:(10,5) ; End point:(120,20) ; Color:GREEN ; 2+1=3 pixel wide ; -1=additional pixels are under the line 

Proc TftLine(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If bWidth = 0 Then bWidth = 1
    
    'Horizontal Line
    If wY_Start = wY_Stop Then                    
        If bWidth = 1 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftLineHN(wX_Start, wX_Stop, wY_Start, wColor)
            ExitProc
        EndIf
        If sbDirection = 1 Then
            TftLineHTU(wX_Start, wX_Stop, wY_Start, wColor, bWidth)
            ExitProc
        EndIf  
        If sbDirection = -1 Then
            TftLineHTD(wX_Start, wX_Stop, wY_Start, wColor, bWidth)
            ExitProc
        EndIf
    EndIf        
    
    'Vertical Line    
    If wX_Start = wX_Stop Then               
        If bWidth = 1 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
            TftLineVN(wX_Start, wY_Start, wY_Stop, wColor)
            ExitProc
        EndIf
        If sbDirection = 1 Then
            TftLineVTR(wX_Start, wY_Start, wY_Stop, wColor, bWidth)
            ExitProc
        EndIf  
        If sbDirection = -1 Then
            TftLineVTL(wX_Start, wY_Start, wY_Stop, wColor, bWidth)
            ExitProc
        EndIf 
    EndIf
    
    'Diagonal Line
    If bWidth = 1 Then
        TftLineDN(wX_Start,wY_Start, wX_Stop,wY_Stop, wColor)
    Else
        TftLineDT(wX_Start,wY_Start, wX_Stop,wY_Stop, wColor, bWidth, sbDirection)
    EndIf
EndProc

'Print 1 pixel thick Horizontal line with parameters:
'wX_Start = X start coordinate
'wX_Stop = X stop coordinate
'wY_Common = Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftLineHN(10,120,5, GREEN) -->
'Print Horizontal line Start point:(10,5) ; End point:(120,5) ; Color:GREEN  

Proc TftLineHN(wX_Start As Word, wX_Stop As Word, wY_Common As Word, wColor As Word)
    Global Dim wTftCounter2_Line As Word Shared
    
    If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop
    
    $if TftPixelCheck = 1
        If wX_Start < TftScreenWidth And wY_Common < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_Stop >= TftScreenWidth Then 
                wX_Stop = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_Start, wX_Stop, wY_Common, wY_Common)     
        Else
            pOutOfScreen = 1
            ExitProc                                   
        EndIf
    $else
        TftSetWindow(wX_Start, wX_Stop, wY_Common, wY_Common)
    $endif
    TftInitiateDataRam()
    For wTftCounter2_Line = 0 To wX_Stop - wX_Start 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()
EndProc     

'Print Horizontal line expanded upwards with parameters:
'wX_Start = X start coordinate
'wX_Stop = X stop coordinate
'wY_Common = Y coordinate
'wColor = 16b color in 565 RGB format 
'Width = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'Example: TftLineHTU(10,120,5, GREEN, 2) -->
'Print Horizontal line Start point:(10,5) ; End point:(120,5) ; Color:GREEN, 2+1=3 Pixels thick, expanded upwards 

Proc TftLineHTU(wX_Start As Word, wX_Stop As Word, wY_Common As Word, wColor As Word, bWidth As Byte)
    If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop
    
    $if TftPixelCheck = 1
        If wX_Start < TftScreenWidth And wY_Common < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_Stop >= TftScreenWidth Then 
                wX_Stop = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            wTempVertical = wY_Common + bWidth
            If wTempVertical >= TftScreenHeight Then 
                wTempVertical = TftScreenHeight - 1 
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_Start, wX_Stop, wY_Common, wTempVertical)     
        Else
            pOutOfScreen = 1
            ExitProc                        
        EndIf
    $else
        TftSetWindow(wX_Start, wX_Stop, wY_Common, wY_Common + bWidth)
    $endif
    TftInitiateDataRam()
    For wTftCounter1_Line = 0 To (wX_Stop - wX_Start) * (bWidth + 1) + bWidth 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor) 
        $endif
    Next
    TftStopDataRam()
EndProc


'Print Horizontal line expanded downwards with parameters:
'wX_Start = X start coordinate
'wX_Stop = X stop coordinate
'wY_Common = Y coordinate
'wColor = 16b color in 565 RGB format 
'Width = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'Example: TftLineHTD(10,120,5, GREEN, 2) -->
'Print Horizontal line Start point:(10,5) ; End point:(120,5) ; Color:GREEN ; 2+1=3 Pixels thick, expanded downwards 

Proc TftLineHTD(wX_Start As Word, wX_Stop As Word, wY_Common As Word, wColor As Word, bWidth As Byte)
    If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop
    
    $if TftPixelCheck = 1
        wTempVertical = wY_Common - bWidth
        If wX_Start < TftScreenWidth And wTempVertical < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_Stop >= TftScreenWidth Then 
                wX_Stop = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            If wY_Common >= TftScreenHeight Then 
                wY_Common = TftScreenHeight - 1 
                pOutOfScreen = 1
            EndIf 
            TftSetWindow(wX_Start, wX_Stop, wTempVertical, wY_Common) 
        Else
            pOutOfScreen = 1
            ExitProc                         
        EndIf
    $else
        TftSetWindow(wX_Start, wX_Stop, wY_Common - bWidth, wY_Common)
    $endif
    TftInitiateDataRam()
    For wTftCounter1_Line = 0 To (wX_Stop - wX_Start) * (bWidth + 1) + bWidth 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()
EndProc

'Print 1 pixel thick Vertical line with parameters:
'wX_Common = X coordinate
'wY_Start = Y start coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftLineVN(10,5,100, GREEN) -->
'Print Vertical line Start point:(10,5) ; End point:(10,100) ; Color:GREEN  

Proc TftLineVN(wX_Common As Word, wY_Start As Word, wY_Stop As Word, wColor As Word)
    Global Dim wTftCounter2_Line As Word Shared
    
    If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
    
    $if TftPixelCheck = 1
        If wX_Common < TftScreenWidth And wY_Start < TftScreenHeight Then
            pOutOfScreen = 0
            If wY_Stop >= TftScreenHeight Then 
                wY_Stop = TftScreenHeight - 1
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_Common, wX_Common, wY_Start, wY_Stop)  
        Else
            pOutOfScreen = 1
            ExitProc                            
        EndIf
    $else
         TftSetWindow(wX_Common, wX_Common, wY_Start, wY_Stop)
    $endif
    TftInitiateDataRam()
    For wTftCounter2_Line = 0 To wY_Stop - wY_Start
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()
EndProc

'Print Vertical line expanded left with parameters:
'wX_Common = X coordinate
'wY_Start = Y start coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'Example: TftLineVTL(10,5,100, GREEN, 2) -->
'Print Vertical line Start point:(10,5) ; End point:(10,100) ; Color:GREEN ; 2+1=3 Pixels thick, expanded left  

Proc TftLineVTL(wX_Common As Word, wY_Start As Word, wY_Stop As Word, wColor As Word, bWidth As Byte)
    If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
    
    $if TftPixelCheck = 1
        wTempHorizontal = wX_Common - bWidth
        If wTempHorizontal < TftScreenWidth And wY_Start < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_Common >= TftScreenWidth Then 
                wX_Common = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            If wY_Stop >= TftScreenHeight Then 
                wY_Stop = TftScreenHeight - 1
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wTempHorizontal, wX_Common, wY_Start, wY_Stop)    
        Else
            pOutOfScreen = 1
            ExitProc                        
        EndIf
    $else
        TftSetWindow(wX_Common - bWidth, wX_Common, wY_Start, wY_Stop)
    $endif
    TftInitiateDataRam()
    For wTftCounter1_Line = 0 To (wY_Stop - wY_Start) * (bWidth + 1) + bWidth 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()
EndProc

'Print Vertical line expanded right with parameters:
'wX_Common = X coordinate
'wY_Start = Y start coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'Example: TftLineVTR(10,5,100, GREEN, 2) -->
'Print Vertical line Start point:(10,5) ; End point:(10,100) ; Color:GREEN ; 2+1=3 Pixels thick, expanded right  

Proc TftLineVTR(wX_Common As Word, wY_Start As Word, wY_Stop As Word, wColor As Word, bWidth As Byte)
    If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
    
    $if TftPixelCheck = 1
        If wX_Common < TftScreenWidth And wY_Start < TftScreenHeight Then
            pOutOfScreen = 0
            wTempHorizontal = wX_Common + bWidth
            If wTempHorizontal >= TftScreenWidth Then 
                wTempHorizontal = TftScreenWidth - 1  
                pOutOfScreen = 1
            EndIf
            TftSetWindow(wX_Common, wTempHorizontal, wY_Start, wY_Stop)
        Else
            pOutOfScreen = 1
            ExitProc                             
        EndIf
    $else
        TftSetWindow(wX_Common, wX_Common + bWidth, wY_Start, wY_Stop)
    $endif
     TftInitiateDataRam()
    For wTftCounter1_Line = 0 To (wY_Stop - wY_Start) * (bWidth + 1) + bWidth 
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)  
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wColor)
        $endif
    Next
    TftStopDataRam()
EndProc

'Print 1 pixel thick Diagonal line with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftLineDN(10,5, 120,50, GREEN) -->
'Print Diagonal line Start point:(10,5) ; End point:(120,50) ; Color:GREEN 

Proc TftLineDN(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wColor As Word)
    If Abs(wX_Stop - wX_Start) > Abs(wY_Stop - wY_Start) Then
        fTftTemp1_Line = (wY_Stop - wY_Start) / (wX_Stop - wX_Start)
        fTftTemp2_Line = wY_Start - (fTftTemp1_Line * wX_Start)
        If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop   
        
        For wTftCounter1_Line = wX_Start To wX_Stop 
            fTftTemp3_Line = (fTftTemp1_Line * wTftCounter1_Line) + fTftTemp2_Line
            wTftTemp1_Line = fRound(fTftTemp3_Line)
            TftPixel(wTftCounter1_Line, wTftTemp1_Line, wColor)
        Next
    Else
        fTftTemp1_Line = (wX_Stop - wX_Start) / (wY_Stop - wY_Start)
        fTftTemp2_Line = wX_Start - (fTftTemp1_Line * wY_Start)
        If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
        
        For wTftCounter1_Line = wY_Start To wY_Stop
            fTftTemp3_Line = (fTftTemp1_Line * wTftCounter1_Line) + fTftTemp2_Line
            wTftTemp1_Line = fRound(fTftTemp3_Line)
            TftPixel(wTftTemp1_Line, wTftCounter1_Line, wColor)
        Next
    EndIf
EndProc

'Print 1 pixel thick Diagonal line using fast algorithm with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftLineDNF(10,5, 120,50, GREEN) -->
'Print Diagonal line Start point:(10,5) ; End point:(120,50) ; Color:GREEN 

Proc TftLineDNF(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wColor As Word)
    Dim wTftTemp1_Line As Word
    Dim wTftTemp2_Line As Word
    Dim swTftTemp1_Line As SWord
    Dim swTftTemp2_Line As SWord
    Dim swTftTemp3_Line As SWord
    Dim swTftTemp4_Line As SWord
    
    wTftTemp1_Line = Abs(wX_Stop.SWord - wX_Start.SWord) 
    If wX_Start < wX_Stop Then
        swTftTemp1_Line = 1
    Else
        swTftTemp1_Line = -1
    EndIf
    
    wTftTemp2_Line = -Abs(wY_Stop.SWord - wY_Start.SWord) 
    If wY_Start < wY_Stop Then
        swTftTemp2_Line = 1
    Else
        swTftTemp2_Line = -1
    EndIf
    
    swTftTemp3_Line = wTftTemp1_Line + wTftTemp2_Line
   
    While 1 = 1
        TftPixel(wX_Start, wY_Start, wColor)
        If wX_Start = wX_Stop And wY_Start = wY_Stop Then Break
        swTftTemp4_Line = 2 * swTftTemp3_Line
        If swTftTemp4_Line >= wTftTemp2_Line Then
            If wX_Start = wX_Stop Then Break
            swTftTemp3_Line = swTftTemp3_Line + wTftTemp2_Line
            wX_Start = wX_Start + swTftTemp1_Line
        EndIf
        If swTftTemp4_Line <= wTftTemp1_Line Then
            If wY_Start = wY_Stop Then Break
            swTftTemp3_Line = swTftTemp3_Line + wTftTemp1_Line
            wY_Start = wY_Start + swTftTemp2_Line
        EndIf
    Wend
EndProc

'Print thick Diagonal line with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wColor = 16b color in 565 RGB format 
'bWidth = line additional width in pixels, 0 = no additional width i.e. 1 pixel wide
'sbDirection = pixel position to form the additional width with respect the line direction: 
'            -1 = Expand Left ; 1 = Expand Right ; Else = Ignored (no additional width) 
'Example: TftLineDT(10,5, 120,50, GREEN, 2, -1) -->
'Print Diagonal line Start point:(10,5) ; End point:(120,50) ; Color:GREEN ; 2+1=3 Pixels thick, expanded 
   
Proc TftLineDT(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wColor As Word, bWidth As Byte, sbDirection As SByte)
    If bWidth = 0 Or sbDirection > 1 Or sbDirection < -1 Or sbDirection = 0 Then
        TftLineDN(wX_Start,wY_Start, wX_Stop,wY_Stop, wColor)
        ExitProc
    EndIf
    
    swTftTemp1_Line = wX_Stop - wX_Start
    swTftTemp2_Line = wY_Stop - wY_Start
    dwTftTemp1_Line = swTftTemp1_Line * swTftTemp1_Line   
    dwTftTemp2_Line = swTftTemp2_Line * swTftTemp2_Line 
    dwTftTemp1_Line = dwTftTemp1_Line + dwTftTemp2_Line
    fTftTemp4_Line = Sqr(dwTftTemp1_Line)
    fVectorX_Line = swTftTemp1_Line / fTftTemp4_Line
    fVectorY_Line = swTftTemp2_Line / fTftTemp4_Line
    
    If sbDirection = -1 Then
        fVectorY_Line = -fVectorY_Line
    Else  
        fVectorX_Line = -fVectorX_Line  
    EndIf  
    
    fTftTemp4_Line = bWidth * fVectorY_Line  
    swTftTemp1_Line = fRound(fTftTemp4_Line)  
    fTftTemp4_Line = bWidth * fVectorX_Line 
    swTftTemp2_Line = fRound(fTftTemp4_Line)  
    TftLineDN(wX_Start + swTftTemp1_Line, wY_Start + swTftTemp2_Line, wX_Stop + swTftTemp1_Line, wY_Stop + swTftTemp2_Line, wColor)
    TftQuadS(wX_Start, wY_Start, wX_Start + swTftTemp1_Line, wY_Start + swTftTemp2_Line, wX_Stop + swTftTemp1_Line, wY_Stop + swTftTemp2_Line, wX_Stop, wY_Stop, wColor) 
EndProc

'Print 1 pixel thick Horizontal line in gradient color with parameters:
'wX_Start = X start coordinate
'wX_Stop = X stop coordinate
'wY_Common = Y coordinate
'wStartColor = Start Gradient Color - 16b color in 565 RGB format 
'wEndColor = End Gradient Color - 16b color in 565 RGB format 
'Example: TftLineHNG(10,120,5, GREEN,RED) -->
'Print Horizontal line Start point:(10,5) ; End point:(120,5) ; Gradient Color: Green to Red 

Proc TftLineHNG(wX_Start As Word, wX_Stop As Word, wY_Common As Word, wStartColor As Word, wEndColor As Word)
    If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop
    
    $if TftPixelCheck = 1
        If wX_Start < TftScreenWidth And wY_Common < TftScreenHeight Then
            pOutOfScreen = 0
            If wX_Stop >= TftScreenWidth Then 
                wX_Stop = TftScreenWidth - 1
                pOutOfScreen = 1
            EndIf
            TftSetGradient(wStartColor, wEndColor, wX_Stop - wX_Start)
            TftSetWindow(wX_Start, wX_Stop, wY_Common, wY_Common)
        Else
            pOutOfScreen = 1
            ExitProc                               
        EndIf
    $else
        TftSetGradient(wStartColor, wEndColor, wX_Stop - wX_Start)
        TftSetWindow(wX_Start, wX_Stop, wY_Common, wY_Common)
    $endif
    TftInitiateDataRam()
    For wTftCounter1_Line = 0 To wX_Stop - wX_Start 
        wTftTempGradientColor_Helper = TftBuildGradient(wTftCounter1_Line)
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wTftTempGradientColor_Helper) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wTftTempGradientColor_Helper.Byte1)
                TftSend(wTftTempGradientColor_Helper.Byte0) 
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wTftTempGradientColor_Helper)
        $endif
    Next
    TftStopDataRam()
EndProc 

'Print 1 pixel thick Vertical line in gradient color with parameters:
'wX_Common = X coordinate
'wY_Start = Y start coordinate
'wY_Stop = Y stop coordinate
'wStartColor = Start Gradient Color - 16b color in 565 RGB format 
'wEndColor = End Gradient Color - 16b color in 565 RGB format 
'Example: TftLineVNG(10,5,100, GREEN,RED) -->
'Print Vertical line Start point:(10,5) ; End point:(10,100) ; Gradient Color: GREEN To RED

Proc TftLineVNG(wX_Common As Word, wY_Start As Word, wY_Stop As Word, wStartColor As Word, wEndColor As Word)
    If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
    
    $if TftPixelCheck = 1
        If wX_Common < TftScreenWidth And wY_Start < TftScreenHeight Then
            pOutOfScreen = 0
            If wY_Stop >= TftScreenHeight Then 
                wY_Stop = TftScreenHeight - 1
                pOutOfScreen = 1
            EndIf
            TftSetGradient(wStartColor, wEndColor, wY_Stop - wY_Start)
            TftSetWindow(wX_Common, wX_Common, wY_Start, wY_Stop)
        Else
            pOutOfScreen = 1
            ExitProc                         
        EndIf
    $else
        TftSetGradient(wStartColor, wEndColor, wY_Stop - wY_Start)
        TftSetWindow(wX_Common, wX_Common, wY_Start, wY_Stop)
    $endif
    TftInitiateDataRam()
    For wTftCounter1_Line = 0 To wY_Stop - wY_Start
        wTftTempGradientColor_Helper = TftBuildGradient(wTftCounter1_Line)
        $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wTftTempGradientColor_Helper) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wTftTempGradientColor_Helper.Byte1)
                TftSend(wTftTempGradientColor_Helper.Byte0) 
            $endif
        $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
            TftSend(wTftTempGradientColor_Helper)
        $endif
    Next
    TftStopDataRam()
EndProc

'Print 1 pixel thick Diagonal line in gradient color with parameters:
'wX_Start = X start coordinate
'wY_Start = Y start coordinate
'wX_Stop = X stop coordinate
'wY_Stop = Y stop coordinate
'wStartColor = Start Gradient Color - 16b color in 565 RGB format 
'wEndColor = End Gradient Color - 16b color in 565 RGB format 
'Example: TftLineDNG(10,5, 120,50, GREEN, BLUE) -->
'Print Diagonal line Start point:(10,5) ; End point:(120,50) ; Gradient Color: GREEN to BLUE

Proc TftLineDNG(wX_Start As Word, wY_Start As Word, wX_Stop As Word, wY_Stop As Word, wStartColor As Word, wEndColor As Word)
    swTftTemp1_Line = wX_Stop - wX_Start
    swTftTemp2_Line = wY_Stop - wY_Start
    If Abs(swTftTemp1_Line) > Abs(swTftTemp2_Line) Then
        fTftTemp4_Line = swTftTemp2_Line / swTftTemp1_Line
        fTftTemp3_Line = fTftTemp4_Line * wX_Start
        fTftTemp5_Line = wY_Start - fTftTemp3_Line
        If wX_Start > wX_Stop Then Swap wX_Start, wX_Stop   
        
        TftSetGradient(wStartColor, wEndColor, wX_Stop - wX_Start)
        For wTftCounter1_Line = wX_Start To wX_Stop 
            fTftTemp6_Line = fTftTemp4_Line * wTftCounter1_Line + fTftTemp5_Line
            wTftTemp3_Line = fRound(fTftTemp6_Line)
            wTftTempGradientColor_Helper = TftBuildGradient(wTftCounter1_Line - wX_Start)
            TftPixel(wTftCounter1_Line, wTftTemp3_Line, wTftTempGradientColor_Helper)
        Next
    Else
        fTftTemp4_Line = swTftTemp1_Line / swTftTemp2_Line
        fTftTemp3_Line = fTftTemp4_Line * wY_Start
        fTftTemp5_Line = wX_Start - fTftTemp3_Line
        If wY_Start > wY_Stop Then Swap wY_Start, wY_Stop
        
        TftSetGradient(wStartColor, wEndColor, wY_Stop - wY_Start)
        For wTftCounter1_Line = wY_Start To wY_Stop
            fTftTemp6_Line = fTftTemp1_Line * wTftCounter1_Line + fTftTemp5_Line
            wTftTemp3_Line = fRound(fTftTemp6_Line)
            wTftTempGradientColor_Helper = TftBuildGradient(wTftCounter1_Line - wY_Start)
            TftPixel(wTftTemp3_Line, wTftCounter1_Line, wTftTempGradientColor_Helper)
        Next
    EndIf
EndProc

Proc _____TFT_SHAPES_HELPER_____()
EndProc  

$if McuType = 0
Dim bTftRedStart_Helper As Byte             At sTftString#0
Dim bTftRedEnd_Helper As Byte               At sTftString#1
Dim bTftGreenStart_Helper As Byte           At sTftString#2
Dim bTftGreenEnd_Helper As Byte             At sTftString#3
Dim bTftBlueStart_Helper As Byte            At sTftString#4
Dim bTftBlueEnd_Helper As Byte              At sTftString#5  
Dim fTftGradientRed_Helper As Float         At sTftString#6    
Dim fTftGradientGreen_Helper As Float       At sTftString#10      
Dim fTftGradientBlue_Helper As Float        At sTftString#14
Dim fTftTempGradient_Helper As Float        At sTftString#18
Dim swTftTempGradient_Helper As Word        At sTftString#22
Dim wTftTempGradientColor_Helper As Word    At sTftString#22
Dim bTftTempGradient_Helper As Byte         At sTftString#24
$else
Dim bTftRedStart_Helper As Byte             At sTftString_0
Dim bTftRedEnd_Helper As Byte               At sTftString_1
Dim bTftGreenStart_Helper As Byte           At sTftString_2
Dim bTftGreenEnd_Helper As Byte             At sTftString_3
Dim bTftBlueStart_Helper As Byte            At sTftString_4
Dim bTftBlueEnd_Helper As Byte              At sTftString_5  
Dim fTftGradientRed_Helper As Float         At sTftString_6    
Dim fTftGradientGreen_Helper As Float       At sTftString_10      
Dim fTftGradientBlue_Helper As Float        At sTftString_14
Dim fTftTempGradient_Helper As Float        At sTftString_18
Dim swTftTempGradient_Helper As Word        At sTftString_22
Dim wTftTempGradientColor_Helper As Word    At sTftString_22
Dim bTftTempGradient_Helper As Byte         At sTftString_24
$endif


'Breaks RGB565 to 5-bit Red, 6-bit Green, 5-bit Blue components and calculates coefficients for the gradient 

Proc TftSetGradient(wStartColor As Word, wEndColor As Word, wSteps As Word)
    'Blue
    bTftTempGradient_Helper = wStartColor.Byte0
    bTftTempGradient_Helper = bTftTempGradient_Helper << 3
    bTftBlueStart_Helper = bTftTempGradient_Helper >> 3
    bTftTempGradient_Helper = wEndColor.Byte0
    bTftTempGradient_Helper = bTftTempGradient_Helper << 3
    bTftBlueEnd_Helper = bTftTempGradient_Helper >> 3
    'Green
    swTftTempGradient_Helper =  wStartColor << 5
    bTftGreenStart_Helper = swTftTempGradient_Helper >> 10
    swTftTempGradient_Helper =  wEndColor << 5
    bTftGreenEnd_Helper = swTftTempGradient_Helper >> 10
    'Red
    bTftRedStart_Helper = wStartColor >> 11
    bTftRedEnd_Helper = wEndColor >> 11
    
    fTftTempGradient_Helper = bTftRedStart_Helper
    fTftGradientRed_Helper = (bTftRedEnd_Helper - fTftTempGradient_Helper) / wSteps
    fTftTempGradient_Helper = bTftGreenStart_Helper
    fTftGradientGreen_Helper = (bTftGreenEnd_Helper - fTftTempGradient_Helper) / wSteps
    fTftTempGradient_Helper = bTftBlueStart_Helper
    fTftGradientBlue_Helper = (bTftBlueEnd_Helper - fTftTempGradient_Helper) / wSteps
EndProc

'Build RGB565 color from 5-Bit RED, 6-Bit GREEN, 5-Bit BLUE components for the gradient

Proc TftBuildGradient(wStep As Word), Word
    fTftTempGradient_Helper = wStep * fTftGradientRed_Helper
    fTftTempGradient_Helper = fTftTempGradient_Helper + bTftRedStart_Helper
    swTftTempGradient_Helper = fRound(fTftTempGradient_Helper)
    bTftRedEnd_Helper = Abs(swTftTempGradient_Helper)
    fTftTempGradient_Helper = wStep * fTftGradientGreen_Helper
    fTftTempGradient_Helper = fTftTempGradient_Helper + bTftGreenStart_Helper
    swTftTempGradient_Helper = fRound(fTftTempGradient_Helper)
    bTftGreenEnd_Helper = Abs(swTftTempGradient_Helper)
    fTftTempGradient_Helper = wStep * fTftGradientBlue_Helper
    fTftTempGradient_Helper = fTftTempGradient_Helper + bTftBlueStart_Helper
    swTftTempGradient_Helper = fRound(fTftTempGradient_Helper)
    bTftBlueEnd_Helper = Abs(swTftTempGradient_Helper)

    Result = bTftGreenEnd_Helper
    Result = Result << 5
    bTftRedEnd_Helper = bTftRedEnd_Helper << 3
    bTftTempGradient_Helper = Result.Byte1
    Result.Byte1 = bTftTempGradient_Helper | bTftRedEnd_Helper
    bTftTempGradient_Helper = Result.Byte0
    Result.Byte0 = bTftTempGradient_Helper | bTftBlueEnd_Helper
EndProc

'Pixel gradient helper function to spare code space

Proc TftPixelGradient(wRed As SWord, wGreen As SWord, wBlue As SWord, fDistance As Float), Word
    fTftGradientRed_Helper = fDistance * wRed
    fTftGradientRed_Helper = bTftRedStart_Helper + fTftGradientRed_Helper
    fTftGradientGreen_Helper = fDistance * wGreen
    fTftGradientGreen_Helper = bTftGreenStart_Helper + fTftGradientGreen_Helper
    fTftGradientBlue_Helper = fDistance * wBlue
    fTftGradientBlue_Helper = bTftBlueStart_Helper + fTftGradientBlue_Helper
                
    bTftTempGradient_Helper = fRound(fTftGradientGreen_Helper)
    swTftTempGradient_Helper = bTftTempGradient_Helper
    swTftTempGradient_Helper = swTftTempGradient_Helper << 5
    bTftTempGradient_Helper = fRound(fTftGradientRed_Helper)
    bTftTempGradient_Helper = bTftTempGradient_Helper <<3
    swTftTempGradient_Helper.Byte1 = swTftTempGradient_Helper.Byte1 | bTftTempGradient_Helper
    bTftTempGradient_Helper = fRound(fTftGradientBlue_Helper)
    swTftTempGradient_Helper.Byte0 = swTftTempGradient_Helper.Byte0 | bTftTempGradient_Helper
    Result = swTftTempGradient_Helper
EndProc

'Factor to keep trigonometry calculations 2 to 1 pixel

Proc TftPixelRatio(wRadius As Word)
    Select wRadius
        Case <= 30
            dwTftdwPixelRatio.Byte0 = 1
            dwTftdwPixelRatio.Byte1 = 1 
            dwTftdwPixelRatio.Word1 = 90 
        Case > 30 , <= 45
            dwTftdwPixelRatio.Byte0 = 1
            dwTftdwPixelRatio.Byte1 = 2 
            dwTftdwPixelRatio.Word1 = 180 
        Case > 45 , <= 60
            dwTftdwPixelRatio.Byte0 = 1
            dwTftdwPixelRatio.Byte1 = 3 
            dwTftdwPixelRatio.Word1 = 270       
        Case > 60 , <= 90
            dwTftdwPixelRatio.Byte0 = 1
            dwTftdwPixelRatio.Byte1 = 4 
            dwTftdwPixelRatio.Word1 = 360    
        Case > 90 
            dwTftdwPixelRatio.Byte0 = 1
            dwTftdwPixelRatio.Byte1 = 5 
            dwTftdwPixelRatio.Word1 = 450  
    EndSelect  
EndProc

'2-argument ArcTangent i.e. atan2

Proc TftArcTan2(fY As Float, fX As Float), Float
    If fX > 0 Then
        Result = ATan(fY / fX)
        ExitProc
    EndIf
    If fX < 0 And fY >= 0 Then
        Result = ATan(fY / fX)
        Result = Result + 3.14159265 
        ExitProc
    EndIf
    If fX < 0 And fY < 0 Then
        Result = ATan(fY / fX)
        Result = Result - 3.14159265 
        ExitProc
    EndIf
    If fX = 0 And fY > 0 Then
        Result = 1.570796325
        ExitProc
    EndIf
    If fX = 0 And fY < 0 Then
        Result = -1.570796325 
        ExitProc
    EndIf
    If fX = 0 And fY = 0 Then
        Result = 0
        ExitProc
    EndIf
EndProc 
