$if _xtal =< 64
    Symbol TftReadDelay = 1
$elseif _xtal > 64 And _xtal < 120
    Symbol TftReadDelay = 2   
$elseif _xtal >= 120 And _xtal < 160
    Symbol TftReadDelay = 4 
$elseif _xtal >= 160
    Symbol TftReadDelay = 6    
$endif
        


Proc _____TFT_BASIC____()
EndProc

$if McuType = 0
Dim dwTftCounter1_Basic As Dword       At sTftString#0 
Dim fTftTemp_Basic As Float            At sTftString#20
Dim wTftTemp_Basic As Word             At sTftString#24
Dim dTftTemp_Basic As Dword            At sTftString#26
Dim bTftRed_Basic As Byte              At sTftString#30  
Dim bTftGreen_Basic As Byte            At sTftString#31
Dim bTftBlue_Basic As Byte             At sTftString#32
$else
Dim dwTftCounter1_Basic As Dword       At sTftString_0
Dim fTftTemp_Basic As Float            At sTftString_20
Dim wTftTemp_Basic As Word             At sTftString_24
Dim dTftTemp_Basic As Dword            At sTftString_26
Dim bTftRed_Basic As Byte              At sTftString_30  
Dim bTftGreen_Basic As Byte            At sTftString_31
Dim bTftBlue_Basic As Byte             At sTftString_32
$endif

'Fill the screen with single color, creating the effect of screen reset with parameters:
'wColor = 16b color in 565 RGB format 
'Example: TftResetScreen(BLUE) --> 
'Fill screen with blue pixels

Proc TftResetScreen(wColor As Word)
    TftSetWindow(0,wTftScreenWidth - 1, 0,wTftScreenHeight - 1)
    TftInitiateDataRam()
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        For dwTftCounter1_Basic = 0 To wTftScreenWidth * wTftScreenHeight
            $if TFT_IC = ILI9488 
                Rgb16ToRgb18(wColor) 
                TftSend(dColor.Byte2)
                TftSend(dColor.Byte1)
                TftSend(dColor.Byte0)  
            $else
                TftSend(wColor.Byte1)
                TftSend(wColor.Byte0)
            $endif
        Next
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        For dwTftCounter1_Basic = 0 To wTftScreenWidth * wTftScreenHeight 
            $if McuType = 0
                TftDataHighByte = wColor.Byte1 
                TftDataLowByte = wColor.Byte0
            $else
                TftDataWord = wColor
            $endif
            PinClear TFT_WR : PinSet TFT_WR
        Next 
    $endif 
    TftStopDataRam()
EndProc

'Print a single pixel with parameters:
'wX_Pixel = X coordinate
'wY_Pixel = Y coordinate
'wColor = 16b color in 565 RGB format 
'Example: TftPixel(20,30, RED) --> 
'Print pixel at coordinates x=20 ; y=30 ; Color=RED 

Proc TftPixel(wX_Pixel As Word, wY_Pixel As Word, wColor As Word)
    $if TftPixelCheck = 1
        If wX_Pixel < TftScreenWidth And wY_Pixel < TftScreenHeight Then
            pOutOfScreen = 0
            TftSetWindow(wX_Pixel, wX_Pixel, wY_Pixel, wY_Pixel)      
        Else
            pOutOfScreen = 1
            ExitProc                                
        EndIf   
    $else
        TftSetWindow(wX_Pixel, wX_Pixel, wY_Pixel, wY_Pixel)   
    $endif
    TftInitiateDataRam()
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        $if TFT_IC = ILI9488 
            Rgb16ToRgb18(wColor) 
            TftSend(dColor.Byte2)
            TftSend(dColor.Byte1)
            TftSend(dColor.Byte0)  
        $else
            TftSend(wColor.Byte1)
            TftSend(wColor.Byte0)  
        $endif  
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        TftSend(wColor)
    $endif
    TftStopDataRam()
EndProc

'Read a single pixel from graphic memory
'wX_Pixel = X coordinate
'wY_Pixel = Y coordinate
'Result = 16b color in 565 RGB format 
'Example: TftReadPixel(20,30) --> 
'Read pixel at coordinates x=20 ; y=30 
Proc TftReadPixel(wX_Pixel As Word, wY_Pixel As Word), Word
    Result = 0
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        TftSetWindow(wX_Pixel, wX_Pixel, wY_Pixel, wY_Pixel)
        TftInitiateDataRamRead()
        TftReceive()
        bTftRed_Basic = TftReceive() >> 2 
        Result.Byte1 = TftReceive() >> 2
        bTftBlue_Basic = TftReceive() >> 2 
        TftStopDataRam()
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        TftSetWindow(wX_Pixel, wX_Pixel, wY_Pixel, wY_Pixel)
        TftInitiateDataRamRead()
        $if TFT_IC = ILI9486 
            TftReceive()
        $endif
        Result = TftReceive()
        TftStopDataRam()
    $endif
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW                
        bTftBlue_Basic = CRead8 Color6bTo5b[bTftBlue_Basic]
        bTftRed_Basic = CRead8 Color6bTo5b[bTftRed_Basic]
        Result = Result >> 3
        Result.Byte0 = Result.Byte0 | bTftBlue_Basic
        bTftRed_Basic = bTftRed_Basic << 3
        Result.Byte1 = Result.Byte1 | bTftRed_Basic 
    $endif
EndProc

Proc TftReadPixelSda(wX_Pixel As Word, wY_Pixel As Word), Word
    Result = 0
    
    Tft2bWriteCommand(0x3A, 0x06)
    TftSetWindow(wX_Pixel, wX_Pixel, wY_Pixel, wY_Pixel)
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(0x2E)
        PinSet TFT_DC
            $if TFT_COM = SPI_1  
                $if McuType = 0
                    SSP1CON1.5 = 0
                $else
                    SPI1STAT.15 = 0
                $endif
            $elseif TFT_COM = SPI_2 
                $if McuType = 0
                    SSP2CON1.5 = 0
                $else
                    SPI2STAT.15 = 0
                $endif
            $endif
            Input TFT_MOSI
            $if TFT_IC <> ST7789
                PinSet TFT_SCLK : PinClear TFT_SCLK 
            $endif
            TftReceiveSda()
            bTftRed_Basic = TftReceiveSda() >> 2 
            Result.Byte1 = TftReceiveSda() >> 2
            bTftBlue_Basic = TftReceiveSda() >> 2 
        PinSet TFT_CS 
        
        $if TFT_COM = SPI_1  
            $if McuType = 0
                SSP1CON1.5 = 1   
            $else
                SPI1STAT.15 = 1   
            $endif
        $elseif TFT_COM = SPI_2 
            $if McuType = 0
                SSP2CON1.5 = 1  
            $else
                SPI2STAT.15 = 1   
            $endif
        $endif
        Output TFT_MOSI
        Tft2bWriteCommand(0x3A, 0x05)
        bTftBlue_Basic = CRead8 Color6bTo5b[bTftBlue_Basic]
        bTftRed_Basic = CRead8 Color6bTo5b[bTftRed_Basic]
        Result = Result >> 3
        Result.Byte0 = Result.Byte0 | bTftBlue_Basic
        bTftRed_Basic = bTftRed_Basic << 3
        Result.Byte1 = Result.Byte1 | bTftRed_Basic 
    $endif
EndProc


Proc _____TFT_SYSTEM____()
EndProc

'Sends 1 Bytes write command --> Command

Proc Tft1bWriteCommand(bCommand As Byte)
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(bCommand)
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = bCommand  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_CS  
    $endif
EndProc

'Sends 2 Bytes write command --> Command, Parameter1

Proc Tft2bWriteCommand(bCommand As Byte, bParameter As Byte)
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(bCommand)
        PinSet TFT_DC
            TftSend(bParameter)
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = bCommand  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = bParameter  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_CS   
    $endif
EndProc

'Sends 3 Bytes write command --> Command, Parameter1, Parameter2

Proc Tft3bWriteCommand(bCommand As Byte, bParameter1 As Byte, bParameter2 As Byte)
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(bCommand)
        PinSet TFT_DC
            TftSend(bParameter1)
            TftSend(bParameter2)
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = bCommand  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = bParameter1  
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = bParameter2  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_CS         
    $endif
EndProc

'Sends 4 Bytes write command --> Command, Parameter1, Parameter2, Parameter3

Proc Tft4bWriteCommand(bCommand As Byte, bParameter1 As Byte, bParameter2 As Byte, bParameter3 As Byte)
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(bCommand)
        PinSet TFT_DC
            TftSend(bParameter1)
            TftSend(bParameter2)
            TftSend(bParameter3)
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = bCommand  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = bParameter1  
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = bParameter2  
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = bParameter2  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_CS 
    $endif
EndProc

'Start transfer to TFT graphic RAM

Proc TftInitiateDataRam()
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_DC
            TftSend(0x2C)
        PinSet TFT_DC
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_DC 
            TftDataLowByte = 0x2C  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
    $endif
EndProc

'Start transfer to TFT graphic RAM

Proc TftInitiateDataRamRead()
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_DC
            TftSend(0x2E)
        PinSet TFT_DC
    $elseif TFT_COM = PAR_2x8b 
        PinClear TFT_DC 
            TftDataLowByte = 0x2E 
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
    $elseif TFT_COM = PAR_16b
        PinClear TFT_DC 
            TftDataLowByte = 0x2E 
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
    $endif
EndProc

'Stop transfer to TFT module and execute

Proc TftStopDataRam()
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinSet TFT_CS
    $endif
EndProc

'Set Graphic RAM Window

Proc TftSetWindow(wStartColumn As Word, wStopColumn As Word, wStartPage As Word, wStopPage As Word)
    wStartColumn = wStartColumn + wTftWidthOffset
    wStopColumn = wStopColumn + wTftWidthOffset
    wStartPage = wStartPage + wTftHeightOffset
    wStopPage = wStopPage + wTftHeightOffset
    
    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS 
            TftSend(0x2A) 
        PinSet TFT_DC
            TftSend(wStartColumn.Byte1)
            TftSend(wStartColumn.Byte0)
            TftSend(wStopColumn.Byte1)
            TftSend(wStopColumn.Byte0)
        PinClear TFT_DC
            TftSend(0x2B)
        PinSet TFT_DC
            TftSend(wStartPage.Byte1)
            TftSend(wStartPage.Byte0)
            TftSend(wStopPage.Byte1)
            TftSend(wStopPage.Byte0)
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = 0x2A  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = wStartColumn.Byte1 
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = wStartColumn.Byte0 
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = wStopColumn.Byte1
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = wStopColumn.Byte0
            PinClear TFT_WR : PinSet TFT_WR
        PinClear TFT_DC 
            TftDataLowByte = 0x2B  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = wStartPage.Byte1
            PinClear TFT_WR : PinSet TFT_WR                
            TftDataLowByte = wStartPage.Byte0  
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = wStopPage.Byte1 
            PinClear TFT_WR : PinSet TFT_WR 
            TftDataLowByte = wStopPage.Byte0
            PinClear TFT_WR : PinSet TFT_WR
    $endif          
EndProc

'Set partial area to be displayed, only this part of the screen will be shown until partial display is disabled
'wStartPage = display area start row
'wStopPage = display area end row
'Example: TftSetPartialArea(160, 190) -->
'display only the area between row 160 and 190

Proc TftSetPartialArea(wStartPage As Word, wStopPage As Word)
    wStartPage = wStartPage + TftHeightOffset  
    wStopPage = wStopPage + TftHeightOffset 

    $if TFT_COM = SPI_1 Or TFT_COM = SPI_2 Or TFT_COM = SPI_SW
        PinClear TFT_SCLK : PinClear TFT_DC
        PinClear TFT_CS
            TftSend(0x30)
        PinSet TFT_DC
            TftSend(wStartPage.Byte1)
            TftSend(wStartPage.Byte0)
            TftSend(wStopPage.Byte1)
            TftSend(wStopPage.Byte0)
        PinSet TFT_CS
    $elseif TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
        PinClear TFT_CS 
        PinClear TFT_DC 
            TftDataLowByte = 0x30  
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_DC 
            TftDataLowByte = wStartPage.Byte1
            PinClear TFT_WR : PinSet TFT_WR                
            TftDataLowByte = wStartPage.Byte0  
            PinClear TFT_WR : PinSet TFT_WR
            TftDataLowByte = wStopPage.Byte1 
            PinClear TFT_WR : PinSet TFT_WR 
            TftDataLowByte = wStopPage.Byte0
            PinClear TFT_WR : PinSet TFT_WR
        PinSet TFT_CS
    $endif          
EndProc

Proc TftSend(wSpiWord As Word)
    Dim bTemp As Byte
    
    $if TFT_COM = SPI_1
        $if McuType = 0
            SSP1BUF = wSpiWord.Byte0
            While SSP1STAT.0 = 0 : Wend  
            bTemp = SSP1BUF
        $else
            SPI1BUF = wSpiWord.Byte0
            While SPI1STAT.0 = 0 : Wend
            bTemp = SPI1BUF
        $endif
    $elseif TFT_COM = SPI_2 
        $if McuType = 0
            SSP2BUF = wSpiWord.Byte0
            While SSP2STAT.0 = 0 : Wend
            bTemp = SSP2BUF
        $else
            SPI2BUF = wSpiWord.Byte0
            While SPI2STAT.0 = 0 : Wend
            bTemp = SPI2BUF
        $endif   
    $elseif TFT_COM = SPI_SW 
        TFT_MOSI = wSpiWord.7 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.6 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.5 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.4 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.3 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.2 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.1 : PinSet TFT_SCLK : PinClear TFT_SCLK
        TFT_MOSI = wSpiWord.0 : PinSet TFT_SCLK : PinClear TFT_SCLK
    $elseif TFT_COM = PAR_2x8b 
        TftDataHighByte = wSpiWord.Byte1 
        TftDataLowByte = wSpiWord.Byte0
        PinClear TFT_WR : PinSet TFT_WR
    $elseif TFT_COM = PAR_16b
        TftDataWord = wSpiWord
        PinClear TFT_WR : PinSet TFT_WR
    $endif
EndProc

$if TFT_COM = PAR_2x8b Or TFT_COM = PAR_16b
Proc TftReceive(), Word
$else
Proc TftReceive(), Byte
$endif
    $if TFT_COM = SPI_1
        $if McuType = 0
            SSP1BUF = 0xFF
            While SSP1STAT.0 = 0 : Wend  
            Result = SSP1BUF
        $else
            SPI1BUF = 0xFF
            While SPI1STAT.0 = 0 : Wend
            Result = SPI1BUF
        $endif
    $elseif TFT_COM = SPI_2 
        $if McuType = 0
            SSP2BUF = 0xFF
            While SSP2STAT.0 = 0 : Wend
            Result = SSP2BUF
        $else
            SPI2BUF = 0xFF
            While SPI2STAT.0 = 0 : Wend
            Result = SPI2BUF
        $endif  
    $elseif TFT_COM = SPI_SW 
        PinSet TFT_SCLK : Result.7 = TFT_MISO : PinClear TFT_SCLK  
        PinSet TFT_SCLK : Result.6 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.5 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.4 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.3 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.2 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.1 = TFT_MISO : PinClear TFT_SCLK 
        PinSet TFT_SCLK : Result.0 = TFT_MISO : PinClear TFT_SCLK 
    $elseif TFT_COM = PAR_2x8b 
        Input TftDataHighByte
        Input TftDataLowByte
        PinClear TFT_RD : PinSet TFT_RD
        Result.Byte1 = TftDataHighByte
        Result.Byte0 = TftDataLowByte
        Output TftDataHighByte
        Output TftDataLowByte
    $elseif TFT_COM = PAR_16b
        Input TftDataWord 
        PinClear TFT_RD : DelayCS TftReadDelay : PinSet TFT_RD : DelayCS TftReadDelay
        Result = TftDataWord
        Output TftDataWord
    $endif
EndProc

Proc TftReceiveSda(), Byte
    PinSet TFT_SCLK : Result.7 = TFT_MOSI : PinClear TFT_SCLK  
    PinSet TFT_SCLK : Result.6 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.5 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.4 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.3 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.2 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.1 = TFT_MOSI : PinClear TFT_SCLK 
    PinSet TFT_SCLK : Result.0 = TFT_MOSI : PinClear TFT_SCLK 
EndProc

Dim Color6bTo5b As Flash8 = 0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14,15,15,16,16,17,17,18,_
18,19,19,20,20,21,21,22,22,23,23,24,24,25,25,26,26,27,27,28,28,29,29,30,30,31,31 
